<!-- How to Use Button -->
    <button class="btn btn-info me-3" type="button" data-bs-toggle="collapse" data-bs-target="#howToUseCard" aria-expanded="false" aria-controls="howToUseCard">
      How to use?
    </button>
<!-- Collapsible Card for How to Use -->
<div class="collapse" id="howToUseCard">
  <div class="card card-body">
    <h5>Pop Up Admin Panel – Quick Guide</h5>
    <ul>
      <li>
        <strong>Overview:</strong> The Pop Up Admin Panel lets you configure two types of pop ups that can be displayed on specific pages of your website. For each popup, you can set:
        <ul>
          <li><strong>Target Page:</strong> The specific page (filename) on which the popup will appear.</li>
          <li><strong>Background Image URL:</strong> An image that will be used as the background in the popup.</li>
          <li><strong>HTML Content:</strong> The message or content (including HTML formatting) that will be shown in the popup.</li>
          <li><strong>Enable Checkbox:</strong> Check this box to activate the popup.</li>
        </ul>
      </li>
      <li>
        <strong>How to Configure a Popup:</strong>
        <ul>
          <li>
            <strong>Popup Target Page:</strong> This field tells the system on which page the popup should be triggered.
            <ul>
              <li>For example, if you want Popup 1 to only appear on an event details page, enter the filename (e.g., <code>index.php?cPath=1</code>).</li>
              <li>For Popup 2, if it should appear on a special offer page, enter that filename (e.g., <code>special_offer.php</code>).</li>
              <li><em>Tip:</em> Make sure you enter the correct filename without any path or extra characters.</li>
			  <li>
            <strong>NOTE: Popup Target Home Page:</strong> If you want to target the homepage usually the index.php, write HOME in the Pop UP Target Page
          </li>
            </ul>
            <strong>Background Image URL:</strong> Provide the Path to URL to an image that will be used as the popup’s background. This helps make your popup visually appealing.
          </li>
          <li>
            <strong>HTML Content:</strong> Create a Static Page in your CMS section and when you have saved the static page ...take not of the Static Page ID and enter the number in the Popup 1 Static Page ID input. You can create many static pages for later use as pop up marketing pages.
          </li>
          <li>
            <strong>Enable the Popup:</strong> Tick the checkbox if you want the popup to be active on the front end. Untick it if you want to disable the popup without losing your settings.
          </li>
        </ul>
      </li>
      <li>
        <strong>Testing the Popup:</strong>
        <ul>
          <li>
            <strong>Test Button:</strong> Next to each popup configuration, you’ll find a “Test Popup” button.
          </li>
          <li>
            <strong>How it Works:</strong> Clicking the button will show you a preview of the popup content (using a simple alert or preview modal in the admin panel).
          </li>
          <li>
            <strong>Purpose:</strong> This allows you to quickly check your HTML content and styling before making the popup live.
          </li>
        </ul>
      </li>
      <li>
        <strong>Final Notes:</strong>
        <ul>
          <li>
            <strong>Saving Your Changes:</strong> After you have entered or updated the information for each popup, click “Save Changes” to update the settings in the configuration database.
          </li>
          <li>
            <strong>Remember About Targets:</strong> The Target Page is critical. It determines exactly where on your website the popup will appear. If the target is set incorrectly, the popup may either show on the wrong page or not at all.
          </li>
        </ul>
      </li>
      <li>
        By following these steps, you ensure that each popup is correctly configured and will only appear on the designated pages. If you have any questions or need further assistance, please contact your web administrator.
      </li>
    </ul>
  </div>
</div>