# osConcert: Thanks to: osCommerce, Open Source E-Commerce Solutions
# http://www.oscommerce.com
#
# Database Backup For Darling Harbour
# Copyright (c) 2025 Stars on Ice
#
# Database: darling
# Database Server: 127.0.0.1
#
# Backup Date: 05/04/2025 20:50:39
# Backed up tables: categories, categories_description, products, products_description, products_price_break, products_to_categories

drop table if exists `categories`;
CREATE TABLE `categories` (
  `categories_id` int(11) NOT NULL AUTO_INCREMENT,
  `categories_image` varchar(64) DEFAULT NULL,
  `parent_id` int(11) NOT NULL DEFAULT 0,
  `sort_order` int(3) DEFAULT NULL,
  `date_added` datetime DEFAULT NULL,
  `last_modified` datetime DEFAULT NULL,
  `categories_status` tinyint(1) unsigned NOT NULL DEFAULT 1,
  `categories_products_lock` int(1) NOT NULL DEFAULT 1,
  `date_id` varchar(64) NOT NULL,
  `plan_id` int(1) NOT NULL,
  `categories_quantity` int(6) NOT NULL DEFAULT 0,
  `categories_quantity_remaining` int(6) NOT NULL DEFAULT 0,
  `categories_GA` tinyint(1) NOT NULL DEFAULT 0,
  `categories_image_2` varchar(64) DEFAULT NULL,
  `color_code` varchar(12) NOT NULL,
  `manufacturers_id` varchar(28) NOT NULL,
  `categories_is_printable` tinyint(1) NOT NULL DEFAULT 1,
  `section_id` int(11) NOT NULL,
  `categories_shipping` tinyint(1) NOT NULL,
  `concert_date_unix` bigint(20) NOT NULL,
  `categories_image_3` varchar(64) NOT NULL,
  `categories_image_4` varchar(64) NOT NULL,
  `bg_height` int(11) NOT NULL,
  `categories_advance_fee` decimal(15,4) NOT NULL DEFAULT 0.0000,
  PRIMARY KEY (`categories_id`),
  KEY `idx_categories_parent_id` (`parent_id`)
);

insert into `categories` (`categories_id`, `categories_image`, `parent_id`, `sort_order`, `date_added`, `last_modified`, `categories_status`, `categories_products_lock`, `date_id`, `plan_id`, `categories_quantity`, `categories_quantity_remaining`, `categories_GA`, `categories_image_2`, `color_code`, `manufacturers_id`, `categories_is_printable`, `section_id`, `categories_shipping`, `concert_date_unix`, `categories_image_3`, `categories_image_4`, `bg_height`, `categories_advance_fee`) values ('1','skating.jpg','0','1','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','27-06-2025','9','180','0','0','','','','1','0','0','1750946400','','','0','0.0000'),
('2','skating.jpg','0','14','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','28-06-2025','9','180','0','0','','','','1','0','0','1751032800','','','0','0.0000'),
('3','skating.jpg','0','27','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','29-06-2025','9','180','0','0','','','','1','0','0','1751119200','','','0','0.0000'),
('4','skating.jpg','0','40','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','30-06-2025','9','180','0','0','','','','1','0','0','1751205600','','','0','0.0000'),
('5','skating.jpg','0','53','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','01-07-2025','9','180','0','0','','','','1','0','0','1751292000','','','0','0.0000'),
('6','skating.jpg','0','66','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','02-07-2025','9','180','0','0','','','','1','0','0','1751378400','','','0','0.0000'),
('7','skating.jpg','0','79','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','03-07-2025','9','180','0','0','','','','1','0','0','1751464800','','','0','0.0000'),
('8','skating.jpg','0','92','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','04-07-2025','9','180','0','0','','','','1','0','0','1751551200','','','0','0.0000'),
('9','skating.jpg','0','105','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','05-07-2025','9','180','0','0','','','','1','0','0','1751637600','','','0','0.0000'),
('10','skating.jpg','0','118','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','06-07-2025','9','180','0','0','','','','1','0','0','1751724000','','','0','0.0000'),
('11','skating.jpg','0','131','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','07-07-2025','9','180','0','0','','','','1','0','0','1751810400','','','0','0.0000'),
('12','skating.jpg','0','144','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','08-07-2025','9','180','0','0','','','','1','0','0','1751896800','','','0','0.0000'),
('13','skating.jpg','0','157','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','09-07-2025','9','180','0','0','','','','1','0','0','1751983200','','','0','0.0000'),
('14','skating.jpg','0','170','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','10-07-2025','9','180','0','0','','','','1','0','0','1752069600','','','0','0.0000'),
('15','skating.jpg','0','183','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','11-07-2025','9','180','0','0','','','','1','0','0','1752156000','','','0','0.0000'),
('16','skating.jpg','0','196','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','12-07-2025','9','180','0','0','','','','1','0','0','1752242400','','','0','0.0000'),
('17','skating.jpg','0','209','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','13-07-2025','9','180','0','0','','','','1','0','0','1752328800','','','0','0.0000'),
('18','skating.jpg','0','222','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','14-07-2025','9','180','0','0','','','','1','0','0','1752415200','','','0','0.0000'),
('19','skating.jpg','0','235','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','15-07-2025','9','180','0','0','','','','1','0','0','1752501600','','','0','0.0000'),
('20','skating.jpg','0','248','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','16-07-2025','9','180','0','0','','','','1','0','0','1752588000','','','0','0.0000');
insert into `categories` (`categories_id`, `categories_image`, `parent_id`, `sort_order`, `date_added`, `last_modified`, `categories_status`, `categories_products_lock`, `date_id`, `plan_id`, `categories_quantity`, `categories_quantity_remaining`, `categories_GA`, `categories_image_2`, `color_code`, `manufacturers_id`, `categories_is_printable`, `section_id`, `categories_shipping`, `concert_date_unix`, `categories_image_3`, `categories_image_4`, `bg_height`, `categories_advance_fee`) values ('21','skating.jpg','0','261','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','17-07-2025','9','180','0','0','','','','1','0','0','1752674400','','','0','0.0000'),
('22','skating.jpg','0','274','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','18-07-2025','9','180','0','0','','','','1','0','0','1752760800','','','0','0.0000'),
('23','skating.jpg','0','287','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','19-07-2025','9','180','0','0','','','','1','0','0','1752847200','','','0','0.0000'),
('24','skating.jpg','0','300','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','20-07-2025','9','180','0','0','','','','1','0','0','1752933600','','','0','0.0000'),
('25','skating.jpg','1','2','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','27-06-2025 1000','9','180','180','1','1000','','','1','0','0','1750982400','','','0','0.0000'),
('26','skating.jpg','1','3','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','27-06-2025 1100','9','180','180','1','1100','','','1','0','0','1750986000','','','0','0.0000'),
('27','skating.jpg','1','4','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','27-06-2025 1200','9','180','180','1','1200','','','1','0','0','1750989600','','','0','0.0000'),
('28','skating.jpg','1','5','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','27-06-2025 1300','9','180','180','1','1300','','','1','0','0','1750993200','','','0','0.0000'),
('29','skating.jpg','1','6','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','27-06-2025 1400','9','180','180','1','1400','','','1','0','0','1750996800','','','0','0.0000'),
('30','skating.jpg','1','7','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','27-06-2025 1500','9','180','180','1','1500','','','1','0','0','1751000400','','','0','0.0000'),
('31','skating.jpg','1','8','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','27-06-2025 1600','9','180','180','1','1600','','','1','0','0','1751004000','','','0','0.0000'),
('32','skating.jpg','1','9','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','27-06-2025 1700','9','180','180','1','1700','','','1','0','0','1751007600','','','0','0.0000'),
('33','skating.jpg','1','10','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','27-06-2025 1800','9','180','180','1','1800','','','1','0','0','1751011200','','','0','0.0000'),
('34','skating.jpg','1','11','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','27-06-2025 1900','9','180','180','1','1900','','','1','0','0','1751014800','','','0','0.0000'),
('35','skating.jpg','1','12','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','27-06-2025 2000','9','180','180','1','2000','','','1','0','0','1751018400','','','0','0.0000'),
('36','skating.jpg','1','13','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','27-06-2025 2100','9','180','180','1','2100','','','1','0','0','1751022000','','','0','0.0000'),
('37','skating.jpg','2','15','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','28-06-2025 1000','9','180','180','1','1000','','','1','0','0','1751068800','','','0','0.0000'),
('38','skating.jpg','2','16','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','28-06-2025 1100','9','180','180','1','1100','','','1','0','0','1751072400','','','0','0.0000'),
('39','skating.jpg','2','17','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','28-06-2025 1200','9','180','180','1','1200','','','1','0','0','1751076000','','','0','0.0000'),
('40','skating.jpg','2','18','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','28-06-2025 1300','9','180','180','1','1300','','','1','0','0','1751079600','','','0','0.0000');
insert into `categories` (`categories_id`, `categories_image`, `parent_id`, `sort_order`, `date_added`, `last_modified`, `categories_status`, `categories_products_lock`, `date_id`, `plan_id`, `categories_quantity`, `categories_quantity_remaining`, `categories_GA`, `categories_image_2`, `color_code`, `manufacturers_id`, `categories_is_printable`, `section_id`, `categories_shipping`, `concert_date_unix`, `categories_image_3`, `categories_image_4`, `bg_height`, `categories_advance_fee`) values ('41','skating.jpg','2','19','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','28-06-2025 1400','9','180','180','1','1400','','','1','0','0','1751083200','','','0','0.0000'),
('42','skating.jpg','2','20','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','28-06-2025 1500','9','180','180','1','1500','','','1','0','0','1751086800','','','0','0.0000'),
('43','skating.jpg','2','21','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','28-06-2025 1600','9','180','180','1','1600','','','1','0','0','1751090400','','','0','0.0000'),
('44','skating.jpg','2','22','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','28-06-2025 1700','9','180','180','1','1700','','','1','0','0','1751094000','','','0','0.0000'),
('45','skating.jpg','2','23','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','28-06-2025 1800','9','180','180','1','1800','','','1','0','0','1751097600','','','0','0.0000'),
('46','skating.jpg','2','24','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','28-06-2025 1900','9','180','180','1','1900','','','1','0','0','1751101200','','','0','0.0000'),
('47','skating.jpg','2','25','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','28-06-2025 2000','9','180','180','1','2000','','','1','0','0','1751104800','','','0','0.0000'),
('48','skating.jpg','2','26','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','28-06-2025 2100','9','180','180','1','2100','','','1','0','0','1751108400','','','0','0.0000'),
('49','skating.jpg','3','28','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','29-06-2025 1000','9','180','180','1','1000','','','1','0','0','1751155200','','','0','0.0000'),
('50','skating.jpg','3','29','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','29-06-2025 1100','9','180','180','1','1100','','','1','0','0','1751158800','','','0','0.0000'),
('51','skating.jpg','3','30','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','29-06-2025 1200','9','180','180','1','1200','','','1','0','0','1751162400','','','0','0.0000'),
('52','skating.jpg','3','31','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','29-06-2025 1300','9','180','180','1','1300','','','1','0','0','1751166000','','','0','0.0000'),
('53','skating.jpg','3','32','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','29-06-2025 1400','9','180','180','1','1400','','','1','0','0','1751169600','','','0','0.0000'),
('54','skating.jpg','3','33','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','29-06-2025 1500','9','180','180','1','1500','','','1','0','0','1751173200','','','0','0.0000'),
('55','skating.jpg','3','34','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','29-06-2025 1600','9','180','180','1','1600','','','1','0','0','1751176800','','','0','0.0000'),
('56','skating.jpg','3','35','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','29-06-2025 1700','9','180','180','1','1700','','','1','0','0','1751180400','','','0','0.0000'),
('57','skating.jpg','3','36','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','29-06-2025 1800','9','180','180','1','1800','','','1','0','0','1751184000','','','0','0.0000'),
('58','skating.jpg','3','37','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','29-06-2025 1900','9','180','180','1','1900','','','1','0','0','1751187600','','','0','0.0000'),
('59','skating.jpg','3','38','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','29-06-2025 2000','9','180','180','1','2000','','','1','0','0','1751191200','','','0','0.0000'),
('60','skating.jpg','3','39','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','29-06-2025 2100','9','180','180','1','2100','','','1','0','0','1751194800','','','0','0.0000');
insert into `categories` (`categories_id`, `categories_image`, `parent_id`, `sort_order`, `date_added`, `last_modified`, `categories_status`, `categories_products_lock`, `date_id`, `plan_id`, `categories_quantity`, `categories_quantity_remaining`, `categories_GA`, `categories_image_2`, `color_code`, `manufacturers_id`, `categories_is_printable`, `section_id`, `categories_shipping`, `concert_date_unix`, `categories_image_3`, `categories_image_4`, `bg_height`, `categories_advance_fee`) values ('61','skating.jpg','4','41','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','30-06-2025 1000','9','180','180','1','1000','','','1','0','0','1751241600','','','0','0.0000'),
('62','skating.jpg','4','42','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','30-06-2025 1100','9','180','180','1','1100','','','1','0','0','1751245200','','','0','0.0000'),
('63','skating.jpg','4','43','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','30-06-2025 1200','9','180','180','1','1200','','','1','0','0','1751248800','','','0','0.0000'),
('64','skating.jpg','4','44','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','30-06-2025 1300','9','180','180','1','1300','','','1','0','0','1751252400','','','0','0.0000'),
('65','skating.jpg','4','45','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','30-06-2025 1400','9','180','180','1','1400','','','1','0','0','1751256000','','','0','0.0000'),
('66','skating.jpg','4','46','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','30-06-2025 1500','9','180','180','1','1500','','','1','0','0','1751259600','','','0','0.0000'),
('67','skating.jpg','4','47','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','30-06-2025 1600','9','180','180','1','1600','','','1','0','0','1751263200','','','0','0.0000'),
('68','skating.jpg','4','48','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','30-06-2025 1700','9','180','180','1','1700','','','1','0','0','1751266800','','','0','0.0000'),
('69','skating.jpg','4','49','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','30-06-2025 1800','9','180','180','1','1800','','','1','0','0','1751270400','','','0','0.0000'),
('70','skating.jpg','4','50','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','30-06-2025 1900','9','180','180','1','1900','','','1','0','0','1751274000','','','0','0.0000'),
('71','skating.jpg','4','51','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','30-06-2025 2000','9','180','180','1','2000','','','1','0','0','1751277600','','','0','0.0000'),
('72','skating.jpg','4','52','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','30-06-2025 2100','9','180','180','1','2100','','','1','0','0','1751281200','','','0','0.0000'),
('73','skating.jpg','5','54','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','01-07-2025 1000','9','180','180','1','1000','','','1','0','0','1751328000','','','0','0.0000'),
('74','skating.jpg','5','55','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','01-07-2025 1100','9','180','180','1','1100','','','1','0','0','1751331600','','','0','0.0000'),
('75','skating.jpg','5','56','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','01-07-2025 1200','9','180','180','1','1200','','','1','0','0','1751335200','','','0','0.0000'),
('76','skating.jpg','5','57','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','01-07-2025 1300','9','180','180','1','1300','','','1','0','0','1751338800','','','0','0.0000'),
('77','skating.jpg','5','58','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','01-07-2025 1400','9','180','180','1','1400','','','1','0','0','1751342400','','','0','0.0000'),
('78','skating.jpg','5','59','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','01-07-2025 1500','9','180','180','1','1500','','','1','0','0','1751346000','','','0','0.0000'),
('79','skating.jpg','5','60','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','01-07-2025 1600','9','180','180','1','1600','','','1','0','0','1751349600','','','0','0.0000'),
('80','skating.jpg','5','61','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','01-07-2025 1700','9','180','180','1','1700','','','1','0','0','1751353200','','','0','0.0000');
insert into `categories` (`categories_id`, `categories_image`, `parent_id`, `sort_order`, `date_added`, `last_modified`, `categories_status`, `categories_products_lock`, `date_id`, `plan_id`, `categories_quantity`, `categories_quantity_remaining`, `categories_GA`, `categories_image_2`, `color_code`, `manufacturers_id`, `categories_is_printable`, `section_id`, `categories_shipping`, `concert_date_unix`, `categories_image_3`, `categories_image_4`, `bg_height`, `categories_advance_fee`) values ('81','skating.jpg','5','62','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','01-07-2025 1800','9','180','180','1','1800','','','1','0','0','1751356800','','','0','0.0000'),
('82','skating.jpg','5','63','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','01-07-2025 1900','9','180','180','1','1900','','','1','0','0','1751360400','','','0','0.0000'),
('83','skating.jpg','5','64','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','01-07-2025 2000','9','180','180','1','2000','','','1','0','0','1751364000','','','0','0.0000'),
('84','skating.jpg','5','65','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','01-07-2025 2100','9','180','180','1','2100','','','1','0','0','1751367600','','','0','0.0000'),
('85','skating.jpg','6','67','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','02-07-2025 1000','9','180','180','1','1000','','','1','0','0','1751414400','','','0','0.0000'),
('86','skating.jpg','6','68','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','02-07-2025 1100','9','180','180','1','1100','','','1','0','0','1751418000','','','0','0.0000'),
('87','skating.jpg','6','69','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','02-07-2025 1200','9','180','180','1','1200','','','1','0','0','1751421600','','','0','0.0000'),
('88','skating.jpg','6','70','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','02-07-2025 1300','9','180','180','1','1300','','','1','0','0','1751425200','','','0','0.0000'),
('89','skating.jpg','6','71','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','02-07-2025 1400','9','180','180','1','1400','','','1','0','0','1751428800','','','0','0.0000'),
('90','skating.jpg','6','72','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','02-07-2025 1500','9','180','180','1','1500','','','1','0','0','1751432400','','','0','0.0000'),
('91','skating.jpg','6','73','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','02-07-2025 1600','9','180','180','1','1600','','','1','0','0','1751436000','','','0','0.0000'),
('92','skating.jpg','6','74','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','02-07-2025 1700','9','180','180','1','1700','','','1','0','0','1751439600','','','0','0.0000'),
('93','skating.jpg','6','75','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','02-07-2025 1800','9','180','180','1','1800','','','1','0','0','1751443200','','','0','0.0000'),
('94','skating.jpg','6','76','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','02-07-2025 1900','9','180','180','1','1900','','','1','0','0','1751446800','','','0','0.0000'),
('95','skating.jpg','6','77','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','02-07-2025 2000','9','180','180','1','2000','','','1','0','0','1751450400','','','0','0.0000'),
('96','skating.jpg','6','78','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','02-07-2025 2100','9','180','180','1','2100','','','1','0','0','1751454000','','','0','0.0000'),
('97','skating.jpg','7','80','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','03-07-2025 1000','9','180','180','1','1000','','','1','0','0','1751500800','','','0','0.0000'),
('98','skating.jpg','7','81','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','03-07-2025 1100','9','180','180','1','1100','','','1','0','0','1751504400','','','0','0.0000'),
('99','skating.jpg','7','82','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','03-07-2025 1200','9','180','180','1','1200','','','1','0','0','1751508000','','','0','0.0000'),
('100','skating.jpg','7','83','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','03-07-2025 1300','9','180','180','1','1300','','','1','0','0','1751511600','','','0','0.0000');
insert into `categories` (`categories_id`, `categories_image`, `parent_id`, `sort_order`, `date_added`, `last_modified`, `categories_status`, `categories_products_lock`, `date_id`, `plan_id`, `categories_quantity`, `categories_quantity_remaining`, `categories_GA`, `categories_image_2`, `color_code`, `manufacturers_id`, `categories_is_printable`, `section_id`, `categories_shipping`, `concert_date_unix`, `categories_image_3`, `categories_image_4`, `bg_height`, `categories_advance_fee`) values ('101','skating.jpg','7','84','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','03-07-2025 1400','9','180','180','1','1400','','','1','0','0','1751515200','','','0','0.0000'),
('102','skating.jpg','7','85','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','03-07-2025 1500','9','180','180','1','1500','','','1','0','0','1751518800','','','0','0.0000'),
('103','skating.jpg','7','86','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','03-07-2025 1600','9','180','180','1','1600','','','1','0','0','1751522400','','','0','0.0000'),
('104','skating.jpg','7','87','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','03-07-2025 1700','9','180','180','1','1700','','','1','0','0','1751526000','','','0','0.0000'),
('105','skating.jpg','7','88','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','03-07-2025 1800','9','180','180','1','1800','','','1','0','0','1751529600','','','0','0.0000'),
('106','skating.jpg','7','89','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','03-07-2025 1900','9','180','180','1','1900','','','1','0','0','1751533200','','','0','0.0000'),
('107','skating.jpg','7','90','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','03-07-2025 2000','9','180','180','1','2000','','','1','0','0','1751536800','','','0','0.0000'),
('108','skating.jpg','7','91','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','03-07-2025 2100','9','180','180','1','2100','','','1','0','0','1751540400','','','0','0.0000'),
('109','skating.jpg','8','93','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','04-07-2025 1000','9','180','180','1','1000','','','1','0','0','1751587200','','','0','0.0000'),
('110','skating.jpg','8','94','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','04-07-2025 1100','9','180','180','1','1100','','','1','0','0','1751590800','','','0','0.0000'),
('111','skating.jpg','8','95','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','04-07-2025 1200','9','180','180','1','1200','','','1','0','0','1751594400','','','0','0.0000'),
('112','skating.jpg','8','96','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','04-07-2025 1300','9','180','180','1','1300','','','1','0','0','1751598000','','','0','0.0000'),
('113','skating.jpg','8','97','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','04-07-2025 1400','9','180','180','1','1400','','','1','0','0','1751601600','','','0','0.0000'),
('114','skating.jpg','8','98','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','04-07-2025 1500','9','180','180','1','1500','','','1','0','0','1751605200','','','0','0.0000'),
('115','skating.jpg','8','99','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','04-07-2025 1600','9','180','180','1','1600','','','1','0','0','1751608800','','','0','0.0000'),
('116','skating.jpg','8','100','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','04-07-2025 1700','9','180','180','1','1700','','','1','0','0','1751612400','','','0','0.0000'),
('117','skating.jpg','8','101','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','04-07-2025 1800','9','180','180','1','1800','','','1','0','0','1751616000','','','0','0.0000'),
('118','skating.jpg','8','102','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','04-07-2025 1900','9','180','180','1','1900','','','1','0','0','1751619600','','','0','0.0000'),
('119','skating.jpg','8','103','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','04-07-2025 2000','9','180','180','1','2000','','','1','0','0','1751623200','','','0','0.0000'),
('120','skating.jpg','8','104','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','04-07-2025 2100','9','180','180','1','2100','','','1','0','0','1751626800','','','0','0.0000');
insert into `categories` (`categories_id`, `categories_image`, `parent_id`, `sort_order`, `date_added`, `last_modified`, `categories_status`, `categories_products_lock`, `date_id`, `plan_id`, `categories_quantity`, `categories_quantity_remaining`, `categories_GA`, `categories_image_2`, `color_code`, `manufacturers_id`, `categories_is_printable`, `section_id`, `categories_shipping`, `concert_date_unix`, `categories_image_3`, `categories_image_4`, `bg_height`, `categories_advance_fee`) values ('121','skating.jpg','9','106','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','05-07-2025 1000','9','180','180','1','1000','','','1','0','0','1751673600','','','0','0.0000'),
('122','skating.jpg','9','107','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','05-07-2025 1100','9','180','180','1','1100','','','1','0','0','1751677200','','','0','0.0000'),
('123','skating.jpg','9','108','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','05-07-2025 1200','9','180','180','1','1200','','','1','0','0','1751680800','','','0','0.0000'),
('124','skating.jpg','9','109','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','05-07-2025 1300','9','180','180','1','1300','','','1','0','0','1751684400','','','0','0.0000'),
('125','skating.jpg','9','110','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','05-07-2025 1400','9','180','180','1','1400','','','1','0','0','1751688000','','','0','0.0000'),
('126','skating.jpg','9','111','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','05-07-2025 1500','9','180','180','1','1500','','','1','0','0','1751691600','','','0','0.0000'),
('127','skating.jpg','9','112','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','05-07-2025 1600','9','180','180','1','1600','','','1','0','0','1751695200','','','0','0.0000'),
('128','skating.jpg','9','113','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','05-07-2025 1700','9','180','180','1','1700','','','1','0','0','1751698800','','','0','0.0000'),
('129','skating.jpg','9','114','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','05-07-2025 1800','9','180','180','1','1800','','','1','0','0','1751702400','','','0','0.0000'),
('130','skating.jpg','9','115','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','05-07-2025 1900','9','180','180','1','1900','','','1','0','0','1751706000','','','0','0.0000'),
('131','skating.jpg','9','116','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','05-07-2025 2000','9','180','180','1','2000','','','1','0','0','1751709600','','','0','0.0000'),
('132','skating.jpg','9','117','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','05-07-2025 2100','9','180','180','1','2100','','','1','0','0','1751713200','','','0','0.0000'),
('133','skating.jpg','10','119','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','06-07-2025 1000','9','180','180','1','1000','','','1','0','0','1751760000','','','0','0.0000'),
('134','skating.jpg','10','120','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','06-07-2025 1100','9','180','180','1','1100','','','1','0','0','1751763600','','','0','0.0000'),
('135','skating.jpg','10','121','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','06-07-2025 1200','9','180','180','1','1200','','','1','0','0','1751767200','','','0','0.0000'),
('136','skating.jpg','10','122','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','06-07-2025 1300','9','180','180','1','1300','','','1','0','0','1751770800','','','0','0.0000'),
('137','skating.jpg','10','123','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','06-07-2025 1400','9','180','180','1','1400','','','1','0','0','1751774400','','','0','0.0000'),
('138','skating.jpg','10','124','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','06-07-2025 1500','9','180','180','1','1500','','','1','0','0','1751778000','','','0','0.0000'),
('139','skating.jpg','10','125','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','06-07-2025 1600','9','180','180','1','1600','','','1','0','0','1751781600','','','0','0.0000'),
('140','skating.jpg','10','126','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','06-07-2025 1700','9','180','180','1','1700','','','1','0','0','1751785200','','','0','0.0000');
insert into `categories` (`categories_id`, `categories_image`, `parent_id`, `sort_order`, `date_added`, `last_modified`, `categories_status`, `categories_products_lock`, `date_id`, `plan_id`, `categories_quantity`, `categories_quantity_remaining`, `categories_GA`, `categories_image_2`, `color_code`, `manufacturers_id`, `categories_is_printable`, `section_id`, `categories_shipping`, `concert_date_unix`, `categories_image_3`, `categories_image_4`, `bg_height`, `categories_advance_fee`) values ('141','skating.jpg','10','127','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','06-07-2025 1800','9','180','180','1','1800','','','1','0','0','1751788800','','','0','0.0000'),
('142','skating.jpg','10','128','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','06-07-2025 1900','9','180','180','1','1900','','','1','0','0','1751792400','','','0','0.0000'),
('143','skating.jpg','10','129','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','06-07-2025 2000','9','180','180','1','2000','','','1','0','0','1751796000','','','0','0.0000'),
('144','skating.jpg','10','130','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','06-07-2025 2100','9','180','180','1','2100','','','1','0','0','1751799600','','','0','0.0000'),
('145','skating.jpg','11','132','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','07-07-2025 1000','9','180','180','1','1000','','','1','0','0','1751846400','','','0','0.0000'),
('146','skating.jpg','11','133','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','07-07-2025 1100','9','180','180','1','1100','','','1','0','0','1751850000','','','0','0.0000'),
('147','skating.jpg','11','134','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','07-07-2025 1200','9','180','180','1','1200','','','1','0','0','1751853600','','','0','0.0000'),
('148','skating.jpg','11','135','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','07-07-2025 1300','9','180','180','1','1300','','','1','0','0','1751857200','','','0','0.0000'),
('149','skating.jpg','11','136','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','07-07-2025 1400','9','180','180','1','1400','','','1','0','0','1751860800','','','0','0.0000'),
('150','skating.jpg','11','137','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','07-07-2025 1500','9','180','180','1','1500','','','1','0','0','1751864400','','','0','0.0000'),
('151','skating.jpg','11','138','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','07-07-2025 1600','9','180','180','1','1600','','','1','0','0','1751868000','','','0','0.0000'),
('152','skating.jpg','11','139','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','07-07-2025 1700','9','180','180','1','1700','','','1','0','0','1751871600','','','0','0.0000'),
('153','skating.jpg','11','140','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','07-07-2025 1800','9','180','180','1','1800','','','1','0','0','1751875200','','','0','0.0000'),
('154','skating.jpg','11','141','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','07-07-2025 1900','9','180','180','1','1900','','','1','0','0','1751878800','','','0','0.0000'),
('155','skating.jpg','11','142','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','07-07-2025 2000','9','180','180','1','2000','','','1','0','0','1751882400','','','0','0.0000'),
('156','skating.jpg','11','143','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','07-07-2025 2100','9','180','180','1','2100','','','1','0','0','1751886000','','','0','0.0000'),
('157','skating.jpg','12','145','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','08-07-2025 1000','9','180','180','1','1000','','','1','0','0','1751932800','','','0','0.0000'),
('158','skating.jpg','12','146','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','08-07-2025 1100','9','180','180','1','1100','','','1','0','0','1751936400','','','0','0.0000'),
('159','skating.jpg','12','147','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','08-07-2025 1200','9','180','180','1','1200','','','1','0','0','1751940000','','','0','0.0000'),
('160','skating.jpg','12','148','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','08-07-2025 1300','9','180','180','1','1300','','','1','0','0','1751943600','','','0','0.0000');
insert into `categories` (`categories_id`, `categories_image`, `parent_id`, `sort_order`, `date_added`, `last_modified`, `categories_status`, `categories_products_lock`, `date_id`, `plan_id`, `categories_quantity`, `categories_quantity_remaining`, `categories_GA`, `categories_image_2`, `color_code`, `manufacturers_id`, `categories_is_printable`, `section_id`, `categories_shipping`, `concert_date_unix`, `categories_image_3`, `categories_image_4`, `bg_height`, `categories_advance_fee`) values ('161','skating.jpg','12','149','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','08-07-2025 1400','9','180','180','1','1400','','','1','0','0','1751947200','','','0','0.0000'),
('162','skating.jpg','12','150','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','08-07-2025 1500','9','180','180','1','1500','','','1','0','0','1751950800','','','0','0.0000'),
('163','skating.jpg','12','151','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','08-07-2025 1600','9','180','180','1','1600','','','1','0','0','1751954400','','','0','0.0000'),
('164','skating.jpg','12','152','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','08-07-2025 1700','9','180','180','1','1700','','','1','0','0','1751958000','','','0','0.0000'),
('165','skating.jpg','12','153','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','08-07-2025 1800','9','180','180','1','1800','','','1','0','0','1751961600','','','0','0.0000'),
('166','skating.jpg','12','154','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','08-07-2025 1900','9','180','180','1','1900','','','1','0','0','1751965200','','','0','0.0000'),
('167','skating.jpg','12','155','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','08-07-2025 2000','9','180','180','1','2000','','','1','0','0','1751968800','','','0','0.0000'),
('168','skating.jpg','12','156','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','08-07-2025 2100','9','180','180','1','2100','','','1','0','0','1751972400','','','0','0.0000'),
('169','skating.jpg','13','158','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','09-07-2025 1000','9','180','180','1','1000','','','1','0','0','1752019200','','','0','0.0000'),
('170','skating.jpg','13','159','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','09-07-2025 1100','9','180','180','1','1100','','','1','0','0','1752022800','','','0','0.0000'),
('171','skating.jpg','13','160','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','09-07-2025 1200','9','180','180','1','1200','','','1','0','0','1752026400','','','0','0.0000'),
('172','skating.jpg','13','161','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','09-07-2025 1300','9','180','180','1','1300','','','1','0','0','1752030000','','','0','0.0000'),
('173','skating.jpg','13','162','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','09-07-2025 1400','9','180','180','1','1400','','','1','0','0','1752033600','','','0','0.0000'),
('174','skating.jpg','13','163','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','09-07-2025 1500','9','180','180','1','1500','','','1','0','0','1752037200','','','0','0.0000'),
('175','skating.jpg','13','164','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','09-07-2025 1600','9','180','180','1','1600','','','1','0','0','1752040800','','','0','0.0000'),
('176','skating.jpg','13','165','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','09-07-2025 1700','9','180','180','1','1700','','','1','0','0','1752044400','','','0','0.0000'),
('177','skating.jpg','13','166','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','09-07-2025 1800','9','180','180','1','1800','','','1','0','0','1752048000','','','0','0.0000'),
('178','skating.jpg','13','167','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','09-07-2025 1900','9','180','180','1','1900','','','1','0','0','1752051600','','','0','0.0000'),
('179','skating.jpg','13','168','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','09-07-2025 2000','9','180','180','1','2000','','','1','0','0','1752055200','','','0','0.0000'),
('180','skating.jpg','13','169','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','09-07-2025 2100','9','180','180','1','2100','','','1','0','0','1752058800','','','0','0.0000');
insert into `categories` (`categories_id`, `categories_image`, `parent_id`, `sort_order`, `date_added`, `last_modified`, `categories_status`, `categories_products_lock`, `date_id`, `plan_id`, `categories_quantity`, `categories_quantity_remaining`, `categories_GA`, `categories_image_2`, `color_code`, `manufacturers_id`, `categories_is_printable`, `section_id`, `categories_shipping`, `concert_date_unix`, `categories_image_3`, `categories_image_4`, `bg_height`, `categories_advance_fee`) values ('181','skating.jpg','14','171','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','10-07-2025 1000','9','180','180','1','1000','','','1','0','0','1752105600','','','0','0.0000'),
('182','skating.jpg','14','172','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','10-07-2025 1100','9','180','180','1','1100','','','1','0','0','1752109200','','','0','0.0000'),
('183','skating.jpg','14','173','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','10-07-2025 1200','9','180','180','1','1200','','','1','0','0','1752112800','','','0','0.0000'),
('184','skating.jpg','14','174','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','10-07-2025 1300','9','180','180','1','1300','','','1','0','0','1752116400','','','0','0.0000'),
('185','skating.jpg','14','175','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','10-07-2025 1400','9','180','180','1','1400','','','1','0','0','1752120000','','','0','0.0000'),
('186','skating.jpg','14','176','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','10-07-2025 1500','9','180','180','1','1500','','','1','0','0','1752123600','','','0','0.0000'),
('187','skating.jpg','14','177','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','10-07-2025 1600','9','180','180','1','1600','','','1','0','0','1752127200','','','0','0.0000'),
('188','skating.jpg','14','178','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','10-07-2025 1700','9','180','180','1','1700','','','1','0','0','1752130800','','','0','0.0000'),
('189','skating.jpg','14','179','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','10-07-2025 1800','9','180','180','1','1800','','','1','0','0','1752134400','','','0','0.0000'),
('190','skating.jpg','14','180','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','10-07-2025 1900','9','180','180','1','1900','','','1','0','0','1752138000','','','0','0.0000'),
('191','skating.jpg','14','181','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','10-07-2025 2000','9','180','180','1','2000','','','1','0','0','1752141600','','','0','0.0000'),
('192','skating.jpg','14','182','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','10-07-2025 2100','9','180','180','1','2100','','','1','0','0','1752145200','','','0','0.0000'),
('193','skating.jpg','15','184','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','11-07-2025 1000','9','180','180','1','1000','','','1','0','0','1752192000','','','0','0.0000'),
('194','skating.jpg','15','185','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','11-07-2025 1100','9','180','180','1','1100','','','1','0','0','1752195600','','','0','0.0000'),
('195','skating.jpg','15','186','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','11-07-2025 1200','9','180','180','1','1200','','','1','0','0','1752199200','','','0','0.0000'),
('196','skating.jpg','15','187','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','11-07-2025 1300','9','180','180','1','1300','','','1','0','0','1752202800','','','0','0.0000'),
('197','skating.jpg','15','188','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','11-07-2025 1400','9','180','180','1','1400','','','1','0','0','1752206400','','','0','0.0000'),
('198','skating.jpg','15','189','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','11-07-2025 1500','9','180','180','1','1500','','','1','0','0','1752210000','','','0','0.0000'),
('199','skating.jpg','15','190','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','11-07-2025 1600','9','180','180','1','1600','','','1','0','0','1752213600','','','0','0.0000'),
('200','skating.jpg','15','191','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','11-07-2025 1700','9','180','180','1','1700','','','1','0','0','1752217200','','','0','0.0000');
insert into `categories` (`categories_id`, `categories_image`, `parent_id`, `sort_order`, `date_added`, `last_modified`, `categories_status`, `categories_products_lock`, `date_id`, `plan_id`, `categories_quantity`, `categories_quantity_remaining`, `categories_GA`, `categories_image_2`, `color_code`, `manufacturers_id`, `categories_is_printable`, `section_id`, `categories_shipping`, `concert_date_unix`, `categories_image_3`, `categories_image_4`, `bg_height`, `categories_advance_fee`) values ('201','skating.jpg','15','192','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','11-07-2025 1800','9','180','180','1','1800','','','1','0','0','1752220800','','','0','0.0000'),
('202','skating.jpg','15','193','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','11-07-2025 1900','9','180','180','1','1900','','','1','0','0','1752224400','','','0','0.0000'),
('203','skating.jpg','15','194','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','11-07-2025 2000','9','180','180','1','2000','','','1','0','0','1752228000','','','0','0.0000'),
('204','skating.jpg','15','195','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','11-07-2025 2100','9','180','180','1','2100','','','1','0','0','1752231600','','','0','0.0000'),
('205','skating.jpg','16','197','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','12-07-2025 1000','9','180','180','1','1000','','','1','0','0','1752278400','','','0','0.0000'),
('206','skating.jpg','16','198','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','12-07-2025 1100','9','180','180','1','1100','','','1','0','0','1752282000','','','0','0.0000'),
('207','skating.jpg','16','199','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','12-07-2025 1200','9','180','180','1','1200','','','1','0','0','1752285600','','','0','0.0000'),
('208','skating.jpg','16','200','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','12-07-2025 1300','9','180','180','1','1300','','','1','0','0','1752289200','','','0','0.0000'),
('209','skating.jpg','16','201','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','12-07-2025 1400','9','180','180','1','1400','','','1','0','0','1752292800','','','0','0.0000'),
('210','skating.jpg','16','202','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','12-07-2025 1500','9','180','180','1','1500','','','1','0','0','1752296400','','','0','0.0000'),
('211','skating.jpg','16','203','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','12-07-2025 1600','9','180','180','1','1600','','','1','0','0','1752300000','','','0','0.0000'),
('212','skating.jpg','16','204','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','12-07-2025 1700','9','180','180','1','1700','','','1','0','0','1752303600','','','0','0.0000'),
('213','skating.jpg','16','205','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','12-07-2025 1800','9','180','180','1','1800','','','1','0','0','1752307200','','','0','0.0000'),
('214','skating.jpg','16','206','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','12-07-2025 1900','9','180','180','1','1900','','','1','0','0','1752310800','','','0','0.0000'),
('215','skating.jpg','16','207','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','12-07-2025 2000','9','180','180','1','2000','','','1','0','0','1752314400','','','0','0.0000'),
('216','skating.jpg','16','208','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','12-07-2025 2100','9','180','180','1','2100','','','1','0','0','1752318000','','','0','0.0000'),
('217','skating.jpg','17','210','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','13-07-2025 1000','9','180','180','1','1000','','','1','0','0','1752364800','','','0','0.0000'),
('218','skating.jpg','17','211','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','13-07-2025 1100','9','180','180','1','1100','','','1','0','0','1752368400','','','0','0.0000'),
('219','skating.jpg','17','212','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','13-07-2025 1200','9','180','180','1','1200','','','1','0','0','1752372000','','','0','0.0000'),
('220','skating.jpg','17','213','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','13-07-2025 1300','9','180','180','1','1300','','','1','0','0','1752375600','','','0','0.0000');
insert into `categories` (`categories_id`, `categories_image`, `parent_id`, `sort_order`, `date_added`, `last_modified`, `categories_status`, `categories_products_lock`, `date_id`, `plan_id`, `categories_quantity`, `categories_quantity_remaining`, `categories_GA`, `categories_image_2`, `color_code`, `manufacturers_id`, `categories_is_printable`, `section_id`, `categories_shipping`, `concert_date_unix`, `categories_image_3`, `categories_image_4`, `bg_height`, `categories_advance_fee`) values ('221','skating.jpg','17','214','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','13-07-2025 1400','9','180','180','1','1400','','','1','0','0','1752379200','','','0','0.0000'),
('222','skating.jpg','17','215','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','13-07-2025 1500','9','180','180','1','1500','','','1','0','0','1752382800','','','0','0.0000'),
('223','skating.jpg','17','216','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','13-07-2025 1600','9','180','180','1','1600','','','1','0','0','1752386400','','','0','0.0000'),
('224','skating.jpg','17','217','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','13-07-2025 1700','9','180','180','1','1700','','','1','0','0','1752390000','','','0','0.0000'),
('225','skating.jpg','17','218','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','13-07-2025 1800','9','180','180','1','1800','','','1','0','0','1752393600','','','0','0.0000'),
('226','skating.jpg','17','219','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','13-07-2025 1900','9','180','180','1','1900','','','1','0','0','1752397200','','','0','0.0000'),
('227','skating.jpg','17','220','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','13-07-2025 2000','9','180','180','1','2000','','','1','0','0','1752400800','','','0','0.0000'),
('228','skating.jpg','17','221','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','13-07-2025 2100','9','180','180','1','2100','','','1','0','0','1752404400','','','0','0.0000'),
('229','skating.jpg','18','223','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','14-07-2025 1000','9','180','180','1','1000','','','1','0','0','1752451200','','','0','0.0000'),
('230','skating.jpg','18','224','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','14-07-2025 1100','9','180','180','1','1100','','','1','0','0','1752454800','','','0','0.0000'),
('231','skating.jpg','18','225','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','14-07-2025 1200','9','180','180','1','1200','','','1','0','0','1752458400','','','0','0.0000'),
('232','skating.jpg','18','226','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','14-07-2025 1300','9','180','180','1','1300','','','1','0','0','1752462000','','','0','0.0000'),
('233','skating.jpg','18','227','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','14-07-2025 1400','9','180','180','1','1400','','','1','0','0','1752465600','','','0','0.0000'),
('234','skating.jpg','18','228','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','14-07-2025 1500','9','180','180','1','1500','','','1','0','0','1752469200','','','0','0.0000'),
('235','skating.jpg','18','229','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','14-07-2025 1600','9','180','180','1','1600','','','1','0','0','1752472800','','','0','0.0000'),
('236','skating.jpg','18','230','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','14-07-2025 1700','9','180','180','1','1700','','','1','0','0','1752476400','','','0','0.0000'),
('237','skating.jpg','18','231','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','14-07-2025 1800','9','180','180','1','1800','','','1','0','0','1752480000','','','0','0.0000'),
('238','skating.jpg','18','232','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','14-07-2025 1900','9','180','180','1','1900','','','1','0','0','1752483600','','','0','0.0000'),
('239','skating.jpg','18','233','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','14-07-2025 2000','9','180','180','1','2000','','','1','0','0','1752487200','','','0','0.0000'),
('240','skating.jpg','18','234','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','14-07-2025 2100','9','180','180','1','2100','','','1','0','0','1752490800','','','0','0.0000');
insert into `categories` (`categories_id`, `categories_image`, `parent_id`, `sort_order`, `date_added`, `last_modified`, `categories_status`, `categories_products_lock`, `date_id`, `plan_id`, `categories_quantity`, `categories_quantity_remaining`, `categories_GA`, `categories_image_2`, `color_code`, `manufacturers_id`, `categories_is_printable`, `section_id`, `categories_shipping`, `concert_date_unix`, `categories_image_3`, `categories_image_4`, `bg_height`, `categories_advance_fee`) values ('241','skating.jpg','19','236','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','15-07-2025 1000','9','180','180','1','1000','','','1','0','0','1752537600','','','0','0.0000'),
('242','skating.jpg','19','237','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','15-07-2025 1100','9','180','180','1','1100','','','1','0','0','1752541200','','','0','0.0000'),
('243','skating.jpg','19','238','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','15-07-2025 1200','9','180','180','1','1200','','','1','0','0','1752544800','','','0','0.0000'),
('244','skating.jpg','19','239','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','15-07-2025 1300','9','180','180','1','1300','','','1','0','0','1752548400','','','0','0.0000'),
('245','skating.jpg','19','240','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','15-07-2025 1400','9','180','180','1','1400','','','1','0','0','1752552000','','','0','0.0000'),
('246','skating.jpg','19','241','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','15-07-2025 1500','9','180','180','1','1500','','','1','0','0','1752555600','','','0','0.0000'),
('247','skating.jpg','19','242','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','15-07-2025 1600','9','180','180','1','1600','','','1','0','0','1752559200','','','0','0.0000'),
('248','skating.jpg','19','243','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','15-07-2025 1700','9','180','180','1','1700','','','1','0','0','1752562800','','','0','0.0000'),
('249','skating.jpg','19','244','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','15-07-2025 1800','9','180','180','1','1800','','','1','0','0','1752566400','','','0','0.0000'),
('250','skating.jpg','19','245','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','15-07-2025 1900','9','180','180','1','1900','','','1','0','0','1752570000','','','0','0.0000'),
('251','skating.jpg','19','246','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','15-07-2025 2000','9','180','180','1','2000','','','1','0','0','1752573600','','','0','0.0000'),
('252','skating.jpg','19','247','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','15-07-2025 2100','9','180','180','1','2100','','','1','0','0','1752577200','','','0','0.0000'),
('253','skating.jpg','20','249','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','16-07-2025 1000','9','180','180','1','1000','','','1','0','0','1752624000','','','0','0.0000'),
('254','skating.jpg','20','250','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','16-07-2025 1100','9','180','180','1','1100','','','1','0','0','1752627600','','','0','0.0000'),
('255','skating.jpg','20','251','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','16-07-2025 1200','9','180','180','1','1200','','','1','0','0','1752631200','','','0','0.0000'),
('256','skating.jpg','20','252','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','16-07-2025 1300','9','180','180','1','1300','','','1','0','0','1752634800','','','0','0.0000'),
('257','skating.jpg','20','253','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','16-07-2025 1400','9','180','180','1','1400','','','1','0','0','1752638400','','','0','0.0000'),
('258','skating.jpg','20','254','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','16-07-2025 1500','9','180','180','1','1500','','','1','0','0','1752642000','','','0','0.0000'),
('259','skating.jpg','20','255','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','16-07-2025 1600','9','180','180','1','1600','','','1','0','0','1752645600','','','0','0.0000'),
('260','skating.jpg','20','256','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','16-07-2025 1700','9','180','180','1','1700','','','1','0','0','1752649200','','','0','0.0000');
insert into `categories` (`categories_id`, `categories_image`, `parent_id`, `sort_order`, `date_added`, `last_modified`, `categories_status`, `categories_products_lock`, `date_id`, `plan_id`, `categories_quantity`, `categories_quantity_remaining`, `categories_GA`, `categories_image_2`, `color_code`, `manufacturers_id`, `categories_is_printable`, `section_id`, `categories_shipping`, `concert_date_unix`, `categories_image_3`, `categories_image_4`, `bg_height`, `categories_advance_fee`) values ('261','skating.jpg','20','257','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','16-07-2025 1800','9','180','180','1','1800','','','1','0','0','1752652800','','','0','0.0000'),
('262','skating.jpg','20','258','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','16-07-2025 1900','9','180','180','1','1900','','','1','0','0','1752656400','','','0','0.0000'),
('263','skating.jpg','20','259','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','16-07-2025 2000','9','180','180','1','2000','','','1','0','0','1752660000','','','0','0.0000'),
('264','skating.jpg','20','260','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','16-07-2025 2100','9','180','180','1','2100','','','1','0','0','1752663600','','','0','0.0000'),
('265','skating.jpg','21','262','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','17-07-2025 1000','9','180','180','1','1000','','','1','0','0','1752710400','','','0','0.0000'),
('266','skating.jpg','21','263','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','17-07-2025 1100','9','180','180','1','1100','','','1','0','0','1752714000','','','0','0.0000'),
('267','skating.jpg','21','264','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','17-07-2025 1200','9','180','180','1','1200','','','1','0','0','1752717600','','','0','0.0000'),
('268','skating.jpg','21','265','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','17-07-2025 1300','9','180','180','1','1300','','','1','0','0','1752721200','','','0','0.0000'),
('269','skating.jpg','21','266','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','17-07-2025 1400','9','180','180','1','1400','','','1','0','0','1752724800','','','0','0.0000'),
('270','skating.jpg','21','267','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','17-07-2025 1500','9','180','180','1','1500','','','1','0','0','1752728400','','','0','0.0000'),
('271','skating.jpg','21','268','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','17-07-2025 1600','9','180','180','1','1600','','','1','0','0','1752732000','','','0','0.0000'),
('272','skating.jpg','21','269','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','17-07-2025 1700','9','180','180','1','1700','','','1','0','0','1752735600','','','0','0.0000'),
('273','skating.jpg','21','270','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','17-07-2025 1800','9','180','180','1','1800','','','1','0','0','1752739200','','','0','0.0000'),
('274','skating.jpg','21','271','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','17-07-2025 1900','9','180','180','1','1900','','','1','0','0','1752742800','','','0','0.0000'),
('275','skating.jpg','21','272','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','17-07-2025 2000','9','180','180','1','2000','','','1','0','0','1752746400','','','0','0.0000'),
('276','skating.jpg','21','273','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','17-07-2025 2100','9','180','180','1','2100','','','1','0','0','1752750000','','','0','0.0000'),
('277','skating.jpg','22','274','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','18-07-2025 1000','9','180','180','1','1000','','','1','0','0','1752796800','','','0','0.0000'),
('278','skating.jpg','22','275','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','18-07-2025 1100','9','180','180','1','1100','','','1','0','0','1752800400','','','0','0.0000'),
('279','skating.jpg','22','276','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','18-07-2025 1200','9','180','180','1','1200','','','1','0','0','1752804000','','','0','0.0000'),
('280','skating.jpg','22','277','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','18-07-2025 1300','9','180','180','1','1300','','','1','0','0','1752807600','','','0','0.0000');
insert into `categories` (`categories_id`, `categories_image`, `parent_id`, `sort_order`, `date_added`, `last_modified`, `categories_status`, `categories_products_lock`, `date_id`, `plan_id`, `categories_quantity`, `categories_quantity_remaining`, `categories_GA`, `categories_image_2`, `color_code`, `manufacturers_id`, `categories_is_printable`, `section_id`, `categories_shipping`, `concert_date_unix`, `categories_image_3`, `categories_image_4`, `bg_height`, `categories_advance_fee`) values ('281','skating.jpg','22','278','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','18-07-2025 1400','9','180','180','1','1400','','','1','0','0','1752811200','','','0','0.0000'),
('282','skating.jpg','22','279','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','18-07-2025 1500','9','180','180','1','1500','','','1','0','0','1752814800','','','0','0.0000'),
('283','skating.jpg','22','280','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','18-07-2025 1600','9','180','180','1','1600','','','1','0','0','1752818400','','','0','0.0000'),
('284','skating.jpg','22','281','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','18-07-2025 1700','9','180','180','1','1700','','','1','0','0','1752822000','','','0','0.0000'),
('285','skating.jpg','22','282','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','18-07-2025 1800','9','180','180','1','1800','','','1','0','0','1752825600','','','0','0.0000'),
('286','skating.jpg','22','283','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','18-07-2025 1900','9','180','180','1','1900','','','1','0','0','1752829200','','','0','0.0000'),
('287','skating.jpg','22','284','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','18-07-2025 2000','9','180','180','1','2000','','','1','0','0','1752832800','','','0','0.0000'),
('288','skating.jpg','22','285','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','18-07-2025 2100','9','180','180','1','2100','','','1','0','0','1752836400','','','0','0.0000'),
('289','skating.jpg','23','287','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','19-07-2025 1000','9','180','180','1','1000','','','1','0','0','1752883200','','','0','0.0000'),
('290','skating.jpg','23','288','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','19-07-2025 1100','9','180','180','1','1100','','','1','0','0','1752886800','','','0','0.0000'),
('291','skating.jpg','23','289','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','19-07-2025 1200','9','180','180','1','1200','','','1','0','0','1752890400','','','0','0.0000'),
('292','skating.jpg','23','290','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','19-07-2025 1300','9','180','180','1','1300','','','1','0','0','1752894000','','','0','0.0000'),
('293','skating.jpg','23','291','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','19-07-2025 1400','9','180','180','1','1400','','','1','0','0','1752897600','','','0','0.0000'),
('294','skating.jpg','23','292','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','19-07-2025 1500','9','180','180','1','1500','','','1','0','0','1752901200','','','0','0.0000'),
('295','skating.jpg','23','293','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','19-07-2025 1600','9','180','180','1','1600','','','1','0','0','1752904800','','','0','0.0000'),
('296','skating.jpg','23','294','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','19-07-2025 1700','9','180','180','1','1700','','','1','0','0','1752908400','','','0','0.0000'),
('297','skating.jpg','23','295','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','19-07-2025 1800','9','180','180','1','1800','','','1','0','0','1752912000','','','0','0.0000'),
('298','skating.jpg','23','296','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','19-07-2025 1900','9','180','180','1','1900','','','1','0','0','1752915600','','','0','0.0000'),
('299','skating.jpg','23','297','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','19-07-2025 2000','9','180','180','1','2000','','','1','0','0','1752919200','','','0','0.0000'),
('300','skating.jpg','23','298','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','19-07-2025 2100','9','180','180','1','2100','','','1','0','0','1752922800','','','0','0.0000');
insert into `categories` (`categories_id`, `categories_image`, `parent_id`, `sort_order`, `date_added`, `last_modified`, `categories_status`, `categories_products_lock`, `date_id`, `plan_id`, `categories_quantity`, `categories_quantity_remaining`, `categories_GA`, `categories_image_2`, `color_code`, `manufacturers_id`, `categories_is_printable`, `section_id`, `categories_shipping`, `concert_date_unix`, `categories_image_3`, `categories_image_4`, `bg_height`, `categories_advance_fee`) values ('301','skating.jpg','24','300','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','20-07-2025 1000','9','180','180','1','1000','','','1','0','0','1752969600','','','0','0.0000'),
('302','skating.jpg','24','301','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','20-07-2025 1100','9','180','180','1','1100','','','1','0','0','1752973200','','','0','0.0000'),
('303','skating.jpg','24','302','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','20-07-2025 1200','9','180','180','1','1200','','','1','0','0','1752976800','','','0','0.0000'),
('304','skating.jpg','24','303','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','20-07-2025 1300','9','180','180','1','1300','','','1','0','0','1752980400','','','0','0.0000'),
('305','skating.jpg','24','304','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','20-07-2025 1400','9','180','180','1','1400','','','1','0','0','1752984000','','','0','0.0000'),
('306','skating.jpg','24','305','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','20-07-2025 1500','9','180','180','1','1500','','','1','0','0','1752987600','','','0','0.0000'),
('307','skating.jpg','24','306','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','20-07-2025 1600','9','180','180','1','1600','','','1','0','0','1752991200','','','0','0.0000'),
('308','skating.jpg','24','307','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','20-07-2025 1700','9','180','180','1','1700','','','1','0','0','1752994800','','','0','0.0000'),
('309','skating.jpg','24','308','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','20-07-2025 1800','9','180','180','1','1800','','','1','0','0','1752998400','','','0','0.0000'),
('310','skating.jpg','24','309','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','20-07-2025 1900','9','180','180','1','1900','','','1','0','0','1753002000','','','0','0.0000'),
('311','skating.jpg','24','310','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','20-07-2025 2000','9','180','180','1','2000','','','1','0','0','1753005600','','','0','0.0000'),
('312','skating.jpg','24','311','0000-00-00 00:00:00','0000-00-00 00:00:00','1','1','20-07-2025 2100','9','180','180','1','2100','','','1','0','0','1753009200','','','0','0.0000');

drop table if exists `categories_description`;
CREATE TABLE `categories_description` (
  `categories_id` int(11) NOT NULL DEFAULT 0,
  `language_id` int(11) NOT NULL DEFAULT 1,
  `categories_name` varchar(128) NOT NULL,
  `categories_heading_title` varchar(128) DEFAULT NULL,
  `categories_description` text DEFAULT NULL,
  `concert_venue` varchar(128) NOT NULL,
  `concert_date` varchar(28) NOT NULL,
  `concert_time` varchar(8) NOT NULL,
  `venue_id` varchar(64) NOT NULL,
  `section_id` int(11) NOT NULL,
  PRIMARY KEY (`categories_id`,`language_id`),
  KEY `idx_categories_name` (`categories_name`)
);

insert into `categories_description` (`categories_id`, `language_id`, `categories_name`, `categories_heading_title`, `categories_description`, `concert_venue`, `concert_date`, `concert_time`, `venue_id`, `section_id`) values ('1','1','Friday','Friday','','Darling Harbour','27-06-2025','','1','1'),
('2','1','Saturday','Saturday','','Darling Harbour','28-06-2025','','2','2'),
('3','1','Sunday','Sunday','','Darling Harbour','29-06-2025','','3','3'),
('4','1','Monday','Monday','','Darling Harbour','30-06-2025','','4','4'),
('5','1','Tuesday','Tuesday','','Darling Harbour','01-07-2025','','5','5'),
('6','1','Wednesday','Wednesday','','Darling Harbour','02-07-2025','','6','6'),
('7','1','Thursday','Thursday','','Darling Harbour','03-07-2025','','7','7'),
('8','1','Friday','Friday','','Darling Harbour','04-07-2025','','8','8'),
('9','1','Saturday','Saturday','','Darling Harbour','05-07-2025','','9','9'),
('10','1','Sunday','Sunday','','Darling Harbour','06-07-2025','','10','10'),
('11','1','Monday','Monday','','Darling Harbour','07-07-2025','','11','11'),
('12','1','Tuesday','Tuesday','','Darling Harbour','08-07-2025','','12','12'),
('13','1','Wednesday','Wednesday','','Darling Harbour','09-07-2025','','13','13'),
('14','1','Thursday','Thursday','','Darling Harbour','10-07-2025','','14','14'),
('15','1','Friday','Friday','','Darling Harbour','11-07-2025','','15','15'),
('16','1','Saturday','Saturday','','Darling Harbour','12-07-2025','','16','16'),
('17','1','Sunday','Sunday','','Darling Harbour','13-07-2025','','17','17'),
('18','1','Monday','Monday','','Darling Harbour','14-07-2025','','18','18'),
('19','1','Tuesday','Tuesday','','Darling Harbour','15-07-2025','','19','19'),
('20','1','Wednesday','Wednesday','','Darling Harbour','16-07-2025','','20','20');
insert into `categories_description` (`categories_id`, `language_id`, `categories_name`, `categories_heading_title`, `categories_description`, `concert_venue`, `concert_date`, `concert_time`, `venue_id`, `section_id`) values ('21','1','Thursday','Thursday','','Darling Harbour','17-07-2025','','21','21'),
('22','1','Friday','Friday','','Darling Harbour','18-07-2025','','22','22'),
('23','1','Saturday','Saturday','','Darling Harbour','19-07-2025','','23','23'),
('24','1','Sunday','Sunday','','Darling Harbour','20-07-2025','','24','24'),
('25','1','10:00 AM','Public Skating','','Darling Harbour','27-06-2025','1000','1','1'),
('26','1','11:00 AM','Public Skating','','Darling Harbour','27-06-2025','1100','1','1'),
('27','1','12:00 PM','Public Skating','','Darling Harbour','27-06-2025','1200','1','1'),
('28','1','1:00 PM','Public Skating','','Darling Harbour','27-06-2025','1300','1','1'),
('29','1','2:00 PM','Public Skating','','Darling Harbour','27-06-2025','1400','1','1'),
('30','1','3:00 PM','Public Skating','','Darling Harbour','27-06-2025','1500','1','1'),
('31','1','4:00 PM','Public Skating','','Darling Harbour','27-06-2025','1600','1','1'),
('32','1','5:00 PM','Public Skating','','Darling Harbour','27-06-2025','1700','1','1'),
('33','1','6:00 PM','Public Skating','','Darling Harbour','27-06-2025','1800','1','1'),
('34','1','7:00 PM','Public Skating','','Darling Harbour','27-06-2025','1900','1','1'),
('35','1','8:00 PM','Public Skating','','Darling Harbour','27-06-2025','2000','1','1'),
('36','1','9:00 PM','Public Skating','','Darling Harbour','27-06-2025','2100','1','1'),
('37','1','10:00 AM','Public Skating','','Darling Harbour','28-06-2025','1000','2','2'),
('38','1','11:00 AM','Public Skating','','Darling Harbour','28-06-2025','1100','2','2'),
('39','1','12:00 PM','Public Skating','','Darling Harbour','28-06-2025','1200','2','2'),
('40','1','1:00 PM','Public Skating','','Darling Harbour','28-06-2025','1300','2','2');
insert into `categories_description` (`categories_id`, `language_id`, `categories_name`, `categories_heading_title`, `categories_description`, `concert_venue`, `concert_date`, `concert_time`, `venue_id`, `section_id`) values ('41','1','2:00 PM','Public Skating','','Darling Harbour','28-06-2025','1400','2','2'),
('42','1','3:00 PM','Public Skating','','Darling Harbour','28-06-2025','1500','2','2'),
('43','1','4:00 PM','Public Skating','','Darling Harbour','28-06-2025','1600','2','2'),
('44','1','5:00 PM','Public Skating','','Darling Harbour','28-06-2025','1700','2','2'),
('45','1','6:00 PM','Public Skating','','Darling Harbour','28-06-2025','1800','2','2'),
('46','1','7:00 PM','Public Skating','','Darling Harbour','28-06-2025','1900','2','2'),
('47','1','8:00 PM','Public Skating','','Darling Harbour','28-06-2025','2000','2','2'),
('48','1','9:00 PM','Public Skating','','Darling Harbour','28-06-2025','2100','2','2'),
('49','1','10:00 AM','Public Skating','','Darling Harbour','29-06-2025','1000','3','3'),
('50','1','11:00 AM','Public Skating','','Darling Harbour','29-06-2025','1100','3','3'),
('51','1','12:00 PM','Public Skating','','Darling Harbour','29-06-2025','1200','3','3'),
('52','1','1:00 PM','Public Skating','','Darling Harbour','29-06-2025','1300','3','3'),
('53','1','2:00 PM','Public Skating','','Darling Harbour','29-06-2025','1400','3','3'),
('54','1','3:00 PM','Public Skating','','Darling Harbour','29-06-2025','1500','3','3'),
('55','1','4:00 PM','Public Skating','','Darling Harbour','29-06-2025','1600','3','3'),
('56','1','5:00 PM','Public Skating','','Darling Harbour','29-06-2025','1700','3','3'),
('57','1','6:00 PM','Public Skating','','Darling Harbour','29-06-2025','1800','3','3'),
('58','1','7:00 PM','Public Skating','','Darling Harbour','29-06-2025','1900','3','3'),
('59','1','8:00 PM','Public Skating','','Darling Harbour','29-06-2025','2000','3','3'),
('60','1','9:00 PM','Public Skating','','Darling Harbour','29-06-2025','2100','3','3');
insert into `categories_description` (`categories_id`, `language_id`, `categories_name`, `categories_heading_title`, `categories_description`, `concert_venue`, `concert_date`, `concert_time`, `venue_id`, `section_id`) values ('61','1','10:00 AM','Public Skating','','Darling Harbour','30-06-2025','1000','4','4'),
('62','1','11:00 AM','Public Skating','','Darling Harbour','30-06-2025','1100','4','4'),
('63','1','12:00 PM','Public Skating','','Darling Harbour','30-06-2025','1200','4','4'),
('64','1','1:00 PM','Public Skating','','Darling Harbour','30-06-2025','1300','4','4'),
('65','1','2:00 PM','Public Skating','','Darling Harbour','30-06-2025','1400','4','4'),
('66','1','3:00 PM','Public Skating','','Darling Harbour','30-06-2025','1500','4','4'),
('67','1','4:00 PM','Public Skating','','Darling Harbour','30-06-2025','1600','4','4'),
('68','1','5:00 PM','Public Skating','','Darling Harbour','30-06-2025','1700','4','4'),
('69','1','6:00 PM','Public Skating','','Darling Harbour','30-06-2025','1800','4','4'),
('70','1','7:00 PM','Public Skating','','Darling Harbour','30-06-2025','1900','4','4'),
('71','1','8:00 PM','Public Skating','','Darling Harbour','30-06-2025','2000','4','4'),
('72','1','9:00 PM','Public Skating','','Darling Harbour','30-06-2025','2100','4','4'),
('73','1','10:00 AM','Public Skating','','Darling Harbour','01-07-2025','1000','5','5'),
('74','1','11:00 AM','Public Skating','','Darling Harbour','01-07-2025','1100','5','5'),
('75','1','12:00 PM','Public Skating','','Darling Harbour','01-07-2025','1200','5','5'),
('76','1','1:00 PM','Public Skating','','Darling Harbour','01-07-2025','1300','5','5'),
('77','1','2:00 PM','Public Skating','','Darling Harbour','01-07-2025','1400','5','5'),
('78','1','3:00 PM','Public Skating','','Darling Harbour','01-07-2025','1500','5','5'),
('79','1','4:00 PM','Public Skating','','Darling Harbour','01-07-2025','1600','5','5'),
('80','1','5:00 PM','Public Skating','','Darling Harbour','01-07-2025','1700','5','5');
insert into `categories_description` (`categories_id`, `language_id`, `categories_name`, `categories_heading_title`, `categories_description`, `concert_venue`, `concert_date`, `concert_time`, `venue_id`, `section_id`) values ('81','1','6:00 PM','Public Skating','','Darling Harbour','01-07-2025','1800','5','5'),
('82','1','7:00 PM','Public Skating','','Darling Harbour','01-07-2025','1900','5','5'),
('83','1','8:00 PM','Public Skating','','Darling Harbour','01-07-2025','2000','5','5'),
('84','1','9:00 PM','Public Skating','','Darling Harbour','01-07-2025','2100','5','5'),
('85','1','10:00 AM','Public Skating','','Darling Harbour','02-07-2025','1000','6','6'),
('86','1','11:00 AM','Public Skating','','Darling Harbour','02-07-2025','1100','6','6'),
('87','1','12:00 PM','Public Skating','','Darling Harbour','02-07-2025','1200','6','6'),
('88','1','1:00 PM','Public Skating','','Darling Harbour','02-07-2025','1300','6','6'),
('89','1','2:00 PM','Public Skating','','Darling Harbour','02-07-2025','1400','6','6'),
('90','1','3:00 PM','Public Skating','','Darling Harbour','02-07-2025','1500','6','6'),
('91','1','4:00 PM','Public Skating','','Darling Harbour','02-07-2025','1600','6','6'),
('92','1','5:00 PM','Public Skating','','Darling Harbour','02-07-2025','1700','6','6'),
('93','1','6:00 PM','Public Skating','','Darling Harbour','02-07-2025','1800','6','6'),
('94','1','7:00 PM','Public Skating','','Darling Harbour','02-07-2025','1900','6','6'),
('95','1','8:00 PM','Public Skating','','Darling Harbour','02-07-2025','2000','6','6'),
('96','1','9:00 PM','Public Skating','','Darling Harbour','02-07-2025','2100','6','6'),
('97','1','10:00 AM','Public Skating','','Darling Harbour','03-07-2025','1000','7','7'),
('98','1','11:00 AM','Public Skating','','Darling Harbour','03-07-2025','1100','7','7'),
('99','1','12:00 PM','Public Skating','','Darling Harbour','03-07-2025','1200','7','7'),
('100','1','1:00 PM','Public Skating','','Darling Harbour','03-07-2025','1300','7','7');
insert into `categories_description` (`categories_id`, `language_id`, `categories_name`, `categories_heading_title`, `categories_description`, `concert_venue`, `concert_date`, `concert_time`, `venue_id`, `section_id`) values ('101','1','2:00 PM','Public Skating','','Darling Harbour','03-07-2025','1400','7','7'),
('102','1','3:00 PM','Public Skating','','Darling Harbour','03-07-2025','1500','7','7'),
('103','1','4:00 PM','Public Skating','','Darling Harbour','03-07-2025','1600','7','7'),
('104','1','5:00 PM','Public Skating','','Darling Harbour','03-07-2025','1700','7','7'),
('105','1','6:00 PM','Public Skating','','Darling Harbour','03-07-2025','1800','7','7'),
('106','1','7:00 PM','Public Skating','','Darling Harbour','03-07-2025','1900','7','7'),
('107','1','8:00 PM','Public Skating','','Darling Harbour','03-07-2025','2000','7','7'),
('108','1','9:00 PM','Public Skating','','Darling Harbour','03-07-2025','2100','7','7'),
('109','1','10:00 AM','Public Skating','','Darling Harbour','04-07-2025','1000','8','8'),
('110','1','11:00 AM','Public Skating','','Darling Harbour','04-07-2025','1100','8','8'),
('111','1','12:00 PM','Public Skating','','Darling Harbour','04-07-2025','1200','8','8'),
('112','1','1:00 PM','Public Skating','','Darling Harbour','04-07-2025','1300','8','8'),
('113','1','2:00 PM','Public Skating','','Darling Harbour','04-07-2025','1400','8','8'),
('114','1','3:00 PM','Public Skating','','Darling Harbour','04-07-2025','1500','8','8'),
('115','1','4:00 PM','Public Skating','','Darling Harbour','04-07-2025','1600','8','8'),
('116','1','5:00 PM','Public Skating','','Darling Harbour','04-07-2025','1700','8','8'),
('117','1','6:00 PM','Public Skating','','Darling Harbour','04-07-2025','1800','8','8'),
('118','1','7:00 PM','Public Skating','','Darling Harbour','04-07-2025','1900','8','8'),
('119','1','8:00 PM','Public Skating','','Darling Harbour','04-07-2025','2000','8','8'),
('120','1','9:00 PM','Public Skating','','Darling Harbour','04-07-2025','2100','8','8');
insert into `categories_description` (`categories_id`, `language_id`, `categories_name`, `categories_heading_title`, `categories_description`, `concert_venue`, `concert_date`, `concert_time`, `venue_id`, `section_id`) values ('121','1','10:00 AM','Public Skating','','Darling Harbour','05-07-2025','1000','9','9'),
('122','1','11:00 AM','Public Skating','','Darling Harbour','05-07-2025','1100','9','9'),
('123','1','12:00 PM','Public Skating','','Darling Harbour','05-07-2025','1200','9','9'),
('124','1','1:00 PM','Public Skating','','Darling Harbour','05-07-2025','1300','9','9'),
('125','1','2:00 PM','Public Skating','','Darling Harbour','05-07-2025','1400','9','9'),
('126','1','3:00 PM','Public Skating','','Darling Harbour','05-07-2025','1500','9','9'),
('127','1','4:00 PM','Public Skating','','Darling Harbour','05-07-2025','1600','9','9'),
('128','1','5:00 PM','Public Skating','','Darling Harbour','05-07-2025','1700','9','9'),
('129','1','6:00 PM','Public Skating','','Darling Harbour','05-07-2025','1800','9','9'),
('130','1','7:00 PM','Public Skating','','Darling Harbour','05-07-2025','1900','9','9'),
('131','1','8:00 PM','Public Skating','','Darling Harbour','05-07-2025','2000','9','9'),
('132','1','9:00 PM','Public Skating','','Darling Harbour','05-07-2025','2100','9','9'),
('133','1','10:00 AM','Public Skating','','Darling Harbour','06-07-2025','1000','10','10'),
('134','1','11:00 AM','Public Skating','','Darling Harbour','06-07-2025','1100','10','10'),
('135','1','12:00 PM','Public Skating','','Darling Harbour','06-07-2025','1200','10','10'),
('136','1','1:00 PM','Public Skating','','Darling Harbour','06-07-2025','1300','10','10'),
('137','1','2:00 PM','Public Skating','','Darling Harbour','06-07-2025','1400','10','10'),
('138','1','3:00 PM','Public Skating','','Darling Harbour','06-07-2025','1500','10','10'),
('139','1','4:00 PM','Public Skating','','Darling Harbour','06-07-2025','1600','10','10'),
('140','1','5:00 PM','Public Skating','','Darling Harbour','06-07-2025','1700','10','10');
insert into `categories_description` (`categories_id`, `language_id`, `categories_name`, `categories_heading_title`, `categories_description`, `concert_venue`, `concert_date`, `concert_time`, `venue_id`, `section_id`) values ('141','1','6:00 PM','Public Skating','','Darling Harbour','06-07-2025','1800','10','10'),
('142','1','7:00 PM','Public Skating','','Darling Harbour','06-07-2025','1900','10','10'),
('143','1','8:00 PM','Public Skating','','Darling Harbour','06-07-2025','2000','10','10'),
('144','1','9:00 PM','Public Skating','','Darling Harbour','06-07-2025','2100','10','10'),
('145','1','10:00 AM','Public Skating','','Darling Harbour','07-07-2025','1000','11','11'),
('146','1','11:00 AM','Public Skating','','Darling Harbour','07-07-2025','1100','11','11'),
('147','1','12:00 PM','Public Skating','','Darling Harbour','07-07-2025','1200','11','11'),
('148','1','1:00 PM','Public Skating','','Darling Harbour','07-07-2025','1300','11','11'),
('149','1','2:00 PM','Public Skating','','Darling Harbour','07-07-2025','1400','11','11'),
('150','1','3:00 PM','Public Skating','','Darling Harbour','07-07-2025','1500','11','11'),
('151','1','4:00 PM','Public Skating','','Darling Harbour','07-07-2025','1600','11','11'),
('152','1','5:00 PM','Public Skating','','Darling Harbour','07-07-2025','1700','11','11'),
('153','1','6:00 PM','Public Skating','','Darling Harbour','07-07-2025','1800','11','11'),
('154','1','7:00 PM','Public Skating','','Darling Harbour','07-07-2025','1900','11','11'),
('155','1','8:00 PM','Public Skating','','Darling Harbour','07-07-2025','2000','11','11'),
('156','1','9:00 PM','Public Skating','','Darling Harbour','07-07-2025','2100','11','11'),
('157','1','10:00 AM','Public Skating','','Darling Harbour','08-07-2025','1000','12','12'),
('158','1','11:00 AM','Public Skating','','Darling Harbour','08-07-2025','1100','12','12'),
('159','1','12:00 PM','Public Skating','','Darling Harbour','08-07-2025','1200','12','12'),
('160','1','1:00 PM','Public Skating','','Darling Harbour','08-07-2025','1300','12','12');
insert into `categories_description` (`categories_id`, `language_id`, `categories_name`, `categories_heading_title`, `categories_description`, `concert_venue`, `concert_date`, `concert_time`, `venue_id`, `section_id`) values ('161','1','2:00 PM','Public Skating','','Darling Harbour','08-07-2025','1400','12','12'),
('162','1','3:00 PM','Public Skating','','Darling Harbour','08-07-2025','1500','12','12'),
('163','1','4:00 PM','Public Skating','','Darling Harbour','08-07-2025','1600','12','12'),
('164','1','5:00 PM','Public Skating','','Darling Harbour','08-07-2025','1700','12','12'),
('165','1','6:00 PM','Public Skating','','Darling Harbour','08-07-2025','1800','12','12'),
('166','1','7:00 PM','Public Skating','','Darling Harbour','08-07-2025','1900','12','12'),
('167','1','8:00 PM','Public Skating','','Darling Harbour','08-07-2025','2000','12','12'),
('168','1','9:00 PM','Public Skating','','Darling Harbour','08-07-2025','2100','12','12'),
('169','1','10:00 AM','Public Skating','','Darling Harbour','09-07-2025','1000','13','13'),
('170','1','11:00 AM','Public Skating','','Darling Harbour','09-07-2025','1100','13','13'),
('171','1','12:00 PM','Public Skating','','Darling Harbour','09-07-2025','1200','13','13'),
('172','1','1:00 PM','Public Skating','','Darling Harbour','09-07-2025','1300','13','13'),
('173','1','2:00 PM','Public Skating','','Darling Harbour','09-07-2025','1400','13','13'),
('174','1','3:00 PM','Public Skating','','Darling Harbour','09-07-2025','1500','13','13'),
('175','1','4:00 PM','Public Skating','','Darling Harbour','09-07-2025','1600','13','13'),
('176','1','5:00 PM','Public Skating','','Darling Harbour','09-07-2025','1700','13','13'),
('177','1','6:00 PM','Public Skating','','Darling Harbour','09-07-2025','1800','13','13'),
('178','1','7:00 PM','Public Skating','','Darling Harbour','09-07-2025','1900','13','13'),
('179','1','8:00 PM','Public Skating','','Darling Harbour','09-07-2025','2000','13','13'),
('180','1','9:00 PM','Public Skating','','Darling Harbour','09-07-2025','2100','13','13');
insert into `categories_description` (`categories_id`, `language_id`, `categories_name`, `categories_heading_title`, `categories_description`, `concert_venue`, `concert_date`, `concert_time`, `venue_id`, `section_id`) values ('181','1','10:00 AM','Public Skating','','Darling Harbour','10-07-2025','1000','14','14'),
('182','1','11:00 AM','Public Skating','','Darling Harbour','10-07-2025','1100','14','14'),
('183','1','12:00 PM','Public Skating','','Darling Harbour','10-07-2025','1200','14','14'),
('184','1','1:00 PM','Public Skating','','Darling Harbour','10-07-2025','1300','14','14'),
('185','1','2:00 PM','Public Skating','','Darling Harbour','10-07-2025','1400','14','14'),
('186','1','3:00 PM','Public Skating','','Darling Harbour','10-07-2025','1500','14','14'),
('187','1','4:00 PM','Public Skating','','Darling Harbour','10-07-2025','1600','14','14'),
('188','1','5:00 PM','Public Skating','','Darling Harbour','10-07-2025','1700','14','14'),
('189','1','6:00 PM','Public Skating','','Darling Harbour','10-07-2025','1800','14','14'),
('190','1','7:00 PM','Public Skating','','Darling Harbour','10-07-2025','1900','14','14'),
('191','1','8:00 PM','Public Skating','','Darling Harbour','10-07-2025','2000','14','14'),
('192','1','9:00 PM','Public Skating','','Darling Harbour','10-07-2025','2100','14','14'),
('193','1','10:00 AM','Public Skating','','Darling Harbour','11-07-2025','1000','15','15'),
('194','1','11:00 AM','Public Skating','','Darling Harbour','11-07-2025','1100','15','15'),
('195','1','12:00 PM','Public Skating','','Darling Harbour','11-07-2025','1200','15','15'),
('196','1','1:00 PM','Public Skating','','Darling Harbour','11-07-2025','1300','15','15'),
('197','1','2:00 PM','Public Skating','','Darling Harbour','11-07-2025','1400','15','15'),
('198','1','3:00 PM','Public Skating','','Darling Harbour','11-07-2025','1500','15','15'),
('199','1','4:00 PM','Public Skating','','Darling Harbour','11-07-2025','1600','15','15'),
('200','1','5:00 PM','Public Skating','','Darling Harbour','11-07-2025','1700','15','15');
insert into `categories_description` (`categories_id`, `language_id`, `categories_name`, `categories_heading_title`, `categories_description`, `concert_venue`, `concert_date`, `concert_time`, `venue_id`, `section_id`) values ('201','1','6:00 PM','Public Skating','','Darling Harbour','11-07-2025','1800','15','15'),
('202','1','7:00 PM','Public Skating','','Darling Harbour','11-07-2025','1900','15','15'),
('203','1','8:00 PM','Public Skating','','Darling Harbour','11-07-2025','2000','15','15'),
('204','1','9:00 PM','Public Skating','','Darling Harbour','11-07-2025','2100','15','15'),
('205','1','10:00 AM','Public Skating','','Darling Harbour','12-07-2025','1000','16','16'),
('206','1','11:00 AM','Public Skating','','Darling Harbour','12-07-2025','1100','16','16'),
('207','1','12:00 PM','Public Skating','','Darling Harbour','12-07-2025','1200','16','16'),
('208','1','1:00 PM','Public Skating','','Darling Harbour','12-07-2025','1300','16','16'),
('209','1','2:00 PM','Public Skating','','Darling Harbour','12-07-2025','1400','16','16'),
('210','1','3:00 PM','Public Skating','','Darling Harbour','12-07-2025','1500','16','16'),
('211','1','4:00 PM','Public Skating','','Darling Harbour','12-07-2025','1600','16','16'),
('212','1','5:00 PM','Public Skating','','Darling Harbour','12-07-2025','1700','16','16'),
('213','1','6:00 PM','Public Skating','','Darling Harbour','12-07-2025','1800','16','16'),
('214','1','7:00 PM','Public Skating','','Darling Harbour','12-07-2025','1900','16','16'),
('215','1','8:00 PM','Public Skating','','Darling Harbour','12-07-2025','2000','16','16'),
('216','1','9:00 PM','Public Skating','','Darling Harbour','12-07-2025','2100','16','16'),
('217','1','10:00 AM','Public Skating','','Darling Harbour','13-07-2025','1000','17','17'),
('218','1','11:00 AM','Public Skating','','Darling Harbour','13-07-2025','1100','17','17'),
('219','1','12:00 PM','Public Skating','','Darling Harbour','13-07-2025','1200','17','17'),
('220','1','1:00 PM','Public Skating','','Darling Harbour','13-07-2025','1300','17','17');
insert into `categories_description` (`categories_id`, `language_id`, `categories_name`, `categories_heading_title`, `categories_description`, `concert_venue`, `concert_date`, `concert_time`, `venue_id`, `section_id`) values ('221','1','2:00 PM','Public Skating','','Darling Harbour','13-07-2025','1400','17','17'),
('222','1','3:00 PM','Public Skating','','Darling Harbour','13-07-2025','1500','17','17'),
('223','1','4:00 PM','Public Skating','','Darling Harbour','13-07-2025','1600','17','17'),
('224','1','5:00 PM','Public Skating','','Darling Harbour','13-07-2025','1700','17','17'),
('225','1','6:00 PM','Public Skating','','Darling Harbour','13-07-2025','1800','17','17'),
('226','1','7:00 PM','Public Skating','','Darling Harbour','13-07-2025','1900','17','17'),
('227','1','8:00 PM','Public Skating','','Darling Harbour','13-07-2025','2000','17','17'),
('228','1','9:00 PM','Public Skating','','Darling Harbour','13-07-2025','2100','17','17'),
('229','1','10:00 AM','Public Skating','','Darling Harbour','14-07-2025','1000','18','18'),
('230','1','11:00 AM','Public Skating','','Darling Harbour','14-07-2025','1100','18','18'),
('231','1','12:00 PM','Public Skating','','Darling Harbour','14-07-2025','1200','18','18'),
('232','1','1:00 PM','Public Skating','','Darling Harbour','14-07-2025','1300','18','18'),
('233','1','2:00 PM','Public Skating','','Darling Harbour','14-07-2025','1400','18','18'),
('234','1','3:00 PM','Public Skating','','Darling Harbour','14-07-2025','1500','18','18'),
('235','1','4:00 PM','Public Skating','','Darling Harbour','14-07-2025','1600','18','18'),
('236','1','5:00 PM','Public Skating','','Darling Harbour','14-07-2025','1700','18','18'),
('237','1','6:00 PM','Public Skating','','Darling Harbour','14-07-2025','1800','18','18'),
('238','1','7:00 PM','Public Skating','','Darling Harbour','14-07-2025','1900','18','18'),
('239','1','8:00 PM','Public Skating','','Darling Harbour','14-07-2025','2000','18','18'),
('240','1','9:00 PM','Public Skating','','Darling Harbour','14-07-2025','2100','18','18');
insert into `categories_description` (`categories_id`, `language_id`, `categories_name`, `categories_heading_title`, `categories_description`, `concert_venue`, `concert_date`, `concert_time`, `venue_id`, `section_id`) values ('241','1','10:00 AM','Public Skating','','Darling Harbour','15-07-2025','1000','19','19'),
('242','1','11:00 AM','Public Skating','','Darling Harbour','15-07-2025','1100','19','19'),
('243','1','12:00 PM','Public Skating','','Darling Harbour','15-07-2025','1200','19','19'),
('244','1','1:00 PM','Public Skating','','Darling Harbour','15-07-2025','1300','19','19'),
('245','1','2:00 PM','Public Skating','','Darling Harbour','15-07-2025','1400','19','19'),
('246','1','3:00 PM','Public Skating','','Darling Harbour','15-07-2025','1500','19','19'),
('247','1','4:00 PM','Public Skating','','Darling Harbour','15-07-2025','1600','19','19'),
('248','1','5:00 PM','Public Skating','','Darling Harbour','15-07-2025','1700','19','19'),
('249','1','6:00 PM','Public Skating','','Darling Harbour','15-07-2025','1800','19','19'),
('250','1','7:00 PM','Public Skating','','Darling Harbour','15-07-2025','1900','19','19'),
('251','1','8:00 PM','Public Skating','','Darling Harbour','15-07-2025','2000','19','19'),
('252','1','9:00 PM','Public Skating','','Darling Harbour','15-07-2025','2100','19','19'),
('253','1','10:00 AM','Public Skating','','Darling Harbour','16-07-2025','1000','20','20'),
('254','1','11:00 AM','Public Skating','','Darling Harbour','16-07-2025','1100','20','20'),
('255','1','12:00 PM','Public Skating','','Darling Harbour','16-07-2025','1200','20','20'),
('256','1','1:00 PM','Public Skating','','Darling Harbour','16-07-2025','1300','20','20'),
('257','1','2:00 PM','Public Skating','','Darling Harbour','16-07-2025','1400','20','20'),
('258','1','3:00 PM','Public Skating','','Darling Harbour','16-07-2025','1500','20','20'),
('259','1','4:00 PM','Public Skating','','Darling Harbour','16-07-2025','1600','20','20'),
('260','1','5:00 PM','Public Skating','','Darling Harbour','16-07-2025','1700','20','20');
insert into `categories_description` (`categories_id`, `language_id`, `categories_name`, `categories_heading_title`, `categories_description`, `concert_venue`, `concert_date`, `concert_time`, `venue_id`, `section_id`) values ('261','1','6:00 PM','Public Skating','','Darling Harbour','16-07-2025','1800','20','20'),
('262','1','7:00 PM','Public Skating','','Darling Harbour','16-07-2025','1900','20','20'),
('263','1','8:00 PM','Public Skating','','Darling Harbour','16-07-2025','2000','20','20'),
('264','1','9:00 PM','Public Skating','','Darling Harbour','16-07-2025','2100','20','20'),
('265','1','10:00 AM','Public Skating','','Darling Harbour','17-07-2025','1000','21','21'),
('266','1','11:00 AM','Public Skating','','Darling Harbour','17-07-2025','1100','21','21'),
('267','1','12:00 PM','Public Skating','','Darling Harbour','17-07-2025','1200','21','21'),
('268','1','1:00 PM','Public Skating','','Darling Harbour','17-07-2025','1300','21','21'),
('269','1','2:00 PM','Public Skating','','Darling Harbour','17-07-2025','1400','21','21'),
('270','1','3:00 PM','Public Skating','','Darling Harbour','17-07-2025','1500','21','21'),
('271','1','4:00 PM','Public Skating','','Darling Harbour','17-07-2025','1600','21','21'),
('272','1','5:00 PM','Public Skating','','Darling Harbour','17-07-2025','1700','21','21'),
('273','1','6:00 PM','Public Skating','','Darling Harbour','17-07-2025','1800','21','21'),
('274','1','7:00 PM','Public Skating','','Darling Harbour','17-07-2025','1900','21','21'),
('275','1','8:00 PM','Public Skating','','Darling Harbour','17-07-2025','2000','21','21'),
('276','1','9:00 PM','Public Skating','','Darling Harbour','17-07-2025','2100','21','21'),
('277','1','10:00 AM','Public Skating','','Darling Harbour','18-07-2025','1000','22','22'),
('278','1','11:00 AM','Public Skating','','Darling Harbour','18-07-2025','1100','22','22'),
('279','1','12:00 PM','Public Skating','','Darling Harbour','18-07-2025','1200','22','22'),
('280','1','1:00 PM','Public Skating','','Darling Harbour','18-07-2025','1300','22','22');
insert into `categories_description` (`categories_id`, `language_id`, `categories_name`, `categories_heading_title`, `categories_description`, `concert_venue`, `concert_date`, `concert_time`, `venue_id`, `section_id`) values ('281','1','2:00 PM','Public Skating','','Darling Harbour','18-07-2025','1400','22','22'),
('282','1','3:00 PM','Public Skating','','Darling Harbour','18-07-2025','1500','22','22'),
('283','1','4:00 PM','Public Skating','','Darling Harbour','18-07-2025','1600','22','22'),
('284','1','5:00 PM','Public Skating','','Darling Harbour','18-07-2025','1700','22','22'),
('285','1','6:00 PM','Public Skating','','Darling Harbour','18-07-2025','1800','22','22'),
('286','1','7:00 PM','Public Skating','','Darling Harbour','18-07-2025','1900','22','22'),
('287','1','8:00 PM','Public Skating','','Darling Harbour','18-07-2025','2000','22','22'),
('288','1','9:00 PM','Public Skating','','Darling Harbour','18-07-2025','2100','22','22'),
('289','1','10:00 AM','Public Skating','','Darling Harbour','19-07-2025','1000','23','23'),
('290','1','11:00 AM','Public Skating','','Darling Harbour','19-07-2025','1100','23','23'),
('291','1','12:00 PM','Public Skating','','Darling Harbour','19-07-2025','1200','23','23'),
('292','1','1:00 PM','Public Skating','','Darling Harbour','19-07-2025','1300','23','23'),
('293','1','2:00 PM','Public Skating','','Darling Harbour','19-07-2025','1400','23','23'),
('294','1','3:00 PM','Public Skating','','Darling Harbour','19-07-2025','1500','23','23'),
('295','1','4:00 PM','Public Skating','','Darling Harbour','19-07-2025','1600','23','23'),
('296','1','5:00 PM','Public Skating','','Darling Harbour','19-07-2025','1700','23','23'),
('297','1','6:00 PM','Public Skating','','Darling Harbour','19-07-2025','1800','23','23'),
('298','1','7:00 PM','Public Skating','','Darling Harbour','19-07-2025','1900','23','23'),
('299','1','8:00 PM','Public Skating','','Darling Harbour','19-07-2025','2000','23','23'),
('300','1','9:00 PM','Public Skating','','Darling Harbour','19-07-2025','2100','23','23');
insert into `categories_description` (`categories_id`, `language_id`, `categories_name`, `categories_heading_title`, `categories_description`, `concert_venue`, `concert_date`, `concert_time`, `venue_id`, `section_id`) values ('301','1','10:00 AM','Public Skating','','Darling Harbour','20-07-2025','1000','24','24'),
('302','1','11:00 AM','Public Skating','','Darling Harbour','20-07-2025','1100','24','24'),
('303','1','12:00 PM','Public Skating','','Darling Harbour','20-07-2025','1200','24','24'),
('304','1','1:00 PM','Public Skating','','Darling Harbour','20-07-2025','1300','24','24'),
('305','1','2:00 PM','Public Skating','','Darling Harbour','20-07-2025','1400','24','24'),
('306','1','3:00 PM','Public Skating','','Darling Harbour','20-07-2025','1500','24','24'),
('307','1','4:00 PM','Public Skating','','Darling Harbour','20-07-2025','1600','24','24'),
('308','1','5:00 PM','Public Skating','','Darling Harbour','20-07-2025','1700','24','24'),
('309','1','6:00 PM','Public Skating','','Darling Harbour','20-07-2025','1800','24','24'),
('310','1','7:00 PM','Public Skating','','Darling Harbour','20-07-2025','1900','24','24'),
('311','1','8:00 PM','Public Skating','','Darling Harbour','20-07-2025','2000','24','24'),
('312','1','9:00 PM','Public Skating','','Darling Harbour','20-07-2025','2100','24','24');

drop table if exists `products`;
CREATE TABLE `products` (
  `products_id` int(11) NOT NULL AUTO_INCREMENT,
  `products_quantity` int(4) NOT NULL DEFAULT 0,
  `products_model` varchar(64) DEFAULT NULL,
  `products_image_1` varchar(64) DEFAULT NULL,
  `products_price` decimal(15,4) DEFAULT NULL,
  `color_code` varchar(12) DEFAULT NULL,
  `products_date_added` datetime DEFAULT NULL,
  `products_last_modified` datetime DEFAULT NULL,
  `products_date_available` datetime DEFAULT NULL,
  `products_weight` decimal(5,2) NOT NULL DEFAULT 0.00,
  `products_status` tinyint(1) NOT NULL DEFAULT 0,
  `products_tax_class_id` int(11) NOT NULL DEFAULT 0,
  `manufacturers_id` int(11) NOT NULL DEFAULT 0,
  `products_ordered` int(11) NOT NULL DEFAULT 0,
  `products_title_1` varchar(100) DEFAULT NULL,
  `section_id` int(6) DEFAULT NULL,
  `parent_id` int(6) DEFAULT NULL,
  `products_sort_order` int(6) NOT NULL DEFAULT 0,
  `is_attributes` char(1) NOT NULL DEFAULT 'Y',
  `products_sku` varchar(20) NOT NULL DEFAULT '2',
  `author_name` varchar(255) NOT NULL,
  `products_price_break` varchar(1) NOT NULL DEFAULT 'N',
  `restrict_to_groups` text DEFAULT NULL,
  `restrict_to_customers` text DEFAULT NULL,
  `product_type` char(1) NOT NULL DEFAULT 'G',
  `product_mode` char(1) NOT NULL DEFAULT 'P',
  `downloads_per_customer` int(11) NOT NULL DEFAULT 0,
  `download_last_date` date DEFAULT NULL,
  `download_link` varchar(255) NOT NULL,
  `download_no_of_days` varchar(11) DEFAULT '0',
  `master_quantity` int(11) NOT NULL,
  `products_season` varchar(32) NOT NULL,
  `products_x` int(11) NOT NULL,
  `products_y` int(11) NOT NULL,
  `products_w` int(11) NOT NULL,
  `products_h` int(11) NOT NULL,
  `products_r` int(11) NOT NULL,
  `products_sx` decimal(8,2) NOT NULL DEFAULT 0.00,
  `products_sy` decimal(8,2) NOT NULL DEFAULT 0.00,
  PRIMARY KEY (`products_id`),
  KEY `idx_products_date_added` (`products_date_added`)
);

insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1','180','27-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','25','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('2','180','27-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','25','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('3','180','27-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','25','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('4','180','27-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','25','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('5','30','27-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','25','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('6','180','27-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','25','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('7','180','27-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','26','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('8','180','27-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','26','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('9','180','27-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','26','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('10','180','27-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','26','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('11','30','27-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','26','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('12','180','27-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','26','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('13','180','27-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','27','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('14','180','27-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','27','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('15','180','27-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','27','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('16','180','27-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','27','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('17','30','27-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','27','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('18','180','27-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','27','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('19','180','27-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','28','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('20','180','27-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','28','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('21','180','27-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','28','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('22','180','27-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','28','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('23','30','27-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','28','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('24','180','27-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','28','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('25','180','27-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','29','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('26','180','27-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','29','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('27','180','27-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','29','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('28','180','27-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','29','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('29','30','27-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','29','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('30','180','27-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','29','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('31','180','27-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','30','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('32','180','27-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','30','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('33','180','27-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','30','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('34','180','27-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','30','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('35','30','27-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','30','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('36','180','27-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','30','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('37','180','27-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','31','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('38','180','27-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','31','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('39','180','27-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','31','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('40','180','27-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','31','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('41','30','27-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','31','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('42','180','27-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','31','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('43','180','27-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','32','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('44','180','27-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','32','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('45','180','27-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','32','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('46','180','27-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','32','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('47','30','27-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','32','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('48','180','27-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','32','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('49','180','27-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','33','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('50','180','27-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','33','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('51','180','27-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','33','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('52','180','27-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','33','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('53','30','27-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','33','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('54','180','27-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','33','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('55','180','27-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','34','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('56','180','27-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','34','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('57','180','27-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','34','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('58','180','27-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','34','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('59','30','27-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','34','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('60','180','27-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','34','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('61','180','27-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','35','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('62','180','27-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','35','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('63','180','27-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','35','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('64','180','27-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','35','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('65','30','27-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','35','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('66','180','27-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','35','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('67','180','27-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','36','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('68','180','27-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','36','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('69','180','27-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','36','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('70','180','27-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','36','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('71','30','27-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','36','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('72','180','27-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','1','36','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('73','180','28-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','37','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('74','180','28-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','37','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('75','180','28-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','37','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('76','180','28-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','37','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('77','30','28-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','37','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('78','180','28-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','37','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('79','180','28-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','38','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('80','180','28-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','38','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('81','180','28-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','38','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('82','180','28-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','38','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('83','30','28-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','38','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('84','180','28-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','38','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('85','180','28-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','39','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('86','180','28-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','39','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('87','180','28-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','39','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('88','180','28-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','39','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('89','30','28-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','39','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('90','180','28-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','39','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('91','180','28-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','40','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('92','180','28-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','40','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('93','180','28-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','40','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('94','180','28-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','40','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('95','30','28-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','40','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('96','180','28-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','40','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('97','180','28-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','41','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('98','180','28-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','41','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('99','180','28-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','41','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('100','180','28-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','41','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('101','30','28-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','41','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('102','180','28-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','41','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('103','180','28-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','42','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('104','180','28-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','42','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('105','180','28-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','42','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('106','180','28-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','42','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('107','30','28-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','42','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('108','180','28-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','42','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('109','180','28-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','43','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('110','180','28-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','43','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('111','180','28-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','43','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('112','180','28-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','43','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('113','30','28-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','43','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('114','180','28-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','43','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('115','180','28-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','44','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('116','180','28-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','44','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('117','180','28-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','44','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('118','180','28-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','44','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('119','30','28-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','44','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('120','180','28-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','44','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('121','180','28-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','45','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('122','180','28-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','45','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('123','180','28-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','45','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('124','180','28-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','45','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('125','30','28-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','45','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('126','180','28-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','45','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('127','180','28-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','46','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('128','180','28-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','46','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('129','180','28-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','46','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('130','180','28-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','46','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('131','30','28-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','46','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('132','180','28-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','46','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('133','180','28-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','47','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('134','180','28-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','47','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('135','180','28-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','47','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('136','180','28-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','47','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('137','30','28-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','47','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('138','180','28-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','47','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('139','180','28-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','48','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('140','180','28-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','48','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('141','180','28-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','48','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('142','180','28-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','48','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('143','30','28-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','48','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('144','180','28-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','2','48','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('145','180','29-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','49','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('146','180','29-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','49','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('147','180','29-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','49','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('148','180','29-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','49','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('149','30','29-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','49','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('150','180','29-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','49','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('151','180','29-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','50','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('152','180','29-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','50','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('153','180','29-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','50','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('154','180','29-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','50','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('155','30','29-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','50','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('156','180','29-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','50','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('157','180','29-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','51','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('158','180','29-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','51','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('159','180','29-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','51','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('160','180','29-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','51','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('161','30','29-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','51','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('162','180','29-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','51','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('163','180','29-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','52','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('164','180','29-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','52','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('165','180','29-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','52','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('166','180','29-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','52','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('167','30','29-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','52','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('168','180','29-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','52','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('169','180','29-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','53','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('170','180','29-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','53','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('171','180','29-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','53','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('172','180','29-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','53','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('173','30','29-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','53','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('174','180','29-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','53','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('175','180','29-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','54','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('176','180','29-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','54','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('177','180','29-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','54','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('178','180','29-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','54','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('179','30','29-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','54','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('180','180','29-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','54','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('181','180','29-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','55','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('182','180','29-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','55','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('183','180','29-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','55','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('184','180','29-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','55','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('185','30','29-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','55','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('186','180','29-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','55','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('187','180','29-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','56','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('188','180','29-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','56','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('189','180','29-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','56','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('190','180','29-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','56','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('191','30','29-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','56','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('192','180','29-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','56','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('193','180','29-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','57','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('194','180','29-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','57','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('195','180','29-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','57','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('196','180','29-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','57','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('197','30','29-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','57','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('198','180','29-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','57','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('199','180','29-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','58','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('200','180','29-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','58','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('201','180','29-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','58','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('202','180','29-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','58','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('203','30','29-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','58','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('204','180','29-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','58','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('205','180','29-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','59','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('206','180','29-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','59','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('207','180','29-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','59','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('208','180','29-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','59','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('209','30','29-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','59','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('210','180','29-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','59','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('211','180','29-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','60','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('212','180','29-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','60','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('213','180','29-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','60','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('214','180','29-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','60','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('215','30','29-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','60','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('216','180','29-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','3','60','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('217','180','30-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','61','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('218','180','30-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','61','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('219','180','30-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','61','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('220','180','30-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','61','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('221','30','30-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','61','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('222','180','30-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','61','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('223','180','30-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','62','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('224','180','30-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','62','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('225','180','30-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','62','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('226','180','30-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','62','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('227','30','30-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','62','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('228','180','30-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','62','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('229','180','30-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','63','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('230','180','30-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','63','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('231','180','30-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','63','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('232','180','30-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','63','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('233','30','30-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','63','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('234','180','30-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','63','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('235','180','30-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','64','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('236','180','30-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','64','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('237','180','30-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','64','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('238','180','30-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','64','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('239','30','30-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','64','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('240','180','30-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','64','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('241','180','30-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','65','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('242','180','30-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','65','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('243','180','30-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','65','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('244','180','30-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','65','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('245','30','30-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','65','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('246','180','30-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','65','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('247','180','30-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','66','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('248','180','30-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','66','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('249','180','30-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','66','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('250','180','30-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','66','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('251','30','30-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','66','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('252','180','30-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','66','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('253','180','30-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','67','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('254','180','30-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','67','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('255','180','30-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','67','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('256','180','30-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','67','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('257','30','30-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','67','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('258','180','30-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','67','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('259','180','30-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','68','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('260','180','30-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','68','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('261','180','30-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','68','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('262','180','30-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','68','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('263','30','30-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','68','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('264','180','30-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','68','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('265','180','30-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','69','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('266','180','30-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','69','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('267','180','30-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','69','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('268','180','30-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','69','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('269','30','30-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','69','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('270','180','30-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','69','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('271','180','30-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','70','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('272','180','30-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','70','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('273','180','30-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','70','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('274','180','30-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','70','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('275','30','30-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','70','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('276','180','30-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','70','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('277','180','30-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','71','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('278','180','30-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','71','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('279','180','30-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','71','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('280','180','30-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','71','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('281','30','30-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','71','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('282','180','30-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','71','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('283','180','30-06-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','72','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('284','180','30-06-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','72','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('285','180','30-06-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','72','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('286','180','30-06-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','72','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('287','30','30-06-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','72','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('288','180','30-06-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','4','72','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('289','180','01-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','73','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('290','180','01-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','73','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('291','180','01-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','73','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('292','180','01-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','73','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('293','30','01-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','73','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('294','180','01-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','73','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('295','180','01-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','74','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('296','180','01-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','74','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('297','180','01-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','74','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('298','180','01-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','74','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('299','30','01-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','74','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('300','180','01-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','74','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('301','180','01-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','75','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('302','180','01-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','75','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('303','180','01-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','75','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('304','180','01-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','75','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('305','30','01-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','75','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('306','180','01-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','75','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('307','180','01-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','76','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('308','180','01-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','76','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('309','180','01-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','76','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('310','180','01-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','76','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('311','30','01-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','76','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('312','180','01-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','76','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('313','180','01-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','77','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('314','180','01-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','77','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('315','180','01-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','77','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('316','180','01-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','77','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('317','30','01-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','77','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('318','180','01-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','77','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('319','180','01-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','78','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('320','180','01-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','78','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('321','180','01-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','78','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('322','180','01-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','78','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('323','30','01-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','78','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('324','180','01-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','78','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('325','180','01-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','79','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('326','180','01-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','79','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('327','180','01-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','79','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('328','180','01-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','79','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('329','30','01-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','79','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('330','180','01-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','79','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('331','180','01-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','80','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('332','180','01-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','80','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('333','180','01-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','80','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('334','180','01-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','80','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('335','30','01-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','80','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('336','180','01-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','80','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('337','180','01-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','81','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('338','180','01-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','81','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('339','180','01-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','81','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('340','180','01-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','81','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('341','30','01-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','81','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('342','180','01-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','81','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('343','180','01-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','82','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('344','180','01-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','82','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('345','180','01-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','82','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('346','180','01-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','82','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('347','30','01-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','82','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('348','180','01-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','82','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('349','180','01-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','83','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('350','180','01-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','83','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('351','180','01-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','83','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('352','180','01-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','83','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('353','30','01-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','83','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('354','180','01-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','83','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('355','180','01-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','84','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('356','180','01-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','84','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('357','180','01-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','84','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('358','180','01-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','84','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('359','30','01-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','84','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('360','180','01-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','5','84','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('361','180','02-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','85','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('362','180','02-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','85','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('363','180','02-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','85','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('364','180','02-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','85','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('365','30','02-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','85','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('366','180','02-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','85','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('367','180','02-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','86','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('368','180','02-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','86','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('369','180','02-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','86','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('370','180','02-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','86','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('371','30','02-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','86','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('372','180','02-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','86','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('373','180','02-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','87','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('374','180','02-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','87','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('375','180','02-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','87','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('376','180','02-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','87','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('377','30','02-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','87','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('378','180','02-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','87','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('379','180','02-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','88','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('380','180','02-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','88','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('381','180','02-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','88','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('382','180','02-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','88','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('383','30','02-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','88','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('384','180','02-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','88','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('385','180','02-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','89','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('386','180','02-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','89','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('387','180','02-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','89','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('388','180','02-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','89','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('389','30','02-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','89','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('390','180','02-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','89','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('391','180','02-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','90','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('392','180','02-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','90','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('393','180','02-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','90','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('394','180','02-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','90','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('395','30','02-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','90','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('396','180','02-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','90','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('397','180','02-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','91','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('398','180','02-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','91','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('399','180','02-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','91','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('400','180','02-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','91','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('401','30','02-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','91','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('402','180','02-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','91','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('403','180','02-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','92','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('404','180','02-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','92','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('405','180','02-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','92','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('406','180','02-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','92','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('407','30','02-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','92','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('408','180','02-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','92','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('409','180','02-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','93','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('410','180','02-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','93','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('411','180','02-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','93','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('412','180','02-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','93','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('413','30','02-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','93','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('414','180','02-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','93','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('415','180','02-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','94','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('416','180','02-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','94','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('417','180','02-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','94','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('418','180','02-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','94','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('419','30','02-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','94','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('420','180','02-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','94','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('421','180','02-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','95','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('422','180','02-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','95','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('423','180','02-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','95','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('424','180','02-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','95','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('425','30','02-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','95','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('426','180','02-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','95','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('427','180','02-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','96','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('428','180','02-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','96','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('429','180','02-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','96','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('430','180','02-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','96','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('431','30','02-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','96','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('432','180','02-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','6','96','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('433','180','03-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','97','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('434','180','03-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','97','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('435','180','03-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','97','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('436','180','03-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','97','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('437','30','03-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','97','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('438','180','03-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','97','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('439','180','03-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','98','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('440','180','03-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','98','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('441','180','03-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','98','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('442','180','03-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','98','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('443','30','03-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','98','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('444','180','03-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','98','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('445','180','03-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','99','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('446','180','03-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','99','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('447','180','03-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','99','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('448','180','03-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','99','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('449','30','03-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','99','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('450','180','03-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','99','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('451','180','03-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','100','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('452','180','03-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','100','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('453','180','03-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','100','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('454','180','03-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','100','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('455','30','03-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','100','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('456','180','03-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','100','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('457','180','03-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','101','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('458','180','03-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','101','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('459','180','03-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','101','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('460','180','03-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','101','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('461','30','03-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','101','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('462','180','03-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','101','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('463','180','03-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','102','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('464','180','03-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','102','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('465','180','03-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','102','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('466','180','03-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','102','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('467','30','03-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','102','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('468','180','03-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','102','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('469','180','03-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','103','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('470','180','03-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','103','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('471','180','03-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','103','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('472','180','03-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','103','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('473','30','03-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','103','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('474','180','03-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','103','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('475','180','03-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','104','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('476','180','03-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','104','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('477','180','03-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','104','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('478','180','03-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','104','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('479','30','03-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','104','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('480','180','03-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','104','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('481','180','03-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','105','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('482','180','03-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','105','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('483','180','03-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','105','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('484','180','03-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','105','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('485','30','03-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','105','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('486','180','03-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','105','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('487','180','03-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','106','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('488','180','03-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','106','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('489','180','03-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','106','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('490','180','03-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','106','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('491','30','03-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','106','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('492','180','03-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','106','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('493','180','03-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','107','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('494','180','03-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','107','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('495','180','03-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','107','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('496','180','03-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','107','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('497','30','03-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','107','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('498','180','03-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','107','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('499','180','03-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','108','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('500','180','03-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','108','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('501','180','03-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','108','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('502','180','03-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','108','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('503','30','03-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','108','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('504','180','03-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','7','108','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('505','180','04-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','109','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('506','180','04-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','109','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('507','180','04-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','109','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('508','180','04-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','109','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('509','30','04-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','109','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('510','180','04-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','109','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('511','180','04-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','110','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('512','180','04-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','110','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('513','180','04-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','110','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('514','180','04-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','110','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('515','30','04-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','110','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('516','180','04-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','110','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('517','180','04-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','111','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('518','180','04-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','111','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('519','180','04-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','111','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('520','180','04-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','111','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('521','30','04-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','111','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('522','180','04-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','111','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('523','180','04-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','112','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('524','180','04-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','112','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('525','180','04-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','112','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('526','180','04-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','112','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('527','30','04-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','112','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('528','180','04-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','112','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('529','180','04-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','113','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('530','180','04-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','113','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('531','180','04-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','113','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('532','180','04-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','113','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('533','30','04-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','113','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('534','180','04-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','113','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('535','180','04-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','114','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('536','180','04-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','114','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('537','180','04-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','114','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('538','180','04-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','114','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('539','30','04-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','114','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('540','180','04-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','114','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('541','180','04-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','115','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('542','180','04-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','115','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('543','180','04-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','115','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('544','180','04-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','115','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('545','30','04-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','115','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('546','180','04-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','115','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('547','180','04-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','116','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('548','180','04-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','116','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('549','180','04-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','116','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('550','180','04-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','116','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('551','30','04-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','116','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('552','180','04-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','116','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('553','180','04-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','117','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('554','180','04-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','117','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('555','180','04-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','117','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('556','180','04-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','117','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('557','30','04-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','117','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('558','180','04-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','117','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('559','180','04-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','118','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('560','180','04-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','118','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('561','180','04-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','118','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('562','180','04-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','118','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('563','30','04-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','118','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('564','180','04-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','118','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('565','180','04-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','119','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('566','180','04-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','119','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('567','180','04-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','119','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('568','180','04-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','119','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('569','30','04-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','119','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('570','180','04-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','119','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('571','180','04-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','120','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('572','180','04-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','120','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('573','180','04-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','120','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('574','180','04-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','120','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('575','30','04-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','120','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('576','180','04-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','8','120','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('577','180','05-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','121','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('578','180','05-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','121','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('579','180','05-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','121','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('580','180','05-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','121','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('581','30','05-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','121','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('582','180','05-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','121','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('583','180','05-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','122','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('584','180','05-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','122','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('585','180','05-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','122','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('586','180','05-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','122','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('587','30','05-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','122','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('588','180','05-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','122','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('589','180','05-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','123','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('590','180','05-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','123','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('591','180','05-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','123','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('592','180','05-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','123','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('593','30','05-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','123','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('594','180','05-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','123','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('595','180','05-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','124','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('596','180','05-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','124','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('597','180','05-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','124','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('598','180','05-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','124','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('599','30','05-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','124','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('600','180','05-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','124','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('601','180','05-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','125','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('602','180','05-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','125','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('603','180','05-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','125','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('604','180','05-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','125','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('605','30','05-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','125','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('606','180','05-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','125','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('607','180','05-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','126','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('608','180','05-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','126','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('609','180','05-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','126','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('610','180','05-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','126','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('611','30','05-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','126','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('612','180','05-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','126','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('613','180','05-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','127','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('614','180','05-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','127','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('615','180','05-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','127','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('616','180','05-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','127','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('617','30','05-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','127','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('618','180','05-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','127','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('619','180','05-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','128','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('620','180','05-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','128','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('621','180','05-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','128','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('622','180','05-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','128','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('623','30','05-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','128','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('624','180','05-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','128','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('625','180','05-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','129','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('626','180','05-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','129','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('627','180','05-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','129','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('628','180','05-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','129','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('629','30','05-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','129','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('630','180','05-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','129','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('631','180','05-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','130','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('632','180','05-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','130','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('633','180','05-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','130','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('634','180','05-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','130','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('635','30','05-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','130','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('636','180','05-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','130','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('637','180','05-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','131','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('638','180','05-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','131','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('639','180','05-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','131','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('640','180','05-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','131','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('641','30','05-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','131','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('642','180','05-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','131','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('643','180','05-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','132','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('644','180','05-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','132','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('645','180','05-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','132','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('646','180','05-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','132','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('647','30','05-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','132','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('648','180','05-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','9','132','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('649','180','06-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','133','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('650','180','06-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','133','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('651','180','06-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','133','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('652','180','06-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','133','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('653','30','06-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','133','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('654','180','06-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','133','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('655','180','06-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','134','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('656','180','06-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','134','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('657','180','06-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','134','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('658','180','06-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','134','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('659','30','06-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','134','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('660','180','06-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','134','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('661','180','06-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','135','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('662','180','06-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','135','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('663','180','06-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','135','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('664','180','06-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','135','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('665','30','06-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','135','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('666','180','06-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','135','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('667','180','06-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','136','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('668','180','06-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','136','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('669','180','06-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','136','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('670','180','06-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','136','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('671','30','06-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','136','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('672','180','06-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','136','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('673','180','06-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','137','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('674','180','06-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','137','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('675','180','06-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','137','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('676','180','06-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','137','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('677','30','06-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','137','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('678','180','06-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','137','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('679','180','06-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','138','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('680','180','06-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','138','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('681','180','06-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','138','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('682','180','06-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','138','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('683','30','06-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','138','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('684','180','06-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','138','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('685','180','06-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','139','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('686','180','06-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','139','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('687','180','06-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','139','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('688','180','06-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','139','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('689','30','06-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','139','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('690','180','06-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','139','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('691','180','06-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','140','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('692','180','06-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','140','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('693','180','06-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','140','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('694','180','06-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','140','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('695','30','06-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','140','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('696','180','06-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','140','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('697','180','06-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','141','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('698','180','06-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','141','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('699','180','06-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','141','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('700','180','06-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','141','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('701','30','06-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','141','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('702','180','06-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','141','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('703','180','06-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','142','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('704','180','06-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','142','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('705','180','06-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','142','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('706','180','06-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','142','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('707','30','06-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','142','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('708','180','06-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','142','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('709','180','06-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','143','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('710','180','06-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','143','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('711','180','06-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','143','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('712','180','06-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','143','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('713','30','06-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','143','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('714','180','06-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','143','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('715','180','06-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','144','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('716','180','06-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','144','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('717','180','06-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','144','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('718','180','06-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','144','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('719','30','06-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','144','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('720','180','06-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','10','144','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('721','180','07-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','145','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('722','180','07-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','145','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('723','180','07-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','145','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('724','180','07-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','145','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('725','30','07-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','145','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('726','180','07-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','145','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('727','180','07-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','146','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('728','180','07-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','146','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('729','180','07-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','146','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('730','180','07-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','146','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('731','30','07-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','146','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('732','180','07-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','146','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('733','180','07-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','147','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('734','180','07-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','147','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('735','180','07-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','147','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('736','180','07-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','147','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('737','30','07-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','147','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('738','180','07-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','147','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('739','180','07-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','148','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('740','180','07-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','148','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('741','180','07-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','148','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('742','180','07-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','148','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('743','30','07-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','148','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('744','180','07-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','148','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('745','180','07-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','149','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('746','180','07-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','149','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('747','180','07-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','149','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('748','180','07-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','149','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('749','30','07-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','149','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('750','180','07-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','149','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('751','180','07-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','150','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('752','180','07-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','150','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('753','180','07-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','150','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('754','180','07-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','150','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('755','30','07-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','150','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('756','180','07-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','150','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('757','180','07-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','151','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('758','180','07-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','151','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('759','180','07-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','151','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('760','180','07-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','151','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('761','30','07-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','151','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('762','180','07-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','151','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('763','180','07-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','152','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('764','180','07-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','152','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('765','180','07-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','152','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('766','180','07-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','152','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('767','30','07-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','152','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('768','180','07-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','152','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('769','180','07-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','153','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('770','180','07-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','153','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('771','180','07-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','153','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('772','180','07-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','153','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('773','30','07-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','153','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('774','180','07-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','153','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('775','180','07-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','154','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('776','180','07-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','154','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('777','180','07-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','154','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('778','180','07-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','154','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('779','30','07-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','154','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('780','180','07-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','154','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('781','180','07-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','155','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('782','180','07-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','155','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('783','180','07-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','155','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('784','180','07-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','155','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('785','30','07-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','155','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('786','180','07-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','155','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('787','180','07-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','156','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('788','180','07-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','156','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('789','180','07-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','156','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('790','180','07-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','156','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('791','30','07-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','156','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('792','180','07-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','11','156','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('793','180','08-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','157','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('794','180','08-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','157','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('795','180','08-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','157','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('796','180','08-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','157','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('797','30','08-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','157','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('798','180','08-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','157','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('799','180','08-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','158','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('800','180','08-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','158','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('801','180','08-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','158','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('802','180','08-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','158','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('803','30','08-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','158','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('804','180','08-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','158','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('805','180','08-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','159','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('806','180','08-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','159','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('807','180','08-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','159','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('808','180','08-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','159','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('809','30','08-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','159','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('810','180','08-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','159','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('811','180','08-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','160','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('812','180','08-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','160','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('813','180','08-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','160','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('814','180','08-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','160','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('815','30','08-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','160','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('816','180','08-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','160','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('817','180','08-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','161','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('818','180','08-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','161','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('819','180','08-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','161','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('820','180','08-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','161','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('821','30','08-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','161','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('822','180','08-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','161','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('823','180','08-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','162','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('824','180','08-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','162','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('825','180','08-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','162','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('826','180','08-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','162','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('827','30','08-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','162','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('828','180','08-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','162','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('829','180','08-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','163','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('830','180','08-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','163','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('831','180','08-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','163','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('832','180','08-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','163','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('833','30','08-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','163','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('834','180','08-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','163','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('835','180','08-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','164','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('836','180','08-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','164','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('837','180','08-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','164','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('838','180','08-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','164','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('839','30','08-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','164','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('840','180','08-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','164','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('841','180','08-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','165','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('842','180','08-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','165','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('843','180','08-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','165','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('844','180','08-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','165','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('845','30','08-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','165','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('846','180','08-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','165','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('847','180','08-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','166','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('848','180','08-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','166','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('849','180','08-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','166','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('850','180','08-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','166','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('851','30','08-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','166','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('852','180','08-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','166','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('853','180','08-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','167','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('854','180','08-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','167','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('855','180','08-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','167','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('856','180','08-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','167','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('857','30','08-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','167','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('858','180','08-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','167','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('859','180','08-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','168','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('860','180','08-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','168','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('861','180','08-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','168','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('862','180','08-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','168','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('863','30','08-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','168','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('864','180','08-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','12','168','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('865','180','09-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','169','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('866','180','09-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','169','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('867','180','09-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','169','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('868','180','09-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','169','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('869','30','09-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','169','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('870','180','09-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','169','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('871','180','09-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','170','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('872','180','09-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','170','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('873','180','09-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','170','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('874','180','09-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','170','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('875','30','09-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','170','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('876','180','09-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','170','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('877','180','09-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','171','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('878','180','09-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','171','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('879','180','09-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','171','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('880','180','09-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','171','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('881','30','09-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','171','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('882','180','09-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','171','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('883','180','09-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','172','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('884','180','09-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','172','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('885','180','09-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','172','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('886','180','09-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','172','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('887','30','09-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','172','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('888','180','09-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','172','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('889','180','09-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','173','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('890','180','09-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','173','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('891','180','09-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','173','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('892','180','09-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','173','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('893','30','09-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','173','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('894','180','09-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','173','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('895','180','09-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','174','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('896','180','09-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','174','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('897','180','09-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','174','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('898','180','09-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','174','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('899','30','09-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','174','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('900','180','09-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','174','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('901','180','09-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','175','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('902','180','09-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','175','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('903','180','09-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','175','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('904','180','09-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','175','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('905','30','09-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','175','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('906','180','09-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','175','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('907','180','09-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','176','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('908','180','09-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','176','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('909','180','09-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','176','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('910','180','09-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','176','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('911','30','09-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','176','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('912','180','09-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','176','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('913','180','09-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','177','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('914','180','09-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','177','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('915','180','09-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','177','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('916','180','09-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','177','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('917','30','09-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','177','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('918','180','09-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','177','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('919','180','09-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','178','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('920','180','09-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','178','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('921','180','09-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','178','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('922','180','09-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','178','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('923','30','09-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','178','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('924','180','09-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','178','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('925','180','09-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','179','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('926','180','09-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','179','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('927','180','09-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','179','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('928','180','09-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','179','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('929','30','09-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','179','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('930','180','09-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','179','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('931','180','09-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','180','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('932','180','09-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','180','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('933','180','09-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','180','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('934','180','09-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','180','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('935','30','09-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','180','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('936','180','09-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','13','180','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('937','180','10-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','181','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('938','180','10-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','181','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('939','180','10-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','181','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('940','180','10-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','181','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('941','30','10-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','181','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('942','180','10-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','181','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('943','180','10-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','182','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('944','180','10-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','182','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('945','180','10-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','182','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('946','180','10-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','182','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('947','30','10-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','182','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('948','180','10-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','182','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('949','180','10-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','183','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('950','180','10-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','183','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('951','180','10-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','183','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('952','180','10-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','183','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('953','30','10-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','183','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('954','180','10-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','183','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('955','180','10-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','184','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('956','180','10-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','184','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('957','180','10-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','184','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('958','180','10-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','184','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('959','30','10-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','184','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('960','180','10-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','184','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('961','180','10-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','185','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('962','180','10-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','185','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('963','180','10-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','185','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('964','180','10-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','185','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('965','30','10-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','185','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('966','180','10-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','185','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('967','180','10-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','186','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('968','180','10-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','186','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('969','180','10-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','186','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('970','180','10-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','186','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('971','30','10-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','186','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('972','180','10-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','186','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('973','180','10-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','187','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('974','180','10-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','187','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('975','180','10-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','187','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('976','180','10-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','187','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('977','30','10-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','187','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('978','180','10-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','187','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('979','180','10-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','188','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('980','180','10-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','188','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('981','180','10-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','188','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('982','180','10-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','188','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('983','30','10-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','188','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('984','180','10-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','188','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('985','180','10-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','189','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('986','180','10-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','189','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('987','180','10-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','189','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('988','180','10-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','189','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('989','30','10-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','189','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('990','180','10-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','189','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('991','180','10-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','190','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('992','180','10-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','190','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('993','180','10-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','190','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('994','180','10-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','190','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('995','30','10-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','190','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('996','180','10-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','190','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('997','180','10-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','191','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('998','180','10-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','191','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('999','180','10-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','191','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1000','180','10-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','191','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1001','30','10-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','191','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('1002','180','10-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','191','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1003','180','10-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','192','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1004','180','10-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','192','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1005','180','10-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','192','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1006','180','10-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','192','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1007','30','10-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','192','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('1008','180','10-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','14','192','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1009','180','11-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','193','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1010','180','11-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','193','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1011','180','11-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','193','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1012','180','11-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','193','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1013','30','11-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','193','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('1014','180','11-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','193','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1015','180','11-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','194','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1016','180','11-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','194','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1017','180','11-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','194','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1018','180','11-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','194','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1019','30','11-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','194','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('1020','180','11-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','194','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1021','180','11-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','195','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1022','180','11-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','195','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1023','180','11-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','195','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1024','180','11-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','195','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1025','30','11-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','195','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('1026','180','11-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','195','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1027','180','11-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','196','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1028','180','11-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','196','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1029','180','11-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','196','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1030','180','11-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','196','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1031','30','11-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','196','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('1032','180','11-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','196','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1033','180','11-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','197','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1034','180','11-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','197','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1035','180','11-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','197','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1036','180','11-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','197','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1037','30','11-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','197','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('1038','180','11-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','197','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1039','180','11-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','198','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1040','180','11-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','198','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1041','180','11-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','198','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1042','180','11-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','198','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1043','30','11-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','198','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('1044','180','11-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','198','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1045','180','11-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','199','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1046','180','11-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','199','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1047','180','11-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','199','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1048','180','11-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','199','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1049','30','11-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','199','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('1050','180','11-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','199','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1051','180','11-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','200','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1052','180','11-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','200','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1053','180','11-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','200','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1054','180','11-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','200','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1055','30','11-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','200','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('1056','180','11-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','200','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1057','180','11-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','201','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1058','180','11-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','201','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1059','180','11-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','201','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1060','180','11-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','201','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1061','30','11-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','201','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('1062','180','11-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','201','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1063','180','11-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','202','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1064','180','11-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','202','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1065','180','11-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','202','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1066','180','11-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','202','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1067','30','11-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','202','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('1068','180','11-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','202','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1069','180','11-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','203','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1070','180','11-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','203','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1071','180','11-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','203','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1072','180','11-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','203','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1073','30','11-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','203','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('1074','180','11-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','203','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1075','180','11-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','204','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1076','180','11-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','204','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1077','180','11-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','204','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1078','180','11-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','204','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1079','30','11-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','204','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('1080','180','11-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','15','204','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1081','180','12-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','205','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1082','180','12-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','205','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1083','180','12-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','205','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1084','180','12-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','205','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1085','30','12-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','205','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('1086','180','12-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','205','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1087','180','12-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','206','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1088','180','12-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','206','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1089','180','12-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','206','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1090','180','12-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','206','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1091','30','12-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','206','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('1092','180','12-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','206','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1093','180','12-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','207','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1094','180','12-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','207','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1095','180','12-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','207','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1096','180','12-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','207','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1097','30','12-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','207','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('1098','180','12-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','207','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1099','180','12-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','208','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1100','180','12-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','208','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1101','180','12-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','208','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1102','180','12-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','208','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1103','30','12-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','208','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('1104','180','12-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','208','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1105','180','12-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','209','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1106','180','12-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','209','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1107','180','12-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','209','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1108','180','12-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','209','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1109','30','12-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','209','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('1110','180','12-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','209','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1111','180','12-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','210','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1112','180','12-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','210','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1113','180','12-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','210','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1114','180','12-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','210','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1115','30','12-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','210','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('1116','180','12-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','210','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1117','180','12-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','211','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1118','180','12-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','211','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1119','180','12-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','211','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1120','180','12-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','211','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1121','30','12-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','211','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('1122','180','12-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','211','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1123','180','12-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','212','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1124','180','12-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','212','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1125','180','12-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','212','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1126','180','12-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','212','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1127','30','12-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','212','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('1128','180','12-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','212','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1129','180','12-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','213','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1130','180','12-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','213','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1131','180','12-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','213','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1132','180','12-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','213','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1133','30','12-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','213','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('1134','180','12-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','213','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1135','180','12-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','214','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1136','180','12-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','214','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1137','180','12-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','214','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1138','180','12-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','214','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1139','30','12-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','214','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('1140','180','12-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','214','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1141','180','12-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','215','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1142','180','12-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','215','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1143','180','12-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','215','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1144','180','12-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','215','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1145','30','12-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','215','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('1146','180','12-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','215','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1147','180','12-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','216','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1148','180','12-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','216','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1149','180','12-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','216','0','N','9','N','N','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1150','180','12-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','216','0','N','9','N','N','','','F','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1151','30','12-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','216','0','N','9','N','N','','','B','P','0','0000-00-00','','','30','','0','0','0','0','0','0.00','0.00'),
('1152','180','12-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','16','216','0','N','9','N','Y','','','G','P','0','0000-00-00','','','180','','0','0','0','0','0','0.00','0.00'),
('1153','180','13-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','217','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1154','180','13-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','217','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1155','180','13-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','217','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1156','180','13-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','217','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1157','30','13-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','217','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1158','180','13-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','217','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1159','180','13-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','218','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1160','180','13-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','218','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1161','180','13-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','218','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1162','180','13-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','218','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1163','30','13-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','218','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1164','180','13-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','218','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1165','180','13-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','219','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1166','180','13-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','219','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1167','180','13-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','219','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1168','180','13-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','219','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1169','30','13-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','219','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1170','180','13-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','219','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1171','180','13-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','220','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1172','180','13-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','220','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1173','180','13-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','220','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1174','180','13-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','220','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1175','30','13-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','220','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1176','180','13-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','220','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1177','180','13-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','221','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1178','180','13-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','221','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1179','180','13-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','221','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1180','180','13-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','221','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1181','30','13-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','221','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1182','180','13-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','221','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1183','180','13-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','222','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1184','180','13-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','222','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1185','180','13-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','222','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1186','180','13-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','222','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1187','30','13-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','222','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1188','180','13-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','222','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1189','180','13-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','223','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1190','180','13-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','223','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1191','180','13-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','223','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1192','180','13-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','223','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1193','30','13-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','223','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1194','180','13-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','223','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1195','180','13-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','224','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1196','180','13-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','224','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1197','180','13-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','224','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1198','180','13-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','224','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1199','30','13-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','224','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1200','180','13-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','224','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1201','180','13-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','225','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1202','180','13-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','225','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1203','180','13-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','225','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1204','180','13-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','225','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1205','30','13-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','225','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1206','180','13-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','225','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1207','180','13-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','226','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1208','180','13-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','226','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1209','180','13-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','226','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1210','180','13-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','226','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1211','30','13-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','226','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1212','180','13-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','226','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1213','180','13-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','227','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1214','180','13-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','227','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1215','180','13-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','227','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1216','180','13-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','227','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1217','30','13-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','227','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1218','180','13-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','227','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1219','180','13-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','228','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1220','180','13-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','228','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1221','180','13-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','228','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1222','180','13-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','228','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1223','30','13-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','228','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1224','180','13-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','17','228','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1225','180','14-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','229','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1226','180','14-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','229','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1227','180','14-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','229','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1228','180','14-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','229','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1229','30','14-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','229','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1230','180','14-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','229','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1231','180','14-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','230','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1232','180','14-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','230','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1233','180','14-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','230','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1234','180','14-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','230','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1235','30','14-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','230','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1236','180','14-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','230','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1237','180','14-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','231','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1238','180','14-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','231','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1239','180','14-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','231','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1240','180','14-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','231','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1241','30','14-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','231','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1242','180','14-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','231','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1243','180','14-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','232','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1244','180','14-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','232','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1245','180','14-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','232','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1246','180','14-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','232','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1247','30','14-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','232','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1248','180','14-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','232','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1249','180','14-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','233','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1250','180','14-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','233','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1251','180','14-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','233','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1252','180','14-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','233','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1253','30','14-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','233','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1254','180','14-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','233','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1255','180','14-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','234','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1256','180','14-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','234','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1257','180','14-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','234','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1258','180','14-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','234','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1259','30','14-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','234','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1260','180','14-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','234','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1261','180','14-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','235','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1262','180','14-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','235','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1263','180','14-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','235','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1264','180','14-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','235','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1265','30','14-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','235','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1266','180','14-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','235','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1267','180','14-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','236','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1268','180','14-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','236','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1269','180','14-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','236','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1270','180','14-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','236','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1271','30','14-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','236','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1272','180','14-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','236','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1273','180','14-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','237','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1274','180','14-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','237','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1275','180','14-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','237','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1276','180','14-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','237','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1277','30','14-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','237','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1278','180','14-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','237','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1279','180','14-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','238','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1280','180','14-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','238','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1281','180','14-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','238','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1282','180','14-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','238','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1283','30','14-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','238','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1284','180','14-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','238','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1285','180','14-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','239','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1286','180','14-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','239','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1287','180','14-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','239','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1288','180','14-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','239','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1289','30','14-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','239','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1290','180','14-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','239','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1291','180','14-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','240','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1292','180','14-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','240','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1293','180','14-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','240','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1294','180','14-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','240','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1295','30','14-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','240','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1296','180','14-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','18','240','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1297','180','15-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','241','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1298','180','15-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','241','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1299','180','15-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','241','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1300','180','15-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','241','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1301','30','15-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','241','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1302','180','15-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','241','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1303','180','15-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','242','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1304','180','15-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','242','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1305','180','15-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','242','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1306','180','15-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','242','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1307','30','15-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','242','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1308','180','15-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','242','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1309','180','15-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','243','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1310','180','15-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','243','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1311','180','15-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','243','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1312','180','15-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','243','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1313','30','15-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','243','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1314','180','15-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','243','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1315','180','15-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','244','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1316','180','15-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','244','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1317','180','15-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','244','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1318','180','15-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','244','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1319','30','15-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','244','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1320','180','15-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','244','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1321','180','15-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','245','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1322','180','15-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','245','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1323','180','15-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','245','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1324','180','15-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','245','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1325','30','15-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','245','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1326','180','15-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','245','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1327','180','15-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','246','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1328','180','15-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','246','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1329','180','15-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','246','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1330','180','15-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','246','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1331','30','15-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','246','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1332','180','15-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','246','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1333','180','15-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','247','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1334','180','15-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','247','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1335','180','15-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','247','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1336','180','15-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','247','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1337','30','15-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','247','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1338','180','15-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','247','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1339','180','15-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','248','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1340','180','15-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','248','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1341','180','15-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','248','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1342','180','15-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','248','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1343','30','15-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','248','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1344','180','15-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','248','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1345','180','15-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','249','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1346','180','15-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','249','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1347','180','15-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','249','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1348','180','15-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','249','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1349','30','15-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','249','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1350','180','15-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','249','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1351','180','15-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','250','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1352','180','15-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','250','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1353','180','15-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','250','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1354','180','15-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','250','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1355','30','15-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','250','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1356','180','15-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','250','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1357','180','15-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','251','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1358','180','15-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','251','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1359','180','15-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','251','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1360','180','15-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','251','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1361','30','15-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','251','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1362','180','15-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','251','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1363','180','15-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','252','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1364','180','15-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','252','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1365','180','15-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','252','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1366','180','15-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','252','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1367','30','15-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','252','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1368','180','15-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','19','252','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1369','180','16-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','253','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1370','180','16-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','253','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1371','180','16-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','253','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1372','180','16-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','253','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1373','30','16-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','253','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1374','180','16-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','253','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1375','180','16-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','254','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1376','180','16-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','254','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1377','180','16-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','254','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1378','180','16-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','254','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1379','30','16-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','254','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1380','180','16-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','254','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1381','180','16-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','255','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1382','180','16-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','255','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1383','180','16-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','255','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1384','180','16-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','255','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1385','30','16-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','255','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1386','180','16-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','255','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1387','180','16-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','256','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1388','180','16-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','256','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1389','180','16-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','256','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1390','180','16-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','256','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1391','30','16-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','256','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1392','180','16-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','256','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1393','180','16-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','257','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1394','180','16-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','257','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1395','180','16-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','257','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1396','180','16-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','257','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1397','30','16-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','257','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1398','180','16-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','257','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1399','180','16-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','258','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1400','180','16-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','258','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1401','180','16-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','258','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1402','180','16-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','258','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1403','30','16-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','258','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1404','180','16-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','258','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1405','180','16-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','259','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1406','180','16-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','259','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1407','180','16-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','259','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1408','180','16-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','259','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1409','30','16-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','259','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1410','180','16-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','259','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1411','180','16-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','260','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1412','180','16-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','260','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1413','180','16-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','260','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1414','180','16-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','260','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1415','30','16-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','260','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1416','180','16-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','260','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1417','180','16-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','261','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1418','180','16-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','261','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1419','180','16-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','261','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1420','180','16-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','261','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1421','30','16-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','261','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1422','180','16-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','261','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1423','180','16-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','262','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1424','180','16-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','262','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1425','180','16-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','262','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1426','180','16-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','262','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1427','30','16-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','262','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1428','180','16-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','262','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1429','180','16-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','263','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1430','180','16-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','263','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1431','180','16-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','263','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1432','180','16-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','263','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1433','30','16-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','263','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1434','180','16-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','263','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1435','180','16-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','264','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1436','180','16-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','264','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1437','180','16-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','264','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1438','180','16-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','264','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1439','30','16-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','264','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1440','180','16-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','20','264','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1441','180','17-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','265','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1442','180','17-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','265','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1443','180','17-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','265','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1444','180','17-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','265','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1445','30','17-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','265','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1446','180','17-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','265','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1447','180','17-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','266','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1448','180','17-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','266','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1449','180','17-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','266','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1450','180','17-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','266','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1451','30','17-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','266','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1452','180','17-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','266','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1453','180','17-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','267','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1454','180','17-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','267','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1455','180','17-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','267','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1456','180','17-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','267','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1457','30','17-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','267','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1458','180','17-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','267','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1459','180','17-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','268','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1460','180','17-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','268','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1461','180','17-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','268','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1462','180','17-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','268','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1463','30','17-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','268','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1464','180','17-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','268','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1465','180','17-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','269','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1466','180','17-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','269','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1467','180','17-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','269','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1468','180','17-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','269','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1469','30','17-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','269','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1470','180','17-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','269','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1471','180','17-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','270','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1472','180','17-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','270','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1473','180','17-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','270','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1474','180','17-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','270','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1475','30','17-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','270','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1476','180','17-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','270','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1477','180','17-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','271','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1478','180','17-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','271','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1479','180','17-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','271','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1480','180','17-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','271','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1481','30','17-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','271','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1482','180','17-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','271','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1483','180','17-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','272','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1484','180','17-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','272','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1485','180','17-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','272','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1486','180','17-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','272','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1487','30','17-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','272','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1488','180','17-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','272','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1489','180','17-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','273','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1490','180','17-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','273','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1491','180','17-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','273','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1492','180','17-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','273','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1493','30','17-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','273','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1494','180','17-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','273','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1495','180','17-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','274','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1496','180','17-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','274','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1497','180','17-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','274','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1498','180','17-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','274','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1499','30','17-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','274','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1500','180','17-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','274','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1501','180','17-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','275','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1502','180','17-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','275','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1503','180','17-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','275','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1504','180','17-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','275','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1505','30','17-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','275','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1506','180','17-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','275','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1507','180','17-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','276','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1508','180','17-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','276','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1509','180','17-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','276','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1510','180','17-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','276','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1511','30','17-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','276','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1512','180','17-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','21','276','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1513','180','18-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','277','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1514','180','18-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','277','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1515','180','18-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','277','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1516','180','18-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','277','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1517','30','18-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','277','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1518','180','18-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','277','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1519','180','18-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','278','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1520','180','18-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','278','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1521','180','18-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','278','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1522','180','18-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','278','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1523','30','18-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','278','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1524','180','18-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','278','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1525','180','18-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','279','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1526','180','18-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','279','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1527','180','18-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','279','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1528','180','18-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','279','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1529','30','18-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','279','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1530','180','18-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','279','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1531','180','18-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','280','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1532','180','18-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','280','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1533','180','18-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','280','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1534','180','18-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','280','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1535','30','18-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','280','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1536','180','18-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','280','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1537','180','18-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','281','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1538','180','18-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','281','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1539','180','18-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','281','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1540','180','18-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','281','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1541','30','18-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','281','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1542','180','18-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','281','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1543','180','18-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','282','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1544','180','18-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','282','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1545','180','18-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','282','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1546','180','18-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','282','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1547','30','18-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','282','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1548','180','18-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','282','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1549','180','18-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','283','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1550','180','18-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','283','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1551','180','18-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','283','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1552','180','18-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','283','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1553','30','18-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','283','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1554','180','18-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','283','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1555','180','18-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','284','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1556','180','18-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','284','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1557','180','18-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','284','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1558','180','18-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','284','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1559','30','18-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','284','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1560','180','18-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','284','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1561','180','18-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','285','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1562','180','18-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','285','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1563','180','18-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','285','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1564','180','18-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','285','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1565','30','18-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','285','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1566','180','18-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','285','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1567','180','18-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','286','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1568','180','18-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','286','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1569','180','18-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','286','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1570','180','18-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','286','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1571','30','18-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','286','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1572','180','18-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','286','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1573','180','18-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','287','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1574','180','18-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','287','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1575','180','18-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','287','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1576','180','18-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','287','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1577','30','18-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','287','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1578','180','18-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','287','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1579','180','18-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','288','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1580','180','18-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','288','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1581','180','18-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','288','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1582','180','18-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','288','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1583','30','18-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','288','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1584','180','18-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','22','288','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1585','180','19-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','289','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1586','180','19-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','289','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1587','180','19-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','289','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1588','180','19-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','289','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1589','30','19-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','289','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1590','180','19-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','289','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1591','180','19-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','290','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1592','180','19-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','290','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1593','180','19-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','290','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1594','180','19-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','290','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1595','30','19-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','290','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1596','180','19-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','290','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1597','180','19-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','291','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1598','180','19-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','291','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1599','180','19-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','291','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1600','180','19-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','291','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1601','30','19-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','291','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1602','180','19-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','291','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1603','180','19-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','292','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1604','180','19-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','292','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1605','180','19-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','292','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1606','180','19-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','292','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1607','30','19-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','292','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1608','180','19-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','292','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1609','180','19-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','293','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1610','180','19-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','293','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1611','180','19-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','293','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1612','180','19-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','293','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1613','30','19-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','293','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1614','180','19-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','293','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1615','180','19-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','294','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1616','180','19-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','294','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1617','180','19-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','294','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1618','180','19-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','294','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1619','30','19-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','294','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1620','180','19-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','294','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1621','180','19-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','295','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1622','180','19-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','295','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1623','180','19-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','295','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1624','180','19-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','295','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1625','30','19-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','295','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1626','180','19-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','295','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1627','180','19-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','296','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1628','180','19-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','296','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1629','180','19-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','296','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1630','180','19-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','296','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1631','30','19-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','296','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1632','180','19-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','296','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1633','180','19-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','297','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1634','180','19-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','297','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1635','180','19-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','297','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1636','180','19-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','297','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1637','30','19-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','297','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1638','180','19-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','297','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1639','180','19-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','298','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1640','180','19-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','298','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1641','180','19-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','298','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1642','180','19-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','298','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1643','30','19-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','298','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1644','180','19-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','298','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1645','180','19-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','299','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1646','180','19-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','299','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1647','180','19-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','299','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1648','180','19-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','299','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1649','30','19-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','299','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1650','180','19-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','299','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1651','180','19-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','300','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1652','180','19-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','300','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1653','180','19-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','300','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1654','180','19-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','300','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1655','30','19-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','300','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1656','180','19-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','23','300','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1657','180','20-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','301','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1658','180','20-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','301','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1659','180','20-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','301','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1660','180','20-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','301','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1661','30','20-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','301','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1662','180','20-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','301','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1663','180','20-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','302','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1664','180','20-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','302','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1665','180','20-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','302','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1666','180','20-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','302','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1667','30','20-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','302','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1668','180','20-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','302','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1669','180','20-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','303','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1670','180','20-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','303','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1671','180','20-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','303','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1672','180','20-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','303','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1673','30','20-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','303','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1674','180','20-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','303','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1675','180','20-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','304','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1676','180','20-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','304','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1677','180','20-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','304','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1678','180','20-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','304','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1679','30','20-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','304','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1680','180','20-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','304','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1681','180','20-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','305','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1682','180','20-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','305','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1683','180','20-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','305','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1684','180','20-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','305','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1685','30','20-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','305','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1686','180','20-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','305','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1687','180','20-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','306','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1688','180','20-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','306','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1689','180','20-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','306','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1690','180','20-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','306','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1691','30','20-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','306','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1692','180','20-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','306','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1693','180','20-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','307','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1694','180','20-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','307','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1695','180','20-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','307','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1696','180','20-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','307','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1697','30','20-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','307','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1698','180','20-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','307','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1699','180','20-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','308','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1700','180','20-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','308','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1701','180','20-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','308','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1702','180','20-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','308','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1703','30','20-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','308','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1704','180','20-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','308','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1705','180','20-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','309','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1706','180','20-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','309','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1707','180','20-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','309','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1708','180','20-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','309','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1709','30','20-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','309','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1710','180','20-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','309','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1711','180','20-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','310','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1712','180','20-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','310','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1713','180','20-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','310','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1714','180','20-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','310','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1715','30','20-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','310','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1716','180','20-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','310','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1717','180','20-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','311','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1718','180','20-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','311','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1719','180','20-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','311','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1720','180','20-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','311','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');
insert into `products` (`products_id`, `products_quantity`, `products_model`, `products_image_1`, `products_price`, `color_code`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `manufacturers_id`, `products_ordered`, `products_title_1`, `section_id`, `parent_id`, `products_sort_order`, `is_attributes`, `products_sku`, `author_name`, `products_price_break`, `restrict_to_groups`, `restrict_to_customers`, `product_type`, `product_mode`, `downloads_per_customer`, `download_last_date`, `download_link`, `download_no_of_days`, `master_quantity`, `products_season`, `products_x`, `products_y`, `products_w`, `products_h`, `products_r`, `products_sx`, `products_sy`) values ('1721','30','20-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','311','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1722','180','20-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','311','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1723','180','20-07-2025 1000','ticket_icon.png','15.0000','skyblue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','312','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1724','180','20-07-2025 1100','ticket_icon.png','20.0000','orange','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','312','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1725','180','20-07-2025 1200','ticket_icon.png','27.0000','palegreen','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','312','0','N','9','N','N','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1726','180','20-07-2025 1300','ticket_icon.png','75.0000','salmon','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','312','0','N','9','N','N','','','F','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1727','30','20-07-2025 1400','penguin.png','10.0000','yellow','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','312','0','N','9','N','N','','','B','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00'),
('1728','180','20-07-2025 1500','ticket_icon.png','20.0000','blue','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0.00','1','0','0','0','','24','312','0','N','9','N','Y','','','G','P','0','0000-00-00','','','0','','0','0','0','0','0','0.00','0.00');

drop table if exists `products_description`;
CREATE TABLE `products_description` (
  `products_id` int(11) NOT NULL AUTO_INCREMENT,
  `html` char(1) NOT NULL,
  `language_id` int(11) NOT NULL DEFAULT 1,
  `products_name` varchar(64) NOT NULL,
  `products_number` varchar(128) NOT NULL,
  `products_description` text DEFAULT NULL,
  `products_url` varchar(255) DEFAULT NULL,
  `products_viewed` int(5) DEFAULT 0,
  `section_id` int(11) NOT NULL,
  PRIMARY KEY (`products_id`,`language_id`),
  KEY `products_name` (`products_name`)
);

insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1','','1','Toddler 2-4 years','1000','Toddler: $15 (4 years and under)',NULL,'0','1'),
('2','','1','Child/pensioner/concession card holder 5-14 years','1000','Child/Concession $20 (5-14 years)',NULL,'0','1'),
('3','','1','Adult 15 yrs and above','1000','Adult: $27 (15+ years)',NULL,'0','1'),
('4','','1','Family Ticket','1000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','1'),
('5','','1','Penguin Hire','1000','Penguin Skating Aids $10',NULL,'0','1'),
('6','','1','Group Booking','1000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','1'),
('7','','1','Toddler 2-4 years','1100','Toddler: $15 (4 years and under)',NULL,'0','1'),
('8','','1','Child/pensioner/concession card holder 5-14 years','1100','Child/Concession $20 (5-14 years)',NULL,'0','1'),
('9','','1','Adult 15 yrs and above','1100','Adult: $27 (15+ years)',NULL,'0','1'),
('10','','1','Family Ticket','1100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','1'),
('11','','1','Penguin Hire','1100','Penguin Skating Aids $10',NULL,'0','1'),
('12','','1','Group Booking','1100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','1'),
('13','','1','Toddler 2-4 years','1200','Toddler: $15 (4 years and under)',NULL,'0','1'),
('14','','1','Child/pensioner/concession card holder 5-14 years','1200','Child/Concession $20 (5-14 years)',NULL,'0','1'),
('15','','1','Adult 15 yrs and above','1200','Adult: $27 (15+ years)',NULL,'0','1'),
('16','','1','Family Ticket','1200','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','1'),
('17','','1','Penguin Hire','1200','Penguin Skating Aids $10',NULL,'0','1'),
('18','','1','Group Booking','1200','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','1'),
('19','','1','Toddler 2-4 years','1300','Toddler: $15 (4 years and under)',NULL,'0','1'),
('20','','1','Child/pensioner/concession card holder 5-14 years','1300','Child/Concession $20 (5-14 years)',NULL,'0','1');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('21','','1','Adult 15 yrs and above','1300','Adult: $27 (15+ years)',NULL,'0','1'),
('22','','1','Family Ticket','1300','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','1'),
('23','','1','Penguin Hire','1300','Penguin Skating Aids $10',NULL,'0','1'),
('24','','1','Group Booking','1300','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','1'),
('25','','1','Toddler 2-4 years','1400','Toddler: $15 (4 years and under)',NULL,'0','1'),
('26','','1','Child/pensioner/concession card holder 5-14 years','1400','Child/Concession $20 (5-14 years)',NULL,'0','1'),
('27','','1','Adult 15 yrs and above','1400','Adult: $27 (15+ years)',NULL,'0','1'),
('28','','1','Family Ticket','1400','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','1'),
('29','','1','Penguin Hire','1400','Penguin Skating Aids $10',NULL,'0','1'),
('30','','1','Group Booking','1400','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','1'),
('31','','1','Toddler 2-4 years','1500','Toddler: $15 (4 years and under)',NULL,'0','1'),
('32','','1','Child/pensioner/concession card holder 5-14 years','1500','Child/Concession $20 (5-14 years)',NULL,'0','1'),
('33','','1','Adult 15 yrs and above','1500','Adult: $27 (15+ years)',NULL,'0','1'),
('34','','1','Family Ticket','1500','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','1'),
('35','','1','Penguin Hire','1500','Penguin Skating Aids $10',NULL,'0','1'),
('36','','1','Group Booking','1500','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','1'),
('37','','1','Toddler 2-4 years','1600','Toddler: $15 (4 years and under)',NULL,'0','1'),
('38','','1','Child/pensioner/concession card holder 5-14 years','1600','Child/Concession $20 (5-14 years)',NULL,'0','1'),
('39','','1','Adult 15 yrs and above','1600','Adult: $27 (15+ years)',NULL,'0','1'),
('40','','1','Family Ticket','1600','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','1');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('41','','1','Penguin Hire','1600','Penguin Skating Aids $10',NULL,'0','1'),
('42','','1','Group Booking','1600','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','1'),
('43','','1','Toddler 2-4 years','1700','Toddler: $15 (4 years and under)',NULL,'0','1'),
('44','','1','Child/pensioner/concession card holder 5-14 years','1700','Child/Concession $20 (5-14 years)',NULL,'0','1'),
('45','','1','Adult 15 yrs and above','1700','Adult: $27 (15+ years)',NULL,'0','1'),
('46','','1','Family Ticket','1700','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','1'),
('47','','1','Penguin Hire','1700','Penguin Skating Aids $10',NULL,'0','1'),
('48','','1','Group Booking','1700','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','1'),
('49','','1','Toddler 2-4 years','1800','Toddler: $15 (4 years and under)',NULL,'0','1'),
('50','','1','Child/pensioner/concession card holder 5-14 years','1800','Child/Concession $20 (5-14 years)',NULL,'0','1'),
('51','','1','Adult 15 yrs and above','1800','Adult: $27 (15+ years)',NULL,'0','1'),
('52','','1','Family Ticket','1800','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','1'),
('53','','1','Penguin Hire','1800','Penguin Skating Aids $10',NULL,'0','1'),
('54','','1','Group Booking','1800','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','1'),
('55','','1','Toddler 2-4 years','1900','Toddler: $15 (4 years and under)',NULL,'0','1'),
('56','','1','Child/pensioner/concession card holder 5-14 years','1900','Child/Concession $20 (5-14 years)',NULL,'0','1'),
('57','','1','Adult 15 yrs and above','1900','Adult: $27 (15+ years)',NULL,'0','1'),
('58','','1','Family Ticket','1900','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','1'),
('59','','1','Penguin Hire','1900','Penguin Skating Aids $10',NULL,'0','1'),
('60','','1','Group Booking','1900','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','1');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('61','','1','Toddler 2-4 years','2000','Toddler: $15 (4 years and under)',NULL,'0','1'),
('62','','1','Child/pensioner/concession card holder 5-14 years','2000','Child/Concession $20 (5-14 years)',NULL,'0','1'),
('63','','1','Adult 15 yrs and above','2000','Adult: $27 (15+ years)',NULL,'0','1'),
('64','','1','Family Ticket','2000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','1'),
('65','','1','Penguin Hire','2000','Penguin Skating Aids $10',NULL,'0','1'),
('66','','1','Group Booking','2000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','1'),
('67','','1','Toddler 2-4 years','2100','Toddler: $15 (4 years and under)',NULL,'0','1'),
('68','','1','Child/pensioner/concession card holder 5-14 years','2100','Child/Concession $20 (5-14 years)',NULL,'0','1'),
('69','','1','Adult 15 yrs and above','2100','Adult: $27 (15+ years)',NULL,'0','1'),
('70','','1','Family Ticket','2100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','1'),
('71','','1','Penguin Hire','2100','Penguin Skating Aids $10',NULL,'0','1'),
('72','','1','Group Booking','2100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','1'),
('73','','1','Toddler 2-4 years','1000','Toddler: $15 (4 years and under)',NULL,'0','2'),
('74','','1','Child/pensioner/concession card holder 5-14 years','1000','Child/Concession $20 (5-14 years)',NULL,'0','2'),
('75','','1','Adult 15 yrs and above','1000','Adult: $27 (15+ years)',NULL,'0','2'),
('76','','1','Family Ticket','1000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','2'),
('77','','1','Penguin Hire','1000','Penguin Skating Aids $10',NULL,'0','2'),
('78','','1','Group Booking','1000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','2'),
('79','','1','Toddler 2-4 years','1100','Toddler: $15 (4 years and under)',NULL,'0','2'),
('80','','1','Child/pensioner/concession card holder 5-14 years','1100','Child/Concession $20 (5-14 years)',NULL,'0','2');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('81','','1','Adult 15 yrs and above','1100','Adult: $27 (15+ years)',NULL,'0','2'),
('82','','1','Family Ticket','1100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','2'),
('83','','1','Penguin Hire','1100','Penguin Skating Aids $10',NULL,'0','2'),
('84','','1','Group Booking','1100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','2'),
('85','','1','Toddler 2-4 years','1200','Toddler: $15 (4 years and under)',NULL,'0','2'),
('86','','1','Child/pensioner/concession card holder 5-14 years','1200','Child/Concession $20 (5-14 years)',NULL,'0','2'),
('87','','1','Adult 15 yrs and above','1200','Adult: $27 (15+ years)',NULL,'0','2'),
('88','','1','Family Ticket','1200','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','2'),
('89','','1','Penguin Hire','1200','Penguin Skating Aids $10',NULL,'0','2'),
('90','','1','Group Booking','1200','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','2'),
('91','','1','Toddler 2-4 years','1300','Toddler: $15 (4 years and under)',NULL,'0','2'),
('92','','1','Child/pensioner/concession card holder 5-14 years','1300','Child/Concession $20 (5-14 years)',NULL,'0','2'),
('93','','1','Adult 15 yrs and above','1300','Adult: $27 (15+ years)',NULL,'0','2'),
('94','','1','Family Ticket','1300','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','2'),
('95','','1','Penguin Hire','1300','Penguin Skating Aids $10',NULL,'0','2'),
('96','','1','Group Booking','1300','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','2'),
('97','','1','Toddler 2-4 years','1400','Toddler: $15 (4 years and under)',NULL,'0','2'),
('98','','1','Child/pensioner/concession card holder 5-14 years','1400','Child/Concession $20 (5-14 years)',NULL,'0','2'),
('99','','1','Adult 15 yrs and above','1400','Adult: $27 (15+ years)',NULL,'0','2'),
('100','','1','Family Ticket','1400','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','2');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('101','','1','Penguin Hire','1400','Penguin Skating Aids $10',NULL,'0','2'),
('102','','1','Group Booking','1400','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','2'),
('103','','1','Toddler 2-4 years','1500','Toddler: $15 (4 years and under)',NULL,'0','2'),
('104','','1','Child/pensioner/concession card holder 5-14 years','1500','Child/Concession $20 (5-14 years)',NULL,'0','2'),
('105','','1','Adult 15 yrs and above','1500','Adult: $27 (15+ years)',NULL,'0','2'),
('106','','1','Family Ticket','1500','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','2'),
('107','','1','Penguin Hire','1500','Penguin Skating Aids $10',NULL,'0','2'),
('108','','1','Group Booking','1500','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','2'),
('109','','1','Toddler 2-4 years','1600','Toddler: $15 (4 years and under)',NULL,'0','2'),
('110','','1','Child/pensioner/concession card holder 5-14 years','1600','Child/Concession $20 (5-14 years)',NULL,'0','2'),
('111','','1','Adult 15 yrs and above','1600','Adult: $27 (15+ years)',NULL,'0','2'),
('112','','1','Family Ticket','1600','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','2'),
('113','','1','Penguin Hire','1600','Penguin Skating Aids $10',NULL,'0','2'),
('114','','1','Group Booking','1600','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','2'),
('115','','1','Toddler 2-4 years','1700','Toddler: $15 (4 years and under)',NULL,'0','2'),
('116','','1','Child/pensioner/concession card holder 5-14 years','1700','Child/Concession $20 (5-14 years)',NULL,'0','2'),
('117','','1','Adult 15 yrs and above','1700','Adult: $27 (15+ years)',NULL,'0','2'),
('118','','1','Family Ticket','1700','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','2'),
('119','','1','Penguin Hire','1700','Penguin Skating Aids $10',NULL,'0','2'),
('120','','1','Group Booking','1700','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','2');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('121','','1','Toddler 2-4 years','1800','Toddler: $15 (4 years and under)',NULL,'0','2'),
('122','','1','Child/pensioner/concession card holder 5-14 years','1800','Child/Concession $20 (5-14 years)',NULL,'0','2'),
('123','','1','Adult 15 yrs and above','1800','Adult: $27 (15+ years)',NULL,'0','2'),
('124','','1','Family Ticket','1800','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','2'),
('125','','1','Penguin Hire','1800','Penguin Skating Aids $10',NULL,'0','2'),
('126','','1','Group Booking','1800','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','2'),
('127','','1','Toddler 2-4 years','1900','Toddler: $15 (4 years and under)',NULL,'0','2'),
('128','','1','Child/pensioner/concession card holder 5-14 years','1900','Child/Concession $20 (5-14 years)',NULL,'0','2'),
('129','','1','Adult 15 yrs and above','1900','Adult: $27 (15+ years)',NULL,'0','2'),
('130','','1','Family Ticket','1900','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','2'),
('131','','1','Penguin Hire','1900','Penguin Skating Aids $10',NULL,'0','2'),
('132','','1','Group Booking','1900','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','2'),
('133','','1','Toddler 2-4 years','2000','Toddler: $15 (4 years and under)',NULL,'0','2'),
('134','','1','Child/pensioner/concession card holder 5-14 years','2000','Child/Concession $20 (5-14 years)',NULL,'0','2'),
('135','','1','Adult 15 yrs and above','2000','Adult: $27 (15+ years)',NULL,'0','2'),
('136','','1','Family Ticket','2000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','2'),
('137','','1','Penguin Hire','2000','Penguin Skating Aids $10',NULL,'0','2'),
('138','','1','Group Booking','2000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','2'),
('139','','1','Toddler 2-4 years','2100','Toddler: $15 (4 years and under)',NULL,'0','2'),
('140','','1','Child/pensioner/concession card holder 5-14 years','2100','Child/Concession $20 (5-14 years)',NULL,'0','2');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('141','','1','Adult 15 yrs and above','2100','Adult: $27 (15+ years)',NULL,'0','2'),
('142','','1','Family Ticket','2100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','2'),
('143','','1','Penguin Hire','2100','Penguin Skating Aids $10',NULL,'0','2'),
('144','','1','Group Booking','2100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','2'),
('145','','1','Toddler 2-4 years','1000','Toddler: $15 (4 years and under)',NULL,'0','3'),
('146','','1','Child/pensioner/concession card holder 5-14 years','1000','Child/Concession $20 (5-14 years)',NULL,'0','3'),
('147','','1','Adult 15 yrs and above','1000','Adult: $27 (15+ years)',NULL,'0','3'),
('148','','1','Family Ticket','1000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','3'),
('149','','1','Penguin Hire','1000','Penguin Skating Aids $10',NULL,'0','3'),
('150','','1','Group Booking','1000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','3'),
('151','','1','Toddler 2-4 years','1100','Toddler: $15 (4 years and under)',NULL,'0','3'),
('152','','1','Child/pensioner/concession card holder 5-14 years','1100','Child/Concession $20 (5-14 years)',NULL,'0','3'),
('153','','1','Adult 15 yrs and above','1100','Adult: $27 (15+ years)',NULL,'0','3'),
('154','','1','Family Ticket','1100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','3'),
('155','','1','Penguin Hire','1100','Penguin Skating Aids $10',NULL,'0','3'),
('156','','1','Group Booking','1100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','3'),
('157','','1','Toddler 2-4 years','1200','Toddler: $15 (4 years and under)',NULL,'0','3'),
('158','','1','Child/pensioner/concession card holder 5-14 years','1200','Child/Concession $20 (5-14 years)',NULL,'0','3'),
('159','','1','Adult 15 yrs and above','1200','Adult: $27 (15+ years)',NULL,'0','3'),
('160','','1','Family Ticket','1200','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','3');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('161','','1','Penguin Hire','1200','Penguin Skating Aids $10',NULL,'0','3'),
('162','','1','Group Booking','1200','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','3'),
('163','','1','Toddler 2-4 years','1300','Toddler: $15 (4 years and under)',NULL,'0','3'),
('164','','1','Child/pensioner/concession card holder 5-14 years','1300','Child/Concession $20 (5-14 years)',NULL,'0','3'),
('165','','1','Adult 15 yrs and above','1300','Adult: $27 (15+ years)',NULL,'0','3'),
('166','','1','Family Ticket','1300','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','3'),
('167','','1','Penguin Hire','1300','Penguin Skating Aids $10',NULL,'0','3'),
('168','','1','Group Booking','1300','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','3'),
('169','','1','Toddler 2-4 years','1400','Toddler: $15 (4 years and under)',NULL,'0','3'),
('170','','1','Child/pensioner/concession card holder 5-14 years','1400','Child/Concession $20 (5-14 years)',NULL,'0','3'),
('171','','1','Adult 15 yrs and above','1400','Adult: $27 (15+ years)',NULL,'0','3'),
('172','','1','Family Ticket','1400','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','3'),
('173','','1','Penguin Hire','1400','Penguin Skating Aids $10',NULL,'0','3'),
('174','','1','Group Booking','1400','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','3'),
('175','','1','Toddler 2-4 years','1500','Toddler: $15 (4 years and under)',NULL,'0','3'),
('176','','1','Child/pensioner/concession card holder 5-14 years','1500','Child/Concession $20 (5-14 years)',NULL,'0','3'),
('177','','1','Adult 15 yrs and above','1500','Adult: $27 (15+ years)',NULL,'0','3'),
('178','','1','Family Ticket','1500','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','3'),
('179','','1','Penguin Hire','1500','Penguin Skating Aids $10',NULL,'0','3'),
('180','','1','Group Booking','1500','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','3');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('181','','1','Toddler 2-4 years','1600','Toddler: $15 (4 years and under)',NULL,'0','3'),
('182','','1','Child/pensioner/concession card holder 5-14 years','1600','Child/Concession $20 (5-14 years)',NULL,'0','3'),
('183','','1','Adult 15 yrs and above','1600','Adult: $27 (15+ years)',NULL,'0','3'),
('184','','1','Family Ticket','1600','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','3'),
('185','','1','Penguin Hire','1600','Penguin Skating Aids $10',NULL,'0','3'),
('186','','1','Group Booking','1600','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','3'),
('187','','1','Toddler 2-4 years','1700','Toddler: $15 (4 years and under)',NULL,'0','3'),
('188','','1','Child/pensioner/concession card holder 5-14 years','1700','Child/Concession $20 (5-14 years)',NULL,'0','3'),
('189','','1','Adult 15 yrs and above','1700','Adult: $27 (15+ years)',NULL,'0','3'),
('190','','1','Family Ticket','1700','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','3'),
('191','','1','Penguin Hire','1700','Penguin Skating Aids $10',NULL,'0','3'),
('192','','1','Group Booking','1700','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','3'),
('193','','1','Toddler 2-4 years','1800','Toddler: $15 (4 years and under)',NULL,'0','3'),
('194','','1','Child/pensioner/concession card holder 5-14 years','1800','Child/Concession $20 (5-14 years)',NULL,'0','3'),
('195','','1','Adult 15 yrs and above','1800','Adult: $27 (15+ years)',NULL,'0','3'),
('196','','1','Family Ticket','1800','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','3'),
('197','','1','Penguin Hire','1800','Penguin Skating Aids $10',NULL,'0','3'),
('198','','1','Group Booking','1800','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','3'),
('199','','1','Toddler 2-4 years','1900','Toddler: $15 (4 years and under)',NULL,'0','3'),
('200','','1','Child/pensioner/concession card holder 5-14 years','1900','Child/Concession $20 (5-14 years)',NULL,'0','3');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('201','','1','Adult 15 yrs and above','1900','Adult: $27 (15+ years)',NULL,'0','3'),
('202','','1','Family Ticket','1900','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','3'),
('203','','1','Penguin Hire','1900','Penguin Skating Aids $10',NULL,'0','3'),
('204','','1','Group Booking','1900','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','3'),
('205','','1','Toddler 2-4 years','2000','Toddler: $15 (4 years and under)',NULL,'0','3'),
('206','','1','Child/pensioner/concession card holder 5-14 years','2000','Child/Concession $20 (5-14 years)',NULL,'0','3'),
('207','','1','Adult 15 yrs and above','2000','Adult: $27 (15+ years)',NULL,'0','3'),
('208','','1','Family Ticket','2000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','3'),
('209','','1','Penguin Hire','2000','Penguin Skating Aids $10',NULL,'0','3'),
('210','','1','Group Booking','2000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','3'),
('211','','1','Toddler 2-4 years','2100','Toddler: $15 (4 years and under)',NULL,'0','3'),
('212','','1','Child/pensioner/concession card holder 5-14 years','2100','Child/Concession $20 (5-14 years)',NULL,'0','3'),
('213','','1','Adult 15 yrs and above','2100','Adult: $27 (15+ years)',NULL,'0','3'),
('214','','1','Family Ticket','2100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','3'),
('215','','1','Penguin Hire','2100','Penguin Skating Aids $10',NULL,'0','3'),
('216','','1','Group Booking','2100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','3'),
('217','','1','Toddler 2-4 years','1000','Toddler: $15 (4 years and under)',NULL,'0','4'),
('218','','1','Child/pensioner/concession card holder 5-14 years','1000','Child/Concession $20 (5-14 years)',NULL,'0','4'),
('219','','1','Adult 15 yrs and above','1000','Adult: $27 (15+ years)',NULL,'0','4'),
('220','','1','Family Ticket','1000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','4');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('221','','1','Penguin Hire','1000','Penguin Skating Aids $10',NULL,'0','4'),
('222','','1','Group Booking','1000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','4'),
('223','','1','Toddler 2-4 years','1100','Toddler: $15 (4 years and under)',NULL,'0','4'),
('224','','1','Child/pensioner/concession card holder 5-14 years','1100','Child/Concession $20 (5-14 years)',NULL,'0','4'),
('225','','1','Adult 15 yrs and above','1100','Adult: $27 (15+ years)',NULL,'0','4'),
('226','','1','Family Ticket','1100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','4'),
('227','','1','Penguin Hire','1100','Penguin Skating Aids $10',NULL,'0','4'),
('228','','1','Group Booking','1100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','4'),
('229','','1','Toddler 2-4 years','1200','Toddler: $15 (4 years and under)',NULL,'0','4'),
('230','','1','Child/pensioner/concession card holder 5-14 years','1200','Child/Concession $20 (5-14 years)',NULL,'0','4'),
('231','','1','Adult 15 yrs and above','1200','Adult: $27 (15+ years)',NULL,'0','4'),
('232','','1','Family Ticket','1200','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','4'),
('233','','1','Penguin Hire','1200','Penguin Skating Aids $10',NULL,'0','4'),
('234','','1','Group Booking','1200','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','4'),
('235','','1','Toddler 2-4 years','1300','Toddler: $15 (4 years and under)',NULL,'0','4'),
('236','','1','Child/pensioner/concession card holder 5-14 years','1300','Child/Concession $20 (5-14 years)',NULL,'0','4'),
('237','','1','Adult 15 yrs and above','1300','Adult: $27 (15+ years)',NULL,'0','4'),
('238','','1','Family Ticket','1300','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','4'),
('239','','1','Penguin Hire','1300','Penguin Skating Aids $10',NULL,'0','4'),
('240','','1','Group Booking','1300','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','4');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('241','','1','Toddler 2-4 years','1400','Toddler: $15 (4 years and under)',NULL,'0','4'),
('242','','1','Child/pensioner/concession card holder 5-14 years','1400','Child/Concession $20 (5-14 years)',NULL,'0','4'),
('243','','1','Adult 15 yrs and above','1400','Adult: $27 (15+ years)',NULL,'0','4'),
('244','','1','Family Ticket','1400','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','4'),
('245','','1','Penguin Hire','1400','Penguin Skating Aids $10',NULL,'0','4'),
('246','','1','Group Booking','1400','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','4'),
('247','','1','Toddler 2-4 years','1500','Toddler: $15 (4 years and under)',NULL,'0','4'),
('248','','1','Child/pensioner/concession card holder 5-14 years','1500','Child/Concession $20 (5-14 years)',NULL,'0','4'),
('249','','1','Adult 15 yrs and above','1500','Adult: $27 (15+ years)',NULL,'0','4'),
('250','','1','Family Ticket','1500','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','4'),
('251','','1','Penguin Hire','1500','Penguin Skating Aids $10',NULL,'0','4'),
('252','','1','Group Booking','1500','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','4'),
('253','','1','Toddler 2-4 years','1600','Toddler: $15 (4 years and under)',NULL,'0','4'),
('254','','1','Child/pensioner/concession card holder 5-14 years','1600','Child/Concession $20 (5-14 years)',NULL,'0','4'),
('255','','1','Adult 15 yrs and above','1600','Adult: $27 (15+ years)',NULL,'0','4'),
('256','','1','Family Ticket','1600','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','4'),
('257','','1','Penguin Hire','1600','Penguin Skating Aids $10',NULL,'0','4'),
('258','','1','Group Booking','1600','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','4'),
('259','','1','Toddler 2-4 years','1700','Toddler: $15 (4 years and under)',NULL,'0','4'),
('260','','1','Child/pensioner/concession card holder 5-14 years','1700','Child/Concession $20 (5-14 years)',NULL,'0','4');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('261','','1','Adult 15 yrs and above','1700','Adult: $27 (15+ years)',NULL,'0','4'),
('262','','1','Family Ticket','1700','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','4'),
('263','','1','Penguin Hire','1700','Penguin Skating Aids $10',NULL,'0','4'),
('264','','1','Group Booking','1700','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','4'),
('265','','1','Toddler 2-4 years','1800','Toddler: $15 (4 years and under)',NULL,'0','4'),
('266','','1','Child/pensioner/concession card holder 5-14 years','1800','Child/Concession $20 (5-14 years)',NULL,'0','4'),
('267','','1','Adult 15 yrs and above','1800','Adult: $27 (15+ years)',NULL,'0','4'),
('268','','1','Family Ticket','1800','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','4'),
('269','','1','Penguin Hire','1800','Penguin Skating Aids $10',NULL,'0','4'),
('270','','1','Group Booking','1800','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','4'),
('271','','1','Toddler 2-4 years','1900','Toddler: $15 (4 years and under)',NULL,'0','4'),
('272','','1','Child/pensioner/concession card holder 5-14 years','1900','Child/Concession $20 (5-14 years)',NULL,'0','4'),
('273','','1','Adult 15 yrs and above','1900','Adult: $27 (15+ years)',NULL,'0','4'),
('274','','1','Family Ticket','1900','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','4'),
('275','','1','Penguin Hire','1900','Penguin Skating Aids $10',NULL,'0','4'),
('276','','1','Group Booking','1900','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','4'),
('277','','1','Toddler 2-4 years','2000','Toddler: $15 (4 years and under)',NULL,'0','4'),
('278','','1','Child/pensioner/concession card holder 5-14 years','2000','Child/Concession $20 (5-14 years)',NULL,'0','4'),
('279','','1','Adult 15 yrs and above','2000','Adult: $27 (15+ years)',NULL,'0','4'),
('280','','1','Family Ticket','2000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','4');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('281','','1','Penguin Hire','2000','Penguin Skating Aids $10',NULL,'0','4'),
('282','','1','Group Booking','2000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','4'),
('283','','1','Toddler 2-4 years','2100','Toddler: $15 (4 years and under)',NULL,'0','4'),
('284','','1','Child/pensioner/concession card holder 5-14 years','2100','Child/Concession $20 (5-14 years)',NULL,'0','4'),
('285','','1','Adult 15 yrs and above','2100','Adult: $27 (15+ years)',NULL,'0','4'),
('286','','1','Family Ticket','2100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','4'),
('287','','1','Penguin Hire','2100','Penguin Skating Aids $10',NULL,'0','4'),
('288','','1','Group Booking','2100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','4'),
('289','','1','Toddler 2-4 years','1000','Toddler: $15 (4 years and under)',NULL,'0','5'),
('290','','1','Child/pensioner/concession card holder 5-14 years','1000','Child/Concession $20 (5-14 years)',NULL,'0','5'),
('291','','1','Adult 15 yrs and above','1000','Adult: $27 (15+ years)',NULL,'0','5'),
('292','','1','Family Ticket','1000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','5'),
('293','','1','Penguin Hire','1000','Penguin Skating Aids $10',NULL,'0','5'),
('294','','1','Group Booking','1000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','5'),
('295','','1','Toddler 2-4 years','1100','Toddler: $15 (4 years and under)',NULL,'0','5'),
('296','','1','Child/pensioner/concession card holder 5-14 years','1100','Child/Concession $20 (5-14 years)',NULL,'0','5'),
('297','','1','Adult 15 yrs and above','1100','Adult: $27 (15+ years)',NULL,'0','5'),
('298','','1','Family Ticket','1100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','5'),
('299','','1','Penguin Hire','1100','Penguin Skating Aids $10',NULL,'0','5'),
('300','','1','Group Booking','1100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','5');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('301','','1','Toddler 2-4 years','1200','Toddler: $15 (4 years and under)',NULL,'0','5'),
('302','','1','Child/pensioner/concession card holder 5-14 years','1200','Child/Concession $20 (5-14 years)',NULL,'0','5'),
('303','','1','Adult 15 yrs and above','1200','Adult: $27 (15+ years)',NULL,'0','5'),
('304','','1','Family Ticket','1200','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','5'),
('305','','1','Penguin Hire','1200','Penguin Skating Aids $10',NULL,'0','5'),
('306','','1','Group Booking','1200','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','5'),
('307','','1','Toddler 2-4 years','1300','Toddler: $15 (4 years and under)',NULL,'0','5'),
('308','','1','Child/pensioner/concession card holder 5-14 years','1300','Child/Concession $20 (5-14 years)',NULL,'0','5'),
('309','','1','Adult 15 yrs and above','1300','Adult: $27 (15+ years)',NULL,'0','5'),
('310','','1','Family Ticket','1300','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','5'),
('311','','1','Penguin Hire','1300','Penguin Skating Aids $10',NULL,'0','5'),
('312','','1','Group Booking','1300','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','5'),
('313','','1','Toddler 2-4 years','1400','Toddler: $15 (4 years and under)',NULL,'0','5'),
('314','','1','Child/pensioner/concession card holder 5-14 years','1400','Child/Concession $20 (5-14 years)',NULL,'0','5'),
('315','','1','Adult 15 yrs and above','1400','Adult: $27 (15+ years)',NULL,'0','5'),
('316','','1','Family Ticket','1400','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','5'),
('317','','1','Penguin Hire','1400','Penguin Skating Aids $10',NULL,'0','5'),
('318','','1','Group Booking','1400','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','5'),
('319','','1','Toddler 2-4 years','1500','Toddler: $15 (4 years and under)',NULL,'0','5'),
('320','','1','Child/pensioner/concession card holder 5-14 years','1500','Child/Concession $20 (5-14 years)',NULL,'0','5');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('321','','1','Adult 15 yrs and above','1500','Adult: $27 (15+ years)',NULL,'0','5'),
('322','','1','Family Ticket','1500','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','5'),
('323','','1','Penguin Hire','1500','Penguin Skating Aids $10',NULL,'0','5'),
('324','','1','Group Booking','1500','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','5'),
('325','','1','Toddler 2-4 years','1600','Toddler: $15 (4 years and under)',NULL,'0','5'),
('326','','1','Child/pensioner/concession card holder 5-14 years','1600','Child/Concession $20 (5-14 years)',NULL,'0','5'),
('327','','1','Adult 15 yrs and above','1600','Adult: $27 (15+ years)',NULL,'0','5'),
('328','','1','Family Ticket','1600','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','5'),
('329','','1','Penguin Hire','1600','Penguin Skating Aids $10',NULL,'0','5'),
('330','','1','Group Booking','1600','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','5'),
('331','','1','Toddler 2-4 years','1700','Toddler: $15 (4 years and under)',NULL,'0','5'),
('332','','1','Child/pensioner/concession card holder 5-14 years','1700','Child/Concession $20 (5-14 years)',NULL,'0','5'),
('333','','1','Adult 15 yrs and above','1700','Adult: $27 (15+ years)',NULL,'0','5'),
('334','','1','Family Ticket','1700','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','5'),
('335','','1','Penguin Hire','1700','Penguin Skating Aids $10',NULL,'0','5'),
('336','','1','Group Booking','1700','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','5'),
('337','','1','Toddler 2-4 years','1800','Toddler: $15 (4 years and under)',NULL,'0','5'),
('338','','1','Child/pensioner/concession card holder 5-14 years','1800','Child/Concession $20 (5-14 years)',NULL,'0','5'),
('339','','1','Adult 15 yrs and above','1800','Adult: $27 (15+ years)',NULL,'0','5'),
('340','','1','Family Ticket','1800','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','5');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('341','','1','Penguin Hire','1800','Penguin Skating Aids $10',NULL,'0','5'),
('342','','1','Group Booking','1800','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','5'),
('343','','1','Toddler 2-4 years','1900','Toddler: $15 (4 years and under)',NULL,'0','5'),
('344','','1','Child/pensioner/concession card holder 5-14 years','1900','Child/Concession $20 (5-14 years)',NULL,'0','5'),
('345','','1','Adult 15 yrs and above','1900','Adult: $27 (15+ years)',NULL,'0','5'),
('346','','1','Family Ticket','1900','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','5'),
('347','','1','Penguin Hire','1900','Penguin Skating Aids $10',NULL,'0','5'),
('348','','1','Group Booking','1900','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','5'),
('349','','1','Toddler 2-4 years','2000','Toddler: $15 (4 years and under)',NULL,'0','5'),
('350','','1','Child/pensioner/concession card holder 5-14 years','2000','Child/Concession $20 (5-14 years)',NULL,'0','5'),
('351','','1','Adult 15 yrs and above','2000','Adult: $27 (15+ years)',NULL,'0','5'),
('352','','1','Family Ticket','2000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','5'),
('353','','1','Penguin Hire','2000','Penguin Skating Aids $10',NULL,'0','5'),
('354','','1','Group Booking','2000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','5'),
('355','','1','Toddler 2-4 years','2100','Toddler: $15 (4 years and under)',NULL,'0','5'),
('356','','1','Child/pensioner/concession card holder 5-14 years','2100','Child/Concession $20 (5-14 years)',NULL,'0','5'),
('357','','1','Adult 15 yrs and above','2100','Adult: $27 (15+ years)',NULL,'0','5'),
('358','','1','Family Ticket','2100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','5'),
('359','','1','Penguin Hire','2100','Penguin Skating Aids $10',NULL,'0','5'),
('360','','1','Group Booking','2100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','5');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('361','','1','Toddler 2-4 years','1000','Toddler: $15 (4 years and under)',NULL,'0','6'),
('362','','1','Child/pensioner/concession card holder 5-14 years','1000','Child/Concession $20 (5-14 years)',NULL,'0','6'),
('363','','1','Adult 15 yrs and above','1000','Adult: $27 (15+ years)',NULL,'0','6'),
('364','','1','Family Ticket','1000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','6'),
('365','','1','Penguin Hire','1000','Penguin Skating Aids $10',NULL,'0','6'),
('366','','1','Group Booking','1000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','6'),
('367','','1','Toddler 2-4 years','1100','Toddler: $15 (4 years and under)',NULL,'0','6'),
('368','','1','Child/pensioner/concession card holder 5-14 years','1100','Child/Concession $20 (5-14 years)',NULL,'0','6'),
('369','','1','Adult 15 yrs and above','1100','Adult: $27 (15+ years)',NULL,'0','6'),
('370','','1','Family Ticket','1100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','6'),
('371','','1','Penguin Hire','1100','Penguin Skating Aids $10',NULL,'0','6'),
('372','','1','Group Booking','1100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','6'),
('373','','1','Toddler 2-4 years','1200','Toddler: $15 (4 years and under)',NULL,'0','6'),
('374','','1','Child/pensioner/concession card holder 5-14 years','1200','Child/Concession $20 (5-14 years)',NULL,'0','6'),
('375','','1','Adult 15 yrs and above','1200','Adult: $27 (15+ years)',NULL,'0','6'),
('376','','1','Family Ticket','1200','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','6'),
('377','','1','Penguin Hire','1200','Penguin Skating Aids $10',NULL,'0','6'),
('378','','1','Group Booking','1200','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','6'),
('379','','1','Toddler 2-4 years','1300','Toddler: $15 (4 years and under)',NULL,'0','6'),
('380','','1','Child/pensioner/concession card holder 5-14 years','1300','Child/Concession $20 (5-14 years)',NULL,'0','6');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('381','','1','Adult 15 yrs and above','1300','Adult: $27 (15+ years)',NULL,'0','6'),
('382','','1','Family Ticket','1300','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','6'),
('383','','1','Penguin Hire','1300','Penguin Skating Aids $10',NULL,'0','6'),
('384','','1','Group Booking','1300','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','6'),
('385','','1','Toddler 2-4 years','1400','Toddler: $15 (4 years and under)',NULL,'0','6'),
('386','','1','Child/pensioner/concession card holder 5-14 years','1400','Child/Concession $20 (5-14 years)',NULL,'0','6'),
('387','','1','Adult 15 yrs and above','1400','Adult: $27 (15+ years)',NULL,'0','6'),
('388','','1','Family Ticket','1400','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','6'),
('389','','1','Penguin Hire','1400','Penguin Skating Aids $10',NULL,'0','6'),
('390','','1','Group Booking','1400','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','6'),
('391','','1','Toddler 2-4 years','1500','Toddler: $15 (4 years and under)',NULL,'0','6'),
('392','','1','Child/pensioner/concession card holder 5-14 years','1500','Child/Concession $20 (5-14 years)',NULL,'0','6'),
('393','','1','Adult 15 yrs and above','1500','Adult: $27 (15+ years)',NULL,'0','6'),
('394','','1','Family Ticket','1500','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','6'),
('395','','1','Penguin Hire','1500','Penguin Skating Aids $10',NULL,'0','6'),
('396','','1','Group Booking','1500','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','6'),
('397','','1','Toddler 2-4 years','1600','Toddler: $15 (4 years and under)',NULL,'0','6'),
('398','','1','Child/pensioner/concession card holder 5-14 years','1600','Child/Concession $20 (5-14 years)',NULL,'0','6'),
('399','','1','Adult 15 yrs and above','1600','Adult: $27 (15+ years)',NULL,'0','6'),
('400','','1','Family Ticket','1600','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','6');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('401','','1','Penguin Hire','1600','Penguin Skating Aids $10',NULL,'0','6'),
('402','','1','Group Booking','1600','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','6'),
('403','','1','Toddler 2-4 years','1700','Toddler: $15 (4 years and under)',NULL,'0','6'),
('404','','1','Child/pensioner/concession card holder 5-14 years','1700','Child/Concession $20 (5-14 years)',NULL,'0','6'),
('405','','1','Adult 15 yrs and above','1700','Adult: $27 (15+ years)',NULL,'0','6'),
('406','','1','Family Ticket','1700','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','6'),
('407','','1','Penguin Hire','1700','Penguin Skating Aids $10',NULL,'0','6'),
('408','','1','Group Booking','1700','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','6'),
('409','','1','Toddler 2-4 years','1800','Toddler: $15 (4 years and under)',NULL,'0','6'),
('410','','1','Child/pensioner/concession card holder 5-14 years','1800','Child/Concession $20 (5-14 years)',NULL,'0','6'),
('411','','1','Adult 15 yrs and above','1800','Adult: $27 (15+ years)',NULL,'0','6'),
('412','','1','Family Ticket','1800','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','6'),
('413','','1','Penguin Hire','1800','Penguin Skating Aids $10',NULL,'0','6'),
('414','','1','Group Booking','1800','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','6'),
('415','','1','Toddler 2-4 years','1900','Toddler: $15 (4 years and under)',NULL,'0','6'),
('416','','1','Child/pensioner/concession card holder 5-14 years','1900','Child/Concession $20 (5-14 years)',NULL,'0','6'),
('417','','1','Adult 15 yrs and above','1900','Adult: $27 (15+ years)',NULL,'0','6'),
('418','','1','Family Ticket','1900','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','6'),
('419','','1','Penguin Hire','1900','Penguin Skating Aids $10',NULL,'0','6'),
('420','','1','Group Booking','1900','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','6');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('421','','1','Toddler 2-4 years','2000','Toddler: $15 (4 years and under)',NULL,'0','6'),
('422','','1','Child/pensioner/concession card holder 5-14 years','2000','Child/Concession $20 (5-14 years)',NULL,'0','6'),
('423','','1','Adult 15 yrs and above','2000','Adult: $27 (15+ years)',NULL,'0','6'),
('424','','1','Family Ticket','2000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','6'),
('425','','1','Penguin Hire','2000','Penguin Skating Aids $10',NULL,'0','6'),
('426','','1','Group Booking','2000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','6'),
('427','','1','Toddler 2-4 years','2100','Toddler: $15 (4 years and under)',NULL,'0','6'),
('428','','1','Child/pensioner/concession card holder 5-14 years','2100','Child/Concession $20 (5-14 years)',NULL,'0','6'),
('429','','1','Adult 15 yrs and above','2100','Adult: $27 (15+ years)',NULL,'0','6'),
('430','','1','Family Ticket','2100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','6'),
('431','','1','Penguin Hire','2100','Penguin Skating Aids $10',NULL,'0','6'),
('432','','1','Group Booking','2100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','6'),
('433','','1','Toddler 2-4 years','1000','Toddler: $15 (4 years and under)',NULL,'0','7'),
('434','','1','Child/pensioner/concession card holder 5-14 years','1000','Child/Concession $20 (5-14 years)',NULL,'0','7'),
('435','','1','Adult 15 yrs and above','1000','Adult: $27 (15+ years)',NULL,'0','7'),
('436','','1','Family Ticket','1000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','7'),
('437','','1','Penguin Hire','1000','Penguin Skating Aids $10',NULL,'0','7'),
('438','','1','Group Booking','1000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','7'),
('439','','1','Toddler 2-4 years','1100','Toddler: $15 (4 years and under)',NULL,'0','7'),
('440','','1','Child/pensioner/concession card holder 5-14 years','1100','Child/Concession $20 (5-14 years)',NULL,'0','7');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('441','','1','Adult 15 yrs and above','1100','Adult: $27 (15+ years)',NULL,'0','7'),
('442','','1','Family Ticket','1100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','7'),
('443','','1','Penguin Hire','1100','Penguin Skating Aids $10',NULL,'0','7'),
('444','','1','Group Booking','1100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','7'),
('445','','1','Toddler 2-4 years','1200','Toddler: $15 (4 years and under)',NULL,'0','7'),
('446','','1','Child/pensioner/concession card holder 5-14 years','1200','Child/Concession $20 (5-14 years)',NULL,'0','7'),
('447','','1','Adult 15 yrs and above','1200','Adult: $27 (15+ years)',NULL,'0','7'),
('448','','1','Family Ticket','1200','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','7'),
('449','','1','Penguin Hire','1200','Penguin Skating Aids $10',NULL,'0','7'),
('450','','1','Group Booking','1200','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','7'),
('451','','1','Toddler 2-4 years','1300','Toddler: $15 (4 years and under)',NULL,'0','7'),
('452','','1','Child/pensioner/concession card holder 5-14 years','1300','Child/Concession $20 (5-14 years)',NULL,'0','7'),
('453','','1','Adult 15 yrs and above','1300','Adult: $27 (15+ years)',NULL,'0','7'),
('454','','1','Family Ticket','1300','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','7'),
('455','','1','Penguin Hire','1300','Penguin Skating Aids $10',NULL,'0','7'),
('456','','1','Group Booking','1300','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','7'),
('457','','1','Toddler 2-4 years','1400','Toddler: $15 (4 years and under)',NULL,'0','7'),
('458','','1','Child/pensioner/concession card holder 5-14 years','1400','Child/Concession $20 (5-14 years)',NULL,'0','7'),
('459','','1','Adult 15 yrs and above','1400','Adult: $27 (15+ years)',NULL,'0','7'),
('460','','1','Family Ticket','1400','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','7');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('461','','1','Penguin Hire','1400','Penguin Skating Aids $10',NULL,'0','7'),
('462','','1','Group Booking','1400','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','7'),
('463','','1','Toddler 2-4 years','1500','Toddler: $15 (4 years and under)',NULL,'0','7'),
('464','','1','Child/pensioner/concession card holder 5-14 years','1500','Child/Concession $20 (5-14 years)',NULL,'0','7'),
('465','','1','Adult 15 yrs and above','1500','Adult: $27 (15+ years)',NULL,'0','7'),
('466','','1','Family Ticket','1500','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','7'),
('467','','1','Penguin Hire','1500','Penguin Skating Aids $10',NULL,'0','7'),
('468','','1','Group Booking','1500','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','7'),
('469','','1','Toddler 2-4 years','1600','Toddler: $15 (4 years and under)',NULL,'0','7'),
('470','','1','Child/pensioner/concession card holder 5-14 years','1600','Child/Concession $20 (5-14 years)',NULL,'0','7'),
('471','','1','Adult 15 yrs and above','1600','Adult: $27 (15+ years)',NULL,'0','7'),
('472','','1','Family Ticket','1600','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','7'),
('473','','1','Penguin Hire','1600','Penguin Skating Aids $10',NULL,'0','7'),
('474','','1','Group Booking','1600','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','7'),
('475','','1','Toddler 2-4 years','1700','Toddler: $15 (4 years and under)',NULL,'0','7'),
('476','','1','Child/pensioner/concession card holder 5-14 years','1700','Child/Concession $20 (5-14 years)',NULL,'0','7'),
('477','','1','Adult 15 yrs and above','1700','Adult: $27 (15+ years)',NULL,'0','7'),
('478','','1','Family Ticket','1700','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','7'),
('479','','1','Penguin Hire','1700','Penguin Skating Aids $10',NULL,'0','7'),
('480','','1','Group Booking','1700','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','7');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('481','','1','Toddler 2-4 years','1800','Toddler: $15 (4 years and under)',NULL,'0','7'),
('482','','1','Child/pensioner/concession card holder 5-14 years','1800','Child/Concession $20 (5-14 years)',NULL,'0','7'),
('483','','1','Adult 15 yrs and above','1800','Adult: $27 (15+ years)',NULL,'0','7'),
('484','','1','Family Ticket','1800','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','7'),
('485','','1','Penguin Hire','1800','Penguin Skating Aids $10',NULL,'0','7'),
('486','','1','Group Booking','1800','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','7'),
('487','','1','Toddler 2-4 years','1900','Toddler: $15 (4 years and under)',NULL,'0','7'),
('488','','1','Child/pensioner/concession card holder 5-14 years','1900','Child/Concession $20 (5-14 years)',NULL,'0','7'),
('489','','1','Adult 15 yrs and above','1900','Adult: $27 (15+ years)',NULL,'0','7'),
('490','','1','Family Ticket','1900','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','7'),
('491','','1','Penguin Hire','1900','Penguin Skating Aids $10',NULL,'0','7'),
('492','','1','Group Booking','1900','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','7'),
('493','','1','Toddler 2-4 years','2000','Toddler: $15 (4 years and under)',NULL,'0','7'),
('494','','1','Child/pensioner/concession card holder 5-14 years','2000','Child/Concession $20 (5-14 years)',NULL,'0','7'),
('495','','1','Adult 15 yrs and above','2000','Adult: $27 (15+ years)',NULL,'0','7'),
('496','','1','Family Ticket','2000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','7'),
('497','','1','Penguin Hire','2000','Penguin Skating Aids $10',NULL,'0','7'),
('498','','1','Group Booking','2000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','7'),
('499','','1','Toddler 2-4 years','2100','Toddler: $15 (4 years and under)',NULL,'0','7'),
('500','','1','Child/pensioner/concession card holder 5-14 years','2100','Child/Concession $20 (5-14 years)',NULL,'0','7');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('501','','1','Adult 15 yrs and above','2100','Adult: $27 (15+ years)',NULL,'0','7'),
('502','','1','Family Ticket','2100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','7'),
('503','','1','Penguin Hire','2100','Penguin Skating Aids $10',NULL,'0','7'),
('504','','1','Group Booking','2100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','7'),
('505','','1','Toddler 2-4 years','1000','Toddler: $15 (4 years and under)',NULL,'0','8'),
('506','','1','Child/pensioner/concession card holder 5-14 years','1000','Child/Concession $20 (5-14 years)',NULL,'0','8'),
('507','','1','Adult 15 yrs and above','1000','Adult: $27 (15+ years)',NULL,'0','8'),
('508','','1','Family Ticket','1000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','8'),
('509','','1','Penguin Hire','1000','Penguin Skating Aids $10',NULL,'0','8'),
('510','','1','Group Booking','1000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','8'),
('511','','1','Toddler 2-4 years','1100','Toddler: $15 (4 years and under)',NULL,'0','8'),
('512','','1','Child/pensioner/concession card holder 5-14 years','1100','Child/Concession $20 (5-14 years)',NULL,'0','8'),
('513','','1','Adult 15 yrs and above','1100','Adult: $27 (15+ years)',NULL,'0','8'),
('514','','1','Family Ticket','1100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','8'),
('515','','1','Penguin Hire','1100','Penguin Skating Aids $10',NULL,'0','8'),
('516','','1','Group Booking','1100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','8'),
('517','','1','Toddler 2-4 years','1200','Toddler: $15 (4 years and under)',NULL,'0','8'),
('518','','1','Child/pensioner/concession card holder 5-14 years','1200','Child/Concession $20 (5-14 years)',NULL,'0','8'),
('519','','1','Adult 15 yrs and above','1200','Adult: $27 (15+ years)',NULL,'0','8'),
('520','','1','Family Ticket','1200','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','8');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('521','','1','Penguin Hire','1200','Penguin Skating Aids $10',NULL,'0','8'),
('522','','1','Group Booking','1200','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','8'),
('523','','1','Toddler 2-4 years','1300','Toddler: $15 (4 years and under)',NULL,'0','8'),
('524','','1','Child/pensioner/concession card holder 5-14 years','1300','Child/Concession $20 (5-14 years)',NULL,'0','8'),
('525','','1','Adult 15 yrs and above','1300','Adult: $27 (15+ years)',NULL,'0','8'),
('526','','1','Family Ticket','1300','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','8'),
('527','','1','Penguin Hire','1300','Penguin Skating Aids $10',NULL,'0','8'),
('528','','1','Group Booking','1300','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','8'),
('529','','1','Toddler 2-4 years','1400','Toddler: $15 (4 years and under)',NULL,'0','8'),
('530','','1','Child/pensioner/concession card holder 5-14 years','1400','Child/Concession $20 (5-14 years)',NULL,'0','8'),
('531','','1','Adult 15 yrs and above','1400','Adult: $27 (15+ years)',NULL,'0','8'),
('532','','1','Family Ticket','1400','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','8'),
('533','','1','Penguin Hire','1400','Penguin Skating Aids $10',NULL,'0','8'),
('534','','1','Group Booking','1400','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','8'),
('535','','1','Toddler 2-4 years','1500','Toddler: $15 (4 years and under)',NULL,'0','8'),
('536','','1','Child/pensioner/concession card holder 5-14 years','1500','Child/Concession $20 (5-14 years)',NULL,'0','8'),
('537','','1','Adult 15 yrs and above','1500','Adult: $27 (15+ years)',NULL,'0','8'),
('538','','1','Family Ticket','1500','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','8'),
('539','','1','Penguin Hire','1500','Penguin Skating Aids $10',NULL,'0','8'),
('540','','1','Group Booking','1500','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','8');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('541','','1','Toddler 2-4 years','1600','Toddler: $15 (4 years and under)',NULL,'0','8'),
('542','','1','Child/pensioner/concession card holder 5-14 years','1600','Child/Concession $20 (5-14 years)',NULL,'0','8'),
('543','','1','Adult 15 yrs and above','1600','Adult: $27 (15+ years)',NULL,'0','8'),
('544','','1','Family Ticket','1600','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','8'),
('545','','1','Penguin Hire','1600','Penguin Skating Aids $10',NULL,'0','8'),
('546','','1','Group Booking','1600','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','8'),
('547','','1','Toddler 2-4 years','1700','Toddler: $15 (4 years and under)',NULL,'0','8'),
('548','','1','Child/pensioner/concession card holder 5-14 years','1700','Child/Concession $20 (5-14 years)',NULL,'0','8'),
('549','','1','Adult 15 yrs and above','1700','Adult: $27 (15+ years)',NULL,'0','8'),
('550','','1','Family Ticket','1700','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','8'),
('551','','1','Penguin Hire','1700','Penguin Skating Aids $10',NULL,'0','8'),
('552','','1','Group Booking','1700','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','8'),
('553','','1','Toddler 2-4 years','1800','Toddler: $15 (4 years and under)',NULL,'0','8'),
('554','','1','Child/pensioner/concession card holder 5-14 years','1800','Child/Concession $20 (5-14 years)',NULL,'0','8'),
('555','','1','Adult 15 yrs and above','1800','Adult: $27 (15+ years)',NULL,'0','8'),
('556','','1','Family Ticket','1800','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','8'),
('557','','1','Penguin Hire','1800','Penguin Skating Aids $10',NULL,'0','8'),
('558','','1','Group Booking','1800','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','8'),
('559','','1','Toddler 2-4 years','1900','Toddler: $15 (4 years and under)',NULL,'0','8'),
('560','','1','Child/pensioner/concession card holder 5-14 years','1900','Child/Concession $20 (5-14 years)',NULL,'0','8');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('561','','1','Adult 15 yrs and above','1900','Adult: $27 (15+ years)',NULL,'0','8'),
('562','','1','Family Ticket','1900','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','8'),
('563','','1','Penguin Hire','1900','Penguin Skating Aids $10',NULL,'0','8'),
('564','','1','Group Booking','1900','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','8'),
('565','','1','Toddler 2-4 years','2000','Toddler: $15 (4 years and under)',NULL,'0','8'),
('566','','1','Child/pensioner/concession card holder 5-14 years','2000','Child/Concession $20 (5-14 years)',NULL,'0','8'),
('567','','1','Adult 15 yrs and above','2000','Adult: $27 (15+ years)',NULL,'0','8'),
('568','','1','Family Ticket','2000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','8'),
('569','','1','Penguin Hire','2000','Penguin Skating Aids $10',NULL,'0','8'),
('570','','1','Group Booking','2000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','8'),
('571','','1','Toddler 2-4 years','2100','Toddler: $15 (4 years and under)',NULL,'0','8'),
('572','','1','Child/pensioner/concession card holder 5-14 years','2100','Child/Concession $20 (5-14 years)',NULL,'0','8'),
('573','','1','Adult 15 yrs and above','2100','Adult: $27 (15+ years)',NULL,'0','8'),
('574','','1','Family Ticket','2100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','8'),
('575','','1','Penguin Hire','2100','Penguin Skating Aids $10',NULL,'0','8'),
('576','','1','Group Booking','2100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','8'),
('577','','1','Toddler 2-4 years','1000','Toddler: $15 (4 years and under)',NULL,'0','9'),
('578','','1','Child/pensioner/concession card holder 5-14 years','1000','Child/Concession $20 (5-14 years)',NULL,'0','9'),
('579','','1','Adult 15 yrs and above','1000','Adult: $27 (15+ years)',NULL,'0','9'),
('580','','1','Family Ticket','1000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','9');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('581','','1','Penguin Hire','1000','Penguin Skating Aids $10',NULL,'0','9'),
('582','','1','Group Booking','1000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','9'),
('583','','1','Toddler 2-4 years','1100','Toddler: $15 (4 years and under)',NULL,'0','9'),
('584','','1','Child/pensioner/concession card holder 5-14 years','1100','Child/Concession $20 (5-14 years)',NULL,'0','9'),
('585','','1','Adult 15 yrs and above','1100','Adult: $27 (15+ years)',NULL,'0','9'),
('586','','1','Family Ticket','1100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','9'),
('587','','1','Penguin Hire','1100','Penguin Skating Aids $10',NULL,'0','9'),
('588','','1','Group Booking','1100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','9'),
('589','','1','Toddler 2-4 years','1200','Toddler: $15 (4 years and under)',NULL,'0','9'),
('590','','1','Child/pensioner/concession card holder 5-14 years','1200','Child/Concession $20 (5-14 years)',NULL,'0','9'),
('591','','1','Adult 15 yrs and above','1200','Adult: $27 (15+ years)',NULL,'0','9'),
('592','','1','Family Ticket','1200','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','9'),
('593','','1','Penguin Hire','1200','Penguin Skating Aids $10',NULL,'0','9'),
('594','','1','Group Booking','1200','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','9'),
('595','','1','Toddler 2-4 years','1300','Toddler: $15 (4 years and under)',NULL,'0','9'),
('596','','1','Child/pensioner/concession card holder 5-14 years','1300','Child/Concession $20 (5-14 years)',NULL,'0','9'),
('597','','1','Adult 15 yrs and above','1300','Adult: $27 (15+ years)',NULL,'0','9'),
('598','','1','Family Ticket','1300','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','9'),
('599','','1','Penguin Hire','1300','Penguin Skating Aids $10',NULL,'0','9'),
('600','','1','Group Booking','1300','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','9');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('601','','1','Toddler 2-4 years','1400','Toddler: $15 (4 years and under)',NULL,'0','9'),
('602','','1','Child/pensioner/concession card holder 5-14 years','1400','Child/Concession $20 (5-14 years)',NULL,'0','9'),
('603','','1','Adult 15 yrs and above','1400','Adult: $27 (15+ years)',NULL,'0','9'),
('604','','1','Family Ticket','1400','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','9'),
('605','','1','Penguin Hire','1400','Penguin Skating Aids $10',NULL,'0','9'),
('606','','1','Group Booking','1400','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','9'),
('607','','1','Toddler 2-4 years','1500','Toddler: $15 (4 years and under)',NULL,'0','9'),
('608','','1','Child/pensioner/concession card holder 5-14 years','1500','Child/Concession $20 (5-14 years)',NULL,'0','9'),
('609','','1','Adult 15 yrs and above','1500','Adult: $27 (15+ years)',NULL,'0','9'),
('610','','1','Family Ticket','1500','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','9'),
('611','','1','Penguin Hire','1500','Penguin Skating Aids $10',NULL,'0','9'),
('612','','1','Group Booking','1500','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','9'),
('613','','1','Toddler 2-4 years','1600','Toddler: $15 (4 years and under)',NULL,'0','9'),
('614','','1','Child/pensioner/concession card holder 5-14 years','1600','Child/Concession $20 (5-14 years)',NULL,'0','9'),
('615','','1','Adult 15 yrs and above','1600','Adult: $27 (15+ years)',NULL,'0','9'),
('616','','1','Family Ticket','1600','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','9'),
('617','','1','Penguin Hire','1600','Penguin Skating Aids $10',NULL,'0','9'),
('618','','1','Group Booking','1600','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','9'),
('619','','1','Toddler 2-4 years','1700','Toddler: $15 (4 years and under)',NULL,'0','9'),
('620','','1','Child/pensioner/concession card holder 5-14 years','1700','Child/Concession $20 (5-14 years)',NULL,'0','9');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('621','','1','Adult 15 yrs and above','1700','Adult: $27 (15+ years)',NULL,'0','9'),
('622','','1','Family Ticket','1700','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','9'),
('623','','1','Penguin Hire','1700','Penguin Skating Aids $10',NULL,'0','9'),
('624','','1','Group Booking','1700','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','9'),
('625','','1','Toddler 2-4 years','1800','Toddler: $15 (4 years and under)',NULL,'0','9'),
('626','','1','Child/pensioner/concession card holder 5-14 years','1800','Child/Concession $20 (5-14 years)',NULL,'0','9'),
('627','','1','Adult 15 yrs and above','1800','Adult: $27 (15+ years)',NULL,'0','9'),
('628','','1','Family Ticket','1800','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','9'),
('629','','1','Penguin Hire','1800','Penguin Skating Aids $10',NULL,'0','9'),
('630','','1','Group Booking','1800','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','9'),
('631','','1','Toddler 2-4 years','1900','Toddler: $15 (4 years and under)',NULL,'0','9'),
('632','','1','Child/pensioner/concession card holder 5-14 years','1900','Child/Concession $20 (5-14 years)',NULL,'0','9'),
('633','','1','Adult 15 yrs and above','1900','Adult: $27 (15+ years)',NULL,'0','9'),
('634','','1','Family Ticket','1900','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','9'),
('635','','1','Penguin Hire','1900','Penguin Skating Aids $10',NULL,'0','9'),
('636','','1','Group Booking','1900','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','9'),
('637','','1','Toddler 2-4 years','2000','Toddler: $15 (4 years and under)',NULL,'0','9'),
('638','','1','Child/pensioner/concession card holder 5-14 years','2000','Child/Concession $20 (5-14 years)',NULL,'0','9'),
('639','','1','Adult 15 yrs and above','2000','Adult: $27 (15+ years)',NULL,'0','9'),
('640','','1','Family Ticket','2000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','9');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('641','','1','Penguin Hire','2000','Penguin Skating Aids $10',NULL,'0','9'),
('642','','1','Group Booking','2000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','9'),
('643','','1','Toddler 2-4 years','2100','Toddler: $15 (4 years and under)',NULL,'0','9'),
('644','','1','Child/pensioner/concession card holder 5-14 years','2100','Child/Concession $20 (5-14 years)',NULL,'0','9'),
('645','','1','Adult 15 yrs and above','2100','Adult: $27 (15+ years)',NULL,'0','9'),
('646','','1','Family Ticket','2100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','9'),
('647','','1','Penguin Hire','2100','Penguin Skating Aids $10',NULL,'0','9'),
('648','','1','Group Booking','2100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','9'),
('649','','1','Toddler 2-4 years','1000','Toddler: $15 (4 years and under)',NULL,'0','10'),
('650','','1','Child/pensioner/concession card holder 5-14 years','1000','Child/Concession $20 (5-14 years)',NULL,'0','10'),
('651','','1','Adult 15 yrs and above','1000','Adult: $27 (15+ years)',NULL,'0','10'),
('652','','1','Family Ticket','1000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','10'),
('653','','1','Penguin Hire','1000','Penguin Skating Aids $10',NULL,'0','10'),
('654','','1','Group Booking','1000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','10'),
('655','','1','Toddler 2-4 years','1100','Toddler: $15 (4 years and under)',NULL,'0','10'),
('656','','1','Child/pensioner/concession card holder 5-14 years','1100','Child/Concession $20 (5-14 years)',NULL,'0','10'),
('657','','1','Adult 15 yrs and above','1100','Adult: $27 (15+ years)',NULL,'0','10'),
('658','','1','Family Ticket','1100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','10'),
('659','','1','Penguin Hire','1100','Penguin Skating Aids $10',NULL,'0','10'),
('660','','1','Group Booking','1100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','10');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('661','','1','Toddler 2-4 years','1200','Toddler: $15 (4 years and under)',NULL,'0','10'),
('662','','1','Child/pensioner/concession card holder 5-14 years','1200','Child/Concession $20 (5-14 years)',NULL,'0','10'),
('663','','1','Adult 15 yrs and above','1200','Adult: $27 (15+ years)',NULL,'0','10'),
('664','','1','Family Ticket','1200','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','10'),
('665','','1','Penguin Hire','1200','Penguin Skating Aids $10',NULL,'0','10'),
('666','','1','Group Booking','1200','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','10'),
('667','','1','Toddler 2-4 years','1300','Toddler: $15 (4 years and under)',NULL,'0','10'),
('668','','1','Child/pensioner/concession card holder 5-14 years','1300','Child/Concession $20 (5-14 years)',NULL,'0','10'),
('669','','1','Adult 15 yrs and above','1300','Adult: $27 (15+ years)',NULL,'0','10'),
('670','','1','Family Ticket','1300','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','10'),
('671','','1','Penguin Hire','1300','Penguin Skating Aids $10',NULL,'0','10'),
('672','','1','Group Booking','1300','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','10'),
('673','','1','Toddler 2-4 years','1400','Toddler: $15 (4 years and under)',NULL,'0','10'),
('674','','1','Child/pensioner/concession card holder 5-14 years','1400','Child/Concession $20 (5-14 years)',NULL,'0','10'),
('675','','1','Adult 15 yrs and above','1400','Adult: $27 (15+ years)',NULL,'0','10'),
('676','','1','Family Ticket','1400','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','10'),
('677','','1','Penguin Hire','1400','Penguin Skating Aids $10',NULL,'0','10'),
('678','','1','Group Booking','1400','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','10'),
('679','','1','Toddler 2-4 years','1500','Toddler: $15 (4 years and under)',NULL,'0','10'),
('680','','1','Child/pensioner/concession card holder 5-14 years','1500','Child/Concession $20 (5-14 years)',NULL,'0','10');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('681','','1','Adult 15 yrs and above','1500','Adult: $27 (15+ years)',NULL,'0','10'),
('682','','1','Family Ticket','1500','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','10'),
('683','','1','Penguin Hire','1500','Penguin Skating Aids $10',NULL,'0','10'),
('684','','1','Group Booking','1500','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','10'),
('685','','1','Toddler 2-4 years','1600','Toddler: $15 (4 years and under)',NULL,'0','10'),
('686','','1','Child/pensioner/concession card holder 5-14 years','1600','Child/Concession $20 (5-14 years)',NULL,'0','10'),
('687','','1','Adult 15 yrs and above','1600','Adult: $27 (15+ years)',NULL,'0','10'),
('688','','1','Family Ticket','1600','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','10'),
('689','','1','Penguin Hire','1600','Penguin Skating Aids $10',NULL,'0','10'),
('690','','1','Group Booking','1600','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','10'),
('691','','1','Toddler 2-4 years','1700','Toddler: $15 (4 years and under)',NULL,'0','10'),
('692','','1','Child/pensioner/concession card holder 5-14 years','1700','Child/Concession $20 (5-14 years)',NULL,'0','10'),
('693','','1','Adult 15 yrs and above','1700','Adult: $27 (15+ years)',NULL,'0','10'),
('694','','1','Family Ticket','1700','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','10'),
('695','','1','Penguin Hire','1700','Penguin Skating Aids $10',NULL,'0','10'),
('696','','1','Group Booking','1700','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','10'),
('697','','1','Toddler 2-4 years','1800','Toddler: $15 (4 years and under)',NULL,'0','10'),
('698','','1','Child/pensioner/concession card holder 5-14 years','1800','Child/Concession $20 (5-14 years)',NULL,'0','10'),
('699','','1','Adult 15 yrs and above','1800','Adult: $27 (15+ years)',NULL,'0','10'),
('700','','1','Family Ticket','1800','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','10');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('701','','1','Penguin Hire','1800','Penguin Skating Aids $10',NULL,'0','10'),
('702','','1','Group Booking','1800','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','10'),
('703','','1','Toddler 2-4 years','1900','Toddler: $15 (4 years and under)',NULL,'0','10'),
('704','','1','Child/pensioner/concession card holder 5-14 years','1900','Child/Concession $20 (5-14 years)',NULL,'0','10'),
('705','','1','Adult 15 yrs and above','1900','Adult: $27 (15+ years)',NULL,'0','10'),
('706','','1','Family Ticket','1900','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','10'),
('707','','1','Penguin Hire','1900','Penguin Skating Aids $10',NULL,'0','10'),
('708','','1','Group Booking','1900','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','10'),
('709','','1','Toddler 2-4 years','2000','Toddler: $15 (4 years and under)',NULL,'0','10'),
('710','','1','Child/pensioner/concession card holder 5-14 years','2000','Child/Concession $20 (5-14 years)',NULL,'0','10'),
('711','','1','Adult 15 yrs and above','2000','Adult: $27 (15+ years)',NULL,'0','10'),
('712','','1','Family Ticket','2000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','10'),
('713','','1','Penguin Hire','2000','Penguin Skating Aids $10',NULL,'0','10'),
('714','','1','Group Booking','2000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','10'),
('715','','1','Toddler 2-4 years','2100','Toddler: $15 (4 years and under)',NULL,'0','10'),
('716','','1','Child/pensioner/concession card holder 5-14 years','2100','Child/Concession $20 (5-14 years)',NULL,'0','10'),
('717','','1','Adult 15 yrs and above','2100','Adult: $27 (15+ years)',NULL,'0','10'),
('718','','1','Family Ticket','2100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','10'),
('719','','1','Penguin Hire','2100','Penguin Skating Aids $10',NULL,'0','10'),
('720','','1','Group Booking','2100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','10');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('721','','1','Toddler 2-4 years','1000','Toddler: $15 (4 years and under)',NULL,'0','11'),
('722','','1','Child/pensioner/concession card holder 5-14 years','1000','Child/Concession $20 (5-14 years)',NULL,'0','11'),
('723','','1','Adult 15 yrs and above','1000','Adult: $27 (15+ years)',NULL,'0','11'),
('724','','1','Family Ticket','1000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','11'),
('725','','1','Penguin Hire','1000','Penguin Skating Aids $10',NULL,'0','11'),
('726','','1','Group Booking','1000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','11'),
('727','','1','Toddler 2-4 years','1100','Toddler: $15 (4 years and under)',NULL,'0','11'),
('728','','1','Child/pensioner/concession card holder 5-14 years','1100','Child/Concession $20 (5-14 years)',NULL,'0','11'),
('729','','1','Adult 15 yrs and above','1100','Adult: $27 (15+ years)',NULL,'0','11'),
('730','','1','Family Ticket','1100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','11'),
('731','','1','Penguin Hire','1100','Penguin Skating Aids $10',NULL,'0','11'),
('732','','1','Group Booking','1100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','11'),
('733','','1','Toddler 2-4 years','1200','Toddler: $15 (4 years and under)',NULL,'0','11'),
('734','','1','Child/pensioner/concession card holder 5-14 years','1200','Child/Concession $20 (5-14 years)',NULL,'0','11'),
('735','','1','Adult 15 yrs and above','1200','Adult: $27 (15+ years)',NULL,'0','11'),
('736','','1','Family Ticket','1200','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','11'),
('737','','1','Penguin Hire','1200','Penguin Skating Aids $10',NULL,'0','11'),
('738','','1','Group Booking','1200','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','11'),
('739','','1','Toddler 2-4 years','1300','Toddler: $15 (4 years and under)',NULL,'0','11'),
('740','','1','Child/pensioner/concession card holder 5-14 years','1300','Child/Concession $20 (5-14 years)',NULL,'0','11');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('741','','1','Adult 15 yrs and above','1300','Adult: $27 (15+ years)',NULL,'0','11'),
('742','','1','Family Ticket','1300','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','11'),
('743','','1','Penguin Hire','1300','Penguin Skating Aids $10',NULL,'0','11'),
('744','','1','Group Booking','1300','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','11'),
('745','','1','Toddler 2-4 years','1400','Toddler: $15 (4 years and under)',NULL,'0','11'),
('746','','1','Child/pensioner/concession card holder 5-14 years','1400','Child/Concession $20 (5-14 years)',NULL,'0','11'),
('747','','1','Adult 15 yrs and above','1400','Adult: $27 (15+ years)',NULL,'0','11'),
('748','','1','Family Ticket','1400','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','11'),
('749','','1','Penguin Hire','1400','Penguin Skating Aids $10',NULL,'0','11'),
('750','','1','Group Booking','1400','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','11'),
('751','','1','Toddler 2-4 years','1500','Toddler: $15 (4 years and under)',NULL,'0','11'),
('752','','1','Child/pensioner/concession card holder 5-14 years','1500','Child/Concession $20 (5-14 years)',NULL,'0','11'),
('753','','1','Adult 15 yrs and above','1500','Adult: $27 (15+ years)',NULL,'0','11'),
('754','','1','Family Ticket','1500','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','11'),
('755','','1','Penguin Hire','1500','Penguin Skating Aids $10',NULL,'0','11'),
('756','','1','Group Booking','1500','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','11'),
('757','','1','Toddler 2-4 years','1600','Toddler: $15 (4 years and under)',NULL,'0','11'),
('758','','1','Child/pensioner/concession card holder 5-14 years','1600','Child/Concession $20 (5-14 years)',NULL,'0','11'),
('759','','1','Adult 15 yrs and above','1600','Adult: $27 (15+ years)',NULL,'0','11'),
('760','','1','Family Ticket','1600','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','11');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('761','','1','Penguin Hire','1600','Penguin Skating Aids $10',NULL,'0','11'),
('762','','1','Group Booking','1600','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','11'),
('763','','1','Toddler 2-4 years','1700','Toddler: $15 (4 years and under)',NULL,'0','11'),
('764','','1','Child/pensioner/concession card holder 5-14 years','1700','Child/Concession $20 (5-14 years)',NULL,'0','11'),
('765','','1','Adult 15 yrs and above','1700','Adult: $27 (15+ years)',NULL,'0','11'),
('766','','1','Family Ticket','1700','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','11'),
('767','','1','Penguin Hire','1700','Penguin Skating Aids $10',NULL,'0','11'),
('768','','1','Group Booking','1700','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','11'),
('769','','1','Toddler 2-4 years','1800','Toddler: $15 (4 years and under)',NULL,'0','11'),
('770','','1','Child/pensioner/concession card holder 5-14 years','1800','Child/Concession $20 (5-14 years)',NULL,'0','11'),
('771','','1','Adult 15 yrs and above','1800','Adult: $27 (15+ years)',NULL,'0','11'),
('772','','1','Family Ticket','1800','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','11'),
('773','','1','Penguin Hire','1800','Penguin Skating Aids $10',NULL,'0','11'),
('774','','1','Group Booking','1800','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','11'),
('775','','1','Toddler 2-4 years','1900','Toddler: $15 (4 years and under)',NULL,'0','11'),
('776','','1','Child/pensioner/concession card holder 5-14 years','1900','Child/Concession $20 (5-14 years)',NULL,'0','11'),
('777','','1','Adult 15 yrs and above','1900','Adult: $27 (15+ years)',NULL,'0','11'),
('778','','1','Family Ticket','1900','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','11'),
('779','','1','Penguin Hire','1900','Penguin Skating Aids $10',NULL,'0','11'),
('780','','1','Group Booking','1900','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','11');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('781','','1','Toddler 2-4 years','2000','Toddler: $15 (4 years and under)',NULL,'0','11'),
('782','','1','Child/pensioner/concession card holder 5-14 years','2000','Child/Concession $20 (5-14 years)',NULL,'0','11'),
('783','','1','Adult 15 yrs and above','2000','Adult: $27 (15+ years)',NULL,'0','11'),
('784','','1','Family Ticket','2000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','11'),
('785','','1','Penguin Hire','2000','Penguin Skating Aids $10',NULL,'0','11'),
('786','','1','Group Booking','2000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','11'),
('787','','1','Toddler 2-4 years','2100','Toddler: $15 (4 years and under)',NULL,'0','11'),
('788','','1','Child/pensioner/concession card holder 5-14 years','2100','Child/Concession $20 (5-14 years)',NULL,'0','11'),
('789','','1','Adult 15 yrs and above','2100','Adult: $27 (15+ years)',NULL,'0','11'),
('790','','1','Family Ticket','2100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','11'),
('791','','1','Penguin Hire','2100','Penguin Skating Aids $10',NULL,'0','11'),
('792','','1','Group Booking','2100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','11'),
('793','','1','Toddler 2-4 years','1000','Toddler: $15 (4 years and under)',NULL,'0','12'),
('794','','1','Child/pensioner/concession card holder 5-14 years','1000','Child/Concession $20 (5-14 years)',NULL,'0','12'),
('795','','1','Adult 15 yrs and above','1000','Adult: $27 (15+ years)',NULL,'0','12'),
('796','','1','Family Ticket','1000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','12'),
('797','','1','Penguin Hire','1000','Penguin Skating Aids $10',NULL,'0','12'),
('798','','1','Group Booking','1000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','12'),
('799','','1','Toddler 2-4 years','1100','Toddler: $15 (4 years and under)',NULL,'0','12'),
('800','','1','Child/pensioner/concession card holder 5-14 years','1100','Child/Concession $20 (5-14 years)',NULL,'0','12');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('801','','1','Adult 15 yrs and above','1100','Adult: $27 (15+ years)',NULL,'0','12'),
('802','','1','Family Ticket','1100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','12'),
('803','','1','Penguin Hire','1100','Penguin Skating Aids $10',NULL,'0','12'),
('804','','1','Group Booking','1100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','12'),
('805','','1','Toddler 2-4 years','1200','Toddler: $15 (4 years and under)',NULL,'0','12'),
('806','','1','Child/pensioner/concession card holder 5-14 years','1200','Child/Concession $20 (5-14 years)',NULL,'0','12'),
('807','','1','Adult 15 yrs and above','1200','Adult: $27 (15+ years)',NULL,'0','12'),
('808','','1','Family Ticket','1200','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','12'),
('809','','1','Penguin Hire','1200','Penguin Skating Aids $10',NULL,'0','12'),
('810','','1','Group Booking','1200','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','12'),
('811','','1','Toddler 2-4 years','1300','Toddler: $15 (4 years and under)',NULL,'0','12'),
('812','','1','Child/pensioner/concession card holder 5-14 years','1300','Child/Concession $20 (5-14 years)',NULL,'0','12'),
('813','','1','Adult 15 yrs and above','1300','Adult: $27 (15+ years)',NULL,'0','12'),
('814','','1','Family Ticket','1300','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','12'),
('815','','1','Penguin Hire','1300','Penguin Skating Aids $10',NULL,'0','12'),
('816','','1','Group Booking','1300','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','12'),
('817','','1','Toddler 2-4 years','1400','Toddler: $15 (4 years and under)',NULL,'0','12'),
('818','','1','Child/pensioner/concession card holder 5-14 years','1400','Child/Concession $20 (5-14 years)',NULL,'0','12'),
('819','','1','Adult 15 yrs and above','1400','Adult: $27 (15+ years)',NULL,'0','12'),
('820','','1','Family Ticket','1400','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','12');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('821','','1','Penguin Hire','1400','Penguin Skating Aids $10',NULL,'0','12'),
('822','','1','Group Booking','1400','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','12'),
('823','','1','Toddler 2-4 years','1500','Toddler: $15 (4 years and under)',NULL,'0','12'),
('824','','1','Child/pensioner/concession card holder 5-14 years','1500','Child/Concession $20 (5-14 years)',NULL,'0','12'),
('825','','1','Adult 15 yrs and above','1500','Adult: $27 (15+ years)',NULL,'0','12'),
('826','','1','Family Ticket','1500','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','12'),
('827','','1','Penguin Hire','1500','Penguin Skating Aids $10',NULL,'0','12'),
('828','','1','Group Booking','1500','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','12'),
('829','','1','Toddler 2-4 years','1600','Toddler: $15 (4 years and under)',NULL,'0','12'),
('830','','1','Child/pensioner/concession card holder 5-14 years','1600','Child/Concession $20 (5-14 years)',NULL,'0','12'),
('831','','1','Adult 15 yrs and above','1600','Adult: $27 (15+ years)',NULL,'0','12'),
('832','','1','Family Ticket','1600','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','12'),
('833','','1','Penguin Hire','1600','Penguin Skating Aids $10',NULL,'0','12'),
('834','','1','Group Booking','1600','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','12'),
('835','','1','Toddler 2-4 years','1700','Toddler: $15 (4 years and under)',NULL,'0','12'),
('836','','1','Child/pensioner/concession card holder 5-14 years','1700','Child/Concession $20 (5-14 years)',NULL,'0','12'),
('837','','1','Adult 15 yrs and above','1700','Adult: $27 (15+ years)',NULL,'0','12'),
('838','','1','Family Ticket','1700','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','12'),
('839','','1','Penguin Hire','1700','Penguin Skating Aids $10',NULL,'0','12'),
('840','','1','Group Booking','1700','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','12');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('841','','1','Toddler 2-4 years','1800','Toddler: $15 (4 years and under)',NULL,'0','12'),
('842','','1','Child/pensioner/concession card holder 5-14 years','1800','Child/Concession $20 (5-14 years)',NULL,'0','12'),
('843','','1','Adult 15 yrs and above','1800','Adult: $27 (15+ years)',NULL,'0','12'),
('844','','1','Family Ticket','1800','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','12'),
('845','','1','Penguin Hire','1800','Penguin Skating Aids $10',NULL,'0','12'),
('846','','1','Group Booking','1800','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','12'),
('847','','1','Toddler 2-4 years','1900','Toddler: $15 (4 years and under)',NULL,'0','12'),
('848','','1','Child/pensioner/concession card holder 5-14 years','1900','Child/Concession $20 (5-14 years)',NULL,'0','12'),
('849','','1','Adult 15 yrs and above','1900','Adult: $27 (15+ years)',NULL,'0','12'),
('850','','1','Family Ticket','1900','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','12'),
('851','','1','Penguin Hire','1900','Penguin Skating Aids $10',NULL,'0','12'),
('852','','1','Group Booking','1900','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','12'),
('853','','1','Toddler 2-4 years','2000','Toddler: $15 (4 years and under)',NULL,'0','12'),
('854','','1','Child/pensioner/concession card holder 5-14 years','2000','Child/Concession $20 (5-14 years)',NULL,'0','12'),
('855','','1','Adult 15 yrs and above','2000','Adult: $27 (15+ years)',NULL,'0','12'),
('856','','1','Family Ticket','2000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','12'),
('857','','1','Penguin Hire','2000','Penguin Skating Aids $10',NULL,'0','12'),
('858','','1','Group Booking','2000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','12'),
('859','','1','Toddler 2-4 years','2100','Toddler: $15 (4 years and under)',NULL,'0','12'),
('860','','1','Child/pensioner/concession card holder 5-14 years','2100','Child/Concession $20 (5-14 years)',NULL,'0','12');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('861','','1','Adult 15 yrs and above','2100','Adult: $27 (15+ years)',NULL,'0','12'),
('862','','1','Family Ticket','2100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','12'),
('863','','1','Penguin Hire','2100','Penguin Skating Aids $10',NULL,'0','12'),
('864','','1','Group Booking','2100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','12'),
('865','','1','Toddler 2-4 years','1000','Toddler: $15 (4 years and under)',NULL,'0','13'),
('866','','1','Child/pensioner/concession card holder 5-14 years','1000','Child/Concession $20 (5-14 years)',NULL,'0','13'),
('867','','1','Adult 15 yrs and above','1000','Adult: $27 (15+ years)',NULL,'0','13'),
('868','','1','Family Ticket','1000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','13'),
('869','','1','Penguin Hire','1000','Penguin Skating Aids $10',NULL,'0','13'),
('870','','1','Group Booking','1000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','13'),
('871','','1','Toddler 2-4 years','1100','Toddler: $15 (4 years and under)',NULL,'0','13'),
('872','','1','Child/pensioner/concession card holder 5-14 years','1100','Child/Concession $20 (5-14 years)',NULL,'0','13'),
('873','','1','Adult 15 yrs and above','1100','Adult: $27 (15+ years)',NULL,'0','13'),
('874','','1','Family Ticket','1100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','13'),
('875','','1','Penguin Hire','1100','Penguin Skating Aids $10',NULL,'0','13'),
('876','','1','Group Booking','1100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','13'),
('877','','1','Toddler 2-4 years','1200','Toddler: $15 (4 years and under)',NULL,'0','13'),
('878','','1','Child/pensioner/concession card holder 5-14 years','1200','Child/Concession $20 (5-14 years)',NULL,'0','13'),
('879','','1','Adult 15 yrs and above','1200','Adult: $27 (15+ years)',NULL,'0','13'),
('880','','1','Family Ticket','1200','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','13');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('881','','1','Penguin Hire','1200','Penguin Skating Aids $10',NULL,'0','13'),
('882','','1','Group Booking','1200','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','13'),
('883','','1','Toddler 2-4 years','1300','Toddler: $15 (4 years and under)',NULL,'0','13'),
('884','','1','Child/pensioner/concession card holder 5-14 years','1300','Child/Concession $20 (5-14 years)',NULL,'0','13'),
('885','','1','Adult 15 yrs and above','1300','Adult: $27 (15+ years)',NULL,'0','13'),
('886','','1','Family Ticket','1300','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','13'),
('887','','1','Penguin Hire','1300','Penguin Skating Aids $10',NULL,'0','13'),
('888','','1','Group Booking','1300','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','13'),
('889','','1','Toddler 2-4 years','1400','Toddler: $15 (4 years and under)',NULL,'0','13'),
('890','','1','Child/pensioner/concession card holder 5-14 years','1400','Child/Concession $20 (5-14 years)',NULL,'0','13'),
('891','','1','Adult 15 yrs and above','1400','Adult: $27 (15+ years)',NULL,'0','13'),
('892','','1','Family Ticket','1400','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','13'),
('893','','1','Penguin Hire','1400','Penguin Skating Aids $10',NULL,'0','13'),
('894','','1','Group Booking','1400','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','13'),
('895','','1','Toddler 2-4 years','1500','Toddler: $15 (4 years and under)',NULL,'0','13'),
('896','','1','Child/pensioner/concession card holder 5-14 years','1500','Child/Concession $20 (5-14 years)',NULL,'0','13'),
('897','','1','Adult 15 yrs and above','1500','Adult: $27 (15+ years)',NULL,'0','13'),
('898','','1','Family Ticket','1500','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','13'),
('899','','1','Penguin Hire','1500','Penguin Skating Aids $10',NULL,'0','13'),
('900','','1','Group Booking','1500','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','13');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('901','','1','Toddler 2-4 years','1600','Toddler: $15 (4 years and under)',NULL,'0','13'),
('902','','1','Child/pensioner/concession card holder 5-14 years','1600','Child/Concession $20 (5-14 years)',NULL,'0','13'),
('903','','1','Adult 15 yrs and above','1600','Adult: $27 (15+ years)',NULL,'0','13'),
('904','','1','Family Ticket','1600','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','13'),
('905','','1','Penguin Hire','1600','Penguin Skating Aids $10',NULL,'0','13'),
('906','','1','Group Booking','1600','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','13'),
('907','','1','Toddler 2-4 years','1700','Toddler: $15 (4 years and under)',NULL,'0','13'),
('908','','1','Child/pensioner/concession card holder 5-14 years','1700','Child/Concession $20 (5-14 years)',NULL,'0','13'),
('909','','1','Adult 15 yrs and above','1700','Adult: $27 (15+ years)',NULL,'0','13'),
('910','','1','Family Ticket','1700','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','13'),
('911','','1','Penguin Hire','1700','Penguin Skating Aids $10',NULL,'0','13'),
('912','','1','Group Booking','1700','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','13'),
('913','','1','Toddler 2-4 years','1800','Toddler: $15 (4 years and under)',NULL,'0','13'),
('914','','1','Child/pensioner/concession card holder 5-14 years','1800','Child/Concession $20 (5-14 years)',NULL,'0','13'),
('915','','1','Adult 15 yrs and above','1800','Adult: $27 (15+ years)',NULL,'0','13'),
('916','','1','Family Ticket','1800','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','13'),
('917','','1','Penguin Hire','1800','Penguin Skating Aids $10',NULL,'0','13'),
('918','','1','Group Booking','1800','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','13'),
('919','','1','Toddler 2-4 years','1900','Toddler: $15 (4 years and under)',NULL,'0','13'),
('920','','1','Child/pensioner/concession card holder 5-14 years','1900','Child/Concession $20 (5-14 years)',NULL,'0','13');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('921','','1','Adult 15 yrs and above','1900','Adult: $27 (15+ years)',NULL,'0','13'),
('922','','1','Family Ticket','1900','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','13'),
('923','','1','Penguin Hire','1900','Penguin Skating Aids $10',NULL,'0','13'),
('924','','1','Group Booking','1900','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','13'),
('925','','1','Toddler 2-4 years','2000','Toddler: $15 (4 years and under)',NULL,'0','13'),
('926','','1','Child/pensioner/concession card holder 5-14 years','2000','Child/Concession $20 (5-14 years)',NULL,'0','13'),
('927','','1','Adult 15 yrs and above','2000','Adult: $27 (15+ years)',NULL,'0','13'),
('928','','1','Family Ticket','2000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','13'),
('929','','1','Penguin Hire','2000','Penguin Skating Aids $10',NULL,'0','13'),
('930','','1','Group Booking','2000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','13'),
('931','','1','Toddler 2-4 years','2100','Toddler: $15 (4 years and under)',NULL,'0','13'),
('932','','1','Child/pensioner/concession card holder 5-14 years','2100','Child/Concession $20 (5-14 years)',NULL,'0','13'),
('933','','1','Adult 15 yrs and above','2100','Adult: $27 (15+ years)',NULL,'0','13'),
('934','','1','Family Ticket','2100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','13'),
('935','','1','Penguin Hire','2100','Penguin Skating Aids $10',NULL,'0','13'),
('936','','1','Group Booking','2100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','13'),
('937','','1','Toddler 2-4 years','1000','Toddler: $15 (4 years and under)',NULL,'0','14'),
('938','','1','Child/pensioner/concession card holder 5-14 years','1000','Child/Concession $20 (5-14 years)',NULL,'0','14'),
('939','','1','Adult 15 yrs and above','1000','Adult: $27 (15+ years)',NULL,'0','14'),
('940','','1','Family Ticket','1000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','14');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('941','','1','Penguin Hire','1000','Penguin Skating Aids $10',NULL,'0','14'),
('942','','1','Group Booking','1000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','14'),
('943','','1','Toddler 2-4 years','1100','Toddler: $15 (4 years and under)',NULL,'0','14'),
('944','','1','Child/pensioner/concession card holder 5-14 years','1100','Child/Concession $20 (5-14 years)',NULL,'0','14'),
('945','','1','Adult 15 yrs and above','1100','Adult: $27 (15+ years)',NULL,'0','14'),
('946','','1','Family Ticket','1100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','14'),
('947','','1','Penguin Hire','1100','Penguin Skating Aids $10',NULL,'0','14'),
('948','','1','Group Booking','1100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','14'),
('949','','1','Toddler 2-4 years','1200','Toddler: $15 (4 years and under)',NULL,'0','14'),
('950','','1','Child/pensioner/concession card holder 5-14 years','1200','Child/Concession $20 (5-14 years)',NULL,'0','14'),
('951','','1','Adult 15 yrs and above','1200','Adult: $27 (15+ years)',NULL,'0','14'),
('952','','1','Family Ticket','1200','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','14'),
('953','','1','Penguin Hire','1200','Penguin Skating Aids $10',NULL,'0','14'),
('954','','1','Group Booking','1200','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','14'),
('955','','1','Toddler 2-4 years','1300','Toddler: $15 (4 years and under)',NULL,'0','14'),
('956','','1','Child/pensioner/concession card holder 5-14 years','1300','Child/Concession $20 (5-14 years)',NULL,'0','14'),
('957','','1','Adult 15 yrs and above','1300','Adult: $27 (15+ years)',NULL,'0','14'),
('958','','1','Family Ticket','1300','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','14'),
('959','','1','Penguin Hire','1300','Penguin Skating Aids $10',NULL,'0','14'),
('960','','1','Group Booking','1300','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','14');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('961','','1','Toddler 2-4 years','1400','Toddler: $15 (4 years and under)',NULL,'0','14'),
('962','','1','Child/pensioner/concession card holder 5-14 years','1400','Child/Concession $20 (5-14 years)',NULL,'0','14'),
('963','','1','Adult 15 yrs and above','1400','Adult: $27 (15+ years)',NULL,'0','14'),
('964','','1','Family Ticket','1400','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','14'),
('965','','1','Penguin Hire','1400','Penguin Skating Aids $10',NULL,'0','14'),
('966','','1','Group Booking','1400','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','14'),
('967','','1','Toddler 2-4 years','1500','Toddler: $15 (4 years and under)',NULL,'0','14'),
('968','','1','Child/pensioner/concession card holder 5-14 years','1500','Child/Concession $20 (5-14 years)',NULL,'0','14'),
('969','','1','Adult 15 yrs and above','1500','Adult: $27 (15+ years)',NULL,'0','14'),
('970','','1','Family Ticket','1500','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','14'),
('971','','1','Penguin Hire','1500','Penguin Skating Aids $10',NULL,'0','14'),
('972','','1','Group Booking','1500','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','14'),
('973','','1','Toddler 2-4 years','1600','Toddler: $15 (4 years and under)',NULL,'0','14'),
('974','','1','Child/pensioner/concession card holder 5-14 years','1600','Child/Concession $20 (5-14 years)',NULL,'0','14'),
('975','','1','Adult 15 yrs and above','1600','Adult: $27 (15+ years)',NULL,'0','14'),
('976','','1','Family Ticket','1600','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','14'),
('977','','1','Penguin Hire','1600','Penguin Skating Aids $10',NULL,'0','14'),
('978','','1','Group Booking','1600','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','14'),
('979','','1','Toddler 2-4 years','1700','Toddler: $15 (4 years and under)',NULL,'0','14'),
('980','','1','Child/pensioner/concession card holder 5-14 years','1700','Child/Concession $20 (5-14 years)',NULL,'0','14');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('981','','1','Adult 15 yrs and above','1700','Adult: $27 (15+ years)',NULL,'0','14'),
('982','','1','Family Ticket','1700','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','14'),
('983','','1','Penguin Hire','1700','Penguin Skating Aids $10',NULL,'0','14'),
('984','','1','Group Booking','1700','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','14'),
('985','','1','Toddler 2-4 years','1800','Toddler: $15 (4 years and under)',NULL,'0','14'),
('986','','1','Child/pensioner/concession card holder 5-14 years','1800','Child/Concession $20 (5-14 years)',NULL,'0','14'),
('987','','1','Adult 15 yrs and above','1800','Adult: $27 (15+ years)',NULL,'0','14'),
('988','','1','Family Ticket','1800','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','14'),
('989','','1','Penguin Hire','1800','Penguin Skating Aids $10',NULL,'0','14'),
('990','','1','Group Booking','1800','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','14'),
('991','','1','Toddler 2-4 years','1900','Toddler: $15 (4 years and under)',NULL,'0','14'),
('992','','1','Child/pensioner/concession card holder 5-14 years','1900','Child/Concession $20 (5-14 years)',NULL,'0','14'),
('993','','1','Adult 15 yrs and above','1900','Adult: $27 (15+ years)',NULL,'0','14'),
('994','','1','Family Ticket','1900','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','14'),
('995','','1','Penguin Hire','1900','Penguin Skating Aids $10',NULL,'0','14'),
('996','','1','Group Booking','1900','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','14'),
('997','','1','Toddler 2-4 years','2000','Toddler: $15 (4 years and under)',NULL,'0','14'),
('998','','1','Child/pensioner/concession card holder 5-14 years','2000','Child/Concession $20 (5-14 years)',NULL,'0','14'),
('999','','1','Adult 15 yrs and above','2000','Adult: $27 (15+ years)',NULL,'0','14'),
('1000','','1','Family Ticket','2000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','14');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1001','','1','Penguin Hire','2000','Penguin Skating Aids $10',NULL,'0','14'),
('1002','','1','Group Booking','2000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','14'),
('1003','','1','Toddler 2-4 years','2100','Toddler: $15 (4 years and under)',NULL,'0','14'),
('1004','','1','Child/pensioner/concession card holder 5-14 years','2100','Child/Concession $20 (5-14 years)',NULL,'0','14'),
('1005','','1','Adult 15 yrs and above','2100','Adult: $27 (15+ years)',NULL,'0','14'),
('1006','','1','Family Ticket','2100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','14'),
('1007','','1','Penguin Hire','2100','Penguin Skating Aids $10',NULL,'0','14'),
('1008','','1','Group Booking','2100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','14'),
('1009','','1','Toddler 2-4 years','1000','Toddler: $15 (4 years and under)',NULL,'0','15'),
('1010','','1','Child/pensioner/concession card holder 5-14 years','1000','Child/Concession $20 (5-14 years)',NULL,'0','15'),
('1011','','1','Adult 15 yrs and above','1000','Adult: $27 (15+ years)',NULL,'0','15'),
('1012','','1','Family Ticket','1000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','15'),
('1013','','1','Penguin Hire','1000','Penguin Skating Aids $10',NULL,'0','15'),
('1014','','1','Group Booking','1000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','15'),
('1015','','1','Toddler 2-4 years','1100','Toddler: $15 (4 years and under)',NULL,'0','15'),
('1016','','1','Child/pensioner/concession card holder 5-14 years','1100','Child/Concession $20 (5-14 years)',NULL,'0','15'),
('1017','','1','Adult 15 yrs and above','1100','Adult: $27 (15+ years)',NULL,'0','15'),
('1018','','1','Family Ticket','1100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','15'),
('1019','','1','Penguin Hire','1100','Penguin Skating Aids $10',NULL,'0','15'),
('1020','','1','Group Booking','1100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','15');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1021','','1','Toddler 2-4 years','1200','Toddler: $15 (4 years and under)',NULL,'0','15'),
('1022','','1','Child/pensioner/concession card holder 5-14 years','1200','Child/Concession $20 (5-14 years)',NULL,'0','15'),
('1023','','1','Adult 15 yrs and above','1200','Adult: $27 (15+ years)',NULL,'0','15'),
('1024','','1','Family Ticket','1200','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','15'),
('1025','','1','Penguin Hire','1200','Penguin Skating Aids $10',NULL,'0','15'),
('1026','','1','Group Booking','1200','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','15'),
('1027','','1','Toddler 2-4 years','1300','Toddler: $15 (4 years and under)',NULL,'0','15'),
('1028','','1','Child/pensioner/concession card holder 5-14 years','1300','Child/Concession $20 (5-14 years)',NULL,'0','15'),
('1029','','1','Adult 15 yrs and above','1300','Adult: $27 (15+ years)',NULL,'0','15'),
('1030','','1','Family Ticket','1300','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','15'),
('1031','','1','Penguin Hire','1300','Penguin Skating Aids $10',NULL,'0','15'),
('1032','','1','Group Booking','1300','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','15'),
('1033','','1','Toddler 2-4 years','1400','Toddler: $15 (4 years and under)',NULL,'0','15'),
('1034','','1','Child/pensioner/concession card holder 5-14 years','1400','Child/Concession $20 (5-14 years)',NULL,'0','15'),
('1035','','1','Adult 15 yrs and above','1400','Adult: $27 (15+ years)',NULL,'0','15'),
('1036','','1','Family Ticket','1400','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','15'),
('1037','','1','Penguin Hire','1400','Penguin Skating Aids $10',NULL,'0','15'),
('1038','','1','Group Booking','1400','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','15'),
('1039','','1','Toddler 2-4 years','1500','Toddler: $15 (4 years and under)',NULL,'0','15'),
('1040','','1','Child/pensioner/concession card holder 5-14 years','1500','Child/Concession $20 (5-14 years)',NULL,'0','15');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1041','','1','Adult 15 yrs and above','1500','Adult: $27 (15+ years)',NULL,'0','15'),
('1042','','1','Family Ticket','1500','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','15'),
('1043','','1','Penguin Hire','1500','Penguin Skating Aids $10',NULL,'0','15'),
('1044','','1','Group Booking','1500','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','15'),
('1045','','1','Toddler 2-4 years','1600','Toddler: $15 (4 years and under)',NULL,'0','15'),
('1046','','1','Child/pensioner/concession card holder 5-14 years','1600','Child/Concession $20 (5-14 years)',NULL,'0','15'),
('1047','','1','Adult 15 yrs and above','1600','Adult: $27 (15+ years)',NULL,'0','15'),
('1048','','1','Family Ticket','1600','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','15'),
('1049','','1','Penguin Hire','1600','Penguin Skating Aids $10',NULL,'0','15'),
('1050','','1','Group Booking','1600','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','15'),
('1051','','1','Toddler 2-4 years','1700','Toddler: $15 (4 years and under)',NULL,'0','15'),
('1052','','1','Child/pensioner/concession card holder 5-14 years','1700','Child/Concession $20 (5-14 years)',NULL,'0','15'),
('1053','','1','Adult 15 yrs and above','1700','Adult: $27 (15+ years)',NULL,'0','15'),
('1054','','1','Family Ticket','1700','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','15'),
('1055','','1','Penguin Hire','1700','Penguin Skating Aids $10',NULL,'0','15'),
('1056','','1','Group Booking','1700','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','15'),
('1057','','1','Toddler 2-4 years','1800','Toddler: $15 (4 years and under)',NULL,'0','15'),
('1058','','1','Child/pensioner/concession card holder 5-14 years','1800','Child/Concession $20 (5-14 years)',NULL,'0','15'),
('1059','','1','Adult 15 yrs and above','1800','Adult: $27 (15+ years)',NULL,'0','15'),
('1060','','1','Family Ticket','1800','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','15');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1061','','1','Penguin Hire','1800','Penguin Skating Aids $10',NULL,'0','15'),
('1062','','1','Group Booking','1800','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','15'),
('1063','','1','Toddler 2-4 years','1900','Toddler: $15 (4 years and under)',NULL,'0','15'),
('1064','','1','Child/pensioner/concession card holder 5-14 years','1900','Child/Concession $20 (5-14 years)',NULL,'0','15'),
('1065','','1','Adult 15 yrs and above','1900','Adult: $27 (15+ years)',NULL,'0','15'),
('1066','','1','Family Ticket','1900','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','15'),
('1067','','1','Penguin Hire','1900','Penguin Skating Aids $10',NULL,'0','15'),
('1068','','1','Group Booking','1900','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','15'),
('1069','','1','Toddler 2-4 years','2000','Toddler: $15 (4 years and under)',NULL,'0','15'),
('1070','','1','Child/pensioner/concession card holder 5-14 years','2000','Child/Concession $20 (5-14 years)',NULL,'0','15'),
('1071','','1','Adult 15 yrs and above','2000','Adult: $27 (15+ years)',NULL,'0','15'),
('1072','','1','Family Ticket','2000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','15'),
('1073','','1','Penguin Hire','2000','Penguin Skating Aids $10',NULL,'0','15'),
('1074','','1','Group Booking','2000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','15'),
('1075','','1','Toddler 2-4 years','2100','Toddler: $15 (4 years and under)',NULL,'0','15'),
('1076','','1','Child/pensioner/concession card holder 5-14 years','2100','Child/Concession $20 (5-14 years)',NULL,'0','15'),
('1077','','1','Adult 15 yrs and above','2100','Adult: $27 (15+ years)',NULL,'0','15'),
('1078','','1','Family Ticket','2100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','15'),
('1079','','1','Penguin Hire','2100','Penguin Skating Aids $10',NULL,'0','15'),
('1080','','1','Group Booking','2100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','15');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1081','','1','Toddler 2-4 years','1000','Toddler: $15 (4 years and under)',NULL,'0','16'),
('1082','','1','Child/pensioner/concession card holder 5-14 years','1000','Child/Concession $20 (5-14 years)',NULL,'0','16'),
('1083','','1','Adult 15 yrs and above','1000','Adult: $27 (15+ years)',NULL,'0','16'),
('1084','','1','Family Ticket','1000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','16'),
('1085','','1','Penguin Hire','1000','Penguin Skating Aids $10',NULL,'0','16'),
('1086','','1','Group Booking','1000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','16'),
('1087','','1','Toddler 2-4 years','1100','Toddler: $15 (4 years and under)',NULL,'0','16'),
('1088','','1','Child/pensioner/concession card holder 5-14 years','1100','Child/Concession $20 (5-14 years)',NULL,'0','16'),
('1089','','1','Adult 15 yrs and above','1100','Adult: $27 (15+ years)',NULL,'0','16'),
('1090','','1','Family Ticket','1100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','16'),
('1091','','1','Penguin Hire','1100','Penguin Skating Aids $10',NULL,'0','16'),
('1092','','1','Group Booking','1100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','16'),
('1093','','1','Toddler 2-4 years','1200','Toddler: $15 (4 years and under)',NULL,'0','16'),
('1094','','1','Child/pensioner/concession card holder 5-14 years','1200','Child/Concession $20 (5-14 years)',NULL,'0','16'),
('1095','','1','Adult 15 yrs and above','1200','Adult: $27 (15+ years)',NULL,'0','16'),
('1096','','1','Family Ticket','1200','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','16'),
('1097','','1','Penguin Hire','1200','Penguin Skating Aids $10',NULL,'0','16'),
('1098','','1','Group Booking','1200','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','16'),
('1099','','1','Toddler 2-4 years','1300','Toddler: $15 (4 years and under)',NULL,'0','16'),
('1100','','1','Child/pensioner/concession card holder 5-14 years','1300','Child/Concession $20 (5-14 years)',NULL,'0','16');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1101','','1','Adult 15 yrs and above','1300','Adult: $27 (15+ years)',NULL,'0','16'),
('1102','','1','Family Ticket','1300','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','16'),
('1103','','1','Penguin Hire','1300','Penguin Skating Aids $10',NULL,'0','16'),
('1104','','1','Group Booking','1300','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','16'),
('1105','','1','Toddler 2-4 years','1400','Toddler: $15 (4 years and under)',NULL,'0','16'),
('1106','','1','Child/pensioner/concession card holder 5-14 years','1400','Child/Concession $20 (5-14 years)',NULL,'0','16'),
('1107','','1','Adult 15 yrs and above','1400','Adult: $27 (15+ years)',NULL,'0','16'),
('1108','','1','Family Ticket','1400','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','16'),
('1109','','1','Penguin Hire','1400','Penguin Skating Aids $10',NULL,'0','16'),
('1110','','1','Group Booking','1400','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','16'),
('1111','','1','Toddler 2-4 years','1500','Toddler: $15 (4 years and under)',NULL,'0','16'),
('1112','','1','Child/pensioner/concession card holder 5-14 years','1500','Child/Concession $20 (5-14 years)',NULL,'0','16'),
('1113','','1','Adult 15 yrs and above','1500','Adult: $27 (15+ years)',NULL,'0','16'),
('1114','','1','Family Ticket','1500','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','16'),
('1115','','1','Penguin Hire','1500','Penguin Skating Aids $10',NULL,'0','16'),
('1116','','1','Group Booking','1500','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','16'),
('1117','','1','Toddler 2-4 years','1600','Toddler: $15 (4 years and under)',NULL,'0','16'),
('1118','','1','Child/pensioner/concession card holder 5-14 years','1600','Child/Concession $20 (5-14 years)',NULL,'0','16'),
('1119','','1','Adult 15 yrs and above','1600','Adult: $27 (15+ years)',NULL,'0','16'),
('1120','','1','Family Ticket','1600','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','16');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1121','','1','Penguin Hire','1600','Penguin Skating Aids $10',NULL,'0','16'),
('1122','','1','Group Booking','1600','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','16'),
('1123','','1','Toddler 2-4 years','1700','Toddler: $15 (4 years and under)',NULL,'0','16'),
('1124','','1','Child/pensioner/concession card holder 5-14 years','1700','Child/Concession $20 (5-14 years)',NULL,'0','16'),
('1125','','1','Adult 15 yrs and above','1700','Adult: $27 (15+ years)',NULL,'0','16'),
('1126','','1','Family Ticket','1700','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','16'),
('1127','','1','Penguin Hire','1700','Penguin Skating Aids $10',NULL,'0','16'),
('1128','','1','Group Booking','1700','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','16'),
('1129','','1','Toddler 2-4 years','1800','Toddler: $15 (4 years and under)',NULL,'0','16'),
('1130','','1','Child/pensioner/concession card holder 5-14 years','1800','Child/Concession $20 (5-14 years)',NULL,'0','16'),
('1131','','1','Adult 15 yrs and above','1800','Adult: $27 (15+ years)',NULL,'0','16'),
('1132','','1','Family Ticket','1800','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','16'),
('1133','','1','Penguin Hire','1800','Penguin Skating Aids $10',NULL,'0','16'),
('1134','','1','Group Booking','1800','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','16'),
('1135','','1','Toddler 2-4 years','1900','Toddler: $15 (4 years and under)',NULL,'0','16'),
('1136','','1','Child/pensioner/concession card holder 5-14 years','1900','Child/Concession $20 (5-14 years)',NULL,'0','16'),
('1137','','1','Adult 15 yrs and above','1900','Adult: $27 (15+ years)',NULL,'0','16'),
('1138','','1','Family Ticket','1900','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','16'),
('1139','','1','Penguin Hire','1900','Penguin Skating Aids $10',NULL,'0','16'),
('1140','','1','Group Booking','1900','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','16');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1141','','1','Toddler 2-4 years','2000','Toddler: $15 (4 years and under)',NULL,'0','16'),
('1142','','1','Child/pensioner/concession card holder 5-14 years','2000','Child/Concession $20 (5-14 years)',NULL,'0','16'),
('1143','','1','Adult 15 yrs and above','2000','Adult: $27 (15+ years)',NULL,'0','16'),
('1144','','1','Family Ticket','2000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','16'),
('1145','','1','Penguin Hire','2000','Penguin Skating Aids $10',NULL,'0','16'),
('1146','','1','Group Booking','2000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','16'),
('1147','','1','Toddler 2-4 years','2100','Toddler: $15 (4 years and under)',NULL,'0','16'),
('1148','','1','Child/pensioner/concession card holder 5-14 years','2100','Child/Concession $20 (5-14 years)',NULL,'0','16'),
('1149','','1','Adult 15 yrs and above','2100','Adult: $27 (15+ years)',NULL,'0','16'),
('1150','','1','Family Ticket','2100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','16'),
('1151','','1','Penguin Hire','2100','Penguin Skating Aids $10',NULL,'0','16'),
('1152','','1','Group Booking','2100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','16'),
('1153','','1','Toddler 2-4 years','1000','Toddler: $15 (4 years and under)',NULL,'0','17'),
('1154','','1','Child/pensioner/concession card holder 5-14 years','1000','Child/Concession $20 (5-14 years)',NULL,'0','17'),
('1155','','1','Adult 15 yrs and above','1000','Adult: $27 (15+ years)',NULL,'0','17'),
('1156','','1','Family Ticket','1000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','17'),
('1157','','1','Penguin Hire','1000','Penguin Skating Aids $10',NULL,'0','17'),
('1158','','1','Group Booking','1000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','17'),
('1159','','1','Toddler 2-4 years','1100','Toddler: $15 (4 years and under)',NULL,'0','17'),
('1160','','1','Child/pensioner/concession card holder 5-14 years','1100','Child/Concession $20 (5-14 years)',NULL,'0','17');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1161','','1','Adult 15 yrs and above','1100','Adult: $27 (15+ years)',NULL,'0','17'),
('1162','','1','Family Ticket','1100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','17'),
('1163','','1','Penguin Hire','1100','Penguin Skating Aids $10',NULL,'0','17'),
('1164','','1','Group Booking','1100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','17'),
('1165','','1','Toddler 2-4 years','1200','Toddler: $15 (4 years and under)',NULL,'0','17'),
('1166','','1','Child/pensioner/concession card holder 5-14 years','1200','Child/Concession $20 (5-14 years)',NULL,'0','17'),
('1167','','1','Adult 15 yrs and above','1200','Adult: $27 (15+ years)',NULL,'0','17'),
('1168','','1','Family Ticket','1200','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','17'),
('1169','','1','Penguin Hire','1200','Penguin Skating Aids $10',NULL,'0','17'),
('1170','','1','Group Booking','1200','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','17'),
('1171','','1','Toddler 2-4 years','1300','Toddler: $15 (4 years and under)',NULL,'0','17'),
('1172','','1','Child/pensioner/concession card holder 5-14 years','1300','Child/Concession $20 (5-14 years)',NULL,'0','17'),
('1173','','1','Adult 15 yrs and above','1300','Adult: $27 (15+ years)',NULL,'0','17'),
('1174','','1','Family Ticket','1300','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','17'),
('1175','','1','Penguin Hire','1300','Penguin Skating Aids $10',NULL,'0','17'),
('1176','','1','Group Booking','1300','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','17'),
('1177','','1','Toddler 2-4 years','1400','Toddler: $15 (4 years and under)',NULL,'0','17'),
('1178','','1','Child/pensioner/concession card holder 5-14 years','1400','Child/Concession $20 (5-14 years)',NULL,'0','17'),
('1179','','1','Adult 15 yrs and above','1400','Adult: $27 (15+ years)',NULL,'0','17'),
('1180','','1','Family Ticket','1400','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','17');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1181','','1','Penguin Hire','1400','Penguin Skating Aids $10',NULL,'0','17'),
('1182','','1','Group Booking','1400','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','17'),
('1183','','1','Toddler 2-4 years','1500','Toddler: $15 (4 years and under)',NULL,'0','17'),
('1184','','1','Child/pensioner/concession card holder 5-14 years','1500','Child/Concession $20 (5-14 years)',NULL,'0','17'),
('1185','','1','Adult 15 yrs and above','1500','Adult: $27 (15+ years)',NULL,'0','17'),
('1186','','1','Family Ticket','1500','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','17'),
('1187','','1','Penguin Hire','1500','Penguin Skating Aids $10',NULL,'0','17'),
('1188','','1','Group Booking','1500','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','17'),
('1189','','1','Toddler 2-4 years','1600','Toddler: $15 (4 years and under)',NULL,'0','17'),
('1190','','1','Child/pensioner/concession card holder 5-14 years','1600','Child/Concession $20 (5-14 years)',NULL,'0','17'),
('1191','','1','Adult 15 yrs and above','1600','Adult: $27 (15+ years)',NULL,'0','17'),
('1192','','1','Family Ticket','1600','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','17'),
('1193','','1','Penguin Hire','1600','Penguin Skating Aids $10',NULL,'0','17'),
('1194','','1','Group Booking','1600','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','17'),
('1195','','1','Toddler 2-4 years','1700','Toddler: $15 (4 years and under)',NULL,'0','17'),
('1196','','1','Child/pensioner/concession card holder 5-14 years','1700','Child/Concession $20 (5-14 years)',NULL,'0','17'),
('1197','','1','Adult 15 yrs and above','1700','Adult: $27 (15+ years)',NULL,'0','17'),
('1198','','1','Family Ticket','1700','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','17'),
('1199','','1','Penguin Hire','1700','Penguin Skating Aids $10',NULL,'0','17'),
('1200','','1','Group Booking','1700','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','17');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1201','','1','Toddler 2-4 years','1800','Toddler: $15 (4 years and under)',NULL,'0','17'),
('1202','','1','Child/pensioner/concession card holder 5-14 years','1800','Child/Concession $20 (5-14 years)',NULL,'0','17'),
('1203','','1','Adult 15 yrs and above','1800','Adult: $27 (15+ years)',NULL,'0','17'),
('1204','','1','Family Ticket','1800','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','17'),
('1205','','1','Penguin Hire','1800','Penguin Skating Aids $10',NULL,'0','17'),
('1206','','1','Group Booking','1800','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','17'),
('1207','','1','Toddler 2-4 years','1900','Toddler: $15 (4 years and under)',NULL,'0','17'),
('1208','','1','Child/pensioner/concession card holder 5-14 years','1900','Child/Concession $20 (5-14 years)',NULL,'0','17'),
('1209','','1','Adult 15 yrs and above','1900','Adult: $27 (15+ years)',NULL,'0','17'),
('1210','','1','Family Ticket','1900','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','17'),
('1211','','1','Penguin Hire','1900','Penguin Skating Aids $10',NULL,'0','17'),
('1212','','1','Group Booking','1900','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','17'),
('1213','','1','Toddler 2-4 years','2000','Toddler: $15 (4 years and under)',NULL,'0','17'),
('1214','','1','Child/pensioner/concession card holder 5-14 years','2000','Child/Concession $20 (5-14 years)',NULL,'0','17'),
('1215','','1','Adult 15 yrs and above','2000','Adult: $27 (15+ years)',NULL,'0','17'),
('1216','','1','Family Ticket','2000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','17'),
('1217','','1','Penguin Hire','2000','Penguin Skating Aids $10',NULL,'0','17'),
('1218','','1','Group Booking','2000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','17'),
('1219','','1','Toddler 2-4 years','2100','Toddler: $15 (4 years and under)',NULL,'0','17'),
('1220','','1','Child/pensioner/concession card holder 5-14 years','2100','Child/Concession $20 (5-14 years)',NULL,'0','17');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1221','','1','Adult 15 yrs and above','2100','Adult: $27 (15+ years)',NULL,'0','17'),
('1222','','1','Family Ticket','2100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','17'),
('1223','','1','Penguin Hire','2100','Penguin Skating Aids $10',NULL,'0','17'),
('1224','','1','Group Booking','2100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','17'),
('1225','','1','Toddler 2-4 years','1000','Toddler: $15 (4 years and under)',NULL,'0','18'),
('1226','','1','Child/pensioner/concession card holder 5-14 years','1000','Child/Concession $20 (5-14 years)',NULL,'0','18'),
('1227','','1','Adult 15 yrs and above','1000','Adult: $27 (15+ years)',NULL,'0','18'),
('1228','','1','Family Ticket','1000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','18'),
('1229','','1','Penguin Hire','1000','Penguin Skating Aids $10',NULL,'0','18'),
('1230','','1','Group Booking','1000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','18'),
('1231','','1','Toddler 2-4 years','1100','Toddler: $15 (4 years and under)',NULL,'0','18'),
('1232','','1','Child/pensioner/concession card holder 5-14 years','1100','Child/Concession $20 (5-14 years)',NULL,'0','18'),
('1233','','1','Adult 15 yrs and above','1100','Adult: $27 (15+ years)',NULL,'0','18'),
('1234','','1','Family Ticket','1100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','18'),
('1235','','1','Penguin Hire','1100','Penguin Skating Aids $10',NULL,'0','18'),
('1236','','1','Group Booking','1100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','18'),
('1237','','1','Toddler 2-4 years','1200','Toddler: $15 (4 years and under)',NULL,'0','18'),
('1238','','1','Child/pensioner/concession card holder 5-14 years','1200','Child/Concession $20 (5-14 years)',NULL,'0','18'),
('1239','','1','Adult 15 yrs and above','1200','Adult: $27 (15+ years)',NULL,'0','18'),
('1240','','1','Family Ticket','1200','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','18');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1241','','1','Penguin Hire','1200','Penguin Skating Aids $10',NULL,'0','18'),
('1242','','1','Group Booking','1200','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','18'),
('1243','','1','Toddler 2-4 years','1300','Toddler: $15 (4 years and under)',NULL,'0','18'),
('1244','','1','Child/pensioner/concession card holder 5-14 years','1300','Child/Concession $20 (5-14 years)',NULL,'0','18'),
('1245','','1','Adult 15 yrs and above','1300','Adult: $27 (15+ years)',NULL,'0','18'),
('1246','','1','Family Ticket','1300','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','18'),
('1247','','1','Penguin Hire','1300','Penguin Skating Aids $10',NULL,'0','18'),
('1248','','1','Group Booking','1300','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','18'),
('1249','','1','Toddler 2-4 years','1400','Toddler: $15 (4 years and under)',NULL,'0','18'),
('1250','','1','Child/pensioner/concession card holder 5-14 years','1400','Child/Concession $20 (5-14 years)',NULL,'0','18'),
('1251','','1','Adult 15 yrs and above','1400','Adult: $27 (15+ years)',NULL,'0','18'),
('1252','','1','Family Ticket','1400','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','18'),
('1253','','1','Penguin Hire','1400','Penguin Skating Aids $10',NULL,'0','18'),
('1254','','1','Group Booking','1400','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','18'),
('1255','','1','Toddler 2-4 years','1500','Toddler: $15 (4 years and under)',NULL,'0','18'),
('1256','','1','Child/pensioner/concession card holder 5-14 years','1500','Child/Concession $20 (5-14 years)',NULL,'0','18'),
('1257','','1','Adult 15 yrs and above','1500','Adult: $27 (15+ years)',NULL,'0','18'),
('1258','','1','Family Ticket','1500','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','18'),
('1259','','1','Penguin Hire','1500','Penguin Skating Aids $10',NULL,'0','18'),
('1260','','1','Group Booking','1500','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','18');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1261','','1','Toddler 2-4 years','1600','Toddler: $15 (4 years and under)',NULL,'0','18'),
('1262','','1','Child/pensioner/concession card holder 5-14 years','1600','Child/Concession $20 (5-14 years)',NULL,'0','18'),
('1263','','1','Adult 15 yrs and above','1600','Adult: $27 (15+ years)',NULL,'0','18'),
('1264','','1','Family Ticket','1600','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','18'),
('1265','','1','Penguin Hire','1600','Penguin Skating Aids $10',NULL,'0','18'),
('1266','','1','Group Booking','1600','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','18'),
('1267','','1','Toddler 2-4 years','1700','Toddler: $15 (4 years and under)',NULL,'0','18'),
('1268','','1','Child/pensioner/concession card holder 5-14 years','1700','Child/Concession $20 (5-14 years)',NULL,'0','18'),
('1269','','1','Adult 15 yrs and above','1700','Adult: $27 (15+ years)',NULL,'0','18'),
('1270','','1','Family Ticket','1700','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','18'),
('1271','','1','Penguin Hire','1700','Penguin Skating Aids $10',NULL,'0','18'),
('1272','','1','Group Booking','1700','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','18'),
('1273','','1','Toddler 2-4 years','1800','Toddler: $15 (4 years and under)',NULL,'0','18'),
('1274','','1','Child/pensioner/concession card holder 5-14 years','1800','Child/Concession $20 (5-14 years)',NULL,'0','18'),
('1275','','1','Adult 15 yrs and above','1800','Adult: $27 (15+ years)',NULL,'0','18'),
('1276','','1','Family Ticket','1800','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','18'),
('1277','','1','Penguin Hire','1800','Penguin Skating Aids $10',NULL,'0','18'),
('1278','','1','Group Booking','1800','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','18'),
('1279','','1','Toddler 2-4 years','1900','Toddler: $15 (4 years and under)',NULL,'0','18'),
('1280','','1','Child/pensioner/concession card holder 5-14 years','1900','Child/Concession $20 (5-14 years)',NULL,'0','18');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1281','','1','Adult 15 yrs and above','1900','Adult: $27 (15+ years)',NULL,'0','18'),
('1282','','1','Family Ticket','1900','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','18'),
('1283','','1','Penguin Hire','1900','Penguin Skating Aids $10',NULL,'0','18'),
('1284','','1','Group Booking','1900','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','18'),
('1285','','1','Toddler 2-4 years','2000','Toddler: $15 (4 years and under)',NULL,'0','18'),
('1286','','1','Child/pensioner/concession card holder 5-14 years','2000','Child/Concession $20 (5-14 years)',NULL,'0','18'),
('1287','','1','Adult 15 yrs and above','2000','Adult: $27 (15+ years)',NULL,'0','18'),
('1288','','1','Family Ticket','2000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','18'),
('1289','','1','Penguin Hire','2000','Penguin Skating Aids $10',NULL,'0','18'),
('1290','','1','Group Booking','2000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','18'),
('1291','','1','Toddler 2-4 years','2100','Toddler: $15 (4 years and under)',NULL,'0','18'),
('1292','','1','Child/pensioner/concession card holder 5-14 years','2100','Child/Concession $20 (5-14 years)',NULL,'0','18'),
('1293','','1','Adult 15 yrs and above','2100','Adult: $27 (15+ years)',NULL,'0','18'),
('1294','','1','Family Ticket','2100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','18'),
('1295','','1','Penguin Hire','2100','Penguin Skating Aids $10',NULL,'0','18'),
('1296','','1','Group Booking','2100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','18'),
('1297','','1','Toddler 2-4 years','1000','Toddler: $15 (4 years and under)',NULL,'0','19'),
('1298','','1','Child/pensioner/concession card holder 5-14 years','1000','Child/Concession $20 (5-14 years)',NULL,'0','19'),
('1299','','1','Adult 15 yrs and above','1000','Adult: $27 (15+ years)',NULL,'0','19'),
('1300','','1','Family Ticket','1000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','19');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1301','','1','Penguin Hire','1000','Penguin Skating Aids $10',NULL,'0','19'),
('1302','','1','Group Booking','1000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','19'),
('1303','','1','Toddler 2-4 years','1100','Toddler: $15 (4 years and under)',NULL,'0','19'),
('1304','','1','Child/pensioner/concession card holder 5-14 years','1100','Child/Concession $20 (5-14 years)',NULL,'0','19'),
('1305','','1','Adult 15 yrs and above','1100','Adult: $27 (15+ years)',NULL,'0','19'),
('1306','','1','Family Ticket','1100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','19'),
('1307','','1','Penguin Hire','1100','Penguin Skating Aids $10',NULL,'0','19'),
('1308','','1','Group Booking','1100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','19'),
('1309','','1','Toddler 2-4 years','1200','Toddler: $15 (4 years and under)',NULL,'0','19'),
('1310','','1','Child/pensioner/concession card holder 5-14 years','1200','Child/Concession $20 (5-14 years)',NULL,'0','19'),
('1311','','1','Adult 15 yrs and above','1200','Adult: $27 (15+ years)',NULL,'0','19'),
('1312','','1','Family Ticket','1200','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','19'),
('1313','','1','Penguin Hire','1200','Penguin Skating Aids $10',NULL,'0','19'),
('1314','','1','Group Booking','1200','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','19'),
('1315','','1','Toddler 2-4 years','1300','Toddler: $15 (4 years and under)',NULL,'0','19'),
('1316','','1','Child/pensioner/concession card holder 5-14 years','1300','Child/Concession $20 (5-14 years)',NULL,'0','19'),
('1317','','1','Adult 15 yrs and above','1300','Adult: $27 (15+ years)',NULL,'0','19'),
('1318','','1','Family Ticket','1300','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','19'),
('1319','','1','Penguin Hire','1300','Penguin Skating Aids $10',NULL,'0','19'),
('1320','','1','Group Booking','1300','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','19');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1321','','1','Toddler 2-4 years','1400','Toddler: $15 (4 years and under)',NULL,'0','19'),
('1322','','1','Child/pensioner/concession card holder 5-14 years','1400','Child/Concession $20 (5-14 years)',NULL,'0','19'),
('1323','','1','Adult 15 yrs and above','1400','Adult: $27 (15+ years)',NULL,'0','19'),
('1324','','1','Family Ticket','1400','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','19'),
('1325','','1','Penguin Hire','1400','Penguin Skating Aids $10',NULL,'0','19'),
('1326','','1','Group Booking','1400','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','19'),
('1327','','1','Toddler 2-4 years','1500','Toddler: $15 (4 years and under)',NULL,'0','19'),
('1328','','1','Child/pensioner/concession card holder 5-14 years','1500','Child/Concession $20 (5-14 years)',NULL,'0','19'),
('1329','','1','Adult 15 yrs and above','1500','Adult: $27 (15+ years)',NULL,'0','19'),
('1330','','1','Family Ticket','1500','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','19'),
('1331','','1','Penguin Hire','1500','Penguin Skating Aids $10',NULL,'0','19'),
('1332','','1','Group Booking','1500','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','19'),
('1333','','1','Toddler 2-4 years','1600','Toddler: $15 (4 years and under)',NULL,'0','19'),
('1334','','1','Child/pensioner/concession card holder 5-14 years','1600','Child/Concession $20 (5-14 years)',NULL,'0','19'),
('1335','','1','Adult 15 yrs and above','1600','Adult: $27 (15+ years)',NULL,'0','19'),
('1336','','1','Family Ticket','1600','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','19'),
('1337','','1','Penguin Hire','1600','Penguin Skating Aids $10',NULL,'0','19'),
('1338','','1','Group Booking','1600','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','19'),
('1339','','1','Toddler 2-4 years','1700','Toddler: $15 (4 years and under)',NULL,'0','19'),
('1340','','1','Child/pensioner/concession card holder 5-14 years','1700','Child/Concession $20 (5-14 years)',NULL,'0','19');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1341','','1','Adult 15 yrs and above','1700','Adult: $27 (15+ years)',NULL,'0','19'),
('1342','','1','Family Ticket','1700','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','19'),
('1343','','1','Penguin Hire','1700','Penguin Skating Aids $10',NULL,'0','19'),
('1344','','1','Group Booking','1700','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','19'),
('1345','','1','Toddler 2-4 years','1800','Toddler: $15 (4 years and under)',NULL,'0','19'),
('1346','','1','Child/pensioner/concession card holder 5-14 years','1800','Child/Concession $20 (5-14 years)',NULL,'0','19'),
('1347','','1','Adult 15 yrs and above','1800','Adult: $27 (15+ years)',NULL,'0','19'),
('1348','','1','Family Ticket','1800','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','19'),
('1349','','1','Penguin Hire','1800','Penguin Skating Aids $10',NULL,'0','19'),
('1350','','1','Group Booking','1800','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','19'),
('1351','','1','Toddler 2-4 years','1900','Toddler: $15 (4 years and under)',NULL,'0','19'),
('1352','','1','Child/pensioner/concession card holder 5-14 years','1900','Child/Concession $20 (5-14 years)',NULL,'0','19'),
('1353','','1','Adult 15 yrs and above','1900','Adult: $27 (15+ years)',NULL,'0','19'),
('1354','','1','Family Ticket','1900','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','19'),
('1355','','1','Penguin Hire','1900','Penguin Skating Aids $10',NULL,'0','19'),
('1356','','1','Group Booking','1900','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','19'),
('1357','','1','Toddler 2-4 years','2000','Toddler: $15 (4 years and under)',NULL,'0','19'),
('1358','','1','Child/pensioner/concession card holder 5-14 years','2000','Child/Concession $20 (5-14 years)',NULL,'0','19'),
('1359','','1','Adult 15 yrs and above','2000','Adult: $27 (15+ years)',NULL,'0','19'),
('1360','','1','Family Ticket','2000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','19');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1361','','1','Penguin Hire','2000','Penguin Skating Aids $10',NULL,'0','19'),
('1362','','1','Group Booking','2000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','19'),
('1363','','1','Toddler 2-4 years','2100','Toddler: $15 (4 years and under)',NULL,'0','19'),
('1364','','1','Child/pensioner/concession card holder 5-14 years','2100','Child/Concession $20 (5-14 years)',NULL,'0','19'),
('1365','','1','Adult 15 yrs and above','2100','Adult: $27 (15+ years)',NULL,'0','19'),
('1366','','1','Family Ticket','2100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','19'),
('1367','','1','Penguin Hire','2100','Penguin Skating Aids $10',NULL,'0','19'),
('1368','','1','Group Booking','2100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','19'),
('1369','','1','Toddler 2-4 years','1000','Toddler: $15 (4 years and under)',NULL,'0','20'),
('1370','','1','Child/pensioner/concession card holder 5-14 years','1000','Child/Concession $20 (5-14 years)',NULL,'0','20'),
('1371','','1','Adult 15 yrs and above','1000','Adult: $27 (15+ years)',NULL,'0','20'),
('1372','','1','Family Ticket','1000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','20'),
('1373','','1','Penguin Hire','1000','Penguin Skating Aids $10',NULL,'0','20'),
('1374','','1','Group Booking','1000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','20'),
('1375','','1','Toddler 2-4 years','1100','Toddler: $15 (4 years and under)',NULL,'0','20'),
('1376','','1','Child/pensioner/concession card holder 5-14 years','1100','Child/Concession $20 (5-14 years)',NULL,'0','20'),
('1377','','1','Adult 15 yrs and above','1100','Adult: $27 (15+ years)',NULL,'0','20'),
('1378','','1','Family Ticket','1100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','20'),
('1379','','1','Penguin Hire','1100','Penguin Skating Aids $10',NULL,'0','20'),
('1380','','1','Group Booking','1100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','20');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1381','','1','Toddler 2-4 years','1200','Toddler: $15 (4 years and under)',NULL,'0','20'),
('1382','','1','Child/pensioner/concession card holder 5-14 years','1200','Child/Concession $20 (5-14 years)',NULL,'0','20'),
('1383','','1','Adult 15 yrs and above','1200','Adult: $27 (15+ years)',NULL,'0','20'),
('1384','','1','Family Ticket','1200','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','20'),
('1385','','1','Penguin Hire','1200','Penguin Skating Aids $10',NULL,'0','20'),
('1386','','1','Group Booking','1200','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','20'),
('1387','','1','Toddler 2-4 years','1300','Toddler: $15 (4 years and under)',NULL,'0','20'),
('1388','','1','Child/pensioner/concession card holder 5-14 years','1300','Child/Concession $20 (5-14 years)',NULL,'0','20'),
('1389','','1','Adult 15 yrs and above','1300','Adult: $27 (15+ years)',NULL,'0','20'),
('1390','','1','Family Ticket','1300','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','20'),
('1391','','1','Penguin Hire','1300','Penguin Skating Aids $10',NULL,'0','20'),
('1392','','1','Group Booking','1300','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','20'),
('1393','','1','Toddler 2-4 years','1400','Toddler: $15 (4 years and under)',NULL,'0','20'),
('1394','','1','Child/pensioner/concession card holder 5-14 years','1400','Child/Concession $20 (5-14 years)',NULL,'0','20'),
('1395','','1','Adult 15 yrs and above','1400','Adult: $27 (15+ years)',NULL,'0','20'),
('1396','','1','Family Ticket','1400','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','20'),
('1397','','1','Penguin Hire','1400','Penguin Skating Aids $10',NULL,'0','20'),
('1398','','1','Group Booking','1400','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','20'),
('1399','','1','Toddler 2-4 years','1500','Toddler: $15 (4 years and under)',NULL,'0','20'),
('1400','','1','Child/pensioner/concession card holder 5-14 years','1500','Child/Concession $20 (5-14 years)',NULL,'0','20');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1401','','1','Adult 15 yrs and above','1500','Adult: $27 (15+ years)',NULL,'0','20'),
('1402','','1','Family Ticket','1500','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','20'),
('1403','','1','Penguin Hire','1500','Penguin Skating Aids $10',NULL,'0','20'),
('1404','','1','Group Booking','1500','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','20'),
('1405','','1','Toddler 2-4 years','1600','Toddler: $15 (4 years and under)',NULL,'0','20'),
('1406','','1','Child/pensioner/concession card holder 5-14 years','1600','Child/Concession $20 (5-14 years)',NULL,'0','20'),
('1407','','1','Adult 15 yrs and above','1600','Adult: $27 (15+ years)',NULL,'0','20'),
('1408','','1','Family Ticket','1600','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','20'),
('1409','','1','Penguin Hire','1600','Penguin Skating Aids $10',NULL,'0','20'),
('1410','','1','Group Booking','1600','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','20'),
('1411','','1','Toddler 2-4 years','1700','Toddler: $15 (4 years and under)',NULL,'0','20'),
('1412','','1','Child/pensioner/concession card holder 5-14 years','1700','Child/Concession $20 (5-14 years)',NULL,'0','20'),
('1413','','1','Adult 15 yrs and above','1700','Adult: $27 (15+ years)',NULL,'0','20'),
('1414','','1','Family Ticket','1700','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','20'),
('1415','','1','Penguin Hire','1700','Penguin Skating Aids $10',NULL,'0','20'),
('1416','','1','Group Booking','1700','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','20'),
('1417','','1','Toddler 2-4 years','1800','Toddler: $15 (4 years and under)',NULL,'0','20'),
('1418','','1','Child/pensioner/concession card holder 5-14 years','1800','Child/Concession $20 (5-14 years)',NULL,'0','20'),
('1419','','1','Adult 15 yrs and above','1800','Adult: $27 (15+ years)',NULL,'0','20'),
('1420','','1','Family Ticket','1800','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','20');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1421','','1','Penguin Hire','1800','Penguin Skating Aids $10',NULL,'0','20'),
('1422','','1','Group Booking','1800','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','20'),
('1423','','1','Toddler 2-4 years','1900','Toddler: $15 (4 years and under)',NULL,'0','20'),
('1424','','1','Child/pensioner/concession card holder 5-14 years','1900','Child/Concession $20 (5-14 years)',NULL,'0','20'),
('1425','','1','Adult 15 yrs and above','1900','Adult: $27 (15+ years)',NULL,'0','20'),
('1426','','1','Family Ticket','1900','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','20'),
('1427','','1','Penguin Hire','1900','Penguin Skating Aids $10',NULL,'0','20'),
('1428','','1','Group Booking','1900','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','20'),
('1429','','1','Toddler 2-4 years','2000','Toddler: $15 (4 years and under)',NULL,'0','20'),
('1430','','1','Child/pensioner/concession card holder 5-14 years','2000','Child/Concession $20 (5-14 years)',NULL,'0','20'),
('1431','','1','Adult 15 yrs and above','2000','Adult: $27 (15+ years)',NULL,'0','20'),
('1432','','1','Family Ticket','2000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','20'),
('1433','','1','Penguin Hire','2000','Penguin Skating Aids $10',NULL,'0','20'),
('1434','','1','Group Booking','2000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','20'),
('1435','','1','Toddler 2-4 years','2100','Toddler: $15 (4 years and under)',NULL,'0','20'),
('1436','','1','Child/pensioner/concession card holder 5-14 years','2100','Child/Concession $20 (5-14 years)',NULL,'0','20'),
('1437','','1','Adult 15 yrs and above','2100','Adult: $27 (15+ years)',NULL,'0','20'),
('1438','','1','Family Ticket','2100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','20'),
('1439','','1','Penguin Hire','2100','Penguin Skating Aids $10',NULL,'0','20'),
('1440','','1','Group Booking','2100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','20');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1441','','1','Toddler 2-4 years','1000','Toddler: $15 (4 years and under)',NULL,'0','21'),
('1442','','1','Child/pensioner/concession card holder 5-14 years','1000','Child/Concession $20 (5-14 years)',NULL,'0','21'),
('1443','','1','Adult 15 yrs and above','1000','Adult: $27 (15+ years)',NULL,'0','21'),
('1444','','1','Family Ticket','1000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','21'),
('1445','','1','Penguin Hire','1000','Penguin Skating Aids $10',NULL,'0','21'),
('1446','','1','Group Booking','1000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','21'),
('1447','','1','Toddler 2-4 years','1100','Toddler: $15 (4 years and under)',NULL,'0','21'),
('1448','','1','Child/pensioner/concession card holder 5-14 years','1100','Child/Concession $20 (5-14 years)',NULL,'0','21'),
('1449','','1','Adult 15 yrs and above','1100','Adult: $27 (15+ years)',NULL,'0','21'),
('1450','','1','Family Ticket','1100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','21'),
('1451','','1','Penguin Hire','1100','Penguin Skating Aids $10',NULL,'0','21'),
('1452','','1','Group Booking','1100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','21'),
('1453','','1','Toddler 2-4 years','1200','Toddler: $15 (4 years and under)',NULL,'0','21'),
('1454','','1','Child/pensioner/concession card holder 5-14 years','1200','Child/Concession $20 (5-14 years)',NULL,'0','21'),
('1455','','1','Adult 15 yrs and above','1200','Adult: $27 (15+ years)',NULL,'0','21'),
('1456','','1','Family Ticket','1200','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','21'),
('1457','','1','Penguin Hire','1200','Penguin Skating Aids $10',NULL,'0','21'),
('1458','','1','Group Booking','1200','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','21'),
('1459','','1','Toddler 2-4 years','1300','Toddler: $15 (4 years and under)',NULL,'0','21'),
('1460','','1','Child/pensioner/concession card holder 5-14 years','1300','Child/Concession $20 (5-14 years)',NULL,'0','21');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1461','','1','Adult 15 yrs and above','1300','Adult: $27 (15+ years)',NULL,'0','21'),
('1462','','1','Family Ticket','1300','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','21'),
('1463','','1','Penguin Hire','1300','Penguin Skating Aids $10',NULL,'0','21'),
('1464','','1','Group Booking','1300','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','21'),
('1465','','1','Toddler 2-4 years','1400','Toddler: $15 (4 years and under)',NULL,'0','21'),
('1466','','1','Child/pensioner/concession card holder 5-14 years','1400','Child/Concession $20 (5-14 years)',NULL,'0','21'),
('1467','','1','Adult 15 yrs and above','1400','Adult: $27 (15+ years)',NULL,'0','21'),
('1468','','1','Family Ticket','1400','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','21'),
('1469','','1','Penguin Hire','1400','Penguin Skating Aids $10',NULL,'0','21'),
('1470','','1','Group Booking','1400','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','21'),
('1471','','1','Toddler 2-4 years','1500','Toddler: $15 (4 years and under)',NULL,'0','21'),
('1472','','1','Child/pensioner/concession card holder 5-14 years','1500','Child/Concession $20 (5-14 years)',NULL,'0','21'),
('1473','','1','Adult 15 yrs and above','1500','Adult: $27 (15+ years)',NULL,'0','21'),
('1474','','1','Family Ticket','1500','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','21'),
('1475','','1','Penguin Hire','1500','Penguin Skating Aids $10',NULL,'0','21'),
('1476','','1','Group Booking','1500','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','21'),
('1477','','1','Toddler 2-4 years','1600','Toddler: $15 (4 years and under)',NULL,'0','21'),
('1478','','1','Child/pensioner/concession card holder 5-14 years','1600','Child/Concession $20 (5-14 years)',NULL,'0','21'),
('1479','','1','Adult 15 yrs and above','1600','Adult: $27 (15+ years)',NULL,'0','21'),
('1480','','1','Family Ticket','1600','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','21');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1481','','1','Penguin Hire','1600','Penguin Skating Aids $10',NULL,'0','21'),
('1482','','1','Group Booking','1600','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','21'),
('1483','','1','Toddler 2-4 years','1700','Toddler: $15 (4 years and under)',NULL,'0','21'),
('1484','','1','Child/pensioner/concession card holder 5-14 years','1700','Child/Concession $20 (5-14 years)',NULL,'0','21'),
('1485','','1','Adult 15 yrs and above','1700','Adult: $27 (15+ years)',NULL,'0','21'),
('1486','','1','Family Ticket','1700','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','21'),
('1487','','1','Penguin Hire','1700','Penguin Skating Aids $10',NULL,'0','21'),
('1488','','1','Group Booking','1700','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','21'),
('1489','','1','Toddler 2-4 years','1800','Toddler: $15 (4 years and under)',NULL,'0','21'),
('1490','','1','Child/pensioner/concession card holder 5-14 years','1800','Child/Concession $20 (5-14 years)',NULL,'0','21'),
('1491','','1','Adult 15 yrs and above','1800','Adult: $27 (15+ years)',NULL,'0','21'),
('1492','','1','Family Ticket','1800','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','21'),
('1493','','1','Penguin Hire','1800','Penguin Skating Aids $10',NULL,'0','21'),
('1494','','1','Group Booking','1800','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','21'),
('1495','','1','Toddler 2-4 years','1900','Toddler: $15 (4 years and under)',NULL,'0','21'),
('1496','','1','Child/pensioner/concession card holder 5-14 years','1900','Child/Concession $20 (5-14 years)',NULL,'0','21'),
('1497','','1','Adult 15 yrs and above','1900','Adult: $27 (15+ years)',NULL,'0','21'),
('1498','','1','Family Ticket','1900','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','21'),
('1499','','1','Penguin Hire','1900','Penguin Skating Aids $10',NULL,'0','21'),
('1500','','1','Group Booking','1900','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','21');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1501','','1','Toddler 2-4 years','2000','Toddler: $15 (4 years and under)',NULL,'0','21'),
('1502','','1','Child/pensioner/concession card holder 5-14 years','2000','Child/Concession $20 (5-14 years)',NULL,'0','21'),
('1503','','1','Adult 15 yrs and above','2000','Adult: $27 (15+ years)',NULL,'0','21'),
('1504','','1','Family Ticket','2000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','21'),
('1505','','1','Penguin Hire','2000','Penguin Skating Aids $10',NULL,'0','21'),
('1506','','1','Group Booking','2000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','21'),
('1507','','1','Toddler 2-4 years','2100','Toddler: $15 (4 years and under)',NULL,'0','21'),
('1508','','1','Child/pensioner/concession card holder 5-14 years','2100','Child/Concession $20 (5-14 years)',NULL,'0','21'),
('1509','','1','Adult 15 yrs and above','2100','Adult: $27 (15+ years)',NULL,'0','21'),
('1510','','1','Family Ticket','2100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','21'),
('1511','','1','Penguin Hire','2100','Penguin Skating Aids $10',NULL,'0','21'),
('1512','','1','Group Booking','2100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','21'),
('1513','','1','Toddler 2-4 years','1000','Toddler: $15 (4 years and under)',NULL,'0','22'),
('1514','','1','Child/pensioner/concession card holder 5-14 years','1000','Child/Concession $20 (5-14 years)',NULL,'0','22'),
('1515','','1','Adult 15 yrs and above','1000','Adult: $27 (15+ years)',NULL,'0','22'),
('1516','','1','Family Ticket','1000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','22'),
('1517','','1','Penguin Hire','1000','Penguin Skating Aids $10',NULL,'0','22'),
('1518','','1','Group Booking','1000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','22'),
('1519','','1','Toddler 2-4 years','1100','Toddler: $15 (4 years and under)',NULL,'0','22'),
('1520','','1','Child/pensioner/concession card holder 5-14 years','1100','Child/Concession $20 (5-14 years)',NULL,'0','22');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1521','','1','Adult 15 yrs and above','1100','Adult: $27 (15+ years)',NULL,'0','22'),
('1522','','1','Family Ticket','1100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','22'),
('1523','','1','Penguin Hire','1100','Penguin Skating Aids $10',NULL,'0','22'),
('1524','','1','Group Booking','1100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','22'),
('1525','','1','Toddler 2-4 years','1200','Toddler: $15 (4 years and under)',NULL,'0','22'),
('1526','','1','Child/pensioner/concession card holder 5-14 years','1200','Child/Concession $20 (5-14 years)',NULL,'0','22'),
('1527','','1','Adult 15 yrs and above','1200','Adult: $27 (15+ years)',NULL,'0','22'),
('1528','','1','Family Ticket','1200','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','22'),
('1529','','1','Penguin Hire','1200','Penguin Skating Aids $10',NULL,'0','22'),
('1530','','1','Group Booking','1200','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','22'),
('1531','','1','Toddler 2-4 years','1300','Toddler: $15 (4 years and under)',NULL,'0','22'),
('1532','','1','Child/pensioner/concession card holder 5-14 years','1300','Child/Concession $20 (5-14 years)',NULL,'0','22'),
('1533','','1','Adult 15 yrs and above','1300','Adult: $27 (15+ years)',NULL,'0','22'),
('1534','','1','Family Ticket','1300','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','22'),
('1535','','1','Penguin Hire','1300','Penguin Skating Aids $10',NULL,'0','22'),
('1536','','1','Group Booking','1300','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','22'),
('1537','','1','Toddler 2-4 years','1400','Toddler: $15 (4 years and under)',NULL,'0','22'),
('1538','','1','Child/pensioner/concession card holder 5-14 years','1400','Child/Concession $20 (5-14 years)',NULL,'0','22'),
('1539','','1','Adult 15 yrs and above','1400','Adult: $27 (15+ years)',NULL,'0','22'),
('1540','','1','Family Ticket','1400','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','22');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1541','','1','Penguin Hire','1400','Penguin Skating Aids $10',NULL,'0','22'),
('1542','','1','Group Booking','1400','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','22'),
('1543','','1','Toddler 2-4 years','1500','Toddler: $15 (4 years and under)',NULL,'0','22'),
('1544','','1','Child/pensioner/concession card holder 5-14 years','1500','Child/Concession $20 (5-14 years)',NULL,'0','22'),
('1545','','1','Adult 15 yrs and above','1500','Adult: $27 (15+ years)',NULL,'0','22'),
('1546','','1','Family Ticket','1500','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','22'),
('1547','','1','Penguin Hire','1500','Penguin Skating Aids $10',NULL,'0','22'),
('1548','','1','Group Booking','1500','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','22'),
('1549','','1','Toddler 2-4 years','1600','Toddler: $15 (4 years and under)',NULL,'0','22'),
('1550','','1','Child/pensioner/concession card holder 5-14 years','1600','Child/Concession $20 (5-14 years)',NULL,'0','22'),
('1551','','1','Adult 15 yrs and above','1600','Adult: $27 (15+ years)',NULL,'0','22'),
('1552','','1','Family Ticket','1600','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','22'),
('1553','','1','Penguin Hire','1600','Penguin Skating Aids $10',NULL,'0','22'),
('1554','','1','Group Booking','1600','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','22'),
('1555','','1','Toddler 2-4 years','1700','Toddler: $15 (4 years and under)',NULL,'0','22'),
('1556','','1','Child/pensioner/concession card holder 5-14 years','1700','Child/Concession $20 (5-14 years)',NULL,'0','22'),
('1557','','1','Adult 15 yrs and above','1700','Adult: $27 (15+ years)',NULL,'0','22'),
('1558','','1','Family Ticket','1700','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','22'),
('1559','','1','Penguin Hire','1700','Penguin Skating Aids $10',NULL,'0','22'),
('1560','','1','Group Booking','1700','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','22');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1561','','1','Toddler 2-4 years','1800','Toddler: $15 (4 years and under)',NULL,'0','22'),
('1562','','1','Child/pensioner/concession card holder 5-14 years','1800','Child/Concession $20 (5-14 years)',NULL,'0','22'),
('1563','','1','Adult 15 yrs and above','1800','Adult: $27 (15+ years)',NULL,'0','22'),
('1564','','1','Family Ticket','1800','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','22'),
('1565','','1','Penguin Hire','1800','Penguin Skating Aids $10',NULL,'0','22'),
('1566','','1','Group Booking','1800','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','22'),
('1567','','1','Toddler 2-4 years','1900','Toddler: $15 (4 years and under)',NULL,'0','22'),
('1568','','1','Child/pensioner/concession card holder 5-14 years','1900','Child/Concession $20 (5-14 years)',NULL,'0','22'),
('1569','','1','Adult 15 yrs and above','1900','Adult: $27 (15+ years)',NULL,'0','22'),
('1570','','1','Family Ticket','1900','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','22'),
('1571','','1','Penguin Hire','1900','Penguin Skating Aids $10',NULL,'0','22'),
('1572','','1','Group Booking','1900','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','22'),
('1573','','1','Toddler 2-4 years','2000','Toddler: $15 (4 years and under)',NULL,'0','22'),
('1574','','1','Child/pensioner/concession card holder 5-14 years','2000','Child/Concession $20 (5-14 years)',NULL,'0','22'),
('1575','','1','Adult 15 yrs and above','2000','Adult: $27 (15+ years)',NULL,'0','22'),
('1576','','1','Family Ticket','2000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','22'),
('1577','','1','Penguin Hire','2000','Penguin Skating Aids $10',NULL,'0','22'),
('1578','','1','Group Booking','2000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','22'),
('1579','','1','Toddler 2-4 years','2100','Toddler: $15 (4 years and under)',NULL,'0','22'),
('1580','','1','Child/pensioner/concession card holder 5-14 years','2100','Child/Concession $20 (5-14 years)',NULL,'0','22');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1581','','1','Adult 15 yrs and above','2100','Adult: $27 (15+ years)',NULL,'0','22'),
('1582','','1','Family Ticket','2100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','22'),
('1583','','1','Penguin Hire','2100','Penguin Skating Aids $10',NULL,'0','22'),
('1584','','1','Group Booking','2100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','22'),
('1585','','1','Toddler 2-4 years','1000','Toddler: $15 (4 years and under)',NULL,'0','23'),
('1586','','1','Child/pensioner/concession card holder 5-14 years','1000','Child/Concession $20 (5-14 years)',NULL,'0','23'),
('1587','','1','Adult 15 yrs and above','1000','Adult: $27 (15+ years)',NULL,'0','23'),
('1588','','1','Family Ticket','1000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','23'),
('1589','','1','Penguin Hire','1000','Penguin Skating Aids $10',NULL,'0','23'),
('1590','','1','Group Booking','1000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','23'),
('1591','','1','Toddler 2-4 years','1100','Toddler: $15 (4 years and under)',NULL,'0','23'),
('1592','','1','Child/pensioner/concession card holder 5-14 years','1100','Child/Concession $20 (5-14 years)',NULL,'0','23'),
('1593','','1','Adult 15 yrs and above','1100','Adult: $27 (15+ years)',NULL,'0','23'),
('1594','','1','Family Ticket','1100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','23'),
('1595','','1','Penguin Hire','1100','Penguin Skating Aids $10',NULL,'0','23'),
('1596','','1','Group Booking','1100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','23'),
('1597','','1','Toddler 2-4 years','1200','Toddler: $15 (4 years and under)',NULL,'0','23'),
('1598','','1','Child/pensioner/concession card holder 5-14 years','1200','Child/Concession $20 (5-14 years)',NULL,'0','23'),
('1599','','1','Adult 15 yrs and above','1200','Adult: $27 (15+ years)',NULL,'0','23'),
('1600','','1','Family Ticket','1200','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','23');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1601','','1','Penguin Hire','1200','Penguin Skating Aids $10',NULL,'0','23'),
('1602','','1','Group Booking','1200','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','23'),
('1603','','1','Toddler 2-4 years','1300','Toddler: $15 (4 years and under)',NULL,'0','23'),
('1604','','1','Child/pensioner/concession card holder 5-14 years','1300','Child/Concession $20 (5-14 years)',NULL,'0','23'),
('1605','','1','Adult 15 yrs and above','1300','Adult: $27 (15+ years)',NULL,'0','23'),
('1606','','1','Family Ticket','1300','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','23'),
('1607','','1','Penguin Hire','1300','Penguin Skating Aids $10',NULL,'0','23'),
('1608','','1','Group Booking','1300','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','23'),
('1609','','1','Toddler 2-4 years','1400','Toddler: $15 (4 years and under)',NULL,'0','23'),
('1610','','1','Child/pensioner/concession card holder 5-14 years','1400','Child/Concession $20 (5-14 years)',NULL,'0','23'),
('1611','','1','Adult 15 yrs and above','1400','Adult: $27 (15+ years)',NULL,'0','23'),
('1612','','1','Family Ticket','1400','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','23'),
('1613','','1','Penguin Hire','1400','Penguin Skating Aids $10',NULL,'0','23'),
('1614','','1','Group Booking','1400','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','23'),
('1615','','1','Toddler 2-4 years','1500','Toddler: $15 (4 years and under)',NULL,'0','23'),
('1616','','1','Child/pensioner/concession card holder 5-14 years','1500','Child/Concession $20 (5-14 years)',NULL,'0','23'),
('1617','','1','Adult 15 yrs and above','1500','Adult: $27 (15+ years)',NULL,'0','23'),
('1618','','1','Family Ticket','1500','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','23'),
('1619','','1','Penguin Hire','1500','Penguin Skating Aids $10',NULL,'0','23'),
('1620','','1','Group Booking','1500','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','23');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1621','','1','Toddler 2-4 years','1600','Toddler: $15 (4 years and under)',NULL,'0','23'),
('1622','','1','Child/pensioner/concession card holder 5-14 years','1600','Child/Concession $20 (5-14 years)',NULL,'0','23'),
('1623','','1','Adult 15 yrs and above','1600','Adult: $27 (15+ years)',NULL,'0','23'),
('1624','','1','Family Ticket','1600','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','23'),
('1625','','1','Penguin Hire','1600','Penguin Skating Aids $10',NULL,'0','23'),
('1626','','1','Group Booking','1600','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','23'),
('1627','','1','Toddler 2-4 years','1700','Toddler: $15 (4 years and under)',NULL,'0','23'),
('1628','','1','Child/pensioner/concession card holder 5-14 years','1700','Child/Concession $20 (5-14 years)',NULL,'0','23'),
('1629','','1','Adult 15 yrs and above','1700','Adult: $27 (15+ years)',NULL,'0','23'),
('1630','','1','Family Ticket','1700','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','23'),
('1631','','1','Penguin Hire','1700','Penguin Skating Aids $10',NULL,'0','23'),
('1632','','1','Group Booking','1700','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','23'),
('1633','','1','Toddler 2-4 years','1800','Toddler: $15 (4 years and under)',NULL,'0','23'),
('1634','','1','Child/pensioner/concession card holder 5-14 years','1800','Child/Concession $20 (5-14 years)',NULL,'0','23'),
('1635','','1','Adult 15 yrs and above','1800','Adult: $27 (15+ years)',NULL,'0','23'),
('1636','','1','Family Ticket','1800','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','23'),
('1637','','1','Penguin Hire','1800','Penguin Skating Aids $10',NULL,'0','23'),
('1638','','1','Group Booking','1800','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','23'),
('1639','','1','Toddler 2-4 years','1900','Toddler: $15 (4 years and under)',NULL,'0','23'),
('1640','','1','Child/pensioner/concession card holder 5-14 years','1900','Child/Concession $20 (5-14 years)',NULL,'0','23');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1641','','1','Adult 15 yrs and above','1900','Adult: $27 (15+ years)',NULL,'0','23'),
('1642','','1','Family Ticket','1900','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','23'),
('1643','','1','Penguin Hire','1900','Penguin Skating Aids $10',NULL,'0','23'),
('1644','','1','Group Booking','1900','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','23'),
('1645','','1','Toddler 2-4 years','2000','Toddler: $15 (4 years and under)',NULL,'0','23'),
('1646','','1','Child/pensioner/concession card holder 5-14 years','2000','Child/Concession $20 (5-14 years)',NULL,'0','23'),
('1647','','1','Adult 15 yrs and above','2000','Adult: $27 (15+ years)',NULL,'0','23'),
('1648','','1','Family Ticket','2000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','23'),
('1649','','1','Penguin Hire','2000','Penguin Skating Aids $10',NULL,'0','23'),
('1650','','1','Group Booking','2000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','23'),
('1651','','1','Toddler 2-4 years','2100','Toddler: $15 (4 years and under)',NULL,'0','23'),
('1652','','1','Child/pensioner/concession card holder 5-14 years','2100','Child/Concession $20 (5-14 years)',NULL,'0','23'),
('1653','','1','Adult 15 yrs and above','2100','Adult: $27 (15+ years)',NULL,'0','23'),
('1654','','1','Family Ticket','2100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','23'),
('1655','','1','Penguin Hire','2100','Penguin Skating Aids $10',NULL,'0','23'),
('1656','','1','Group Booking','2100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','23'),
('1657','','1','Toddler 2-4 years','1000','Toddler: $15 (4 years and under)',NULL,'0','24'),
('1658','','1','Child/pensioner/concession card holder 5-14 years','1000','Child/Concession $20 (5-14 years)',NULL,'0','24'),
('1659','','1','Adult 15 yrs and above','1000','Adult: $27 (15+ years)',NULL,'0','24'),
('1660','','1','Family Ticket','1000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','24');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1661','','1','Penguin Hire','1000','Penguin Skating Aids $10',NULL,'0','24'),
('1662','','1','Group Booking','1000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','24'),
('1663','','1','Toddler 2-4 years','1100','Toddler: $15 (4 years and under)',NULL,'0','24'),
('1664','','1','Child/pensioner/concession card holder 5-14 years','1100','Child/Concession $20 (5-14 years)',NULL,'0','24'),
('1665','','1','Adult 15 yrs and above','1100','Adult: $27 (15+ years)',NULL,'0','24'),
('1666','','1','Family Ticket','1100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','24'),
('1667','','1','Penguin Hire','1100','Penguin Skating Aids $10',NULL,'0','24'),
('1668','','1','Group Booking','1100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','24'),
('1669','','1','Toddler 2-4 years','1200','Toddler: $15 (4 years and under)',NULL,'0','24'),
('1670','','1','Child/pensioner/concession card holder 5-14 years','1200','Child/Concession $20 (5-14 years)',NULL,'0','24'),
('1671','','1','Adult 15 yrs and above','1200','Adult: $27 (15+ years)',NULL,'0','24'),
('1672','','1','Family Ticket','1200','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','24'),
('1673','','1','Penguin Hire','1200','Penguin Skating Aids $10',NULL,'0','24'),
('1674','','1','Group Booking','1200','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','24'),
('1675','','1','Toddler 2-4 years','1300','Toddler: $15 (4 years and under)',NULL,'0','24'),
('1676','','1','Child/pensioner/concession card holder 5-14 years','1300','Child/Concession $20 (5-14 years)',NULL,'0','24'),
('1677','','1','Adult 15 yrs and above','1300','Adult: $27 (15+ years)',NULL,'0','24'),
('1678','','1','Family Ticket','1300','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','24'),
('1679','','1','Penguin Hire','1300','Penguin Skating Aids $10',NULL,'0','24'),
('1680','','1','Group Booking','1300','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','24');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1681','','1','Toddler 2-4 years','1400','Toddler: $15 (4 years and under)',NULL,'0','24'),
('1682','','1','Child/pensioner/concession card holder 5-14 years','1400','Child/Concession $20 (5-14 years)',NULL,'0','24'),
('1683','','1','Adult 15 yrs and above','1400','Adult: $27 (15+ years)',NULL,'0','24'),
('1684','','1','Family Ticket','1400','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','24'),
('1685','','1','Penguin Hire','1400','Penguin Skating Aids $10',NULL,'0','24'),
('1686','','1','Group Booking','1400','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','24'),
('1687','','1','Toddler 2-4 years','1500','Toddler: $15 (4 years and under)',NULL,'0','24'),
('1688','','1','Child/pensioner/concession card holder 5-14 years','1500','Child/Concession $20 (5-14 years)',NULL,'0','24'),
('1689','','1','Adult 15 yrs and above','1500','Adult: $27 (15+ years)',NULL,'0','24'),
('1690','','1','Family Ticket','1500','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','24'),
('1691','','1','Penguin Hire','1500','Penguin Skating Aids $10',NULL,'0','24'),
('1692','','1','Group Booking','1500','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','24'),
('1693','','1','Toddler 2-4 years','1600','Toddler: $15 (4 years and under)',NULL,'0','24'),
('1694','','1','Child/pensioner/concession card holder 5-14 years','1600','Child/Concession $20 (5-14 years)',NULL,'0','24'),
('1695','','1','Adult 15 yrs and above','1600','Adult: $27 (15+ years)',NULL,'0','24'),
('1696','','1','Family Ticket','1600','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','24'),
('1697','','1','Penguin Hire','1600','Penguin Skating Aids $10',NULL,'0','24'),
('1698','','1','Group Booking','1600','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','24'),
('1699','','1','Toddler 2-4 years','1700','Toddler: $15 (4 years and under)',NULL,'0','24'),
('1700','','1','Child/pensioner/concession card holder 5-14 years','1700','Child/Concession $20 (5-14 years)',NULL,'0','24');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1701','','1','Adult 15 yrs and above','1700','Adult: $27 (15+ years)',NULL,'0','24'),
('1702','','1','Family Ticket','1700','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','24'),
('1703','','1','Penguin Hire','1700','Penguin Skating Aids $10',NULL,'0','24'),
('1704','','1','Group Booking','1700','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','24'),
('1705','','1','Toddler 2-4 years','1800','Toddler: $15 (4 years and under)',NULL,'0','24'),
('1706','','1','Child/pensioner/concession card holder 5-14 years','1800','Child/Concession $20 (5-14 years)',NULL,'0','24'),
('1707','','1','Adult 15 yrs and above','1800','Adult: $27 (15+ years)',NULL,'0','24'),
('1708','','1','Family Ticket','1800','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','24'),
('1709','','1','Penguin Hire','1800','Penguin Skating Aids $10',NULL,'0','24'),
('1710','','1','Group Booking','1800','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','24'),
('1711','','1','Toddler 2-4 years','1900','Toddler: $15 (4 years and under)',NULL,'0','24'),
('1712','','1','Child/pensioner/concession card holder 5-14 years','1900','Child/Concession $20 (5-14 years)',NULL,'0','24'),
('1713','','1','Adult 15 yrs and above','1900','Adult: $27 (15+ years)',NULL,'0','24'),
('1714','','1','Family Ticket','1900','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','24'),
('1715','','1','Penguin Hire','1900','Penguin Skating Aids $10',NULL,'0','24'),
('1716','','1','Group Booking','1900','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','24'),
('1717','','1','Toddler 2-4 years','2000','Toddler: $15 (4 years and under)',NULL,'0','24'),
('1718','','1','Child/pensioner/concession card holder 5-14 years','2000','Child/Concession $20 (5-14 years)',NULL,'0','24'),
('1719','','1','Adult 15 yrs and above','2000','Adult: $27 (15+ years)',NULL,'0','24'),
('1720','','1','Family Ticket','2000','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','24');
insert into `products_description` (`products_id`, `html`, `language_id`, `products_name`, `products_number`, `products_description`, `products_url`, `products_viewed`, `section_id`) values ('1721','','1','Penguin Hire','2000','Penguin Skating Aids $10',NULL,'0','24'),
('1722','','1','Group Booking','2000','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','24'),
('1723','','1','Toddler 2-4 years','2100','Toddler: $15 (4 years and under)',NULL,'0','24'),
('1724','','1','Child/pensioner/concession card holder 5-14 years','2100','Child/Concession $20 (5-14 years)',NULL,'0','24'),
('1725','','1','Adult 15 yrs and above','2100','Adult: $27 (15+ years)',NULL,'0','24'),
('1726','','1','Family Ticket','2100','Family: $75 (2 adults/2 child or 1 adult/3 child)',NULL,'0','24'),
('1727','','1','Penguin Hire','2100','Penguin Skating Aids $10',NULL,'0','24'),
('1728','','1','Group Booking','2100','Group Booking: $20 each (all ages) 10 or more people   ',NULL,'0','24');

drop table if exists `products_price_break`;
CREATE TABLE `products_price_break` (
  `products_id` int(11) NOT NULL DEFAULT 0,
  `quantity` int(6) NOT NULL DEFAULT 0,
  `discount_per_item` decimal(15,4) DEFAULT NULL
);

insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('6','10','7.0000'),
('12','10','7.0000'),
('18','10','7.0000'),
('24','10','7.0000'),
('30','10','7.0000'),
('36','10','7.0000'),
('42','10','7.0000'),
('48','10','7.0000'),
('54','10','7.0000'),
('60','10','7.0000'),
('66','10','7.0000'),
('72','10','7.0000'),
('78','10','7.0000'),
('84','10','7.0000'),
('90','10','7.0000'),
('96','10','7.0000'),
('102','10','7.0000'),
('108','10','7.0000'),
('114','10','7.0000'),
('120','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('126','10','7.0000'),
('132','10','7.0000'),
('138','10','7.0000'),
('144','10','7.0000'),
('150','10','7.0000'),
('156','10','7.0000'),
('162','10','7.0000'),
('168','10','7.0000'),
('174','10','7.0000'),
('180','10','7.0000'),
('186','10','7.0000'),
('192','10','7.0000'),
('198','10','7.0000'),
('204','10','7.0000'),
('210','10','7.0000'),
('216','10','7.0000'),
('222','10','7.0000'),
('228','10','7.0000'),
('234','10','7.0000'),
('240','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('246','10','7.0000'),
('252','10','7.0000'),
('258','10','7.0000'),
('264','10','7.0000'),
('270','10','7.0000'),
('276','10','7.0000'),
('282','10','7.0000'),
('288','10','7.0000'),
('294','10','7.0000'),
('300','10','7.0000'),
('306','10','7.0000'),
('312','10','7.0000'),
('318','10','7.0000'),
('324','10','7.0000'),
('330','10','7.0000'),
('336','10','7.0000'),
('342','10','7.0000'),
('348','10','7.0000'),
('354','10','7.0000'),
('360','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('366','10','7.0000'),
('372','10','7.0000'),
('378','10','7.0000'),
('384','10','7.0000'),
('390','10','7.0000'),
('396','10','7.0000'),
('402','10','7.0000'),
('408','10','7.0000'),
('414','10','7.0000'),
('420','10','7.0000'),
('426','10','7.0000'),
('432','10','7.0000'),
('438','10','7.0000'),
('444','10','7.0000'),
('450','10','7.0000'),
('456','10','7.0000'),
('462','10','7.0000'),
('468','10','7.0000'),
('474','10','7.0000'),
('480','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('486','10','7.0000'),
('492','10','7.0000'),
('498','10','7.0000'),
('504','10','7.0000'),
('510','10','7.0000'),
('516','10','7.0000'),
('522','10','7.0000'),
('528','10','7.0000'),
('534','10','7.0000'),
('540','10','7.0000'),
('546','10','7.0000'),
('552','10','7.0000'),
('558','10','7.0000'),
('564','10','7.0000'),
('570','10','7.0000'),
('576','10','7.0000'),
('582','10','7.0000'),
('588','10','7.0000'),
('594','10','7.0000'),
('600','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('606','10','7.0000'),
('612','10','7.0000'),
('618','10','7.0000'),
('624','10','7.0000'),
('630','10','7.0000'),
('636','10','7.0000'),
('642','10','7.0000'),
('648','10','7.0000'),
('654','10','7.0000'),
('660','10','7.0000'),
('666','10','7.0000'),
('672','10','7.0000'),
('678','10','7.0000'),
('684','10','7.0000'),
('690','10','7.0000'),
('696','10','7.0000'),
('702','10','7.0000'),
('708','10','7.0000'),
('714','10','7.0000'),
('720','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('726','10','7.0000'),
('732','10','7.0000'),
('738','10','7.0000'),
('744','10','7.0000'),
('750','10','7.0000'),
('756','10','7.0000'),
('762','10','7.0000'),
('768','10','7.0000'),
('774','10','7.0000'),
('780','10','7.0000'),
('786','10','7.0000'),
('792','10','7.0000'),
('798','10','7.0000'),
('804','10','7.0000'),
('810','10','7.0000'),
('816','10','7.0000'),
('822','10','7.0000'),
('828','10','7.0000'),
('834','10','7.0000'),
('840','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('846','10','7.0000'),
('852','10','7.0000'),
('858','10','7.0000'),
('864','10','7.0000'),
('870','10','7.0000'),
('876','10','7.0000'),
('882','10','7.0000'),
('888','10','7.0000'),
('894','10','7.0000'),
('900','10','7.0000'),
('906','10','7.0000'),
('912','10','7.0000'),
('918','10','7.0000'),
('924','10','7.0000'),
('930','10','7.0000'),
('936','10','7.0000'),
('942','10','7.0000'),
('948','10','7.0000'),
('954','10','7.0000'),
('960','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('966','10','7.0000'),
('972','10','7.0000'),
('978','10','7.0000'),
('984','10','7.0000'),
('990','10','7.0000'),
('996','10','7.0000'),
('1002','10','7.0000'),
('1008','10','7.0000'),
('1014','10','7.0000'),
('1020','10','7.0000'),
('1026','10','7.0000'),
('1032','10','7.0000'),
('1038','10','7.0000'),
('1044','10','7.0000'),
('1050','10','7.0000'),
('1056','10','7.0000'),
('1062','10','7.0000'),
('1068','10','7.0000'),
('1074','10','7.0000'),
('1080','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1086','10','7.0000'),
('1092','10','7.0000'),
('1098','10','7.0000'),
('1104','10','7.0000'),
('1110','10','7.0000'),
('1116','10','7.0000'),
('1122','10','7.0000'),
('1128','10','7.0000'),
('1134','10','7.0000'),
('1140','10','7.0000'),
('1146','10','7.0000'),
('1152','10','7.0000'),
('1158','10','7.0000'),
('1164','10','7.0000'),
('1170','10','7.0000'),
('1176','10','7.0000'),
('1182','10','7.0000'),
('1188','10','7.0000'),
('1194','10','7.0000'),
('1200','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1206','10','7.0000'),
('1212','10','7.0000'),
('1218','10','7.0000'),
('1224','10','7.0000'),
('1230','10','7.0000'),
('1236','10','7.0000'),
('1242','10','7.0000'),
('1248','10','7.0000'),
('1254','10','7.0000'),
('1260','10','7.0000'),
('1266','10','7.0000'),
('1272','10','7.0000'),
('1278','10','7.0000'),
('1284','10','7.0000'),
('1290','10','7.0000'),
('1296','10','7.0000'),
('1302','10','7.0000'),
('1308','10','7.0000'),
('1314','10','7.0000'),
('1320','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1326','10','7.0000'),
('1332','10','7.0000'),
('1338','10','7.0000'),
('1344','10','7.0000'),
('1350','10','7.0000'),
('1356','10','7.0000'),
('1362','10','7.0000'),
('1368','10','7.0000'),
('1374','10','7.0000'),
('1380','10','7.0000'),
('1386','10','7.0000'),
('1392','10','7.0000'),
('1398','10','7.0000'),
('1404','10','7.0000'),
('1410','10','7.0000'),
('1416','10','7.0000'),
('1422','10','7.0000'),
('1428','10','7.0000'),
('1434','10','7.0000'),
('1440','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1446','10','7.0000'),
('1452','10','7.0000'),
('1458','10','7.0000'),
('1464','10','7.0000'),
('1470','10','7.0000'),
('1476','10','7.0000'),
('1482','10','7.0000'),
('1488','10','7.0000'),
('1494','10','7.0000'),
('1500','10','7.0000'),
('1506','10','7.0000'),
('1512','10','7.0000'),
('1518','10','7.0000'),
('1524','10','7.0000'),
('1530','10','7.0000'),
('1536','10','7.0000'),
('1542','10','7.0000'),
('1548','10','7.0000'),
('1554','10','7.0000'),
('1560','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1566','10','7.0000'),
('1572','10','7.0000'),
('1578','10','7.0000'),
('1584','10','7.0000'),
('1590','10','7.0000'),
('1596','10','7.0000'),
('1602','10','7.0000'),
('1608','10','7.0000'),
('1614','10','7.0000'),
('1620','10','7.0000'),
('1626','10','7.0000'),
('1632','10','7.0000'),
('1638','10','7.0000'),
('1644','10','7.0000'),
('1650','10','7.0000'),
('1656','10','7.0000'),
('1662','10','7.0000'),
('1668','10','7.0000'),
('1674','10','7.0000'),
('1680','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1686','10','7.0000'),
('1692','10','7.0000'),
('1698','10','7.0000'),
('1704','10','7.0000'),
('1710','10','7.0000'),
('1716','10','7.0000'),
('1722','10','7.0000'),
('1728','10','7.0000'),
('6','10','7.0000'),
('12','10','7.0000'),
('18','10','7.0000'),
('24','10','7.0000'),
('30','10','7.0000'),
('36','10','7.0000'),
('42','10','7.0000'),
('48','10','7.0000'),
('54','10','7.0000'),
('60','10','7.0000'),
('66','10','7.0000'),
('72','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('78','10','7.0000'),
('84','10','7.0000'),
('90','10','7.0000'),
('96','10','7.0000'),
('102','10','7.0000'),
('108','10','7.0000'),
('114','10','7.0000'),
('120','10','7.0000'),
('126','10','7.0000'),
('132','10','7.0000'),
('138','10','7.0000'),
('144','10','7.0000'),
('150','10','7.0000'),
('156','10','7.0000'),
('162','10','7.0000'),
('168','10','7.0000'),
('174','10','7.0000'),
('180','10','7.0000'),
('186','10','7.0000'),
('192','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('198','10','7.0000'),
('204','10','7.0000'),
('210','10','7.0000'),
('216','10','7.0000'),
('222','10','7.0000'),
('228','10','7.0000'),
('234','10','7.0000'),
('240','10','7.0000'),
('246','10','7.0000'),
('252','10','7.0000'),
('258','10','7.0000'),
('264','10','7.0000'),
('270','10','7.0000'),
('276','10','7.0000'),
('282','10','7.0000'),
('288','10','7.0000'),
('294','10','7.0000'),
('300','10','7.0000'),
('306','10','7.0000'),
('312','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('318','10','7.0000'),
('324','10','7.0000'),
('330','10','7.0000'),
('336','10','7.0000'),
('342','10','7.0000'),
('348','10','7.0000'),
('354','10','7.0000'),
('360','10','7.0000'),
('366','10','7.0000'),
('372','10','7.0000'),
('378','10','7.0000'),
('384','10','7.0000'),
('390','10','7.0000'),
('396','10','7.0000'),
('402','10','7.0000'),
('408','10','7.0000'),
('414','10','7.0000'),
('420','10','7.0000'),
('426','10','7.0000'),
('432','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('438','10','7.0000'),
('444','10','7.0000'),
('450','10','7.0000'),
('456','10','7.0000'),
('462','10','7.0000'),
('468','10','7.0000'),
('474','10','7.0000'),
('480','10','7.0000'),
('486','10','7.0000'),
('492','10','7.0000'),
('498','10','7.0000'),
('504','10','7.0000'),
('510','10','7.0000'),
('516','10','7.0000'),
('522','10','7.0000'),
('528','10','7.0000'),
('534','10','7.0000'),
('540','10','7.0000'),
('546','10','7.0000'),
('552','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('558','10','7.0000'),
('564','10','7.0000'),
('570','10','7.0000'),
('576','10','7.0000'),
('582','10','7.0000'),
('588','10','7.0000'),
('594','10','7.0000'),
('600','10','7.0000'),
('606','10','7.0000'),
('612','10','7.0000'),
('618','10','7.0000'),
('624','10','7.0000'),
('630','10','7.0000'),
('636','10','7.0000'),
('642','10','7.0000'),
('648','10','7.0000'),
('654','10','7.0000'),
('660','10','7.0000'),
('666','10','7.0000'),
('672','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('678','10','7.0000'),
('684','10','7.0000'),
('690','10','7.0000'),
('696','10','7.0000'),
('702','10','7.0000'),
('708','10','7.0000'),
('714','10','7.0000'),
('720','10','7.0000'),
('726','10','7.0000'),
('732','10','7.0000'),
('738','10','7.0000'),
('744','10','7.0000'),
('750','10','7.0000'),
('756','10','7.0000'),
('762','10','7.0000'),
('768','10','7.0000'),
('774','10','7.0000'),
('780','10','7.0000'),
('786','10','7.0000'),
('792','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('798','10','7.0000'),
('804','10','7.0000'),
('810','10','7.0000'),
('816','10','7.0000'),
('822','10','7.0000'),
('828','10','7.0000'),
('834','10','7.0000'),
('840','10','7.0000'),
('846','10','7.0000'),
('852','10','7.0000'),
('858','10','7.0000'),
('864','10','7.0000'),
('870','10','7.0000'),
('876','10','7.0000'),
('882','10','7.0000'),
('888','10','7.0000'),
('894','10','7.0000'),
('900','10','7.0000'),
('906','10','7.0000'),
('912','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('918','10','7.0000'),
('924','10','7.0000'),
('930','10','7.0000'),
('936','10','7.0000'),
('942','10','7.0000'),
('948','10','7.0000'),
('954','10','7.0000'),
('960','10','7.0000'),
('966','10','7.0000'),
('972','10','7.0000'),
('978','10','7.0000'),
('984','10','7.0000'),
('990','10','7.0000'),
('996','10','7.0000'),
('1002','10','7.0000'),
('1008','10','7.0000'),
('1014','10','7.0000'),
('1020','10','7.0000'),
('1026','10','7.0000'),
('1032','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1038','10','7.0000'),
('1044','10','7.0000'),
('1050','10','7.0000'),
('1056','10','7.0000'),
('1062','10','7.0000'),
('1068','10','7.0000'),
('1074','10','7.0000'),
('1080','10','7.0000'),
('1086','10','7.0000'),
('1092','10','7.0000'),
('1098','10','7.0000'),
('1104','10','7.0000'),
('1110','10','7.0000'),
('1116','10','7.0000'),
('1122','10','7.0000'),
('1128','10','7.0000'),
('1134','10','7.0000'),
('1140','10','7.0000'),
('1146','10','7.0000'),
('1152','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1158','10','7.0000'),
('1164','10','7.0000'),
('1170','10','7.0000'),
('1176','10','7.0000'),
('1182','10','7.0000'),
('1188','10','7.0000'),
('1194','10','7.0000'),
('1200','10','7.0000'),
('1206','10','7.0000'),
('1212','10','7.0000'),
('1218','10','7.0000'),
('1224','10','7.0000'),
('1230','10','7.0000'),
('1236','10','7.0000'),
('1242','10','7.0000'),
('1248','10','7.0000'),
('1254','10','7.0000'),
('1260','10','7.0000'),
('1266','10','7.0000'),
('1272','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1278','10','7.0000'),
('1284','10','7.0000'),
('1290','10','7.0000'),
('1296','10','7.0000'),
('1302','10','7.0000'),
('1308','10','7.0000'),
('1314','10','7.0000'),
('1320','10','7.0000'),
('1326','10','7.0000'),
('1332','10','7.0000'),
('1338','10','7.0000'),
('1344','10','7.0000'),
('1350','10','7.0000'),
('1356','10','7.0000'),
('1362','10','7.0000'),
('1368','10','7.0000'),
('1374','10','7.0000'),
('1380','10','7.0000'),
('1386','10','7.0000'),
('1392','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1398','10','7.0000'),
('1404','10','7.0000'),
('1410','10','7.0000'),
('1416','10','7.0000'),
('1422','10','7.0000'),
('1428','10','7.0000'),
('1434','10','7.0000'),
('1440','10','7.0000'),
('1446','10','7.0000'),
('1452','10','7.0000'),
('1458','10','7.0000'),
('1464','10','7.0000'),
('1470','10','7.0000'),
('1476','10','7.0000'),
('1482','10','7.0000'),
('1488','10','7.0000'),
('1494','10','7.0000'),
('1500','10','7.0000'),
('1506','10','7.0000'),
('1512','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1518','10','7.0000'),
('1524','10','7.0000'),
('1530','10','7.0000'),
('1536','10','7.0000'),
('1542','10','7.0000'),
('1548','10','7.0000'),
('1554','10','7.0000'),
('1560','10','7.0000'),
('1566','10','7.0000'),
('1572','10','7.0000'),
('1578','10','7.0000'),
('1584','10','7.0000'),
('1590','10','7.0000'),
('1596','10','7.0000'),
('1602','10','7.0000'),
('1608','10','7.0000'),
('1614','10','7.0000'),
('1620','10','7.0000'),
('1626','10','7.0000'),
('1632','10','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1638','10','7.0000'),
('1644','10','7.0000'),
('1650','10','7.0000'),
('1656','10','7.0000'),
('1662','10','7.0000'),
('1668','10','7.0000'),
('1674','10','7.0000'),
('1680','10','7.0000'),
('1686','10','7.0000'),
('1692','10','7.0000'),
('1698','10','7.0000'),
('1704','10','7.0000'),
('1710','10','7.0000'),
('1716','10','7.0000'),
('1722','10','7.0000'),
('1728','10','7.0000'),
('6','11','7.0000'),
('12','11','7.0000'),
('18','11','7.0000'),
('24','11','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('30','11','7.0000'),
('36','11','7.0000'),
('42','11','7.0000'),
('48','11','7.0000'),
('54','11','7.0000'),
('60','11','7.0000'),
('66','11','7.0000'),
('72','11','7.0000'),
('78','11','7.0000'),
('84','11','7.0000'),
('90','11','7.0000'),
('96','11','7.0000'),
('102','11','7.0000'),
('108','11','7.0000'),
('114','11','7.0000'),
('120','11','7.0000'),
('126','11','7.0000'),
('132','11','7.0000'),
('138','11','7.0000'),
('144','11','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('150','11','7.0000'),
('156','11','7.0000'),
('162','11','7.0000'),
('168','11','7.0000'),
('174','11','7.0000'),
('180','11','7.0000'),
('186','11','7.0000'),
('192','11','7.0000'),
('198','11','7.0000'),
('204','11','7.0000'),
('210','11','7.0000'),
('216','11','7.0000'),
('222','11','7.0000'),
('228','11','7.0000'),
('234','11','7.0000'),
('240','11','7.0000'),
('246','11','7.0000'),
('252','11','7.0000'),
('258','11','7.0000'),
('264','11','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('270','11','7.0000'),
('276','11','7.0000'),
('282','11','7.0000'),
('288','11','7.0000'),
('294','11','7.0000'),
('300','11','7.0000'),
('306','11','7.0000'),
('312','11','7.0000'),
('318','11','7.0000'),
('324','11','7.0000'),
('330','11','7.0000'),
('336','11','7.0000'),
('342','11','7.0000'),
('348','11','7.0000'),
('354','11','7.0000'),
('360','11','7.0000'),
('366','11','7.0000'),
('372','11','7.0000'),
('378','11','7.0000'),
('384','11','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('390','11','7.0000'),
('396','11','7.0000'),
('402','11','7.0000'),
('408','11','7.0000'),
('414','11','7.0000'),
('420','11','7.0000'),
('426','11','7.0000'),
('432','11','7.0000'),
('438','11','7.0000'),
('444','11','7.0000'),
('450','11','7.0000'),
('456','11','7.0000'),
('462','11','7.0000'),
('468','11','7.0000'),
('474','11','7.0000'),
('480','11','7.0000'),
('486','11','7.0000'),
('492','11','7.0000'),
('498','11','7.0000'),
('504','11','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('510','11','7.0000'),
('516','11','7.0000'),
('522','11','7.0000'),
('528','11','7.0000'),
('534','11','7.0000'),
('540','11','7.0000'),
('546','11','7.0000'),
('552','11','7.0000'),
('558','11','7.0000'),
('564','11','7.0000'),
('570','11','7.0000'),
('576','11','7.0000'),
('582','11','7.0000'),
('588','11','7.0000'),
('594','11','7.0000'),
('600','11','7.0000'),
('606','11','7.0000'),
('612','11','7.0000'),
('618','11','7.0000'),
('624','11','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('630','11','7.0000'),
('636','11','7.0000'),
('642','11','7.0000'),
('648','11','7.0000'),
('654','11','7.0000'),
('660','11','7.0000'),
('666','11','7.0000'),
('672','11','7.0000'),
('678','11','7.0000'),
('684','11','7.0000'),
('690','11','7.0000'),
('696','11','7.0000'),
('702','11','7.0000'),
('708','11','7.0000'),
('714','11','7.0000'),
('720','11','7.0000'),
('726','11','7.0000'),
('732','11','7.0000'),
('738','11','7.0000'),
('744','11','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('750','11','7.0000'),
('756','11','7.0000'),
('762','11','7.0000'),
('768','11','7.0000'),
('774','11','7.0000'),
('780','11','7.0000'),
('786','11','7.0000'),
('792','11','7.0000'),
('798','11','7.0000'),
('804','11','7.0000'),
('810','11','7.0000'),
('816','11','7.0000'),
('822','11','7.0000'),
('828','11','7.0000'),
('834','11','7.0000'),
('840','11','7.0000'),
('846','11','7.0000'),
('852','11','7.0000'),
('858','11','7.0000'),
('864','11','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('870','11','7.0000'),
('876','11','7.0000'),
('882','11','7.0000'),
('888','11','7.0000'),
('894','11','7.0000'),
('900','11','7.0000'),
('906','11','7.0000'),
('912','11','7.0000'),
('918','11','7.0000'),
('924','11','7.0000'),
('930','11','7.0000'),
('936','11','7.0000'),
('942','11','7.0000'),
('948','11','7.0000'),
('954','11','7.0000'),
('960','11','7.0000'),
('966','11','7.0000'),
('972','11','7.0000'),
('978','11','7.0000'),
('984','11','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('990','11','7.0000'),
('996','11','7.0000'),
('1002','11','7.0000'),
('1008','11','7.0000'),
('1014','11','7.0000'),
('1020','11','7.0000'),
('1026','11','7.0000'),
('1032','11','7.0000'),
('1038','11','7.0000'),
('1044','11','7.0000'),
('1050','11','7.0000'),
('1056','11','7.0000'),
('1062','11','7.0000'),
('1068','11','7.0000'),
('1074','11','7.0000'),
('1080','11','7.0000'),
('1086','11','7.0000'),
('1092','11','7.0000'),
('1098','11','7.0000'),
('1104','11','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1110','11','7.0000'),
('1116','11','7.0000'),
('1122','11','7.0000'),
('1128','11','7.0000'),
('1134','11','7.0000'),
('1140','11','7.0000'),
('1146','11','7.0000'),
('1152','11','7.0000'),
('1158','11','7.0000'),
('1164','11','7.0000'),
('1170','11','7.0000'),
('1176','11','7.0000'),
('1182','11','7.0000'),
('1188','11','7.0000'),
('1194','11','7.0000'),
('1200','11','7.0000'),
('1206','11','7.0000'),
('1212','11','7.0000'),
('1218','11','7.0000'),
('1224','11','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1230','11','7.0000'),
('1236','11','7.0000'),
('1242','11','7.0000'),
('1248','11','7.0000'),
('1254','11','7.0000'),
('1260','11','7.0000'),
('1266','11','7.0000'),
('1272','11','7.0000'),
('1278','11','7.0000'),
('1284','11','7.0000'),
('1290','11','7.0000'),
('1296','11','7.0000'),
('1302','11','7.0000'),
('1308','11','7.0000'),
('1314','11','7.0000'),
('1320','11','7.0000'),
('1326','11','7.0000'),
('1332','11','7.0000'),
('1338','11','7.0000'),
('1344','11','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1350','11','7.0000'),
('1356','11','7.0000'),
('1362','11','7.0000'),
('1368','11','7.0000'),
('1374','11','7.0000'),
('1380','11','7.0000'),
('1386','11','7.0000'),
('1392','11','7.0000'),
('1398','11','7.0000'),
('1404','11','7.0000'),
('1410','11','7.0000'),
('1416','11','7.0000'),
('1422','11','7.0000'),
('1428','11','7.0000'),
('1434','11','7.0000'),
('1440','11','7.0000'),
('1446','11','7.0000'),
('1452','11','7.0000'),
('1458','11','7.0000'),
('1464','11','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1470','11','7.0000'),
('1476','11','7.0000'),
('1482','11','7.0000'),
('1488','11','7.0000'),
('1494','11','7.0000'),
('1500','11','7.0000'),
('1506','11','7.0000'),
('1512','11','7.0000'),
('1518','11','7.0000'),
('1524','11','7.0000'),
('1530','11','7.0000'),
('1536','11','7.0000'),
('1542','11','7.0000'),
('1548','11','7.0000'),
('1554','11','7.0000'),
('1560','11','7.0000'),
('1566','11','7.0000'),
('1572','11','7.0000'),
('1578','11','7.0000'),
('1584','11','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1590','11','7.0000'),
('1596','11','7.0000'),
('1602','11','7.0000'),
('1608','11','7.0000'),
('1614','11','7.0000'),
('1620','11','7.0000'),
('1626','11','7.0000'),
('1632','11','7.0000'),
('1638','11','7.0000'),
('1644','11','7.0000'),
('1650','11','7.0000'),
('1656','11','7.0000'),
('1662','11','7.0000'),
('1668','11','7.0000'),
('1674','11','7.0000'),
('1680','11','7.0000'),
('1686','11','7.0000'),
('1692','11','7.0000'),
('1698','11','7.0000'),
('1704','11','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1710','11','7.0000'),
('1716','11','7.0000'),
('1722','11','7.0000'),
('1728','11','7.0000'),
('6','12','7.0000'),
('12','12','7.0000'),
('18','12','7.0000'),
('24','12','7.0000'),
('30','12','7.0000'),
('36','12','7.0000'),
('42','12','7.0000'),
('48','12','7.0000'),
('54','12','7.0000'),
('60','12','7.0000'),
('66','12','7.0000'),
('72','12','7.0000'),
('78','12','7.0000'),
('84','12','7.0000'),
('90','12','7.0000'),
('96','12','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('102','12','7.0000'),
('108','12','7.0000'),
('114','12','7.0000'),
('120','12','7.0000'),
('126','12','7.0000'),
('132','12','7.0000'),
('138','12','7.0000'),
('144','12','7.0000'),
('150','12','7.0000'),
('156','12','7.0000'),
('162','12','7.0000'),
('168','12','7.0000'),
('174','12','7.0000'),
('180','12','7.0000'),
('186','12','7.0000'),
('192','12','7.0000'),
('198','12','7.0000'),
('204','12','7.0000'),
('210','12','7.0000'),
('216','12','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('222','12','7.0000'),
('228','12','7.0000'),
('234','12','7.0000'),
('240','12','7.0000'),
('246','12','7.0000'),
('252','12','7.0000'),
('258','12','7.0000'),
('264','12','7.0000'),
('270','12','7.0000'),
('276','12','7.0000'),
('282','12','7.0000'),
('288','12','7.0000'),
('294','12','7.0000'),
('300','12','7.0000'),
('306','12','7.0000'),
('312','12','7.0000'),
('318','12','7.0000'),
('324','12','7.0000'),
('330','12','7.0000'),
('336','12','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('342','12','7.0000'),
('348','12','7.0000'),
('354','12','7.0000'),
('360','12','7.0000'),
('366','12','7.0000'),
('372','12','7.0000'),
('378','12','7.0000'),
('384','12','7.0000'),
('390','12','7.0000'),
('396','12','7.0000'),
('402','12','7.0000'),
('408','12','7.0000'),
('414','12','7.0000'),
('420','12','7.0000'),
('426','12','7.0000'),
('432','12','7.0000'),
('438','12','7.0000'),
('444','12','7.0000'),
('450','12','7.0000'),
('456','12','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('462','12','7.0000'),
('468','12','7.0000'),
('474','12','7.0000'),
('480','12','7.0000'),
('486','12','7.0000'),
('492','12','7.0000'),
('498','12','7.0000'),
('504','12','7.0000'),
('510','12','7.0000'),
('516','12','7.0000'),
('522','12','7.0000'),
('528','12','7.0000'),
('534','12','7.0000'),
('540','12','7.0000'),
('546','12','7.0000'),
('552','12','7.0000'),
('558','12','7.0000'),
('564','12','7.0000'),
('570','12','7.0000'),
('576','12','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('582','12','7.0000'),
('588','12','7.0000'),
('594','12','7.0000'),
('600','12','7.0000'),
('606','12','7.0000'),
('612','12','7.0000'),
('618','12','7.0000'),
('624','12','7.0000'),
('630','12','7.0000'),
('636','12','7.0000'),
('642','12','7.0000'),
('648','12','7.0000'),
('654','12','7.0000'),
('660','12','7.0000'),
('666','12','7.0000'),
('672','12','7.0000'),
('678','12','7.0000'),
('684','12','7.0000'),
('690','12','7.0000'),
('696','12','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('702','12','7.0000'),
('708','12','7.0000'),
('714','12','7.0000'),
('720','12','7.0000'),
('726','12','7.0000'),
('732','12','7.0000'),
('738','12','7.0000'),
('744','12','7.0000'),
('750','12','7.0000'),
('756','12','7.0000'),
('762','12','7.0000'),
('768','12','7.0000'),
('774','12','7.0000'),
('780','12','7.0000'),
('786','12','7.0000'),
('792','12','7.0000'),
('798','12','7.0000'),
('804','12','7.0000'),
('810','12','7.0000'),
('816','12','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('822','12','7.0000'),
('828','12','7.0000'),
('834','12','7.0000'),
('840','12','7.0000'),
('846','12','7.0000'),
('852','12','7.0000'),
('858','12','7.0000'),
('864','12','7.0000'),
('870','12','7.0000'),
('876','12','7.0000'),
('882','12','7.0000'),
('888','12','7.0000'),
('894','12','7.0000'),
('900','12','7.0000'),
('906','12','7.0000'),
('912','12','7.0000'),
('918','12','7.0000'),
('924','12','7.0000'),
('930','12','7.0000'),
('936','12','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('942','12','7.0000'),
('948','12','7.0000'),
('954','12','7.0000'),
('960','12','7.0000'),
('966','12','7.0000'),
('972','12','7.0000'),
('978','12','7.0000'),
('984','12','7.0000'),
('990','12','7.0000'),
('996','12','7.0000'),
('1002','12','7.0000'),
('1008','12','7.0000'),
('1014','12','7.0000'),
('1020','12','7.0000'),
('1026','12','7.0000'),
('1032','12','7.0000'),
('1038','12','7.0000'),
('1044','12','7.0000'),
('1050','12','7.0000'),
('1056','12','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1062','12','7.0000'),
('1068','12','7.0000'),
('1074','12','7.0000'),
('1080','12','7.0000'),
('1086','12','7.0000'),
('1092','12','7.0000'),
('1098','12','7.0000'),
('1104','12','7.0000'),
('1110','12','7.0000'),
('1116','12','7.0000'),
('1122','12','7.0000'),
('1128','12','7.0000'),
('1134','12','7.0000'),
('1140','12','7.0000'),
('1146','12','7.0000'),
('1152','12','7.0000'),
('1158','12','7.0000'),
('1164','12','7.0000'),
('1170','12','7.0000'),
('1176','12','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1182','12','7.0000'),
('1188','12','7.0000'),
('1194','12','7.0000'),
('1200','12','7.0000'),
('1206','12','7.0000'),
('1212','12','7.0000'),
('1218','12','7.0000'),
('1224','12','7.0000'),
('1230','12','7.0000'),
('1236','12','7.0000'),
('1242','12','7.0000'),
('1248','12','7.0000'),
('1254','12','7.0000'),
('1260','12','7.0000'),
('1266','12','7.0000'),
('1272','12','7.0000'),
('1278','12','7.0000'),
('1284','12','7.0000'),
('1290','12','7.0000'),
('1296','12','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1302','12','7.0000'),
('1308','12','7.0000'),
('1314','12','7.0000'),
('1320','12','7.0000'),
('1326','12','7.0000'),
('1332','12','7.0000'),
('1338','12','7.0000'),
('1344','12','7.0000'),
('1350','12','7.0000'),
('1356','12','7.0000'),
('1362','12','7.0000'),
('1368','12','7.0000'),
('1374','12','7.0000'),
('1380','12','7.0000'),
('1386','12','7.0000'),
('1392','12','7.0000'),
('1398','12','7.0000'),
('1404','12','7.0000'),
('1410','12','7.0000'),
('1416','12','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1422','12','7.0000'),
('1428','12','7.0000'),
('1434','12','7.0000'),
('1440','12','7.0000'),
('1446','12','7.0000'),
('1452','12','7.0000'),
('1458','12','7.0000'),
('1464','12','7.0000'),
('1470','12','7.0000'),
('1476','12','7.0000'),
('1482','12','7.0000'),
('1488','12','7.0000'),
('1494','12','7.0000'),
('1500','12','7.0000'),
('1506','12','7.0000'),
('1512','12','7.0000'),
('1518','12','7.0000'),
('1524','12','7.0000'),
('1530','12','7.0000'),
('1536','12','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1542','12','7.0000'),
('1548','12','7.0000'),
('1554','12','7.0000'),
('1560','12','7.0000'),
('1566','12','7.0000'),
('1572','12','7.0000'),
('1578','12','7.0000'),
('1584','12','7.0000'),
('1590','12','7.0000'),
('1596','12','7.0000'),
('1602','12','7.0000'),
('1608','12','7.0000'),
('1614','12','7.0000'),
('1620','12','7.0000'),
('1626','12','7.0000'),
('1632','12','7.0000'),
('1638','12','7.0000'),
('1644','12','7.0000'),
('1650','12','7.0000'),
('1656','12','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1662','12','7.0000'),
('1668','12','7.0000'),
('1674','12','7.0000'),
('1680','12','7.0000'),
('1686','12','7.0000'),
('1692','12','7.0000'),
('1698','12','7.0000'),
('1704','12','7.0000'),
('1710','12','7.0000'),
('1716','12','7.0000'),
('1722','12','7.0000'),
('1728','12','7.0000'),
('6','13','7.0000'),
('12','13','7.0000'),
('18','13','7.0000'),
('24','13','7.0000'),
('30','13','7.0000'),
('36','13','7.0000'),
('42','13','7.0000'),
('48','13','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('54','13','7.0000'),
('60','13','7.0000'),
('66','13','7.0000'),
('72','13','7.0000'),
('78','13','7.0000'),
('84','13','7.0000'),
('90','13','7.0000'),
('96','13','7.0000'),
('102','13','7.0000'),
('108','13','7.0000'),
('114','13','7.0000'),
('120','13','7.0000'),
('126','13','7.0000'),
('132','13','7.0000'),
('138','13','7.0000'),
('144','13','7.0000'),
('150','13','7.0000'),
('156','13','7.0000'),
('162','13','7.0000'),
('168','13','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('174','13','7.0000'),
('180','13','7.0000'),
('186','13','7.0000'),
('192','13','7.0000'),
('198','13','7.0000'),
('204','13','7.0000'),
('210','13','7.0000'),
('216','13','7.0000'),
('222','13','7.0000'),
('228','13','7.0000'),
('234','13','7.0000'),
('240','13','7.0000'),
('246','13','7.0000'),
('252','13','7.0000'),
('258','13','7.0000'),
('264','13','7.0000'),
('270','13','7.0000'),
('276','13','7.0000'),
('282','13','7.0000'),
('288','13','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('294','13','7.0000'),
('300','13','7.0000'),
('306','13','7.0000'),
('312','13','7.0000'),
('318','13','7.0000'),
('324','13','7.0000'),
('330','13','7.0000'),
('336','13','7.0000'),
('342','13','7.0000'),
('348','13','7.0000'),
('354','13','7.0000'),
('360','13','7.0000'),
('366','13','7.0000'),
('372','13','7.0000'),
('378','13','7.0000'),
('384','13','7.0000'),
('390','13','7.0000'),
('396','13','7.0000'),
('402','13','7.0000'),
('408','13','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('414','13','7.0000'),
('420','13','7.0000'),
('426','13','7.0000'),
('432','13','7.0000'),
('438','13','7.0000'),
('444','13','7.0000'),
('450','13','7.0000'),
('456','13','7.0000'),
('462','13','7.0000'),
('468','13','7.0000'),
('474','13','7.0000'),
('480','13','7.0000'),
('486','13','7.0000'),
('492','13','7.0000'),
('498','13','7.0000'),
('504','13','7.0000'),
('510','13','7.0000'),
('516','13','7.0000'),
('522','13','7.0000'),
('528','13','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('534','13','7.0000'),
('540','13','7.0000'),
('546','13','7.0000'),
('552','13','7.0000'),
('558','13','7.0000'),
('564','13','7.0000'),
('570','13','7.0000'),
('576','13','7.0000'),
('582','13','7.0000'),
('588','13','7.0000'),
('594','13','7.0000'),
('600','13','7.0000'),
('606','13','7.0000'),
('612','13','7.0000'),
('618','13','7.0000'),
('624','13','7.0000'),
('630','13','7.0000'),
('636','13','7.0000'),
('642','13','7.0000'),
('648','13','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('654','13','7.0000'),
('660','13','7.0000'),
('666','13','7.0000'),
('672','13','7.0000'),
('678','13','7.0000'),
('684','13','7.0000'),
('690','13','7.0000'),
('696','13','7.0000'),
('702','13','7.0000'),
('708','13','7.0000'),
('714','13','7.0000'),
('720','13','7.0000'),
('726','13','7.0000'),
('732','13','7.0000'),
('738','13','7.0000'),
('744','13','7.0000'),
('750','13','7.0000'),
('756','13','7.0000'),
('762','13','7.0000'),
('768','13','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('774','13','7.0000'),
('780','13','7.0000'),
('786','13','7.0000'),
('792','13','7.0000'),
('798','13','7.0000'),
('804','13','7.0000'),
('810','13','7.0000'),
('816','13','7.0000'),
('822','13','7.0000'),
('828','13','7.0000'),
('834','13','7.0000'),
('840','13','7.0000'),
('846','13','7.0000'),
('852','13','7.0000'),
('858','13','7.0000'),
('864','13','7.0000'),
('870','13','7.0000'),
('876','13','7.0000'),
('882','13','7.0000'),
('888','13','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('894','13','7.0000'),
('900','13','7.0000'),
('906','13','7.0000'),
('912','13','7.0000'),
('918','13','7.0000'),
('924','13','7.0000'),
('930','13','7.0000'),
('936','13','7.0000'),
('942','13','7.0000'),
('948','13','7.0000'),
('954','13','7.0000'),
('960','13','7.0000'),
('966','13','7.0000'),
('972','13','7.0000'),
('978','13','7.0000'),
('984','13','7.0000'),
('990','13','7.0000'),
('996','13','7.0000'),
('1002','13','7.0000'),
('1008','13','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1014','13','7.0000'),
('1020','13','7.0000'),
('1026','13','7.0000'),
('1032','13','7.0000'),
('1038','13','7.0000'),
('1044','13','7.0000'),
('1050','13','7.0000'),
('1056','13','7.0000'),
('1062','13','7.0000'),
('1068','13','7.0000'),
('1074','13','7.0000'),
('1080','13','7.0000'),
('1086','13','7.0000'),
('1092','13','7.0000'),
('1098','13','7.0000'),
('1104','13','7.0000'),
('1110','13','7.0000'),
('1116','13','7.0000'),
('1122','13','7.0000'),
('1128','13','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1134','13','7.0000'),
('1140','13','7.0000'),
('1146','13','7.0000'),
('1152','13','7.0000'),
('1158','13','7.0000'),
('1164','13','7.0000'),
('1170','13','7.0000'),
('1176','13','7.0000'),
('1182','13','7.0000'),
('1188','13','7.0000'),
('1194','13','7.0000'),
('1200','13','7.0000'),
('1206','13','7.0000'),
('1212','13','7.0000'),
('1218','13','7.0000'),
('1224','13','7.0000'),
('1230','13','7.0000'),
('1236','13','7.0000'),
('1242','13','7.0000'),
('1248','13','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1254','13','7.0000'),
('1260','13','7.0000'),
('1266','13','7.0000'),
('1272','13','7.0000'),
('1278','13','7.0000'),
('1284','13','7.0000'),
('1290','13','7.0000'),
('1296','13','7.0000'),
('1302','13','7.0000'),
('1308','13','7.0000'),
('1314','13','7.0000'),
('1320','13','7.0000'),
('1326','13','7.0000'),
('1332','13','7.0000'),
('1338','13','7.0000'),
('1344','13','7.0000'),
('1350','13','7.0000'),
('1356','13','7.0000'),
('1362','13','7.0000'),
('1368','13','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1374','13','7.0000'),
('1380','13','7.0000'),
('1386','13','7.0000'),
('1392','13','7.0000'),
('1398','13','7.0000'),
('1404','13','7.0000'),
('1410','13','7.0000'),
('1416','13','7.0000'),
('1422','13','7.0000'),
('1428','13','7.0000'),
('1434','13','7.0000'),
('1440','13','7.0000'),
('1446','13','7.0000'),
('1452','13','7.0000'),
('1458','13','7.0000'),
('1464','13','7.0000'),
('1470','13','7.0000'),
('1476','13','7.0000'),
('1482','13','7.0000'),
('1488','13','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1494','13','7.0000'),
('1500','13','7.0000'),
('1506','13','7.0000'),
('1512','13','7.0000'),
('1518','13','7.0000'),
('1524','13','7.0000'),
('1530','13','7.0000'),
('1536','13','7.0000'),
('1542','13','7.0000'),
('1548','13','7.0000'),
('1554','13','7.0000'),
('1560','13','7.0000'),
('1566','13','7.0000'),
('1572','13','7.0000'),
('1578','13','7.0000'),
('1584','13','7.0000'),
('1590','13','7.0000'),
('1596','13','7.0000'),
('1602','13','7.0000'),
('1608','13','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1614','13','7.0000'),
('1620','13','7.0000'),
('1626','13','7.0000'),
('1632','13','7.0000'),
('1638','13','7.0000'),
('1644','13','7.0000'),
('1650','13','7.0000'),
('1656','13','7.0000'),
('1662','13','7.0000'),
('1668','13','7.0000'),
('1674','13','7.0000'),
('1680','13','7.0000'),
('1686','13','7.0000'),
('1692','13','7.0000'),
('1698','13','7.0000'),
('1704','13','7.0000'),
('1710','13','7.0000'),
('1716','13','7.0000'),
('1722','13','7.0000'),
('1728','13','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('6','14','7.0000'),
('12','14','7.0000'),
('18','14','7.0000'),
('24','14','7.0000'),
('30','14','7.0000'),
('36','14','7.0000'),
('42','14','7.0000'),
('48','14','7.0000'),
('54','14','7.0000'),
('60','14','7.0000'),
('66','14','7.0000'),
('72','14','7.0000'),
('78','14','7.0000'),
('84','14','7.0000'),
('90','14','7.0000'),
('96','14','7.0000'),
('102','14','7.0000'),
('108','14','7.0000'),
('114','14','7.0000'),
('120','14','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('126','14','7.0000'),
('132','14','7.0000'),
('138','14','7.0000'),
('144','14','7.0000'),
('150','14','7.0000'),
('156','14','7.0000'),
('162','14','7.0000'),
('168','14','7.0000'),
('174','14','7.0000'),
('180','14','7.0000'),
('186','14','7.0000'),
('192','14','7.0000'),
('198','14','7.0000'),
('204','14','7.0000'),
('210','14','7.0000'),
('216','14','7.0000'),
('222','14','7.0000'),
('228','14','7.0000'),
('234','14','7.0000'),
('240','14','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('246','14','7.0000'),
('252','14','7.0000'),
('258','14','7.0000'),
('264','14','7.0000'),
('270','14','7.0000'),
('276','14','7.0000'),
('282','14','7.0000'),
('288','14','7.0000'),
('294','14','7.0000'),
('300','14','7.0000'),
('306','14','7.0000'),
('312','14','7.0000'),
('318','14','7.0000'),
('324','14','7.0000'),
('330','14','7.0000'),
('336','14','7.0000'),
('342','14','7.0000'),
('348','14','7.0000'),
('354','14','7.0000'),
('360','14','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('366','14','7.0000'),
('372','14','7.0000'),
('378','14','7.0000'),
('384','14','7.0000'),
('390','14','7.0000'),
('396','14','7.0000'),
('402','14','7.0000'),
('408','14','7.0000'),
('414','14','7.0000'),
('420','14','7.0000'),
('426','14','7.0000'),
('432','14','7.0000'),
('438','14','7.0000'),
('444','14','7.0000'),
('450','14','7.0000'),
('456','14','7.0000'),
('462','14','7.0000'),
('468','14','7.0000'),
('474','14','7.0000'),
('480','14','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('486','14','7.0000'),
('492','14','7.0000'),
('498','14','7.0000'),
('504','14','7.0000'),
('510','14','7.0000'),
('516','14','7.0000'),
('522','14','7.0000'),
('528','14','7.0000'),
('534','14','7.0000'),
('540','14','7.0000'),
('546','14','7.0000'),
('552','14','7.0000'),
('558','14','7.0000'),
('564','14','7.0000'),
('570','14','7.0000'),
('576','14','7.0000'),
('582','14','7.0000'),
('588','14','7.0000'),
('594','14','7.0000'),
('600','14','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('606','14','7.0000'),
('612','14','7.0000'),
('618','14','7.0000'),
('624','14','7.0000'),
('630','14','7.0000'),
('636','14','7.0000'),
('642','14','7.0000'),
('648','14','7.0000'),
('654','14','7.0000'),
('660','14','7.0000'),
('666','14','7.0000'),
('672','14','7.0000'),
('678','14','7.0000'),
('684','14','7.0000'),
('690','14','7.0000'),
('696','14','7.0000'),
('702','14','7.0000'),
('708','14','7.0000'),
('714','14','7.0000'),
('720','14','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('726','14','7.0000'),
('732','14','7.0000'),
('738','14','7.0000'),
('744','14','7.0000'),
('750','14','7.0000'),
('756','14','7.0000'),
('762','14','7.0000'),
('768','14','7.0000'),
('774','14','7.0000'),
('780','14','7.0000'),
('786','14','7.0000'),
('792','14','7.0000'),
('798','14','7.0000'),
('804','14','7.0000'),
('810','14','7.0000'),
('816','14','7.0000'),
('822','14','7.0000'),
('828','14','7.0000'),
('834','14','7.0000'),
('840','14','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('846','14','7.0000'),
('852','14','7.0000'),
('858','14','7.0000'),
('864','14','7.0000'),
('870','14','7.0000'),
('876','14','7.0000'),
('882','14','7.0000'),
('888','14','7.0000'),
('894','14','7.0000'),
('900','14','7.0000'),
('906','14','7.0000'),
('912','14','7.0000'),
('918','14','7.0000'),
('924','14','7.0000'),
('930','14','7.0000'),
('936','14','7.0000'),
('942','14','7.0000'),
('948','14','7.0000'),
('954','14','7.0000'),
('960','14','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('966','14','7.0000'),
('972','14','7.0000'),
('978','14','7.0000'),
('984','14','7.0000'),
('990','14','7.0000'),
('996','14','7.0000'),
('1002','14','7.0000'),
('1008','14','7.0000'),
('1014','14','7.0000'),
('1020','14','7.0000'),
('1026','14','7.0000'),
('1032','14','7.0000'),
('1038','14','7.0000'),
('1044','14','7.0000'),
('1050','14','7.0000'),
('1056','14','7.0000'),
('1062','14','7.0000'),
('1068','14','7.0000'),
('1074','14','7.0000'),
('1080','14','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1086','14','7.0000'),
('1092','14','7.0000'),
('1098','14','7.0000'),
('1104','14','7.0000'),
('1110','14','7.0000'),
('1116','14','7.0000'),
('1122','14','7.0000'),
('1128','14','7.0000'),
('1134','14','7.0000'),
('1140','14','7.0000'),
('1146','14','7.0000'),
('1152','14','7.0000'),
('1158','14','7.0000'),
('1164','14','7.0000'),
('1170','14','7.0000'),
('1176','14','7.0000'),
('1182','14','7.0000'),
('1188','14','7.0000'),
('1194','14','7.0000'),
('1200','14','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1206','14','7.0000'),
('1212','14','7.0000'),
('1218','14','7.0000'),
('1224','14','7.0000'),
('1230','14','7.0000'),
('1236','14','7.0000'),
('1242','14','7.0000'),
('1248','14','7.0000'),
('1254','14','7.0000'),
('1260','14','7.0000'),
('1266','14','7.0000'),
('1272','14','7.0000'),
('1278','14','7.0000'),
('1284','14','7.0000'),
('1290','14','7.0000'),
('1296','14','7.0000'),
('1302','14','7.0000'),
('1308','14','7.0000'),
('1314','14','7.0000'),
('1320','14','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1326','14','7.0000'),
('1332','14','7.0000'),
('1338','14','7.0000'),
('1344','14','7.0000'),
('1350','14','7.0000'),
('1356','14','7.0000'),
('1362','14','7.0000'),
('1368','14','7.0000'),
('1374','14','7.0000'),
('1380','14','7.0000'),
('1386','14','7.0000'),
('1392','14','7.0000'),
('1398','14','7.0000'),
('1404','14','7.0000'),
('1410','14','7.0000'),
('1416','14','7.0000'),
('1422','14','7.0000'),
('1428','14','7.0000'),
('1434','14','7.0000'),
('1440','14','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1446','14','7.0000'),
('1452','14','7.0000'),
('1458','14','7.0000'),
('1464','14','7.0000'),
('1470','14','7.0000'),
('1476','14','7.0000'),
('1482','14','7.0000'),
('1488','14','7.0000'),
('1494','14','7.0000'),
('1500','14','7.0000'),
('1506','14','7.0000'),
('1512','14','7.0000'),
('1518','14','7.0000'),
('1524','14','7.0000'),
('1530','14','7.0000'),
('1536','14','7.0000'),
('1542','14','7.0000'),
('1548','14','7.0000'),
('1554','14','7.0000'),
('1560','14','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1566','14','7.0000'),
('1572','14','7.0000'),
('1578','14','7.0000'),
('1584','14','7.0000'),
('1590','14','7.0000'),
('1596','14','7.0000'),
('1602','14','7.0000'),
('1608','14','7.0000'),
('1614','14','7.0000'),
('1620','14','7.0000'),
('1626','14','7.0000'),
('1632','14','7.0000'),
('1638','14','7.0000'),
('1644','14','7.0000'),
('1650','14','7.0000'),
('1656','14','7.0000'),
('1662','14','7.0000'),
('1668','14','7.0000'),
('1674','14','7.0000'),
('1680','14','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1686','14','7.0000'),
('1692','14','7.0000'),
('1698','14','7.0000'),
('1704','14','7.0000'),
('1710','14','7.0000'),
('1716','14','7.0000'),
('1722','14','7.0000'),
('1728','14','7.0000'),
('6','15','7.0000'),
('12','15','7.0000'),
('18','15','7.0000'),
('24','15','7.0000'),
('30','15','7.0000'),
('36','15','7.0000'),
('42','15','7.0000'),
('48','15','7.0000'),
('54','15','7.0000'),
('60','15','7.0000'),
('66','15','7.0000'),
('72','15','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('78','15','7.0000'),
('84','15','7.0000'),
('90','15','7.0000'),
('96','15','7.0000'),
('102','15','7.0000'),
('108','15','7.0000'),
('114','15','7.0000'),
('120','15','7.0000'),
('126','15','7.0000'),
('132','15','7.0000'),
('138','15','7.0000'),
('144','15','7.0000'),
('150','15','7.0000'),
('156','15','7.0000'),
('162','15','7.0000'),
('168','15','7.0000'),
('174','15','7.0000'),
('180','15','7.0000'),
('186','15','7.0000'),
('192','15','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('198','15','7.0000'),
('204','15','7.0000'),
('210','15','7.0000'),
('216','15','7.0000'),
('222','15','7.0000'),
('228','15','7.0000'),
('234','15','7.0000'),
('240','15','7.0000'),
('246','15','7.0000'),
('252','15','7.0000'),
('258','15','7.0000'),
('264','15','7.0000'),
('270','15','7.0000'),
('276','15','7.0000'),
('282','15','7.0000'),
('288','15','7.0000'),
('294','15','7.0000'),
('300','15','7.0000'),
('306','15','7.0000'),
('312','15','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('318','15','7.0000'),
('324','15','7.0000'),
('330','15','7.0000'),
('336','15','7.0000'),
('342','15','7.0000'),
('348','15','7.0000'),
('354','15','7.0000'),
('360','15','7.0000'),
('366','15','7.0000'),
('372','15','7.0000'),
('378','15','7.0000'),
('384','15','7.0000'),
('390','15','7.0000'),
('396','15','7.0000'),
('402','15','7.0000'),
('408','15','7.0000'),
('414','15','7.0000'),
('420','15','7.0000'),
('426','15','7.0000'),
('432','15','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('438','15','7.0000'),
('444','15','7.0000'),
('450','15','7.0000'),
('456','15','7.0000'),
('462','15','7.0000'),
('468','15','7.0000'),
('474','15','7.0000'),
('480','15','7.0000'),
('486','15','7.0000'),
('492','15','7.0000'),
('498','15','7.0000'),
('504','15','7.0000'),
('510','15','7.0000'),
('516','15','7.0000'),
('522','15','7.0000'),
('528','15','7.0000'),
('534','15','7.0000'),
('540','15','7.0000'),
('546','15','7.0000'),
('552','15','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('558','15','7.0000'),
('564','15','7.0000'),
('570','15','7.0000'),
('576','15','7.0000'),
('582','15','7.0000'),
('588','15','7.0000'),
('594','15','7.0000'),
('600','15','7.0000'),
('606','15','7.0000'),
('612','15','7.0000'),
('618','15','7.0000'),
('624','15','7.0000'),
('630','15','7.0000'),
('636','15','7.0000'),
('642','15','7.0000'),
('648','15','7.0000'),
('654','15','7.0000'),
('660','15','7.0000'),
('666','15','7.0000'),
('672','15','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('678','15','7.0000'),
('684','15','7.0000'),
('690','15','7.0000'),
('696','15','7.0000'),
('702','15','7.0000'),
('708','15','7.0000'),
('714','15','7.0000'),
('720','15','7.0000'),
('726','15','7.0000'),
('732','15','7.0000'),
('738','15','7.0000'),
('744','15','7.0000'),
('750','15','7.0000'),
('756','15','7.0000'),
('762','15','7.0000'),
('768','15','7.0000'),
('774','15','7.0000'),
('780','15','7.0000'),
('786','15','7.0000'),
('792','15','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('798','15','7.0000'),
('804','15','7.0000'),
('810','15','7.0000'),
('816','15','7.0000'),
('822','15','7.0000'),
('828','15','7.0000'),
('834','15','7.0000'),
('840','15','7.0000'),
('846','15','7.0000'),
('852','15','7.0000'),
('858','15','7.0000'),
('864','15','7.0000'),
('870','15','7.0000'),
('876','15','7.0000'),
('882','15','7.0000'),
('888','15','7.0000'),
('894','15','7.0000'),
('900','15','7.0000'),
('906','15','7.0000'),
('912','15','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('918','15','7.0000'),
('924','15','7.0000'),
('930','15','7.0000'),
('936','15','7.0000'),
('942','15','7.0000'),
('948','15','7.0000'),
('954','15','7.0000'),
('960','15','7.0000'),
('966','15','7.0000'),
('972','15','7.0000'),
('978','15','7.0000'),
('984','15','7.0000'),
('990','15','7.0000'),
('996','15','7.0000'),
('1002','15','7.0000'),
('1008','15','7.0000'),
('1014','15','7.0000'),
('1020','15','7.0000'),
('1026','15','7.0000'),
('1032','15','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1038','15','7.0000'),
('1044','15','7.0000'),
('1050','15','7.0000'),
('1056','15','7.0000'),
('1062','15','7.0000'),
('1068','15','7.0000'),
('1074','15','7.0000'),
('1080','15','7.0000'),
('1086','15','7.0000'),
('1092','15','7.0000'),
('1098','15','7.0000'),
('1104','15','7.0000'),
('1110','15','7.0000'),
('1116','15','7.0000'),
('1122','15','7.0000'),
('1128','15','7.0000'),
('1134','15','7.0000'),
('1140','15','7.0000'),
('1146','15','7.0000'),
('1152','15','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1158','15','7.0000'),
('1164','15','7.0000'),
('1170','15','7.0000'),
('1176','15','7.0000'),
('1182','15','7.0000'),
('1188','15','7.0000'),
('1194','15','7.0000'),
('1200','15','7.0000'),
('1206','15','7.0000'),
('1212','15','7.0000'),
('1218','15','7.0000'),
('1224','15','7.0000'),
('1230','15','7.0000'),
('1236','15','7.0000'),
('1242','15','7.0000'),
('1248','15','7.0000'),
('1254','15','7.0000'),
('1260','15','7.0000'),
('1266','15','7.0000'),
('1272','15','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1278','15','7.0000'),
('1284','15','7.0000'),
('1290','15','7.0000'),
('1296','15','7.0000'),
('1302','15','7.0000'),
('1308','15','7.0000'),
('1314','15','7.0000'),
('1320','15','7.0000'),
('1326','15','7.0000'),
('1332','15','7.0000'),
('1338','15','7.0000'),
('1344','15','7.0000'),
('1350','15','7.0000'),
('1356','15','7.0000'),
('1362','15','7.0000'),
('1368','15','7.0000'),
('1374','15','7.0000'),
('1380','15','7.0000'),
('1386','15','7.0000'),
('1392','15','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1398','15','7.0000'),
('1404','15','7.0000'),
('1410','15','7.0000'),
('1416','15','7.0000'),
('1422','15','7.0000'),
('1428','15','7.0000'),
('1434','15','7.0000'),
('1440','15','7.0000'),
('1446','15','7.0000'),
('1452','15','7.0000'),
('1458','15','7.0000'),
('1464','15','7.0000'),
('1470','15','7.0000'),
('1476','15','7.0000'),
('1482','15','7.0000'),
('1488','15','7.0000'),
('1494','15','7.0000'),
('1500','15','7.0000'),
('1506','15','7.0000'),
('1512','15','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1518','15','7.0000'),
('1524','15','7.0000'),
('1530','15','7.0000'),
('1536','15','7.0000'),
('1542','15','7.0000'),
('1548','15','7.0000'),
('1554','15','7.0000'),
('1560','15','7.0000'),
('1566','15','7.0000'),
('1572','15','7.0000'),
('1578','15','7.0000'),
('1584','15','7.0000'),
('1590','15','7.0000'),
('1596','15','7.0000'),
('1602','15','7.0000'),
('1608','15','7.0000'),
('1614','15','7.0000'),
('1620','15','7.0000'),
('1626','15','7.0000'),
('1632','15','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1638','15','7.0000'),
('1644','15','7.0000'),
('1650','15','7.0000'),
('1656','15','7.0000'),
('1662','15','7.0000'),
('1668','15','7.0000'),
('1674','15','7.0000'),
('1680','15','7.0000'),
('1686','15','7.0000'),
('1692','15','7.0000'),
('1698','15','7.0000'),
('1704','15','7.0000'),
('1710','15','7.0000'),
('1716','15','7.0000'),
('1722','15','7.0000'),
('1728','15','7.0000'),
('6','16','7.0000'),
('12','16','7.0000'),
('18','16','7.0000'),
('24','16','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('30','16','7.0000'),
('36','16','7.0000'),
('42','16','7.0000'),
('48','16','7.0000'),
('54','16','7.0000'),
('60','16','7.0000'),
('66','16','7.0000'),
('72','16','7.0000'),
('78','16','7.0000'),
('84','16','7.0000'),
('90','16','7.0000'),
('96','16','7.0000'),
('102','16','7.0000'),
('108','16','7.0000'),
('114','16','7.0000'),
('120','16','7.0000'),
('126','16','7.0000'),
('132','16','7.0000'),
('138','16','7.0000'),
('144','16','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('150','16','7.0000'),
('156','16','7.0000'),
('162','16','7.0000'),
('168','16','7.0000'),
('174','16','7.0000'),
('180','16','7.0000'),
('186','16','7.0000'),
('192','16','7.0000'),
('198','16','7.0000'),
('204','16','7.0000'),
('210','16','7.0000'),
('216','16','7.0000'),
('222','16','7.0000'),
('228','16','7.0000'),
('234','16','7.0000'),
('240','16','7.0000'),
('246','16','7.0000'),
('252','16','7.0000'),
('258','16','7.0000'),
('264','16','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('270','16','7.0000'),
('276','16','7.0000'),
('282','16','7.0000'),
('288','16','7.0000'),
('294','16','7.0000'),
('300','16','7.0000'),
('306','16','7.0000'),
('312','16','7.0000'),
('318','16','7.0000'),
('324','16','7.0000'),
('330','16','7.0000'),
('336','16','7.0000'),
('342','16','7.0000'),
('348','16','7.0000'),
('354','16','7.0000'),
('360','16','7.0000'),
('366','16','7.0000'),
('372','16','7.0000'),
('378','16','7.0000'),
('384','16','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('390','16','7.0000'),
('396','16','7.0000'),
('402','16','7.0000'),
('408','16','7.0000'),
('414','16','7.0000'),
('420','16','7.0000'),
('426','16','7.0000'),
('432','16','7.0000'),
('438','16','7.0000'),
('444','16','7.0000'),
('450','16','7.0000'),
('456','16','7.0000'),
('462','16','7.0000'),
('468','16','7.0000'),
('474','16','7.0000'),
('480','16','7.0000'),
('486','16','7.0000'),
('492','16','7.0000'),
('498','16','7.0000'),
('504','16','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('510','16','7.0000'),
('516','16','7.0000'),
('522','16','7.0000'),
('528','16','7.0000'),
('534','16','7.0000'),
('540','16','7.0000'),
('546','16','7.0000'),
('552','16','7.0000'),
('558','16','7.0000'),
('564','16','7.0000'),
('570','16','7.0000'),
('576','16','7.0000'),
('582','16','7.0000'),
('588','16','7.0000'),
('594','16','7.0000'),
('600','16','7.0000'),
('606','16','7.0000'),
('612','16','7.0000'),
('618','16','7.0000'),
('624','16','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('630','16','7.0000'),
('636','16','7.0000'),
('642','16','7.0000'),
('648','16','7.0000'),
('654','16','7.0000'),
('660','16','7.0000'),
('666','16','7.0000'),
('672','16','7.0000'),
('678','16','7.0000'),
('684','16','7.0000'),
('690','16','7.0000'),
('696','16','7.0000'),
('702','16','7.0000'),
('708','16','7.0000'),
('714','16','7.0000'),
('720','16','7.0000'),
('726','16','7.0000'),
('732','16','7.0000'),
('738','16','7.0000'),
('744','16','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('750','16','7.0000'),
('756','16','7.0000'),
('762','16','7.0000'),
('768','16','7.0000'),
('774','16','7.0000'),
('780','16','7.0000'),
('786','16','7.0000'),
('792','16','7.0000'),
('798','16','7.0000'),
('804','16','7.0000'),
('810','16','7.0000'),
('816','16','7.0000'),
('822','16','7.0000'),
('828','16','7.0000'),
('834','16','7.0000'),
('840','16','7.0000'),
('846','16','7.0000'),
('852','16','7.0000'),
('858','16','7.0000'),
('864','16','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('870','16','7.0000'),
('876','16','7.0000'),
('882','16','7.0000'),
('888','16','7.0000'),
('894','16','7.0000'),
('900','16','7.0000'),
('906','16','7.0000'),
('912','16','7.0000'),
('918','16','7.0000'),
('924','16','7.0000'),
('930','16','7.0000'),
('936','16','7.0000'),
('942','16','7.0000'),
('948','16','7.0000'),
('954','16','7.0000'),
('960','16','7.0000'),
('966','16','7.0000'),
('972','16','7.0000'),
('978','16','7.0000'),
('984','16','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('990','16','7.0000'),
('996','16','7.0000'),
('1002','16','7.0000'),
('1008','16','7.0000'),
('1014','16','7.0000'),
('1020','16','7.0000'),
('1026','16','7.0000'),
('1032','16','7.0000'),
('1038','16','7.0000'),
('1044','16','7.0000'),
('1050','16','7.0000'),
('1056','16','7.0000'),
('1062','16','7.0000'),
('1068','16','7.0000'),
('1074','16','7.0000'),
('1080','16','7.0000'),
('1086','16','7.0000'),
('1092','16','7.0000'),
('1098','16','7.0000'),
('1104','16','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1110','16','7.0000'),
('1116','16','7.0000'),
('1122','16','7.0000'),
('1128','16','7.0000'),
('1134','16','7.0000'),
('1140','16','7.0000'),
('1146','16','7.0000'),
('1152','16','7.0000'),
('1158','16','7.0000'),
('1164','16','7.0000'),
('1170','16','7.0000'),
('1176','16','7.0000'),
('1182','16','7.0000'),
('1188','16','7.0000'),
('1194','16','7.0000'),
('1200','16','7.0000'),
('1206','16','7.0000'),
('1212','16','7.0000'),
('1218','16','7.0000'),
('1224','16','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1230','16','7.0000'),
('1236','16','7.0000'),
('1242','16','7.0000'),
('1248','16','7.0000'),
('1254','16','7.0000'),
('1260','16','7.0000'),
('1266','16','7.0000'),
('1272','16','7.0000'),
('1278','16','7.0000'),
('1284','16','7.0000'),
('1290','16','7.0000'),
('1296','16','7.0000'),
('1302','16','7.0000'),
('1308','16','7.0000'),
('1314','16','7.0000'),
('1320','16','7.0000'),
('1326','16','7.0000'),
('1332','16','7.0000'),
('1338','16','7.0000'),
('1344','16','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1350','16','7.0000'),
('1356','16','7.0000'),
('1362','16','7.0000'),
('1368','16','7.0000'),
('1374','16','7.0000'),
('1380','16','7.0000'),
('1386','16','7.0000'),
('1392','16','7.0000'),
('1398','16','7.0000'),
('1404','16','7.0000'),
('1410','16','7.0000'),
('1416','16','7.0000'),
('1422','16','7.0000'),
('1428','16','7.0000'),
('1434','16','7.0000'),
('1440','16','7.0000'),
('1446','16','7.0000'),
('1452','16','7.0000'),
('1458','16','7.0000'),
('1464','16','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1470','16','7.0000'),
('1476','16','7.0000'),
('1482','16','7.0000'),
('1488','16','7.0000'),
('1494','16','7.0000'),
('1500','16','7.0000'),
('1506','16','7.0000'),
('1512','16','7.0000'),
('1518','16','7.0000'),
('1524','16','7.0000'),
('1530','16','7.0000'),
('1536','16','7.0000'),
('1542','16','7.0000'),
('1548','16','7.0000'),
('1554','16','7.0000'),
('1560','16','7.0000'),
('1566','16','7.0000'),
('1572','16','7.0000'),
('1578','16','7.0000'),
('1584','16','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1590','16','7.0000'),
('1596','16','7.0000'),
('1602','16','7.0000'),
('1608','16','7.0000'),
('1614','16','7.0000'),
('1620','16','7.0000'),
('1626','16','7.0000'),
('1632','16','7.0000'),
('1638','16','7.0000'),
('1644','16','7.0000'),
('1650','16','7.0000'),
('1656','16','7.0000'),
('1662','16','7.0000'),
('1668','16','7.0000'),
('1674','16','7.0000'),
('1680','16','7.0000'),
('1686','16','7.0000'),
('1692','16','7.0000'),
('1698','16','7.0000'),
('1704','16','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1710','16','7.0000'),
('1716','16','7.0000'),
('1722','16','7.0000'),
('1728','16','7.0000'),
('6','17','7.0000'),
('12','17','7.0000'),
('18','17','7.0000'),
('24','17','7.0000'),
('30','17','7.0000'),
('36','17','7.0000'),
('42','17','7.0000'),
('48','17','7.0000'),
('54','17','7.0000'),
('60','17','7.0000'),
('66','17','7.0000'),
('72','17','7.0000'),
('78','17','7.0000'),
('84','17','7.0000'),
('90','17','7.0000'),
('96','17','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('102','17','7.0000'),
('108','17','7.0000'),
('114','17','7.0000'),
('120','17','7.0000'),
('126','17','7.0000'),
('132','17','7.0000'),
('138','17','7.0000'),
('144','17','7.0000'),
('150','17','7.0000'),
('156','17','7.0000'),
('162','17','7.0000'),
('168','17','7.0000'),
('174','17','7.0000'),
('180','17','7.0000'),
('186','17','7.0000'),
('192','17','7.0000'),
('198','17','7.0000'),
('204','17','7.0000'),
('210','17','7.0000'),
('216','17','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('222','17','7.0000'),
('228','17','7.0000'),
('234','17','7.0000'),
('240','17','7.0000'),
('246','17','7.0000'),
('252','17','7.0000'),
('258','17','7.0000'),
('264','17','7.0000'),
('270','17','7.0000'),
('276','17','7.0000'),
('282','17','7.0000'),
('288','17','7.0000'),
('294','17','7.0000'),
('300','17','7.0000'),
('306','17','7.0000'),
('312','17','7.0000'),
('318','17','7.0000'),
('324','17','7.0000'),
('330','17','7.0000'),
('336','17','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('342','17','7.0000'),
('348','17','7.0000'),
('354','17','7.0000'),
('360','17','7.0000'),
('366','17','7.0000'),
('372','17','7.0000'),
('378','17','7.0000'),
('384','17','7.0000'),
('390','17','7.0000'),
('396','17','7.0000'),
('402','17','7.0000'),
('408','17','7.0000'),
('414','17','7.0000'),
('420','17','7.0000'),
('426','17','7.0000'),
('432','17','7.0000'),
('438','17','7.0000'),
('444','17','7.0000'),
('450','17','7.0000'),
('456','17','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('462','17','7.0000'),
('468','17','7.0000'),
('474','17','7.0000'),
('480','17','7.0000'),
('486','17','7.0000'),
('492','17','7.0000'),
('498','17','7.0000'),
('504','17','7.0000'),
('510','17','7.0000'),
('516','17','7.0000'),
('522','17','7.0000'),
('528','17','7.0000'),
('534','17','7.0000'),
('540','17','7.0000'),
('546','17','7.0000'),
('552','17','7.0000'),
('558','17','7.0000'),
('564','17','7.0000'),
('570','17','7.0000'),
('576','17','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('582','17','7.0000'),
('588','17','7.0000'),
('594','17','7.0000'),
('600','17','7.0000'),
('606','17','7.0000'),
('612','17','7.0000'),
('618','17','7.0000'),
('624','17','7.0000'),
('630','17','7.0000'),
('636','17','7.0000'),
('642','17','7.0000'),
('648','17','7.0000'),
('654','17','7.0000'),
('660','17','7.0000'),
('666','17','7.0000'),
('672','17','7.0000'),
('678','17','7.0000'),
('684','17','7.0000'),
('690','17','7.0000'),
('696','17','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('702','17','7.0000'),
('708','17','7.0000'),
('714','17','7.0000'),
('720','17','7.0000'),
('726','17','7.0000'),
('732','17','7.0000'),
('738','17','7.0000'),
('744','17','7.0000'),
('750','17','7.0000'),
('756','17','7.0000'),
('762','17','7.0000'),
('768','17','7.0000'),
('774','17','7.0000'),
('780','17','7.0000'),
('786','17','7.0000'),
('792','17','7.0000'),
('798','17','7.0000'),
('804','17','7.0000'),
('810','17','7.0000'),
('816','17','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('822','17','7.0000'),
('828','17','7.0000'),
('834','17','7.0000'),
('840','17','7.0000'),
('846','17','7.0000'),
('852','17','7.0000'),
('858','17','7.0000'),
('864','17','7.0000'),
('870','17','7.0000'),
('876','17','7.0000'),
('882','17','7.0000'),
('888','17','7.0000'),
('894','17','7.0000'),
('900','17','7.0000'),
('906','17','7.0000'),
('912','17','7.0000'),
('918','17','7.0000'),
('924','17','7.0000'),
('930','17','7.0000'),
('936','17','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('942','17','7.0000'),
('948','17','7.0000'),
('954','17','7.0000'),
('960','17','7.0000'),
('966','17','7.0000'),
('972','17','7.0000'),
('978','17','7.0000'),
('984','17','7.0000'),
('990','17','7.0000'),
('996','17','7.0000'),
('1002','17','7.0000'),
('1008','17','7.0000'),
('1014','17','7.0000'),
('1020','17','7.0000'),
('1026','17','7.0000'),
('1032','17','7.0000'),
('1038','17','7.0000'),
('1044','17','7.0000'),
('1050','17','7.0000'),
('1056','17','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1062','17','7.0000'),
('1068','17','7.0000'),
('1074','17','7.0000'),
('1080','17','7.0000'),
('1086','17','7.0000'),
('1092','17','7.0000'),
('1098','17','7.0000'),
('1104','17','7.0000'),
('1110','17','7.0000'),
('1116','17','7.0000'),
('1122','17','7.0000'),
('1128','17','7.0000'),
('1134','17','7.0000'),
('1140','17','7.0000'),
('1146','17','7.0000'),
('1152','17','7.0000'),
('1158','17','7.0000'),
('1164','17','7.0000'),
('1170','17','7.0000'),
('1176','17','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1182','17','7.0000'),
('1188','17','7.0000'),
('1194','17','7.0000'),
('1200','17','7.0000'),
('1206','17','7.0000'),
('1212','17','7.0000'),
('1218','17','7.0000'),
('1224','17','7.0000'),
('1230','17','7.0000'),
('1236','17','7.0000'),
('1242','17','7.0000'),
('1248','17','7.0000'),
('1254','17','7.0000'),
('1260','17','7.0000'),
('1266','17','7.0000'),
('1272','17','7.0000'),
('1278','17','7.0000'),
('1284','17','7.0000'),
('1290','17','7.0000'),
('1296','17','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1302','17','7.0000'),
('1308','17','7.0000'),
('1314','17','7.0000'),
('1320','17','7.0000'),
('1326','17','7.0000'),
('1332','17','7.0000'),
('1338','17','7.0000'),
('1344','17','7.0000'),
('1350','17','7.0000'),
('1356','17','7.0000'),
('1362','17','7.0000'),
('1368','17','7.0000'),
('1374','17','7.0000'),
('1380','17','7.0000'),
('1386','17','7.0000'),
('1392','17','7.0000'),
('1398','17','7.0000'),
('1404','17','7.0000'),
('1410','17','7.0000'),
('1416','17','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1422','17','7.0000'),
('1428','17','7.0000'),
('1434','17','7.0000'),
('1440','17','7.0000'),
('1446','17','7.0000'),
('1452','17','7.0000'),
('1458','17','7.0000'),
('1464','17','7.0000'),
('1470','17','7.0000'),
('1476','17','7.0000'),
('1482','17','7.0000'),
('1488','17','7.0000'),
('1494','17','7.0000'),
('1500','17','7.0000'),
('1506','17','7.0000'),
('1512','17','7.0000'),
('1518','17','7.0000'),
('1524','17','7.0000'),
('1530','17','7.0000'),
('1536','17','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1542','17','7.0000'),
('1548','17','7.0000'),
('1554','17','7.0000'),
('1560','17','7.0000'),
('1566','17','7.0000'),
('1572','17','7.0000'),
('1578','17','7.0000'),
('1584','17','7.0000'),
('1590','17','7.0000'),
('1596','17','7.0000'),
('1602','17','7.0000'),
('1608','17','7.0000'),
('1614','17','7.0000'),
('1620','17','7.0000'),
('1626','17','7.0000'),
('1632','17','7.0000'),
('1638','17','7.0000'),
('1644','17','7.0000'),
('1650','17','7.0000'),
('1656','17','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1662','17','7.0000'),
('1668','17','7.0000'),
('1674','17','7.0000'),
('1680','17','7.0000'),
('1686','17','7.0000'),
('1692','17','7.0000'),
('1698','17','7.0000'),
('1704','17','7.0000'),
('1710','17','7.0000'),
('1716','17','7.0000'),
('1722','17','7.0000'),
('1728','17','7.0000'),
('6','18','7.0000'),
('12','18','7.0000'),
('18','18','7.0000'),
('24','18','7.0000'),
('30','18','7.0000'),
('36','18','7.0000'),
('42','18','7.0000'),
('48','18','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('54','18','7.0000'),
('60','18','7.0000'),
('66','18','7.0000'),
('72','18','7.0000'),
('78','18','7.0000'),
('84','18','7.0000'),
('90','18','7.0000'),
('96','18','7.0000'),
('102','18','7.0000'),
('108','18','7.0000'),
('114','18','7.0000'),
('120','18','7.0000'),
('126','18','7.0000'),
('132','18','7.0000'),
('138','18','7.0000'),
('144','18','7.0000'),
('150','18','7.0000'),
('156','18','7.0000'),
('162','18','7.0000'),
('168','18','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('174','18','7.0000'),
('180','18','7.0000'),
('186','18','7.0000'),
('192','18','7.0000'),
('198','18','7.0000'),
('204','18','7.0000'),
('210','18','7.0000'),
('216','18','7.0000'),
('222','18','7.0000'),
('228','18','7.0000'),
('234','18','7.0000'),
('240','18','7.0000'),
('246','18','7.0000'),
('252','18','7.0000'),
('258','18','7.0000'),
('264','18','7.0000'),
('270','18','7.0000'),
('276','18','7.0000'),
('282','18','7.0000'),
('288','18','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('294','18','7.0000'),
('300','18','7.0000'),
('306','18','7.0000'),
('312','18','7.0000'),
('318','18','7.0000'),
('324','18','7.0000'),
('330','18','7.0000'),
('336','18','7.0000'),
('342','18','7.0000'),
('348','18','7.0000'),
('354','18','7.0000'),
('360','18','7.0000'),
('366','18','7.0000'),
('372','18','7.0000'),
('378','18','7.0000'),
('384','18','7.0000'),
('390','18','7.0000'),
('396','18','7.0000'),
('402','18','7.0000'),
('408','18','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('414','18','7.0000'),
('420','18','7.0000'),
('426','18','7.0000'),
('432','18','7.0000'),
('438','18','7.0000'),
('444','18','7.0000'),
('450','18','7.0000'),
('456','18','7.0000'),
('462','18','7.0000'),
('468','18','7.0000'),
('474','18','7.0000'),
('480','18','7.0000'),
('486','18','7.0000'),
('492','18','7.0000'),
('498','18','7.0000'),
('504','18','7.0000'),
('510','18','7.0000'),
('516','18','7.0000'),
('522','18','7.0000'),
('528','18','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('534','18','7.0000'),
('540','18','7.0000'),
('546','18','7.0000'),
('552','18','7.0000'),
('558','18','7.0000'),
('564','18','7.0000'),
('570','18','7.0000'),
('576','18','7.0000'),
('582','18','7.0000'),
('588','18','7.0000'),
('594','18','7.0000'),
('600','18','7.0000'),
('606','18','7.0000'),
('612','18','7.0000'),
('618','18','7.0000'),
('624','18','7.0000'),
('630','18','7.0000'),
('636','18','7.0000'),
('642','18','7.0000'),
('648','18','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('654','18','7.0000'),
('660','18','7.0000'),
('666','18','7.0000'),
('672','18','7.0000'),
('678','18','7.0000'),
('684','18','7.0000'),
('690','18','7.0000'),
('696','18','7.0000'),
('702','18','7.0000'),
('708','18','7.0000'),
('714','18','7.0000'),
('720','18','7.0000'),
('726','18','7.0000'),
('732','18','7.0000'),
('738','18','7.0000'),
('744','18','7.0000'),
('750','18','7.0000'),
('756','18','7.0000'),
('762','18','7.0000'),
('768','18','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('774','18','7.0000'),
('780','18','7.0000'),
('786','18','7.0000'),
('792','18','7.0000'),
('798','18','7.0000'),
('804','18','7.0000'),
('810','18','7.0000'),
('816','18','7.0000'),
('822','18','7.0000'),
('828','18','7.0000'),
('834','18','7.0000'),
('840','18','7.0000'),
('846','18','7.0000'),
('852','18','7.0000'),
('858','18','7.0000'),
('864','18','7.0000'),
('870','18','7.0000'),
('876','18','7.0000'),
('882','18','7.0000'),
('888','18','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('894','18','7.0000'),
('900','18','7.0000'),
('906','18','7.0000'),
('912','18','7.0000'),
('918','18','7.0000'),
('924','18','7.0000'),
('930','18','7.0000'),
('936','18','7.0000'),
('942','18','7.0000'),
('948','18','7.0000'),
('954','18','7.0000'),
('960','18','7.0000'),
('966','18','7.0000'),
('972','18','7.0000'),
('978','18','7.0000'),
('984','18','7.0000'),
('990','18','7.0000'),
('996','18','7.0000'),
('1002','18','7.0000'),
('1008','18','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1014','18','7.0000'),
('1020','18','7.0000'),
('1026','18','7.0000'),
('1032','18','7.0000'),
('1038','18','7.0000'),
('1044','18','7.0000'),
('1050','18','7.0000'),
('1056','18','7.0000'),
('1062','18','7.0000'),
('1068','18','7.0000'),
('1074','18','7.0000'),
('1080','18','7.0000'),
('1086','18','7.0000'),
('1092','18','7.0000'),
('1098','18','7.0000'),
('1104','18','7.0000'),
('1110','18','7.0000'),
('1116','18','7.0000'),
('1122','18','7.0000'),
('1128','18','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1134','18','7.0000'),
('1140','18','7.0000'),
('1146','18','7.0000'),
('1152','18','7.0000'),
('1158','18','7.0000'),
('1164','18','7.0000'),
('1170','18','7.0000'),
('1176','18','7.0000'),
('1182','18','7.0000'),
('1188','18','7.0000'),
('1194','18','7.0000'),
('1200','18','7.0000'),
('1206','18','7.0000'),
('1212','18','7.0000'),
('1218','18','7.0000'),
('1224','18','7.0000'),
('1230','18','7.0000'),
('1236','18','7.0000'),
('1242','18','7.0000'),
('1248','18','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1254','18','7.0000'),
('1260','18','7.0000'),
('1266','18','7.0000'),
('1272','18','7.0000'),
('1278','18','7.0000'),
('1284','18','7.0000'),
('1290','18','7.0000'),
('1296','18','7.0000'),
('1302','18','7.0000'),
('1308','18','7.0000'),
('1314','18','7.0000'),
('1320','18','7.0000'),
('1326','18','7.0000'),
('1332','18','7.0000'),
('1338','18','7.0000'),
('1344','18','7.0000'),
('1350','18','7.0000'),
('1356','18','7.0000'),
('1362','18','7.0000'),
('1368','18','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1374','18','7.0000'),
('1380','18','7.0000'),
('1386','18','7.0000'),
('1392','18','7.0000'),
('1398','18','7.0000'),
('1404','18','7.0000'),
('1410','18','7.0000'),
('1416','18','7.0000'),
('1422','18','7.0000'),
('1428','18','7.0000'),
('1434','18','7.0000'),
('1440','18','7.0000'),
('1446','18','7.0000'),
('1452','18','7.0000'),
('1458','18','7.0000'),
('1464','18','7.0000'),
('1470','18','7.0000'),
('1476','18','7.0000'),
('1482','18','7.0000'),
('1488','18','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1494','18','7.0000'),
('1500','18','7.0000'),
('1506','18','7.0000'),
('1512','18','7.0000'),
('1518','18','7.0000'),
('1524','18','7.0000'),
('1530','18','7.0000'),
('1536','18','7.0000'),
('1542','18','7.0000'),
('1548','18','7.0000'),
('1554','18','7.0000'),
('1560','18','7.0000'),
('1566','18','7.0000'),
('1572','18','7.0000'),
('1578','18','7.0000'),
('1584','18','7.0000'),
('1590','18','7.0000'),
('1596','18','7.0000'),
('1602','18','7.0000'),
('1608','18','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1614','18','7.0000'),
('1620','18','7.0000'),
('1626','18','7.0000'),
('1632','18','7.0000'),
('1638','18','7.0000'),
('1644','18','7.0000'),
('1650','18','7.0000'),
('1656','18','7.0000'),
('1662','18','7.0000'),
('1668','18','7.0000'),
('1674','18','7.0000'),
('1680','18','7.0000'),
('1686','18','7.0000'),
('1692','18','7.0000'),
('1698','18','7.0000'),
('1704','18','7.0000'),
('1710','18','7.0000'),
('1716','18','7.0000'),
('1722','18','7.0000'),
('1728','18','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('6','19','7.0000'),
('12','19','7.0000'),
('18','19','7.0000'),
('24','19','7.0000'),
('30','19','7.0000'),
('36','19','7.0000'),
('42','19','7.0000'),
('48','19','7.0000'),
('54','19','7.0000'),
('60','19','7.0000'),
('66','19','7.0000'),
('72','19','7.0000'),
('78','19','7.0000'),
('84','19','7.0000'),
('90','19','7.0000'),
('96','19','7.0000'),
('102','19','7.0000'),
('108','19','7.0000'),
('114','19','7.0000'),
('120','19','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('126','19','7.0000'),
('132','19','7.0000'),
('138','19','7.0000'),
('144','19','7.0000'),
('150','19','7.0000'),
('156','19','7.0000'),
('162','19','7.0000'),
('168','19','7.0000'),
('174','19','7.0000'),
('180','19','7.0000'),
('186','19','7.0000'),
('192','19','7.0000'),
('198','19','7.0000'),
('204','19','7.0000'),
('210','19','7.0000'),
('216','19','7.0000'),
('222','19','7.0000'),
('228','19','7.0000'),
('234','19','7.0000'),
('240','19','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('246','19','7.0000'),
('252','19','7.0000'),
('258','19','7.0000'),
('264','19','7.0000'),
('270','19','7.0000'),
('276','19','7.0000'),
('282','19','7.0000'),
('288','19','7.0000'),
('294','19','7.0000'),
('300','19','7.0000'),
('306','19','7.0000'),
('312','19','7.0000'),
('318','19','7.0000'),
('324','19','7.0000'),
('330','19','7.0000'),
('336','19','7.0000'),
('342','19','7.0000'),
('348','19','7.0000'),
('354','19','7.0000'),
('360','19','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('366','19','7.0000'),
('372','19','7.0000'),
('378','19','7.0000'),
('384','19','7.0000'),
('390','19','7.0000'),
('396','19','7.0000'),
('402','19','7.0000'),
('408','19','7.0000'),
('414','19','7.0000'),
('420','19','7.0000'),
('426','19','7.0000'),
('432','19','7.0000'),
('438','19','7.0000'),
('444','19','7.0000'),
('450','19','7.0000'),
('456','19','7.0000'),
('462','19','7.0000'),
('468','19','7.0000'),
('474','19','7.0000'),
('480','19','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('486','19','7.0000'),
('492','19','7.0000'),
('498','19','7.0000'),
('504','19','7.0000'),
('510','19','7.0000'),
('516','19','7.0000'),
('522','19','7.0000'),
('528','19','7.0000'),
('534','19','7.0000'),
('540','19','7.0000'),
('546','19','7.0000'),
('552','19','7.0000'),
('558','19','7.0000'),
('564','19','7.0000'),
('570','19','7.0000'),
('576','19','7.0000'),
('582','19','7.0000'),
('588','19','7.0000'),
('594','19','7.0000'),
('600','19','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('606','19','7.0000'),
('612','19','7.0000'),
('618','19','7.0000'),
('624','19','7.0000'),
('630','19','7.0000'),
('636','19','7.0000'),
('642','19','7.0000'),
('648','19','7.0000'),
('654','19','7.0000'),
('660','19','7.0000'),
('666','19','7.0000'),
('672','19','7.0000'),
('678','19','7.0000'),
('684','19','7.0000'),
('690','19','7.0000'),
('696','19','7.0000'),
('702','19','7.0000'),
('708','19','7.0000'),
('714','19','7.0000'),
('720','19','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('726','19','7.0000'),
('732','19','7.0000'),
('738','19','7.0000'),
('744','19','7.0000'),
('750','19','7.0000'),
('756','19','7.0000'),
('762','19','7.0000'),
('768','19','7.0000'),
('774','19','7.0000'),
('780','19','7.0000'),
('786','19','7.0000'),
('792','19','7.0000'),
('798','19','7.0000'),
('804','19','7.0000'),
('810','19','7.0000'),
('816','19','7.0000'),
('822','19','7.0000'),
('828','19','7.0000'),
('834','19','7.0000'),
('840','19','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('846','19','7.0000'),
('852','19','7.0000'),
('858','19','7.0000'),
('864','19','7.0000'),
('870','19','7.0000'),
('876','19','7.0000'),
('882','19','7.0000'),
('888','19','7.0000'),
('894','19','7.0000'),
('900','19','7.0000'),
('906','19','7.0000'),
('912','19','7.0000'),
('918','19','7.0000'),
('924','19','7.0000'),
('930','19','7.0000'),
('936','19','7.0000'),
('942','19','7.0000'),
('948','19','7.0000'),
('954','19','7.0000'),
('960','19','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('966','19','7.0000'),
('972','19','7.0000'),
('978','19','7.0000'),
('984','19','7.0000'),
('990','19','7.0000'),
('996','19','7.0000'),
('1002','19','7.0000'),
('1008','19','7.0000'),
('1014','19','7.0000'),
('1020','19','7.0000'),
('1026','19','7.0000'),
('1032','19','7.0000'),
('1038','19','7.0000'),
('1044','19','7.0000'),
('1050','19','7.0000'),
('1056','19','7.0000'),
('1062','19','7.0000'),
('1068','19','7.0000'),
('1074','19','7.0000'),
('1080','19','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1086','19','7.0000'),
('1092','19','7.0000'),
('1098','19','7.0000'),
('1104','19','7.0000'),
('1110','19','7.0000'),
('1116','19','7.0000'),
('1122','19','7.0000'),
('1128','19','7.0000'),
('1134','19','7.0000'),
('1140','19','7.0000'),
('1146','19','7.0000'),
('1152','19','7.0000'),
('1158','19','7.0000'),
('1164','19','7.0000'),
('1170','19','7.0000'),
('1176','19','7.0000'),
('1182','19','7.0000'),
('1188','19','7.0000'),
('1194','19','7.0000'),
('1200','19','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1206','19','7.0000'),
('1212','19','7.0000'),
('1218','19','7.0000'),
('1224','19','7.0000'),
('1230','19','7.0000'),
('1236','19','7.0000'),
('1242','19','7.0000'),
('1248','19','7.0000'),
('1254','19','7.0000'),
('1260','19','7.0000'),
('1266','19','7.0000'),
('1272','19','7.0000'),
('1278','19','7.0000'),
('1284','19','7.0000'),
('1290','19','7.0000'),
('1296','19','7.0000'),
('1302','19','7.0000'),
('1308','19','7.0000'),
('1314','19','7.0000'),
('1320','19','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1326','19','7.0000'),
('1332','19','7.0000'),
('1338','19','7.0000'),
('1344','19','7.0000'),
('1350','19','7.0000'),
('1356','19','7.0000'),
('1362','19','7.0000'),
('1368','19','7.0000'),
('1374','19','7.0000'),
('1380','19','7.0000'),
('1386','19','7.0000'),
('1392','19','7.0000'),
('1398','19','7.0000'),
('1404','19','7.0000'),
('1410','19','7.0000'),
('1416','19','7.0000'),
('1422','19','7.0000'),
('1428','19','7.0000'),
('1434','19','7.0000'),
('1440','19','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1446','19','7.0000'),
('1452','19','7.0000'),
('1458','19','7.0000'),
('1464','19','7.0000'),
('1470','19','7.0000'),
('1476','19','7.0000'),
('1482','19','7.0000'),
('1488','19','7.0000'),
('1494','19','7.0000'),
('1500','19','7.0000'),
('1506','19','7.0000'),
('1512','19','7.0000'),
('1518','19','7.0000'),
('1524','19','7.0000'),
('1530','19','7.0000'),
('1536','19','7.0000'),
('1542','19','7.0000'),
('1548','19','7.0000'),
('1554','19','7.0000'),
('1560','19','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1566','19','7.0000'),
('1572','19','7.0000'),
('1578','19','7.0000'),
('1584','19','7.0000'),
('1590','19','7.0000'),
('1596','19','7.0000'),
('1602','19','7.0000'),
('1608','19','7.0000'),
('1614','19','7.0000'),
('1620','19','7.0000'),
('1626','19','7.0000'),
('1632','19','7.0000'),
('1638','19','7.0000'),
('1644','19','7.0000'),
('1650','19','7.0000'),
('1656','19','7.0000'),
('1662','19','7.0000'),
('1668','19','7.0000'),
('1674','19','7.0000'),
('1680','19','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1686','19','7.0000'),
('1692','19','7.0000'),
('1698','19','7.0000'),
('1704','19','7.0000'),
('1710','19','7.0000'),
('1716','19','7.0000'),
('1722','19','7.0000'),
('1728','19','7.0000'),
('6','20','7.0000'),
('12','20','7.0000'),
('18','20','7.0000'),
('24','20','7.0000'),
('30','20','7.0000'),
('36','20','7.0000'),
('42','20','7.0000'),
('48','20','7.0000'),
('54','20','7.0000'),
('60','20','7.0000'),
('66','20','7.0000'),
('72','20','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('78','20','7.0000'),
('84','20','7.0000'),
('90','20','7.0000'),
('96','20','7.0000'),
('102','20','7.0000'),
('108','20','7.0000'),
('114','20','7.0000'),
('120','20','7.0000'),
('126','20','7.0000'),
('132','20','7.0000'),
('138','20','7.0000'),
('144','20','7.0000'),
('150','20','7.0000'),
('156','20','7.0000'),
('162','20','7.0000'),
('168','20','7.0000'),
('174','20','7.0000'),
('180','20','7.0000'),
('186','20','7.0000'),
('192','20','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('198','20','7.0000'),
('204','20','7.0000'),
('210','20','7.0000'),
('216','20','7.0000'),
('222','20','7.0000'),
('228','20','7.0000'),
('234','20','7.0000'),
('240','20','7.0000'),
('246','20','7.0000'),
('252','20','7.0000'),
('258','20','7.0000'),
('264','20','7.0000'),
('270','20','7.0000'),
('276','20','7.0000'),
('282','20','7.0000'),
('288','20','7.0000'),
('294','20','7.0000'),
('300','20','7.0000'),
('306','20','7.0000'),
('312','20','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('318','20','7.0000'),
('324','20','7.0000'),
('330','20','7.0000'),
('336','20','7.0000'),
('342','20','7.0000'),
('348','20','7.0000'),
('354','20','7.0000'),
('360','20','7.0000'),
('366','20','7.0000'),
('372','20','7.0000'),
('378','20','7.0000'),
('384','20','7.0000'),
('390','20','7.0000'),
('396','20','7.0000'),
('402','20','7.0000'),
('408','20','7.0000'),
('414','20','7.0000'),
('420','20','7.0000'),
('426','20','7.0000'),
('432','20','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('438','20','7.0000'),
('444','20','7.0000'),
('450','20','7.0000'),
('456','20','7.0000'),
('462','20','7.0000'),
('468','20','7.0000'),
('474','20','7.0000'),
('480','20','7.0000'),
('486','20','7.0000'),
('492','20','7.0000'),
('498','20','7.0000'),
('504','20','7.0000'),
('510','20','7.0000'),
('516','20','7.0000'),
('522','20','7.0000'),
('528','20','7.0000'),
('534','20','7.0000'),
('540','20','7.0000'),
('546','20','7.0000'),
('552','20','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('558','20','7.0000'),
('564','20','7.0000'),
('570','20','7.0000'),
('576','20','7.0000'),
('582','20','7.0000'),
('588','20','7.0000'),
('594','20','7.0000'),
('600','20','7.0000'),
('606','20','7.0000'),
('612','20','7.0000'),
('618','20','7.0000'),
('624','20','7.0000'),
('630','20','7.0000'),
('636','20','7.0000'),
('642','20','7.0000'),
('648','20','7.0000'),
('654','20','7.0000'),
('660','20','7.0000'),
('666','20','7.0000'),
('672','20','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('678','20','7.0000'),
('684','20','7.0000'),
('690','20','7.0000'),
('696','20','7.0000'),
('702','20','7.0000'),
('708','20','7.0000'),
('714','20','7.0000'),
('720','20','7.0000'),
('726','20','7.0000'),
('732','20','7.0000'),
('738','20','7.0000'),
('744','20','7.0000'),
('750','20','7.0000'),
('756','20','7.0000'),
('762','20','7.0000'),
('768','20','7.0000'),
('774','20','7.0000'),
('780','20','7.0000'),
('786','20','7.0000'),
('792','20','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('798','20','7.0000'),
('804','20','7.0000'),
('810','20','7.0000'),
('816','20','7.0000'),
('822','20','7.0000'),
('828','20','7.0000'),
('834','20','7.0000'),
('840','20','7.0000'),
('846','20','7.0000'),
('852','20','7.0000'),
('858','20','7.0000'),
('864','20','7.0000'),
('870','20','7.0000'),
('876','20','7.0000'),
('882','20','7.0000'),
('888','20','7.0000'),
('894','20','7.0000'),
('900','20','7.0000'),
('906','20','7.0000'),
('912','20','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('918','20','7.0000'),
('924','20','7.0000'),
('930','20','7.0000'),
('936','20','7.0000'),
('942','20','7.0000'),
('948','20','7.0000'),
('954','20','7.0000'),
('960','20','7.0000'),
('966','20','7.0000'),
('972','20','7.0000'),
('978','20','7.0000'),
('984','20','7.0000'),
('990','20','7.0000'),
('996','20','7.0000'),
('1002','20','7.0000'),
('1008','20','7.0000'),
('1014','20','7.0000'),
('1020','20','7.0000'),
('1026','20','7.0000'),
('1032','20','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1038','20','7.0000'),
('1044','20','7.0000'),
('1050','20','7.0000'),
('1056','20','7.0000'),
('1062','20','7.0000'),
('1068','20','7.0000'),
('1074','20','7.0000'),
('1080','20','7.0000'),
('1086','20','7.0000'),
('1092','20','7.0000'),
('1098','20','7.0000'),
('1104','20','7.0000'),
('1110','20','7.0000'),
('1116','20','7.0000'),
('1122','20','7.0000'),
('1128','20','7.0000'),
('1134','20','7.0000'),
('1140','20','7.0000'),
('1146','20','7.0000'),
('1152','20','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1158','20','7.0000'),
('1164','20','7.0000'),
('1170','20','7.0000'),
('1176','20','7.0000'),
('1182','20','7.0000'),
('1188','20','7.0000'),
('1194','20','7.0000'),
('1200','20','7.0000'),
('1206','20','7.0000'),
('1212','20','7.0000'),
('1218','20','7.0000'),
('1224','20','7.0000'),
('1230','20','7.0000'),
('1236','20','7.0000'),
('1242','20','7.0000'),
('1248','20','7.0000'),
('1254','20','7.0000'),
('1260','20','7.0000'),
('1266','20','7.0000'),
('1272','20','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1278','20','7.0000'),
('1284','20','7.0000'),
('1290','20','7.0000'),
('1296','20','7.0000'),
('1302','20','7.0000'),
('1308','20','7.0000'),
('1314','20','7.0000'),
('1320','20','7.0000'),
('1326','20','7.0000'),
('1332','20','7.0000'),
('1338','20','7.0000'),
('1344','20','7.0000'),
('1350','20','7.0000'),
('1356','20','7.0000'),
('1362','20','7.0000'),
('1368','20','7.0000'),
('1374','20','7.0000'),
('1380','20','7.0000'),
('1386','20','7.0000'),
('1392','20','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1398','20','7.0000'),
('1404','20','7.0000'),
('1410','20','7.0000'),
('1416','20','7.0000'),
('1422','20','7.0000'),
('1428','20','7.0000'),
('1434','20','7.0000'),
('1440','20','7.0000'),
('1446','20','7.0000'),
('1452','20','7.0000'),
('1458','20','7.0000'),
('1464','20','7.0000'),
('1470','20','7.0000'),
('1476','20','7.0000'),
('1482','20','7.0000'),
('1488','20','7.0000'),
('1494','20','7.0000'),
('1500','20','7.0000'),
('1506','20','7.0000'),
('1512','20','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1518','20','7.0000'),
('1524','20','7.0000'),
('1530','20','7.0000'),
('1536','20','7.0000'),
('1542','20','7.0000'),
('1548','20','7.0000'),
('1554','20','7.0000'),
('1560','20','7.0000'),
('1566','20','7.0000'),
('1572','20','7.0000'),
('1578','20','7.0000'),
('1584','20','7.0000'),
('1590','20','7.0000'),
('1596','20','7.0000'),
('1602','20','7.0000'),
('1608','20','7.0000'),
('1614','20','7.0000'),
('1620','20','7.0000'),
('1626','20','7.0000'),
('1632','20','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1638','20','7.0000'),
('1644','20','7.0000'),
('1650','20','7.0000'),
('1656','20','7.0000'),
('1662','20','7.0000'),
('1668','20','7.0000'),
('1674','20','7.0000'),
('1680','20','7.0000'),
('1686','20','7.0000'),
('1692','20','7.0000'),
('1698','20','7.0000'),
('1704','20','7.0000'),
('1710','20','7.0000'),
('1716','20','7.0000'),
('1722','20','7.0000'),
('1728','20','7.0000'),
('6','21','7.0000'),
('12','21','7.0000'),
('18','21','7.0000'),
('24','21','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('30','21','7.0000'),
('36','21','7.0000'),
('42','21','7.0000'),
('48','21','7.0000'),
('54','21','7.0000'),
('60','21','7.0000'),
('66','21','7.0000'),
('72','21','7.0000'),
('78','21','7.0000'),
('84','21','7.0000'),
('90','21','7.0000'),
('96','21','7.0000'),
('102','21','7.0000'),
('108','21','7.0000'),
('114','21','7.0000'),
('120','21','7.0000'),
('126','21','7.0000'),
('132','21','7.0000'),
('138','21','7.0000'),
('144','21','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('150','21','7.0000'),
('156','21','7.0000'),
('162','21','7.0000'),
('168','21','7.0000'),
('174','21','7.0000'),
('180','21','7.0000'),
('186','21','7.0000'),
('192','21','7.0000'),
('198','21','7.0000'),
('204','21','7.0000'),
('210','21','7.0000'),
('216','21','7.0000'),
('222','21','7.0000'),
('228','21','7.0000'),
('234','21','7.0000'),
('240','21','7.0000'),
('246','21','7.0000'),
('252','21','7.0000'),
('258','21','7.0000'),
('264','21','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('270','21','7.0000'),
('276','21','7.0000'),
('282','21','7.0000'),
('288','21','7.0000'),
('294','21','7.0000'),
('300','21','7.0000'),
('306','21','7.0000'),
('312','21','7.0000'),
('318','21','7.0000'),
('324','21','7.0000'),
('330','21','7.0000'),
('336','21','7.0000'),
('342','21','7.0000'),
('348','21','7.0000'),
('354','21','7.0000'),
('360','21','7.0000'),
('366','21','7.0000'),
('372','21','7.0000'),
('378','21','7.0000'),
('384','21','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('390','21','7.0000'),
('396','21','7.0000'),
('402','21','7.0000'),
('408','21','7.0000'),
('414','21','7.0000'),
('420','21','7.0000'),
('426','21','7.0000'),
('432','21','7.0000'),
('438','21','7.0000'),
('444','21','7.0000'),
('450','21','7.0000'),
('456','21','7.0000'),
('462','21','7.0000'),
('468','21','7.0000'),
('474','21','7.0000'),
('480','21','7.0000'),
('486','21','7.0000'),
('492','21','7.0000'),
('498','21','7.0000'),
('504','21','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('510','21','7.0000'),
('516','21','7.0000'),
('522','21','7.0000'),
('528','21','7.0000'),
('534','21','7.0000'),
('540','21','7.0000'),
('546','21','7.0000'),
('552','21','7.0000'),
('558','21','7.0000'),
('564','21','7.0000'),
('570','21','7.0000'),
('576','21','7.0000'),
('582','21','7.0000'),
('588','21','7.0000'),
('594','21','7.0000'),
('600','21','7.0000'),
('606','21','7.0000'),
('612','21','7.0000'),
('618','21','7.0000'),
('624','21','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('630','21','7.0000'),
('636','21','7.0000'),
('642','21','7.0000'),
('648','21','7.0000'),
('654','21','7.0000'),
('660','21','7.0000'),
('666','21','7.0000'),
('672','21','7.0000'),
('678','21','7.0000'),
('684','21','7.0000'),
('690','21','7.0000'),
('696','21','7.0000'),
('702','21','7.0000'),
('708','21','7.0000'),
('714','21','7.0000'),
('720','21','7.0000'),
('726','21','7.0000'),
('732','21','7.0000'),
('738','21','7.0000'),
('744','21','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('750','21','7.0000'),
('756','21','7.0000'),
('762','21','7.0000'),
('768','21','7.0000'),
('774','21','7.0000'),
('780','21','7.0000'),
('786','21','7.0000'),
('792','21','7.0000'),
('798','21','7.0000'),
('804','21','7.0000'),
('810','21','7.0000'),
('816','21','7.0000'),
('822','21','7.0000'),
('828','21','7.0000'),
('834','21','7.0000'),
('840','21','7.0000'),
('846','21','7.0000'),
('852','21','7.0000'),
('858','21','7.0000'),
('864','21','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('870','21','7.0000'),
('876','21','7.0000'),
('882','21','7.0000'),
('888','21','7.0000'),
('894','21','7.0000'),
('900','21','7.0000'),
('906','21','7.0000'),
('912','21','7.0000'),
('918','21','7.0000'),
('924','21','7.0000'),
('930','21','7.0000'),
('936','21','7.0000'),
('942','21','7.0000'),
('948','21','7.0000'),
('954','21','7.0000'),
('960','21','7.0000'),
('966','21','7.0000'),
('972','21','7.0000'),
('978','21','7.0000'),
('984','21','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('990','21','7.0000'),
('996','21','7.0000'),
('1002','21','7.0000'),
('1008','21','7.0000'),
('1014','21','7.0000'),
('1020','21','7.0000'),
('1026','21','7.0000'),
('1032','21','7.0000'),
('1038','21','7.0000'),
('1044','21','7.0000'),
('1050','21','7.0000'),
('1056','21','7.0000'),
('1062','21','7.0000'),
('1068','21','7.0000'),
('1074','21','7.0000'),
('1080','21','7.0000'),
('1086','21','7.0000'),
('1092','21','7.0000'),
('1098','21','7.0000'),
('1104','21','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1110','21','7.0000'),
('1116','21','7.0000'),
('1122','21','7.0000'),
('1128','21','7.0000'),
('1134','21','7.0000'),
('1140','21','7.0000'),
('1146','21','7.0000'),
('1152','21','7.0000'),
('1158','21','7.0000'),
('1164','21','7.0000'),
('1170','21','7.0000'),
('1176','21','7.0000'),
('1182','21','7.0000'),
('1188','21','7.0000'),
('1194','21','7.0000'),
('1200','21','7.0000'),
('1206','21','7.0000'),
('1212','21','7.0000'),
('1218','21','7.0000'),
('1224','21','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1230','21','7.0000'),
('1236','21','7.0000'),
('1242','21','7.0000'),
('1248','21','7.0000'),
('1254','21','7.0000'),
('1260','21','7.0000'),
('1266','21','7.0000'),
('1272','21','7.0000'),
('1278','21','7.0000'),
('1284','21','7.0000'),
('1290','21','7.0000'),
('1296','21','7.0000'),
('1302','21','7.0000'),
('1308','21','7.0000'),
('1314','21','7.0000'),
('1320','21','7.0000'),
('1326','21','7.0000'),
('1332','21','7.0000'),
('1338','21','7.0000'),
('1344','21','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1350','21','7.0000'),
('1356','21','7.0000'),
('1362','21','7.0000'),
('1368','21','7.0000'),
('1374','21','7.0000'),
('1380','21','7.0000'),
('1386','21','7.0000'),
('1392','21','7.0000'),
('1398','21','7.0000'),
('1404','21','7.0000'),
('1410','21','7.0000'),
('1416','21','7.0000'),
('1422','21','7.0000'),
('1428','21','7.0000'),
('1434','21','7.0000'),
('1440','21','7.0000'),
('1446','21','7.0000'),
('1452','21','7.0000'),
('1458','21','7.0000'),
('1464','21','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1470','21','7.0000'),
('1476','21','7.0000'),
('1482','21','7.0000'),
('1488','21','7.0000'),
('1494','21','7.0000'),
('1500','21','7.0000'),
('1506','21','7.0000'),
('1512','21','7.0000'),
('1518','21','7.0000'),
('1524','21','7.0000'),
('1530','21','7.0000'),
('1536','21','7.0000'),
('1542','21','7.0000'),
('1548','21','7.0000'),
('1554','21','7.0000'),
('1560','21','7.0000'),
('1566','21','7.0000'),
('1572','21','7.0000'),
('1578','21','7.0000'),
('1584','21','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1590','21','7.0000'),
('1596','21','7.0000'),
('1602','21','7.0000'),
('1608','21','7.0000'),
('1614','21','7.0000'),
('1620','21','7.0000'),
('1626','21','7.0000'),
('1632','21','7.0000'),
('1638','21','7.0000'),
('1644','21','7.0000'),
('1650','21','7.0000'),
('1656','21','7.0000'),
('1662','21','7.0000'),
('1668','21','7.0000'),
('1674','21','7.0000'),
('1680','21','7.0000'),
('1686','21','7.0000'),
('1692','21','7.0000'),
('1698','21','7.0000'),
('1704','21','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1710','21','7.0000'),
('1716','21','7.0000'),
('1722','21','7.0000'),
('1728','21','7.0000'),
('6','22','7.0000'),
('12','22','7.0000'),
('18','22','7.0000'),
('24','22','7.0000'),
('30','22','7.0000'),
('36','22','7.0000'),
('42','22','7.0000'),
('48','22','7.0000'),
('54','22','7.0000'),
('60','22','7.0000'),
('66','22','7.0000'),
('72','22','7.0000'),
('78','22','7.0000'),
('84','22','7.0000'),
('90','22','7.0000'),
('96','22','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('102','22','7.0000'),
('108','22','7.0000'),
('114','22','7.0000'),
('120','22','7.0000'),
('126','22','7.0000'),
('132','22','7.0000'),
('138','22','7.0000'),
('144','22','7.0000'),
('150','22','7.0000'),
('156','22','7.0000'),
('162','22','7.0000'),
('168','22','7.0000'),
('174','22','7.0000'),
('180','22','7.0000'),
('186','22','7.0000'),
('192','22','7.0000'),
('198','22','7.0000'),
('204','22','7.0000'),
('210','22','7.0000'),
('216','22','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('222','22','7.0000'),
('228','22','7.0000'),
('234','22','7.0000'),
('240','22','7.0000'),
('246','22','7.0000'),
('252','22','7.0000'),
('258','22','7.0000'),
('264','22','7.0000'),
('270','22','7.0000'),
('276','22','7.0000'),
('282','22','7.0000'),
('288','22','7.0000'),
('294','22','7.0000'),
('300','22','7.0000'),
('306','22','7.0000'),
('312','22','7.0000'),
('318','22','7.0000'),
('324','22','7.0000'),
('330','22','7.0000'),
('336','22','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('342','22','7.0000'),
('348','22','7.0000'),
('354','22','7.0000'),
('360','22','7.0000'),
('366','22','7.0000'),
('372','22','7.0000'),
('378','22','7.0000'),
('384','22','7.0000'),
('390','22','7.0000'),
('396','22','7.0000'),
('402','22','7.0000'),
('408','22','7.0000'),
('414','22','7.0000'),
('420','22','7.0000'),
('426','22','7.0000'),
('432','22','7.0000'),
('438','22','7.0000'),
('444','22','7.0000'),
('450','22','7.0000'),
('456','22','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('462','22','7.0000'),
('468','22','7.0000'),
('474','22','7.0000'),
('480','22','7.0000'),
('486','22','7.0000'),
('492','22','7.0000'),
('498','22','7.0000'),
('504','22','7.0000'),
('510','22','7.0000'),
('516','22','7.0000'),
('522','22','7.0000'),
('528','22','7.0000'),
('534','22','7.0000'),
('540','22','7.0000'),
('546','22','7.0000'),
('552','22','7.0000'),
('558','22','7.0000'),
('564','22','7.0000'),
('570','22','7.0000'),
('576','22','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('582','22','7.0000'),
('588','22','7.0000'),
('594','22','7.0000'),
('600','22','7.0000'),
('606','22','7.0000'),
('612','22','7.0000'),
('618','22','7.0000'),
('624','22','7.0000'),
('630','22','7.0000'),
('636','22','7.0000'),
('642','22','7.0000'),
('648','22','7.0000'),
('654','22','7.0000'),
('660','22','7.0000'),
('666','22','7.0000'),
('672','22','7.0000'),
('678','22','7.0000'),
('684','22','7.0000'),
('690','22','7.0000'),
('696','22','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('702','22','7.0000'),
('708','22','7.0000'),
('714','22','7.0000'),
('720','22','7.0000'),
('726','22','7.0000'),
('732','22','7.0000'),
('738','22','7.0000'),
('744','22','7.0000'),
('750','22','7.0000'),
('756','22','7.0000'),
('762','22','7.0000'),
('768','22','7.0000'),
('774','22','7.0000'),
('780','22','7.0000'),
('786','22','7.0000'),
('792','22','7.0000'),
('798','22','7.0000'),
('804','22','7.0000'),
('810','22','7.0000'),
('816','22','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('822','22','7.0000'),
('828','22','7.0000'),
('834','22','7.0000'),
('840','22','7.0000'),
('846','22','7.0000'),
('852','22','7.0000'),
('858','22','7.0000'),
('864','22','7.0000'),
('870','22','7.0000'),
('876','22','7.0000'),
('882','22','7.0000'),
('888','22','7.0000'),
('894','22','7.0000'),
('900','22','7.0000'),
('906','22','7.0000'),
('912','22','7.0000'),
('918','22','7.0000'),
('924','22','7.0000'),
('930','22','7.0000'),
('936','22','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('942','22','7.0000'),
('948','22','7.0000'),
('954','22','7.0000'),
('960','22','7.0000'),
('966','22','7.0000'),
('972','22','7.0000'),
('978','22','7.0000'),
('984','22','7.0000'),
('990','22','7.0000'),
('996','22','7.0000'),
('1002','22','7.0000'),
('1008','22','7.0000'),
('1014','22','7.0000'),
('1020','22','7.0000'),
('1026','22','7.0000'),
('1032','22','7.0000'),
('1038','22','7.0000'),
('1044','22','7.0000'),
('1050','22','7.0000'),
('1056','22','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1062','22','7.0000'),
('1068','22','7.0000'),
('1074','22','7.0000'),
('1080','22','7.0000'),
('1086','22','7.0000'),
('1092','22','7.0000'),
('1098','22','7.0000'),
('1104','22','7.0000'),
('1110','22','7.0000'),
('1116','22','7.0000'),
('1122','22','7.0000'),
('1128','22','7.0000'),
('1134','22','7.0000'),
('1140','22','7.0000'),
('1146','22','7.0000'),
('1152','22','7.0000'),
('1158','22','7.0000'),
('1164','22','7.0000'),
('1170','22','7.0000'),
('1176','22','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1182','22','7.0000'),
('1188','22','7.0000'),
('1194','22','7.0000'),
('1200','22','7.0000'),
('1206','22','7.0000'),
('1212','22','7.0000'),
('1218','22','7.0000'),
('1224','22','7.0000'),
('1230','22','7.0000'),
('1236','22','7.0000'),
('1242','22','7.0000'),
('1248','22','7.0000'),
('1254','22','7.0000'),
('1260','22','7.0000'),
('1266','22','7.0000'),
('1272','22','7.0000'),
('1278','22','7.0000'),
('1284','22','7.0000'),
('1290','22','7.0000'),
('1296','22','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1302','22','7.0000'),
('1308','22','7.0000'),
('1314','22','7.0000'),
('1320','22','7.0000'),
('1326','22','7.0000'),
('1332','22','7.0000'),
('1338','22','7.0000'),
('1344','22','7.0000'),
('1350','22','7.0000'),
('1356','22','7.0000'),
('1362','22','7.0000'),
('1368','22','7.0000'),
('1374','22','7.0000'),
('1380','22','7.0000'),
('1386','22','7.0000'),
('1392','22','7.0000'),
('1398','22','7.0000'),
('1404','22','7.0000'),
('1410','22','7.0000'),
('1416','22','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1422','22','7.0000'),
('1428','22','7.0000'),
('1434','22','7.0000'),
('1440','22','7.0000'),
('1446','22','7.0000'),
('1452','22','7.0000'),
('1458','22','7.0000'),
('1464','22','7.0000'),
('1470','22','7.0000'),
('1476','22','7.0000'),
('1482','22','7.0000'),
('1488','22','7.0000'),
('1494','22','7.0000'),
('1500','22','7.0000'),
('1506','22','7.0000'),
('1512','22','7.0000'),
('1518','22','7.0000'),
('1524','22','7.0000'),
('1530','22','7.0000'),
('1536','22','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1542','22','7.0000'),
('1548','22','7.0000'),
('1554','22','7.0000'),
('1560','22','7.0000'),
('1566','22','7.0000'),
('1572','22','7.0000'),
('1578','22','7.0000'),
('1584','22','7.0000'),
('1590','22','7.0000'),
('1596','22','7.0000'),
('1602','22','7.0000'),
('1608','22','7.0000'),
('1614','22','7.0000'),
('1620','22','7.0000'),
('1626','22','7.0000'),
('1632','22','7.0000'),
('1638','22','7.0000'),
('1644','22','7.0000'),
('1650','22','7.0000'),
('1656','22','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1662','22','7.0000'),
('1668','22','7.0000'),
('1674','22','7.0000'),
('1680','22','7.0000'),
('1686','22','7.0000'),
('1692','22','7.0000'),
('1698','22','7.0000'),
('1704','22','7.0000'),
('1710','22','7.0000'),
('1716','22','7.0000'),
('1722','22','7.0000'),
('1728','22','7.0000'),
('6','23','7.0000'),
('12','23','7.0000'),
('18','23','7.0000'),
('24','23','7.0000'),
('30','23','7.0000'),
('36','23','7.0000'),
('42','23','7.0000'),
('48','23','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('54','23','7.0000'),
('60','23','7.0000'),
('66','23','7.0000'),
('72','23','7.0000'),
('78','23','7.0000'),
('84','23','7.0000'),
('90','23','7.0000'),
('96','23','7.0000'),
('102','23','7.0000'),
('108','23','7.0000'),
('114','23','7.0000'),
('120','23','7.0000'),
('126','23','7.0000'),
('132','23','7.0000'),
('138','23','7.0000'),
('144','23','7.0000'),
('150','23','7.0000'),
('156','23','7.0000'),
('162','23','7.0000'),
('168','23','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('174','23','7.0000'),
('180','23','7.0000'),
('186','23','7.0000'),
('192','23','7.0000'),
('198','23','7.0000'),
('204','23','7.0000'),
('210','23','7.0000'),
('216','23','7.0000'),
('222','23','7.0000'),
('228','23','7.0000'),
('234','23','7.0000'),
('240','23','7.0000'),
('246','23','7.0000'),
('252','23','7.0000'),
('258','23','7.0000'),
('264','23','7.0000'),
('270','23','7.0000'),
('276','23','7.0000'),
('282','23','7.0000'),
('288','23','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('294','23','7.0000'),
('300','23','7.0000'),
('306','23','7.0000'),
('312','23','7.0000'),
('318','23','7.0000'),
('324','23','7.0000'),
('330','23','7.0000'),
('336','23','7.0000'),
('342','23','7.0000'),
('348','23','7.0000'),
('354','23','7.0000'),
('360','23','7.0000'),
('366','23','7.0000'),
('372','23','7.0000'),
('378','23','7.0000'),
('384','23','7.0000'),
('390','23','7.0000'),
('396','23','7.0000'),
('402','23','7.0000'),
('408','23','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('414','23','7.0000'),
('420','23','7.0000'),
('426','23','7.0000'),
('432','23','7.0000'),
('438','23','7.0000'),
('444','23','7.0000'),
('450','23','7.0000'),
('456','23','7.0000'),
('462','23','7.0000'),
('468','23','7.0000'),
('474','23','7.0000'),
('480','23','7.0000'),
('486','23','7.0000'),
('492','23','7.0000'),
('498','23','7.0000'),
('504','23','7.0000'),
('510','23','7.0000'),
('516','23','7.0000'),
('522','23','7.0000'),
('528','23','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('534','23','7.0000'),
('540','23','7.0000'),
('546','23','7.0000'),
('552','23','7.0000'),
('558','23','7.0000'),
('564','23','7.0000'),
('570','23','7.0000'),
('576','23','7.0000'),
('582','23','7.0000'),
('588','23','7.0000'),
('594','23','7.0000'),
('600','23','7.0000'),
('606','23','7.0000'),
('612','23','7.0000'),
('618','23','7.0000'),
('624','23','7.0000'),
('630','23','7.0000'),
('636','23','7.0000'),
('642','23','7.0000'),
('648','23','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('654','23','7.0000'),
('660','23','7.0000'),
('666','23','7.0000'),
('672','23','7.0000'),
('678','23','7.0000'),
('684','23','7.0000'),
('690','23','7.0000'),
('696','23','7.0000'),
('702','23','7.0000'),
('708','23','7.0000'),
('714','23','7.0000'),
('720','23','7.0000'),
('726','23','7.0000'),
('732','23','7.0000'),
('738','23','7.0000'),
('744','23','7.0000'),
('750','23','7.0000'),
('756','23','7.0000'),
('762','23','7.0000'),
('768','23','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('774','23','7.0000'),
('780','23','7.0000'),
('786','23','7.0000'),
('792','23','7.0000'),
('798','23','7.0000'),
('804','23','7.0000'),
('810','23','7.0000'),
('816','23','7.0000'),
('822','23','7.0000'),
('828','23','7.0000'),
('834','23','7.0000'),
('840','23','7.0000'),
('846','23','7.0000'),
('852','23','7.0000'),
('858','23','7.0000'),
('864','23','7.0000'),
('870','23','7.0000'),
('876','23','7.0000'),
('882','23','7.0000'),
('888','23','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('894','23','7.0000'),
('900','23','7.0000'),
('906','23','7.0000'),
('912','23','7.0000'),
('918','23','7.0000'),
('924','23','7.0000'),
('930','23','7.0000'),
('936','23','7.0000'),
('942','23','7.0000'),
('948','23','7.0000'),
('954','23','7.0000'),
('960','23','7.0000'),
('966','23','7.0000'),
('972','23','7.0000'),
('978','23','7.0000'),
('984','23','7.0000'),
('990','23','7.0000'),
('996','23','7.0000'),
('1002','23','7.0000'),
('1008','23','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1014','23','7.0000'),
('1020','23','7.0000'),
('1026','23','7.0000'),
('1032','23','7.0000'),
('1038','23','7.0000'),
('1044','23','7.0000'),
('1050','23','7.0000'),
('1056','23','7.0000'),
('1062','23','7.0000'),
('1068','23','7.0000'),
('1074','23','7.0000'),
('1080','23','7.0000'),
('1086','23','7.0000'),
('1092','23','7.0000'),
('1098','23','7.0000'),
('1104','23','7.0000'),
('1110','23','7.0000'),
('1116','23','7.0000'),
('1122','23','7.0000'),
('1128','23','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1134','23','7.0000'),
('1140','23','7.0000'),
('1146','23','7.0000'),
('1152','23','7.0000'),
('1158','23','7.0000'),
('1164','23','7.0000'),
('1170','23','7.0000'),
('1176','23','7.0000'),
('1182','23','7.0000'),
('1188','23','7.0000'),
('1194','23','7.0000'),
('1200','23','7.0000'),
('1206','23','7.0000'),
('1212','23','7.0000'),
('1218','23','7.0000'),
('1224','23','7.0000'),
('1230','23','7.0000'),
('1236','23','7.0000'),
('1242','23','7.0000'),
('1248','23','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1254','23','7.0000'),
('1260','23','7.0000'),
('1266','23','7.0000'),
('1272','23','7.0000'),
('1278','23','7.0000'),
('1284','23','7.0000'),
('1290','23','7.0000'),
('1296','23','7.0000'),
('1302','23','7.0000'),
('1308','23','7.0000'),
('1314','23','7.0000'),
('1320','23','7.0000'),
('1326','23','7.0000'),
('1332','23','7.0000'),
('1338','23','7.0000'),
('1344','23','7.0000'),
('1350','23','7.0000'),
('1356','23','7.0000'),
('1362','23','7.0000'),
('1368','23','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1374','23','7.0000'),
('1380','23','7.0000'),
('1386','23','7.0000'),
('1392','23','7.0000'),
('1398','23','7.0000'),
('1404','23','7.0000'),
('1410','23','7.0000'),
('1416','23','7.0000'),
('1422','23','7.0000'),
('1428','23','7.0000'),
('1434','23','7.0000'),
('1440','23','7.0000'),
('1446','23','7.0000'),
('1452','23','7.0000'),
('1458','23','7.0000'),
('1464','23','7.0000'),
('1470','23','7.0000'),
('1476','23','7.0000'),
('1482','23','7.0000'),
('1488','23','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1494','23','7.0000'),
('1500','23','7.0000'),
('1506','23','7.0000'),
('1512','23','7.0000'),
('1518','23','7.0000'),
('1524','23','7.0000'),
('1530','23','7.0000'),
('1536','23','7.0000'),
('1542','23','7.0000'),
('1548','23','7.0000'),
('1554','23','7.0000'),
('1560','23','7.0000'),
('1566','23','7.0000'),
('1572','23','7.0000'),
('1578','23','7.0000'),
('1584','23','7.0000'),
('1590','23','7.0000'),
('1596','23','7.0000'),
('1602','23','7.0000'),
('1608','23','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1614','23','7.0000'),
('1620','23','7.0000'),
('1626','23','7.0000'),
('1632','23','7.0000'),
('1638','23','7.0000'),
('1644','23','7.0000'),
('1650','23','7.0000'),
('1656','23','7.0000'),
('1662','23','7.0000'),
('1668','23','7.0000'),
('1674','23','7.0000'),
('1680','23','7.0000'),
('1686','23','7.0000'),
('1692','23','7.0000'),
('1698','23','7.0000'),
('1704','23','7.0000'),
('1710','23','7.0000'),
('1716','23','7.0000'),
('1722','23','7.0000'),
('1728','23','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('6','24','7.0000'),
('12','24','7.0000'),
('18','24','7.0000'),
('24','24','7.0000'),
('30','24','7.0000'),
('36','24','7.0000'),
('42','24','7.0000'),
('48','24','7.0000'),
('54','24','7.0000'),
('60','24','7.0000'),
('66','24','7.0000'),
('72','24','7.0000'),
('78','24','7.0000'),
('84','24','7.0000'),
('90','24','7.0000'),
('96','24','7.0000'),
('102','24','7.0000'),
('108','24','7.0000'),
('114','24','7.0000'),
('120','24','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('126','24','7.0000'),
('132','24','7.0000'),
('138','24','7.0000'),
('144','24','7.0000'),
('150','24','7.0000'),
('156','24','7.0000'),
('162','24','7.0000'),
('168','24','7.0000'),
('174','24','7.0000'),
('180','24','7.0000'),
('186','24','7.0000'),
('192','24','7.0000'),
('198','24','7.0000'),
('204','24','7.0000'),
('210','24','7.0000'),
('216','24','7.0000'),
('222','24','7.0000'),
('228','24','7.0000'),
('234','24','7.0000'),
('240','24','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('246','24','7.0000'),
('252','24','7.0000'),
('258','24','7.0000'),
('264','24','7.0000'),
('270','24','7.0000'),
('276','24','7.0000'),
('282','24','7.0000'),
('288','24','7.0000'),
('294','24','7.0000'),
('300','24','7.0000'),
('306','24','7.0000'),
('312','24','7.0000'),
('318','24','7.0000'),
('324','24','7.0000'),
('330','24','7.0000'),
('336','24','7.0000'),
('342','24','7.0000'),
('348','24','7.0000'),
('354','24','7.0000'),
('360','24','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('366','24','7.0000'),
('372','24','7.0000'),
('378','24','7.0000'),
('384','24','7.0000'),
('390','24','7.0000'),
('396','24','7.0000'),
('402','24','7.0000'),
('408','24','7.0000'),
('414','24','7.0000'),
('420','24','7.0000'),
('426','24','7.0000'),
('432','24','7.0000'),
('438','24','7.0000'),
('444','24','7.0000'),
('450','24','7.0000'),
('456','24','7.0000'),
('462','24','7.0000'),
('468','24','7.0000'),
('474','24','7.0000'),
('480','24','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('486','24','7.0000'),
('492','24','7.0000'),
('498','24','7.0000'),
('504','24','7.0000'),
('510','24','7.0000'),
('516','24','7.0000'),
('522','24','7.0000'),
('528','24','7.0000'),
('534','24','7.0000'),
('540','24','7.0000'),
('546','24','7.0000'),
('552','24','7.0000'),
('558','24','7.0000'),
('564','24','7.0000'),
('570','24','7.0000'),
('576','24','7.0000'),
('582','24','7.0000'),
('588','24','7.0000'),
('594','24','7.0000'),
('600','24','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('606','24','7.0000'),
('612','24','7.0000'),
('618','24','7.0000'),
('624','24','7.0000'),
('630','24','7.0000'),
('636','24','7.0000'),
('642','24','7.0000'),
('648','24','7.0000'),
('654','24','7.0000'),
('660','24','7.0000'),
('666','24','7.0000'),
('672','24','7.0000'),
('678','24','7.0000'),
('684','24','7.0000'),
('690','24','7.0000'),
('696','24','7.0000'),
('702','24','7.0000'),
('708','24','7.0000'),
('714','24','7.0000'),
('720','24','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('726','24','7.0000'),
('732','24','7.0000'),
('738','24','7.0000'),
('744','24','7.0000'),
('750','24','7.0000'),
('756','24','7.0000'),
('762','24','7.0000'),
('768','24','7.0000'),
('774','24','7.0000'),
('780','24','7.0000'),
('786','24','7.0000'),
('792','24','7.0000'),
('798','24','7.0000'),
('804','24','7.0000'),
('810','24','7.0000'),
('816','24','7.0000'),
('822','24','7.0000'),
('828','24','7.0000'),
('834','24','7.0000'),
('840','24','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('846','24','7.0000'),
('852','24','7.0000'),
('858','24','7.0000'),
('864','24','7.0000'),
('870','24','7.0000'),
('876','24','7.0000'),
('882','24','7.0000'),
('888','24','7.0000'),
('894','24','7.0000'),
('900','24','7.0000'),
('906','24','7.0000'),
('912','24','7.0000'),
('918','24','7.0000'),
('924','24','7.0000'),
('930','24','7.0000'),
('936','24','7.0000'),
('942','24','7.0000'),
('948','24','7.0000'),
('954','24','7.0000'),
('960','24','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('966','24','7.0000'),
('972','24','7.0000'),
('978','24','7.0000'),
('984','24','7.0000'),
('990','24','7.0000'),
('996','24','7.0000'),
('1002','24','7.0000'),
('1008','24','7.0000'),
('1014','24','7.0000'),
('1020','24','7.0000'),
('1026','24','7.0000'),
('1032','24','7.0000'),
('1038','24','7.0000'),
('1044','24','7.0000'),
('1050','24','7.0000'),
('1056','24','7.0000'),
('1062','24','7.0000'),
('1068','24','7.0000'),
('1074','24','7.0000'),
('1080','24','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1086','24','7.0000'),
('1092','24','7.0000'),
('1098','24','7.0000'),
('1104','24','7.0000'),
('1110','24','7.0000'),
('1116','24','7.0000'),
('1122','24','7.0000'),
('1128','24','7.0000'),
('1134','24','7.0000'),
('1140','24','7.0000'),
('1146','24','7.0000'),
('1152','24','7.0000'),
('1158','24','7.0000'),
('1164','24','7.0000'),
('1170','24','7.0000'),
('1176','24','7.0000'),
('1182','24','7.0000'),
('1188','24','7.0000'),
('1194','24','7.0000'),
('1200','24','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1206','24','7.0000'),
('1212','24','7.0000'),
('1218','24','7.0000'),
('1224','24','7.0000'),
('1230','24','7.0000'),
('1236','24','7.0000'),
('1242','24','7.0000'),
('1248','24','7.0000'),
('1254','24','7.0000'),
('1260','24','7.0000'),
('1266','24','7.0000'),
('1272','24','7.0000'),
('1278','24','7.0000'),
('1284','24','7.0000'),
('1290','24','7.0000'),
('1296','24','7.0000'),
('1302','24','7.0000'),
('1308','24','7.0000'),
('1314','24','7.0000'),
('1320','24','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1326','24','7.0000'),
('1332','24','7.0000'),
('1338','24','7.0000'),
('1344','24','7.0000'),
('1350','24','7.0000'),
('1356','24','7.0000'),
('1362','24','7.0000'),
('1368','24','7.0000'),
('1374','24','7.0000'),
('1380','24','7.0000'),
('1386','24','7.0000'),
('1392','24','7.0000'),
('1398','24','7.0000'),
('1404','24','7.0000'),
('1410','24','7.0000'),
('1416','24','7.0000'),
('1422','24','7.0000'),
('1428','24','7.0000'),
('1434','24','7.0000'),
('1440','24','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1446','24','7.0000'),
('1452','24','7.0000'),
('1458','24','7.0000'),
('1464','24','7.0000'),
('1470','24','7.0000'),
('1476','24','7.0000'),
('1482','24','7.0000'),
('1488','24','7.0000'),
('1494','24','7.0000'),
('1500','24','7.0000'),
('1506','24','7.0000'),
('1512','24','7.0000'),
('1518','24','7.0000'),
('1524','24','7.0000'),
('1530','24','7.0000'),
('1536','24','7.0000'),
('1542','24','7.0000'),
('1548','24','7.0000'),
('1554','24','7.0000'),
('1560','24','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1566','24','7.0000'),
('1572','24','7.0000'),
('1578','24','7.0000'),
('1584','24','7.0000'),
('1590','24','7.0000'),
('1596','24','7.0000'),
('1602','24','7.0000'),
('1608','24','7.0000'),
('1614','24','7.0000'),
('1620','24','7.0000'),
('1626','24','7.0000'),
('1632','24','7.0000'),
('1638','24','7.0000'),
('1644','24','7.0000'),
('1650','24','7.0000'),
('1656','24','7.0000'),
('1662','24','7.0000'),
('1668','24','7.0000'),
('1674','24','7.0000'),
('1680','24','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1686','24','7.0000'),
('1692','24','7.0000'),
('1698','24','7.0000'),
('1704','24','7.0000'),
('1710','24','7.0000'),
('1716','24','7.0000'),
('1722','24','7.0000'),
('1728','24','7.0000'),
('6','25','7.0000'),
('12','25','7.0000'),
('18','25','7.0000'),
('24','25','7.0000'),
('30','25','7.0000'),
('36','25','7.0000'),
('42','25','7.0000'),
('48','25','7.0000'),
('54','25','7.0000'),
('60','25','7.0000'),
('66','25','7.0000'),
('72','25','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('78','25','7.0000'),
('84','25','7.0000'),
('90','25','7.0000'),
('96','25','7.0000'),
('102','25','7.0000'),
('108','25','7.0000'),
('114','25','7.0000'),
('120','25','7.0000'),
('126','25','7.0000'),
('132','25','7.0000'),
('138','25','7.0000'),
('144','25','7.0000'),
('150','25','7.0000'),
('156','25','7.0000'),
('162','25','7.0000'),
('168','25','7.0000'),
('174','25','7.0000'),
('180','25','7.0000'),
('186','25','7.0000'),
('192','25','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('198','25','7.0000'),
('204','25','7.0000'),
('210','25','7.0000'),
('216','25','7.0000'),
('222','25','7.0000'),
('228','25','7.0000'),
('234','25','7.0000'),
('240','25','7.0000'),
('246','25','7.0000'),
('252','25','7.0000'),
('258','25','7.0000'),
('264','25','7.0000'),
('270','25','7.0000'),
('276','25','7.0000'),
('282','25','7.0000'),
('288','25','7.0000'),
('294','25','7.0000'),
('300','25','7.0000'),
('306','25','7.0000'),
('312','25','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('318','25','7.0000'),
('324','25','7.0000'),
('330','25','7.0000'),
('336','25','7.0000'),
('342','25','7.0000'),
('348','25','7.0000'),
('354','25','7.0000'),
('360','25','7.0000'),
('366','25','7.0000'),
('372','25','7.0000'),
('378','25','7.0000'),
('384','25','7.0000'),
('390','25','7.0000'),
('396','25','7.0000'),
('402','25','7.0000'),
('408','25','7.0000'),
('414','25','7.0000'),
('420','25','7.0000'),
('426','25','7.0000'),
('432','25','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('438','25','7.0000'),
('444','25','7.0000'),
('450','25','7.0000'),
('456','25','7.0000'),
('462','25','7.0000'),
('468','25','7.0000'),
('474','25','7.0000'),
('480','25','7.0000'),
('486','25','7.0000'),
('492','25','7.0000'),
('498','25','7.0000'),
('504','25','7.0000'),
('510','25','7.0000'),
('516','25','7.0000'),
('522','25','7.0000'),
('528','25','7.0000'),
('534','25','7.0000'),
('540','25','7.0000'),
('546','25','7.0000'),
('552','25','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('558','25','7.0000'),
('564','25','7.0000'),
('570','25','7.0000'),
('576','25','7.0000'),
('582','25','7.0000'),
('588','25','7.0000'),
('594','25','7.0000'),
('600','25','7.0000'),
('606','25','7.0000'),
('612','25','7.0000'),
('618','25','7.0000'),
('624','25','7.0000'),
('630','25','7.0000'),
('636','25','7.0000'),
('642','25','7.0000'),
('648','25','7.0000'),
('654','25','7.0000'),
('660','25','7.0000'),
('666','25','7.0000'),
('672','25','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('678','25','7.0000'),
('684','25','7.0000'),
('690','25','7.0000'),
('696','25','7.0000'),
('702','25','7.0000'),
('708','25','7.0000'),
('714','25','7.0000'),
('720','25','7.0000'),
('726','25','7.0000'),
('732','25','7.0000'),
('738','25','7.0000'),
('744','25','7.0000'),
('750','25','7.0000'),
('756','25','7.0000'),
('762','25','7.0000'),
('768','25','7.0000'),
('774','25','7.0000'),
('780','25','7.0000'),
('786','25','7.0000'),
('792','25','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('798','25','7.0000'),
('804','25','7.0000'),
('810','25','7.0000'),
('816','25','7.0000'),
('822','25','7.0000'),
('828','25','7.0000'),
('834','25','7.0000'),
('840','25','7.0000'),
('846','25','7.0000'),
('852','25','7.0000'),
('858','25','7.0000'),
('864','25','7.0000'),
('870','25','7.0000'),
('876','25','7.0000'),
('882','25','7.0000'),
('888','25','7.0000'),
('894','25','7.0000'),
('900','25','7.0000'),
('906','25','7.0000'),
('912','25','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('918','25','7.0000'),
('924','25','7.0000'),
('930','25','7.0000'),
('936','25','7.0000'),
('942','25','7.0000'),
('948','25','7.0000'),
('954','25','7.0000'),
('960','25','7.0000'),
('966','25','7.0000'),
('972','25','7.0000'),
('978','25','7.0000'),
('984','25','7.0000'),
('990','25','7.0000'),
('996','25','7.0000'),
('1002','25','7.0000'),
('1008','25','7.0000'),
('1014','25','7.0000'),
('1020','25','7.0000'),
('1026','25','7.0000'),
('1032','25','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1038','25','7.0000'),
('1044','25','7.0000'),
('1050','25','7.0000'),
('1056','25','7.0000'),
('1062','25','7.0000'),
('1068','25','7.0000'),
('1074','25','7.0000'),
('1080','25','7.0000'),
('1086','25','7.0000'),
('1092','25','7.0000'),
('1098','25','7.0000'),
('1104','25','7.0000'),
('1110','25','7.0000'),
('1116','25','7.0000'),
('1122','25','7.0000'),
('1128','25','7.0000'),
('1134','25','7.0000'),
('1140','25','7.0000'),
('1146','25','7.0000'),
('1152','25','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1158','25','7.0000'),
('1164','25','7.0000'),
('1170','25','7.0000'),
('1176','25','7.0000'),
('1182','25','7.0000'),
('1188','25','7.0000'),
('1194','25','7.0000'),
('1200','25','7.0000'),
('1206','25','7.0000'),
('1212','25','7.0000'),
('1218','25','7.0000'),
('1224','25','7.0000'),
('1230','25','7.0000'),
('1236','25','7.0000'),
('1242','25','7.0000'),
('1248','25','7.0000'),
('1254','25','7.0000'),
('1260','25','7.0000'),
('1266','25','7.0000'),
('1272','25','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1278','25','7.0000'),
('1284','25','7.0000'),
('1290','25','7.0000'),
('1296','25','7.0000'),
('1302','25','7.0000'),
('1308','25','7.0000'),
('1314','25','7.0000'),
('1320','25','7.0000'),
('1326','25','7.0000'),
('1332','25','7.0000'),
('1338','25','7.0000'),
('1344','25','7.0000'),
('1350','25','7.0000'),
('1356','25','7.0000'),
('1362','25','7.0000'),
('1368','25','7.0000'),
('1374','25','7.0000'),
('1380','25','7.0000'),
('1386','25','7.0000'),
('1392','25','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1398','25','7.0000'),
('1404','25','7.0000'),
('1410','25','7.0000'),
('1416','25','7.0000'),
('1422','25','7.0000'),
('1428','25','7.0000'),
('1434','25','7.0000'),
('1440','25','7.0000'),
('1446','25','7.0000'),
('1452','25','7.0000'),
('1458','25','7.0000'),
('1464','25','7.0000'),
('1470','25','7.0000'),
('1476','25','7.0000'),
('1482','25','7.0000'),
('1488','25','7.0000'),
('1494','25','7.0000'),
('1500','25','7.0000'),
('1506','25','7.0000'),
('1512','25','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1518','25','7.0000'),
('1524','25','7.0000'),
('1530','25','7.0000'),
('1536','25','7.0000'),
('1542','25','7.0000'),
('1548','25','7.0000'),
('1554','25','7.0000'),
('1560','25','7.0000'),
('1566','25','7.0000'),
('1572','25','7.0000'),
('1578','25','7.0000'),
('1584','25','7.0000'),
('1590','25','7.0000'),
('1596','25','7.0000'),
('1602','25','7.0000'),
('1608','25','7.0000'),
('1614','25','7.0000'),
('1620','25','7.0000'),
('1626','25','7.0000'),
('1632','25','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1638','25','7.0000'),
('1644','25','7.0000'),
('1650','25','7.0000'),
('1656','25','7.0000'),
('1662','25','7.0000'),
('1668','25','7.0000'),
('1674','25','7.0000'),
('1680','25','7.0000'),
('1686','25','7.0000'),
('1692','25','7.0000'),
('1698','25','7.0000'),
('1704','25','7.0000'),
('1710','25','7.0000'),
('1716','25','7.0000'),
('1722','25','7.0000'),
('1728','25','7.0000'),
('6','26','7.0000'),
('12','26','7.0000'),
('18','26','7.0000'),
('24','26','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('30','26','7.0000'),
('36','26','7.0000'),
('42','26','7.0000'),
('48','26','7.0000'),
('54','26','7.0000'),
('60','26','7.0000'),
('66','26','7.0000'),
('72','26','7.0000'),
('78','26','7.0000'),
('84','26','7.0000'),
('90','26','7.0000'),
('96','26','7.0000'),
('102','26','7.0000'),
('108','26','7.0000'),
('114','26','7.0000'),
('120','26','7.0000'),
('126','26','7.0000'),
('132','26','7.0000'),
('138','26','7.0000'),
('144','26','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('150','26','7.0000'),
('156','26','7.0000'),
('162','26','7.0000'),
('168','26','7.0000'),
('174','26','7.0000'),
('180','26','7.0000'),
('186','26','7.0000'),
('192','26','7.0000'),
('198','26','7.0000'),
('204','26','7.0000'),
('210','26','7.0000'),
('216','26','7.0000'),
('222','26','7.0000'),
('228','26','7.0000'),
('234','26','7.0000'),
('240','26','7.0000'),
('246','26','7.0000'),
('252','26','7.0000'),
('258','26','7.0000'),
('264','26','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('270','26','7.0000'),
('276','26','7.0000'),
('282','26','7.0000'),
('288','26','7.0000'),
('294','26','7.0000'),
('300','26','7.0000'),
('306','26','7.0000'),
('312','26','7.0000'),
('318','26','7.0000'),
('324','26','7.0000'),
('330','26','7.0000'),
('336','26','7.0000'),
('342','26','7.0000'),
('348','26','7.0000'),
('354','26','7.0000'),
('360','26','7.0000'),
('366','26','7.0000'),
('372','26','7.0000'),
('378','26','7.0000'),
('384','26','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('390','26','7.0000'),
('396','26','7.0000'),
('402','26','7.0000'),
('408','26','7.0000'),
('414','26','7.0000'),
('420','26','7.0000'),
('426','26','7.0000'),
('432','26','7.0000'),
('438','26','7.0000'),
('444','26','7.0000'),
('450','26','7.0000'),
('456','26','7.0000'),
('462','26','7.0000'),
('468','26','7.0000'),
('474','26','7.0000'),
('480','26','7.0000'),
('486','26','7.0000'),
('492','26','7.0000'),
('498','26','7.0000'),
('504','26','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('510','26','7.0000'),
('516','26','7.0000'),
('522','26','7.0000'),
('528','26','7.0000'),
('534','26','7.0000'),
('540','26','7.0000'),
('546','26','7.0000'),
('552','26','7.0000'),
('558','26','7.0000'),
('564','26','7.0000'),
('570','26','7.0000'),
('576','26','7.0000'),
('582','26','7.0000'),
('588','26','7.0000'),
('594','26','7.0000'),
('600','26','7.0000'),
('606','26','7.0000'),
('612','26','7.0000'),
('618','26','7.0000'),
('624','26','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('630','26','7.0000'),
('636','26','7.0000'),
('642','26','7.0000'),
('648','26','7.0000'),
('654','26','7.0000'),
('660','26','7.0000'),
('666','26','7.0000'),
('672','26','7.0000'),
('678','26','7.0000'),
('684','26','7.0000'),
('690','26','7.0000'),
('696','26','7.0000'),
('702','26','7.0000'),
('708','26','7.0000'),
('714','26','7.0000'),
('720','26','7.0000'),
('726','26','7.0000'),
('732','26','7.0000'),
('738','26','7.0000'),
('744','26','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('750','26','7.0000'),
('756','26','7.0000'),
('762','26','7.0000'),
('768','26','7.0000'),
('774','26','7.0000'),
('780','26','7.0000'),
('786','26','7.0000'),
('792','26','7.0000'),
('798','26','7.0000'),
('804','26','7.0000'),
('810','26','7.0000'),
('816','26','7.0000'),
('822','26','7.0000'),
('828','26','7.0000'),
('834','26','7.0000'),
('840','26','7.0000'),
('846','26','7.0000'),
('852','26','7.0000'),
('858','26','7.0000'),
('864','26','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('870','26','7.0000'),
('876','26','7.0000'),
('882','26','7.0000'),
('888','26','7.0000'),
('894','26','7.0000'),
('900','26','7.0000'),
('906','26','7.0000'),
('912','26','7.0000'),
('918','26','7.0000'),
('924','26','7.0000'),
('930','26','7.0000'),
('936','26','7.0000'),
('942','26','7.0000'),
('948','26','7.0000'),
('954','26','7.0000'),
('960','26','7.0000'),
('966','26','7.0000'),
('972','26','7.0000'),
('978','26','7.0000'),
('984','26','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('990','26','7.0000'),
('996','26','7.0000'),
('1002','26','7.0000'),
('1008','26','7.0000'),
('1014','26','7.0000'),
('1020','26','7.0000'),
('1026','26','7.0000'),
('1032','26','7.0000'),
('1038','26','7.0000'),
('1044','26','7.0000'),
('1050','26','7.0000'),
('1056','26','7.0000'),
('1062','26','7.0000'),
('1068','26','7.0000'),
('1074','26','7.0000'),
('1080','26','7.0000'),
('1086','26','7.0000'),
('1092','26','7.0000'),
('1098','26','7.0000'),
('1104','26','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1110','26','7.0000'),
('1116','26','7.0000'),
('1122','26','7.0000'),
('1128','26','7.0000'),
('1134','26','7.0000'),
('1140','26','7.0000'),
('1146','26','7.0000'),
('1152','26','7.0000'),
('1158','26','7.0000'),
('1164','26','7.0000'),
('1170','26','7.0000'),
('1176','26','7.0000'),
('1182','26','7.0000'),
('1188','26','7.0000'),
('1194','26','7.0000'),
('1200','26','7.0000'),
('1206','26','7.0000'),
('1212','26','7.0000'),
('1218','26','7.0000'),
('1224','26','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1230','26','7.0000'),
('1236','26','7.0000'),
('1242','26','7.0000'),
('1248','26','7.0000'),
('1254','26','7.0000'),
('1260','26','7.0000'),
('1266','26','7.0000'),
('1272','26','7.0000'),
('1278','26','7.0000'),
('1284','26','7.0000'),
('1290','26','7.0000'),
('1296','26','7.0000'),
('1302','26','7.0000'),
('1308','26','7.0000'),
('1314','26','7.0000'),
('1320','26','7.0000'),
('1326','26','7.0000'),
('1332','26','7.0000'),
('1338','26','7.0000'),
('1344','26','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1350','26','7.0000'),
('1356','26','7.0000'),
('1362','26','7.0000'),
('1368','26','7.0000'),
('1374','26','7.0000'),
('1380','26','7.0000'),
('1386','26','7.0000'),
('1392','26','7.0000'),
('1398','26','7.0000'),
('1404','26','7.0000'),
('1410','26','7.0000'),
('1416','26','7.0000'),
('1422','26','7.0000'),
('1428','26','7.0000'),
('1434','26','7.0000'),
('1440','26','7.0000'),
('1446','26','7.0000'),
('1452','26','7.0000'),
('1458','26','7.0000'),
('1464','26','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1470','26','7.0000'),
('1476','26','7.0000'),
('1482','26','7.0000'),
('1488','26','7.0000'),
('1494','26','7.0000'),
('1500','26','7.0000'),
('1506','26','7.0000'),
('1512','26','7.0000'),
('1518','26','7.0000'),
('1524','26','7.0000'),
('1530','26','7.0000'),
('1536','26','7.0000'),
('1542','26','7.0000'),
('1548','26','7.0000'),
('1554','26','7.0000'),
('1560','26','7.0000'),
('1566','26','7.0000'),
('1572','26','7.0000'),
('1578','26','7.0000'),
('1584','26','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1590','26','7.0000'),
('1596','26','7.0000'),
('1602','26','7.0000'),
('1608','26','7.0000'),
('1614','26','7.0000'),
('1620','26','7.0000'),
('1626','26','7.0000'),
('1632','26','7.0000'),
('1638','26','7.0000'),
('1644','26','7.0000'),
('1650','26','7.0000'),
('1656','26','7.0000'),
('1662','26','7.0000'),
('1668','26','7.0000'),
('1674','26','7.0000'),
('1680','26','7.0000'),
('1686','26','7.0000'),
('1692','26','7.0000'),
('1698','26','7.0000'),
('1704','26','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1710','26','7.0000'),
('1716','26','7.0000'),
('1722','26','7.0000'),
('1728','26','7.0000'),
('6','27','7.0000'),
('12','27','7.0000'),
('18','27','7.0000'),
('24','27','7.0000'),
('30','27','7.0000'),
('36','27','7.0000'),
('42','27','7.0000'),
('48','27','7.0000'),
('54','27','7.0000'),
('60','27','7.0000'),
('66','27','7.0000'),
('72','27','7.0000'),
('78','27','7.0000'),
('84','27','7.0000'),
('90','27','7.0000'),
('96','27','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('102','27','7.0000'),
('108','27','7.0000'),
('114','27','7.0000'),
('120','27','7.0000'),
('126','27','7.0000'),
('132','27','7.0000'),
('138','27','7.0000'),
('144','27','7.0000'),
('150','27','7.0000'),
('156','27','7.0000'),
('162','27','7.0000'),
('168','27','7.0000'),
('174','27','7.0000'),
('180','27','7.0000'),
('186','27','7.0000'),
('192','27','7.0000'),
('198','27','7.0000'),
('204','27','7.0000'),
('210','27','7.0000'),
('216','27','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('222','27','7.0000'),
('228','27','7.0000'),
('234','27','7.0000'),
('240','27','7.0000'),
('246','27','7.0000'),
('252','27','7.0000'),
('258','27','7.0000'),
('264','27','7.0000'),
('270','27','7.0000'),
('276','27','7.0000'),
('282','27','7.0000'),
('288','27','7.0000'),
('294','27','7.0000'),
('300','27','7.0000'),
('306','27','7.0000'),
('312','27','7.0000'),
('318','27','7.0000'),
('324','27','7.0000'),
('330','27','7.0000'),
('336','27','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('342','27','7.0000'),
('348','27','7.0000'),
('354','27','7.0000'),
('360','27','7.0000'),
('366','27','7.0000'),
('372','27','7.0000'),
('378','27','7.0000'),
('384','27','7.0000'),
('390','27','7.0000'),
('396','27','7.0000'),
('402','27','7.0000'),
('408','27','7.0000'),
('414','27','7.0000'),
('420','27','7.0000'),
('426','27','7.0000'),
('432','27','7.0000'),
('438','27','7.0000'),
('444','27','7.0000'),
('450','27','7.0000'),
('456','27','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('462','27','7.0000'),
('468','27','7.0000'),
('474','27','7.0000'),
('480','27','7.0000'),
('486','27','7.0000'),
('492','27','7.0000'),
('498','27','7.0000'),
('504','27','7.0000'),
('510','27','7.0000'),
('516','27','7.0000'),
('522','27','7.0000'),
('528','27','7.0000'),
('534','27','7.0000'),
('540','27','7.0000'),
('546','27','7.0000'),
('552','27','7.0000'),
('558','27','7.0000'),
('564','27','7.0000'),
('570','27','7.0000'),
('576','27','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('582','27','7.0000'),
('588','27','7.0000'),
('594','27','7.0000'),
('600','27','7.0000'),
('606','27','7.0000'),
('612','27','7.0000'),
('618','27','7.0000'),
('624','27','7.0000'),
('630','27','7.0000'),
('636','27','7.0000'),
('642','27','7.0000'),
('648','27','7.0000'),
('654','27','7.0000'),
('660','27','7.0000'),
('666','27','7.0000'),
('672','27','7.0000'),
('678','27','7.0000'),
('684','27','7.0000'),
('690','27','7.0000'),
('696','27','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('702','27','7.0000'),
('708','27','7.0000'),
('714','27','7.0000'),
('720','27','7.0000'),
('726','27','7.0000'),
('732','27','7.0000'),
('738','27','7.0000'),
('744','27','7.0000'),
('750','27','7.0000'),
('756','27','7.0000'),
('762','27','7.0000'),
('768','27','7.0000'),
('774','27','7.0000'),
('780','27','7.0000'),
('786','27','7.0000'),
('792','27','7.0000'),
('798','27','7.0000'),
('804','27','7.0000'),
('810','27','7.0000'),
('816','27','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('822','27','7.0000'),
('828','27','7.0000'),
('834','27','7.0000'),
('840','27','7.0000'),
('846','27','7.0000'),
('852','27','7.0000'),
('858','27','7.0000'),
('864','27','7.0000'),
('870','27','7.0000'),
('876','27','7.0000'),
('882','27','7.0000'),
('888','27','7.0000'),
('894','27','7.0000'),
('900','27','7.0000'),
('906','27','7.0000'),
('912','27','7.0000'),
('918','27','7.0000'),
('924','27','7.0000'),
('930','27','7.0000'),
('936','27','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('942','27','7.0000'),
('948','27','7.0000'),
('954','27','7.0000'),
('960','27','7.0000'),
('966','27','7.0000'),
('972','27','7.0000'),
('978','27','7.0000'),
('984','27','7.0000'),
('990','27','7.0000'),
('996','27','7.0000'),
('1002','27','7.0000'),
('1008','27','7.0000'),
('1014','27','7.0000'),
('1020','27','7.0000'),
('1026','27','7.0000'),
('1032','27','7.0000'),
('1038','27','7.0000'),
('1044','27','7.0000'),
('1050','27','7.0000'),
('1056','27','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1062','27','7.0000'),
('1068','27','7.0000'),
('1074','27','7.0000'),
('1080','27','7.0000'),
('1086','27','7.0000'),
('1092','27','7.0000'),
('1098','27','7.0000'),
('1104','27','7.0000'),
('1110','27','7.0000'),
('1116','27','7.0000'),
('1122','27','7.0000'),
('1128','27','7.0000'),
('1134','27','7.0000'),
('1140','27','7.0000'),
('1146','27','7.0000'),
('1152','27','7.0000'),
('1158','27','7.0000'),
('1164','27','7.0000'),
('1170','27','7.0000'),
('1176','27','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1182','27','7.0000'),
('1188','27','7.0000'),
('1194','27','7.0000'),
('1200','27','7.0000'),
('1206','27','7.0000'),
('1212','27','7.0000'),
('1218','27','7.0000'),
('1224','27','7.0000'),
('1230','27','7.0000'),
('1236','27','7.0000'),
('1242','27','7.0000'),
('1248','27','7.0000'),
('1254','27','7.0000'),
('1260','27','7.0000'),
('1266','27','7.0000'),
('1272','27','7.0000'),
('1278','27','7.0000'),
('1284','27','7.0000'),
('1290','27','7.0000'),
('1296','27','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1302','27','7.0000'),
('1308','27','7.0000'),
('1314','27','7.0000'),
('1320','27','7.0000'),
('1326','27','7.0000'),
('1332','27','7.0000'),
('1338','27','7.0000'),
('1344','27','7.0000'),
('1350','27','7.0000'),
('1356','27','7.0000'),
('1362','27','7.0000'),
('1368','27','7.0000'),
('1374','27','7.0000'),
('1380','27','7.0000'),
('1386','27','7.0000'),
('1392','27','7.0000'),
('1398','27','7.0000'),
('1404','27','7.0000'),
('1410','27','7.0000'),
('1416','27','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1422','27','7.0000'),
('1428','27','7.0000'),
('1434','27','7.0000'),
('1440','27','7.0000'),
('1446','27','7.0000'),
('1452','27','7.0000'),
('1458','27','7.0000'),
('1464','27','7.0000'),
('1470','27','7.0000'),
('1476','27','7.0000'),
('1482','27','7.0000'),
('1488','27','7.0000'),
('1494','27','7.0000'),
('1500','27','7.0000'),
('1506','27','7.0000'),
('1512','27','7.0000'),
('1518','27','7.0000'),
('1524','27','7.0000'),
('1530','27','7.0000'),
('1536','27','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1542','27','7.0000'),
('1548','27','7.0000'),
('1554','27','7.0000'),
('1560','27','7.0000'),
('1566','27','7.0000'),
('1572','27','7.0000'),
('1578','27','7.0000'),
('1584','27','7.0000'),
('1590','27','7.0000'),
('1596','27','7.0000'),
('1602','27','7.0000'),
('1608','27','7.0000'),
('1614','27','7.0000'),
('1620','27','7.0000'),
('1626','27','7.0000'),
('1632','27','7.0000'),
('1638','27','7.0000'),
('1644','27','7.0000'),
('1650','27','7.0000'),
('1656','27','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1662','27','7.0000'),
('1668','27','7.0000'),
('1674','27','7.0000'),
('1680','27','7.0000'),
('1686','27','7.0000'),
('1692','27','7.0000'),
('1698','27','7.0000'),
('1704','27','7.0000'),
('1710','27','7.0000'),
('1716','27','7.0000'),
('1722','27','7.0000'),
('1728','27','7.0000'),
('6','28','7.0000'),
('12','28','7.0000'),
('18','28','7.0000'),
('24','28','7.0000'),
('30','28','7.0000'),
('36','28','7.0000'),
('42','28','7.0000'),
('48','28','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('54','28','7.0000'),
('60','28','7.0000'),
('66','28','7.0000'),
('72','28','7.0000'),
('78','28','7.0000'),
('84','28','7.0000'),
('90','28','7.0000'),
('96','28','7.0000'),
('102','28','7.0000'),
('108','28','7.0000'),
('114','28','7.0000'),
('120','28','7.0000'),
('126','28','7.0000'),
('132','28','7.0000'),
('138','28','7.0000'),
('144','28','7.0000'),
('150','28','7.0000'),
('156','28','7.0000'),
('162','28','7.0000'),
('168','28','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('174','28','7.0000'),
('180','28','7.0000'),
('186','28','7.0000'),
('192','28','7.0000'),
('198','28','7.0000'),
('204','28','7.0000'),
('210','28','7.0000'),
('216','28','7.0000'),
('222','28','7.0000'),
('228','28','7.0000'),
('234','28','7.0000'),
('240','28','7.0000'),
('246','28','7.0000'),
('252','28','7.0000'),
('258','28','7.0000'),
('264','28','7.0000'),
('270','28','7.0000'),
('276','28','7.0000'),
('282','28','7.0000'),
('288','28','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('294','28','7.0000'),
('300','28','7.0000'),
('306','28','7.0000'),
('312','28','7.0000'),
('318','28','7.0000'),
('324','28','7.0000'),
('330','28','7.0000'),
('336','28','7.0000'),
('342','28','7.0000'),
('348','28','7.0000'),
('354','28','7.0000'),
('360','28','7.0000'),
('366','28','7.0000'),
('372','28','7.0000'),
('378','28','7.0000'),
('384','28','7.0000'),
('390','28','7.0000'),
('396','28','7.0000'),
('402','28','7.0000'),
('408','28','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('414','28','7.0000'),
('420','28','7.0000'),
('426','28','7.0000'),
('432','28','7.0000'),
('438','28','7.0000'),
('444','28','7.0000'),
('450','28','7.0000'),
('456','28','7.0000'),
('462','28','7.0000'),
('468','28','7.0000'),
('474','28','7.0000'),
('480','28','7.0000'),
('486','28','7.0000'),
('492','28','7.0000'),
('498','28','7.0000'),
('504','28','7.0000'),
('510','28','7.0000'),
('516','28','7.0000'),
('522','28','7.0000'),
('528','28','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('534','28','7.0000'),
('540','28','7.0000'),
('546','28','7.0000'),
('552','28','7.0000'),
('558','28','7.0000'),
('564','28','7.0000'),
('570','28','7.0000'),
('576','28','7.0000'),
('582','28','7.0000'),
('588','28','7.0000'),
('594','28','7.0000'),
('600','28','7.0000'),
('606','28','7.0000'),
('612','28','7.0000'),
('618','28','7.0000'),
('624','28','7.0000'),
('630','28','7.0000'),
('636','28','7.0000'),
('642','28','7.0000'),
('648','28','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('654','28','7.0000'),
('660','28','7.0000'),
('666','28','7.0000'),
('672','28','7.0000'),
('678','28','7.0000'),
('684','28','7.0000'),
('690','28','7.0000'),
('696','28','7.0000'),
('702','28','7.0000'),
('708','28','7.0000'),
('714','28','7.0000'),
('720','28','7.0000'),
('726','28','7.0000'),
('732','28','7.0000'),
('738','28','7.0000'),
('744','28','7.0000'),
('750','28','7.0000'),
('756','28','7.0000'),
('762','28','7.0000'),
('768','28','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('774','28','7.0000'),
('780','28','7.0000'),
('786','28','7.0000'),
('792','28','7.0000'),
('798','28','7.0000'),
('804','28','7.0000'),
('810','28','7.0000'),
('816','28','7.0000'),
('822','28','7.0000'),
('828','28','7.0000'),
('834','28','7.0000'),
('840','28','7.0000'),
('846','28','7.0000'),
('852','28','7.0000'),
('858','28','7.0000'),
('864','28','7.0000'),
('870','28','7.0000'),
('876','28','7.0000'),
('882','28','7.0000'),
('888','28','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('894','28','7.0000'),
('900','28','7.0000'),
('906','28','7.0000'),
('912','28','7.0000'),
('918','28','7.0000'),
('924','28','7.0000'),
('930','28','7.0000'),
('936','28','7.0000'),
('942','28','7.0000'),
('948','28','7.0000'),
('954','28','7.0000'),
('960','28','7.0000'),
('966','28','7.0000'),
('972','28','7.0000'),
('978','28','7.0000'),
('984','28','7.0000'),
('990','28','7.0000'),
('996','28','7.0000'),
('1002','28','7.0000'),
('1008','28','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1014','28','7.0000'),
('1020','28','7.0000'),
('1026','28','7.0000'),
('1032','28','7.0000'),
('1038','28','7.0000'),
('1044','28','7.0000'),
('1050','28','7.0000'),
('1056','28','7.0000'),
('1062','28','7.0000'),
('1068','28','7.0000'),
('1074','28','7.0000'),
('1080','28','7.0000'),
('1086','28','7.0000'),
('1092','28','7.0000'),
('1098','28','7.0000'),
('1104','28','7.0000'),
('1110','28','7.0000'),
('1116','28','7.0000'),
('1122','28','7.0000'),
('1128','28','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1134','28','7.0000'),
('1140','28','7.0000'),
('1146','28','7.0000'),
('1152','28','7.0000'),
('1158','28','7.0000'),
('1164','28','7.0000'),
('1170','28','7.0000'),
('1176','28','7.0000'),
('1182','28','7.0000'),
('1188','28','7.0000'),
('1194','28','7.0000'),
('1200','28','7.0000'),
('1206','28','7.0000'),
('1212','28','7.0000'),
('1218','28','7.0000'),
('1224','28','7.0000'),
('1230','28','7.0000'),
('1236','28','7.0000'),
('1242','28','7.0000'),
('1248','28','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1254','28','7.0000'),
('1260','28','7.0000'),
('1266','28','7.0000'),
('1272','28','7.0000'),
('1278','28','7.0000'),
('1284','28','7.0000'),
('1290','28','7.0000'),
('1296','28','7.0000'),
('1302','28','7.0000'),
('1308','28','7.0000'),
('1314','28','7.0000'),
('1320','28','7.0000'),
('1326','28','7.0000'),
('1332','28','7.0000'),
('1338','28','7.0000'),
('1344','28','7.0000'),
('1350','28','7.0000'),
('1356','28','7.0000'),
('1362','28','7.0000'),
('1368','28','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1374','28','7.0000'),
('1380','28','7.0000'),
('1386','28','7.0000'),
('1392','28','7.0000'),
('1398','28','7.0000'),
('1404','28','7.0000'),
('1410','28','7.0000'),
('1416','28','7.0000'),
('1422','28','7.0000'),
('1428','28','7.0000'),
('1434','28','7.0000'),
('1440','28','7.0000'),
('1446','28','7.0000'),
('1452','28','7.0000'),
('1458','28','7.0000'),
('1464','28','7.0000'),
('1470','28','7.0000'),
('1476','28','7.0000'),
('1482','28','7.0000'),
('1488','28','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1494','28','7.0000'),
('1500','28','7.0000'),
('1506','28','7.0000'),
('1512','28','7.0000'),
('1518','28','7.0000'),
('1524','28','7.0000'),
('1530','28','7.0000'),
('1536','28','7.0000'),
('1542','28','7.0000'),
('1548','28','7.0000'),
('1554','28','7.0000'),
('1560','28','7.0000'),
('1566','28','7.0000'),
('1572','28','7.0000'),
('1578','28','7.0000'),
('1584','28','7.0000'),
('1590','28','7.0000'),
('1596','28','7.0000'),
('1602','28','7.0000'),
('1608','28','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1614','28','7.0000'),
('1620','28','7.0000'),
('1626','28','7.0000'),
('1632','28','7.0000'),
('1638','28','7.0000'),
('1644','28','7.0000'),
('1650','28','7.0000'),
('1656','28','7.0000'),
('1662','28','7.0000'),
('1668','28','7.0000'),
('1674','28','7.0000'),
('1680','28','7.0000'),
('1686','28','7.0000'),
('1692','28','7.0000'),
('1698','28','7.0000'),
('1704','28','7.0000'),
('1710','28','7.0000'),
('1716','28','7.0000'),
('1722','28','7.0000'),
('1728','28','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('6','29','7.0000'),
('12','29','7.0000'),
('18','29','7.0000'),
('24','29','7.0000'),
('30','29','7.0000'),
('36','29','7.0000'),
('42','29','7.0000'),
('48','29','7.0000'),
('54','29','7.0000'),
('60','29','7.0000'),
('66','29','7.0000'),
('72','29','7.0000'),
('78','29','7.0000'),
('84','29','7.0000'),
('90','29','7.0000'),
('96','29','7.0000'),
('102','29','7.0000'),
('108','29','7.0000'),
('114','29','7.0000'),
('120','29','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('126','29','7.0000'),
('132','29','7.0000'),
('138','29','7.0000'),
('144','29','7.0000'),
('150','29','7.0000'),
('156','29','7.0000'),
('162','29','7.0000'),
('168','29','7.0000'),
('174','29','7.0000'),
('180','29','7.0000'),
('186','29','7.0000'),
('192','29','7.0000'),
('198','29','7.0000'),
('204','29','7.0000'),
('210','29','7.0000'),
('216','29','7.0000'),
('222','29','7.0000'),
('228','29','7.0000'),
('234','29','7.0000'),
('240','29','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('246','29','7.0000'),
('252','29','7.0000'),
('258','29','7.0000'),
('264','29','7.0000'),
('270','29','7.0000'),
('276','29','7.0000'),
('282','29','7.0000'),
('288','29','7.0000'),
('294','29','7.0000'),
('300','29','7.0000'),
('306','29','7.0000'),
('312','29','7.0000'),
('318','29','7.0000'),
('324','29','7.0000'),
('330','29','7.0000'),
('336','29','7.0000'),
('342','29','7.0000'),
('348','29','7.0000'),
('354','29','7.0000'),
('360','29','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('366','29','7.0000'),
('372','29','7.0000'),
('378','29','7.0000'),
('384','29','7.0000'),
('390','29','7.0000'),
('396','29','7.0000'),
('402','29','7.0000'),
('408','29','7.0000'),
('414','29','7.0000'),
('420','29','7.0000'),
('426','29','7.0000'),
('432','29','7.0000'),
('438','29','7.0000'),
('444','29','7.0000'),
('450','29','7.0000'),
('456','29','7.0000'),
('462','29','7.0000'),
('468','29','7.0000'),
('474','29','7.0000'),
('480','29','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('486','29','7.0000'),
('492','29','7.0000'),
('498','29','7.0000'),
('504','29','7.0000'),
('510','29','7.0000'),
('516','29','7.0000'),
('522','29','7.0000'),
('528','29','7.0000'),
('534','29','7.0000'),
('540','29','7.0000'),
('546','29','7.0000'),
('552','29','7.0000'),
('558','29','7.0000'),
('564','29','7.0000'),
('570','29','7.0000'),
('576','29','7.0000'),
('582','29','7.0000'),
('588','29','7.0000'),
('594','29','7.0000'),
('600','29','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('606','29','7.0000'),
('612','29','7.0000'),
('618','29','7.0000'),
('624','29','7.0000'),
('630','29','7.0000'),
('636','29','7.0000'),
('642','29','7.0000'),
('648','29','7.0000'),
('654','29','7.0000'),
('660','29','7.0000'),
('666','29','7.0000'),
('672','29','7.0000'),
('678','29','7.0000'),
('684','29','7.0000'),
('690','29','7.0000'),
('696','29','7.0000'),
('702','29','7.0000'),
('708','29','7.0000'),
('714','29','7.0000'),
('720','29','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('726','29','7.0000'),
('732','29','7.0000'),
('738','29','7.0000'),
('744','29','7.0000'),
('750','29','7.0000'),
('756','29','7.0000'),
('762','29','7.0000'),
('768','29','7.0000'),
('774','29','7.0000'),
('780','29','7.0000'),
('786','29','7.0000'),
('792','29','7.0000'),
('798','29','7.0000'),
('804','29','7.0000'),
('810','29','7.0000'),
('816','29','7.0000'),
('822','29','7.0000'),
('828','29','7.0000'),
('834','29','7.0000'),
('840','29','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('846','29','7.0000'),
('852','29','7.0000'),
('858','29','7.0000'),
('864','29','7.0000'),
('870','29','7.0000'),
('876','29','7.0000'),
('882','29','7.0000'),
('888','29','7.0000'),
('894','29','7.0000'),
('900','29','7.0000'),
('906','29','7.0000'),
('912','29','7.0000'),
('918','29','7.0000'),
('924','29','7.0000'),
('930','29','7.0000'),
('936','29','7.0000'),
('942','29','7.0000'),
('948','29','7.0000'),
('954','29','7.0000'),
('960','29','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('966','29','7.0000'),
('972','29','7.0000'),
('978','29','7.0000'),
('984','29','7.0000'),
('990','29','7.0000'),
('996','29','7.0000'),
('1002','29','7.0000'),
('1008','29','7.0000'),
('1014','29','7.0000'),
('1020','29','7.0000'),
('1026','29','7.0000'),
('1032','29','7.0000'),
('1038','29','7.0000'),
('1044','29','7.0000'),
('1050','29','7.0000'),
('1056','29','7.0000'),
('1062','29','7.0000'),
('1068','29','7.0000'),
('1074','29','7.0000'),
('1080','29','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1086','29','7.0000'),
('1092','29','7.0000'),
('1098','29','7.0000'),
('1104','29','7.0000'),
('1110','29','7.0000'),
('1116','29','7.0000'),
('1122','29','7.0000'),
('1128','29','7.0000'),
('1134','29','7.0000'),
('1140','29','7.0000'),
('1146','29','7.0000'),
('1152','29','7.0000'),
('1158','29','7.0000'),
('1164','29','7.0000'),
('1170','29','7.0000'),
('1176','29','7.0000'),
('1182','29','7.0000'),
('1188','29','7.0000'),
('1194','29','7.0000'),
('1200','29','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1206','29','7.0000'),
('1212','29','7.0000'),
('1218','29','7.0000'),
('1224','29','7.0000'),
('1230','29','7.0000'),
('1236','29','7.0000'),
('1242','29','7.0000'),
('1248','29','7.0000'),
('1254','29','7.0000'),
('1260','29','7.0000'),
('1266','29','7.0000'),
('1272','29','7.0000'),
('1278','29','7.0000'),
('1284','29','7.0000'),
('1290','29','7.0000'),
('1296','29','7.0000'),
('1302','29','7.0000'),
('1308','29','7.0000'),
('1314','29','7.0000'),
('1320','29','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1326','29','7.0000'),
('1332','29','7.0000'),
('1338','29','7.0000'),
('1344','29','7.0000'),
('1350','29','7.0000'),
('1356','29','7.0000'),
('1362','29','7.0000'),
('1368','29','7.0000'),
('1374','29','7.0000'),
('1380','29','7.0000'),
('1386','29','7.0000'),
('1392','29','7.0000'),
('1398','29','7.0000'),
('1404','29','7.0000'),
('1410','29','7.0000'),
('1416','29','7.0000'),
('1422','29','7.0000'),
('1428','29','7.0000'),
('1434','29','7.0000'),
('1440','29','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1446','29','7.0000'),
('1452','29','7.0000'),
('1458','29','7.0000'),
('1464','29','7.0000'),
('1470','29','7.0000'),
('1476','29','7.0000'),
('1482','29','7.0000'),
('1488','29','7.0000'),
('1494','29','7.0000'),
('1500','29','7.0000'),
('1506','29','7.0000'),
('1512','29','7.0000'),
('1518','29','7.0000'),
('1524','29','7.0000'),
('1530','29','7.0000'),
('1536','29','7.0000'),
('1542','29','7.0000'),
('1548','29','7.0000'),
('1554','29','7.0000'),
('1560','29','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1566','29','7.0000'),
('1572','29','7.0000'),
('1578','29','7.0000'),
('1584','29','7.0000'),
('1590','29','7.0000'),
('1596','29','7.0000'),
('1602','29','7.0000'),
('1608','29','7.0000'),
('1614','29','7.0000'),
('1620','29','7.0000'),
('1626','29','7.0000'),
('1632','29','7.0000'),
('1638','29','7.0000'),
('1644','29','7.0000'),
('1650','29','7.0000'),
('1656','29','7.0000'),
('1662','29','7.0000'),
('1668','29','7.0000'),
('1674','29','7.0000'),
('1680','29','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1686','29','7.0000'),
('1692','29','7.0000'),
('1698','29','7.0000'),
('1704','29','7.0000'),
('1710','29','7.0000'),
('1716','29','7.0000'),
('1722','29','7.0000'),
('1728','29','7.0000'),
('6','30','7.0000'),
('12','30','7.0000'),
('18','30','7.0000'),
('24','30','7.0000'),
('30','30','7.0000'),
('36','30','7.0000'),
('42','30','7.0000'),
('48','30','7.0000'),
('54','30','7.0000'),
('60','30','7.0000'),
('66','30','7.0000'),
('72','30','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('78','30','7.0000'),
('84','30','7.0000'),
('90','30','7.0000'),
('96','30','7.0000'),
('102','30','7.0000'),
('108','30','7.0000'),
('114','30','7.0000'),
('120','30','7.0000'),
('126','30','7.0000'),
('132','30','7.0000'),
('138','30','7.0000'),
('144','30','7.0000'),
('150','30','7.0000'),
('156','30','7.0000'),
('162','30','7.0000'),
('168','30','7.0000'),
('174','30','7.0000'),
('180','30','7.0000'),
('186','30','7.0000'),
('192','30','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('198','30','7.0000'),
('204','30','7.0000'),
('210','30','7.0000'),
('216','30','7.0000'),
('222','30','7.0000'),
('228','30','7.0000'),
('234','30','7.0000'),
('240','30','7.0000'),
('246','30','7.0000'),
('252','30','7.0000'),
('258','30','7.0000'),
('264','30','7.0000'),
('270','30','7.0000'),
('276','30','7.0000'),
('282','30','7.0000'),
('288','30','7.0000'),
('294','30','7.0000'),
('300','30','7.0000'),
('306','30','7.0000'),
('312','30','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('318','30','7.0000'),
('324','30','7.0000'),
('330','30','7.0000'),
('336','30','7.0000'),
('342','30','7.0000'),
('348','30','7.0000'),
('354','30','7.0000'),
('360','30','7.0000'),
('366','30','7.0000'),
('372','30','7.0000'),
('378','30','7.0000'),
('384','30','7.0000'),
('390','30','7.0000'),
('396','30','7.0000'),
('402','30','7.0000'),
('408','30','7.0000'),
('414','30','7.0000'),
('420','30','7.0000'),
('426','30','7.0000'),
('432','30','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('438','30','7.0000'),
('444','30','7.0000'),
('450','30','7.0000'),
('456','30','7.0000'),
('462','30','7.0000'),
('468','30','7.0000'),
('474','30','7.0000'),
('480','30','7.0000'),
('486','30','7.0000'),
('492','30','7.0000'),
('498','30','7.0000'),
('504','30','7.0000'),
('510','30','7.0000'),
('516','30','7.0000'),
('522','30','7.0000'),
('528','30','7.0000'),
('534','30','7.0000'),
('540','30','7.0000'),
('546','30','7.0000'),
('552','30','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('558','30','7.0000'),
('564','30','7.0000'),
('570','30','7.0000'),
('576','30','7.0000'),
('582','30','7.0000'),
('588','30','7.0000'),
('594','30','7.0000'),
('600','30','7.0000'),
('606','30','7.0000'),
('612','30','7.0000'),
('618','30','7.0000'),
('624','30','7.0000'),
('630','30','7.0000'),
('636','30','7.0000'),
('642','30','7.0000'),
('648','30','7.0000'),
('654','30','7.0000'),
('660','30','7.0000'),
('666','30','7.0000'),
('672','30','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('678','30','7.0000'),
('684','30','7.0000'),
('690','30','7.0000'),
('696','30','7.0000'),
('702','30','7.0000'),
('708','30','7.0000'),
('714','30','7.0000'),
('720','30','7.0000'),
('726','30','7.0000'),
('732','30','7.0000'),
('738','30','7.0000'),
('744','30','7.0000'),
('750','30','7.0000'),
('756','30','7.0000'),
('762','30','7.0000'),
('768','30','7.0000'),
('774','30','7.0000'),
('780','30','7.0000'),
('786','30','7.0000'),
('792','30','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('798','30','7.0000'),
('804','30','7.0000'),
('810','30','7.0000'),
('816','30','7.0000'),
('822','30','7.0000'),
('828','30','7.0000'),
('834','30','7.0000'),
('840','30','7.0000'),
('846','30','7.0000'),
('852','30','7.0000'),
('858','30','7.0000'),
('864','30','7.0000'),
('870','30','7.0000'),
('876','30','7.0000'),
('882','30','7.0000'),
('888','30','7.0000'),
('894','30','7.0000'),
('900','30','7.0000'),
('906','30','7.0000'),
('912','30','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('918','30','7.0000'),
('924','30','7.0000'),
('930','30','7.0000'),
('936','30','7.0000'),
('942','30','7.0000'),
('948','30','7.0000'),
('954','30','7.0000'),
('960','30','7.0000'),
('966','30','7.0000'),
('972','30','7.0000'),
('978','30','7.0000'),
('984','30','7.0000'),
('990','30','7.0000'),
('996','30','7.0000'),
('1002','30','7.0000'),
('1008','30','7.0000'),
('1014','30','7.0000'),
('1020','30','7.0000'),
('1026','30','7.0000'),
('1032','30','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1038','30','7.0000'),
('1044','30','7.0000'),
('1050','30','7.0000'),
('1056','30','7.0000'),
('1062','30','7.0000'),
('1068','30','7.0000'),
('1074','30','7.0000'),
('1080','30','7.0000'),
('1086','30','7.0000'),
('1092','30','7.0000'),
('1098','30','7.0000'),
('1104','30','7.0000'),
('1110','30','7.0000'),
('1116','30','7.0000'),
('1122','30','7.0000'),
('1128','30','7.0000'),
('1134','30','7.0000'),
('1140','30','7.0000'),
('1146','30','7.0000'),
('1152','30','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1158','30','7.0000'),
('1164','30','7.0000'),
('1170','30','7.0000'),
('1176','30','7.0000'),
('1182','30','7.0000'),
('1188','30','7.0000'),
('1194','30','7.0000'),
('1200','30','7.0000'),
('1206','30','7.0000'),
('1212','30','7.0000'),
('1218','30','7.0000'),
('1224','30','7.0000'),
('1230','30','7.0000'),
('1236','30','7.0000'),
('1242','30','7.0000'),
('1248','30','7.0000'),
('1254','30','7.0000'),
('1260','30','7.0000'),
('1266','30','7.0000'),
('1272','30','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1278','30','7.0000'),
('1284','30','7.0000'),
('1290','30','7.0000'),
('1296','30','7.0000'),
('1302','30','7.0000'),
('1308','30','7.0000'),
('1314','30','7.0000'),
('1320','30','7.0000'),
('1326','30','7.0000'),
('1332','30','7.0000'),
('1338','30','7.0000'),
('1344','30','7.0000'),
('1350','30','7.0000'),
('1356','30','7.0000'),
('1362','30','7.0000'),
('1368','30','7.0000'),
('1374','30','7.0000'),
('1380','30','7.0000'),
('1386','30','7.0000'),
('1392','30','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1398','30','7.0000'),
('1404','30','7.0000'),
('1410','30','7.0000'),
('1416','30','7.0000'),
('1422','30','7.0000'),
('1428','30','7.0000'),
('1434','30','7.0000'),
('1440','30','7.0000'),
('1446','30','7.0000'),
('1452','30','7.0000'),
('1458','30','7.0000'),
('1464','30','7.0000'),
('1470','30','7.0000'),
('1476','30','7.0000'),
('1482','30','7.0000'),
('1488','30','7.0000'),
('1494','30','7.0000'),
('1500','30','7.0000'),
('1506','30','7.0000'),
('1512','30','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1518','30','7.0000'),
('1524','30','7.0000'),
('1530','30','7.0000'),
('1536','30','7.0000'),
('1542','30','7.0000'),
('1548','30','7.0000'),
('1554','30','7.0000'),
('1560','30','7.0000'),
('1566','30','7.0000'),
('1572','30','7.0000'),
('1578','30','7.0000'),
('1584','30','7.0000'),
('1590','30','7.0000'),
('1596','30','7.0000'),
('1602','30','7.0000'),
('1608','30','7.0000'),
('1614','30','7.0000'),
('1620','30','7.0000'),
('1626','30','7.0000'),
('1632','30','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1638','30','7.0000'),
('1644','30','7.0000'),
('1650','30','7.0000'),
('1656','30','7.0000'),
('1662','30','7.0000'),
('1668','30','7.0000'),
('1674','30','7.0000'),
('1680','30','7.0000'),
('1686','30','7.0000'),
('1692','30','7.0000'),
('1698','30','7.0000'),
('1704','30','7.0000'),
('1710','30','7.0000'),
('1716','30','7.0000'),
('1722','30','7.0000'),
('1728','30','7.0000'),
('6','31','7.0000'),
('12','31','7.0000'),
('18','31','7.0000'),
('24','31','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('30','31','7.0000'),
('36','31','7.0000'),
('42','31','7.0000'),
('48','31','7.0000'),
('54','31','7.0000'),
('60','31','7.0000'),
('66','31','7.0000'),
('72','31','7.0000'),
('78','31','7.0000'),
('84','31','7.0000'),
('90','31','7.0000'),
('96','31','7.0000'),
('102','31','7.0000'),
('108','31','7.0000'),
('114','31','7.0000'),
('120','31','7.0000'),
('126','31','7.0000'),
('132','31','7.0000'),
('138','31','7.0000'),
('144','31','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('150','31','7.0000'),
('156','31','7.0000'),
('162','31','7.0000'),
('168','31','7.0000'),
('174','31','7.0000'),
('180','31','7.0000'),
('186','31','7.0000'),
('192','31','7.0000'),
('198','31','7.0000'),
('204','31','7.0000'),
('210','31','7.0000'),
('216','31','7.0000'),
('222','31','7.0000'),
('228','31','7.0000'),
('234','31','7.0000'),
('240','31','7.0000'),
('246','31','7.0000'),
('252','31','7.0000'),
('258','31','7.0000'),
('264','31','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('270','31','7.0000'),
('276','31','7.0000'),
('282','31','7.0000'),
('288','31','7.0000'),
('294','31','7.0000'),
('300','31','7.0000'),
('306','31','7.0000'),
('312','31','7.0000'),
('318','31','7.0000'),
('324','31','7.0000'),
('330','31','7.0000'),
('336','31','7.0000'),
('342','31','7.0000'),
('348','31','7.0000'),
('354','31','7.0000'),
('360','31','7.0000'),
('366','31','7.0000'),
('372','31','7.0000'),
('378','31','7.0000'),
('384','31','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('390','31','7.0000'),
('396','31','7.0000'),
('402','31','7.0000'),
('408','31','7.0000'),
('414','31','7.0000'),
('420','31','7.0000'),
('426','31','7.0000'),
('432','31','7.0000'),
('438','31','7.0000'),
('444','31','7.0000'),
('450','31','7.0000'),
('456','31','7.0000'),
('462','31','7.0000'),
('468','31','7.0000'),
('474','31','7.0000'),
('480','31','7.0000'),
('486','31','7.0000'),
('492','31','7.0000'),
('498','31','7.0000'),
('504','31','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('510','31','7.0000'),
('516','31','7.0000'),
('522','31','7.0000'),
('528','31','7.0000'),
('534','31','7.0000'),
('540','31','7.0000'),
('546','31','7.0000'),
('552','31','7.0000'),
('558','31','7.0000'),
('564','31','7.0000'),
('570','31','7.0000'),
('576','31','7.0000'),
('582','31','7.0000'),
('588','31','7.0000'),
('594','31','7.0000'),
('600','31','7.0000'),
('606','31','7.0000'),
('612','31','7.0000'),
('618','31','7.0000'),
('624','31','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('630','31','7.0000'),
('636','31','7.0000'),
('642','31','7.0000'),
('648','31','7.0000'),
('654','31','7.0000'),
('660','31','7.0000'),
('666','31','7.0000'),
('672','31','7.0000'),
('678','31','7.0000'),
('684','31','7.0000'),
('690','31','7.0000'),
('696','31','7.0000'),
('702','31','7.0000'),
('708','31','7.0000'),
('714','31','7.0000'),
('720','31','7.0000'),
('726','31','7.0000'),
('732','31','7.0000'),
('738','31','7.0000'),
('744','31','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('750','31','7.0000'),
('756','31','7.0000'),
('762','31','7.0000'),
('768','31','7.0000'),
('774','31','7.0000'),
('780','31','7.0000'),
('786','31','7.0000'),
('792','31','7.0000'),
('798','31','7.0000'),
('804','31','7.0000'),
('810','31','7.0000'),
('816','31','7.0000'),
('822','31','7.0000'),
('828','31','7.0000'),
('834','31','7.0000'),
('840','31','7.0000'),
('846','31','7.0000'),
('852','31','7.0000'),
('858','31','7.0000'),
('864','31','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('870','31','7.0000'),
('876','31','7.0000'),
('882','31','7.0000'),
('888','31','7.0000'),
('894','31','7.0000'),
('900','31','7.0000'),
('906','31','7.0000'),
('912','31','7.0000'),
('918','31','7.0000'),
('924','31','7.0000'),
('930','31','7.0000'),
('936','31','7.0000'),
('942','31','7.0000'),
('948','31','7.0000'),
('954','31','7.0000'),
('960','31','7.0000'),
('966','31','7.0000'),
('972','31','7.0000'),
('978','31','7.0000'),
('984','31','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('990','31','7.0000'),
('996','31','7.0000'),
('1002','31','7.0000'),
('1008','31','7.0000'),
('1014','31','7.0000'),
('1020','31','7.0000'),
('1026','31','7.0000'),
('1032','31','7.0000'),
('1038','31','7.0000'),
('1044','31','7.0000'),
('1050','31','7.0000'),
('1056','31','7.0000'),
('1062','31','7.0000'),
('1068','31','7.0000'),
('1074','31','7.0000'),
('1080','31','7.0000'),
('1086','31','7.0000'),
('1092','31','7.0000'),
('1098','31','7.0000'),
('1104','31','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1110','31','7.0000'),
('1116','31','7.0000'),
('1122','31','7.0000'),
('1128','31','7.0000'),
('1134','31','7.0000'),
('1140','31','7.0000'),
('1146','31','7.0000'),
('1152','31','7.0000'),
('1158','31','7.0000'),
('1164','31','7.0000'),
('1170','31','7.0000'),
('1176','31','7.0000'),
('1182','31','7.0000'),
('1188','31','7.0000'),
('1194','31','7.0000'),
('1200','31','7.0000'),
('1206','31','7.0000'),
('1212','31','7.0000'),
('1218','31','7.0000'),
('1224','31','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1230','31','7.0000'),
('1236','31','7.0000'),
('1242','31','7.0000'),
('1248','31','7.0000'),
('1254','31','7.0000'),
('1260','31','7.0000'),
('1266','31','7.0000'),
('1272','31','7.0000'),
('1278','31','7.0000'),
('1284','31','7.0000'),
('1290','31','7.0000'),
('1296','31','7.0000'),
('1302','31','7.0000'),
('1308','31','7.0000'),
('1314','31','7.0000'),
('1320','31','7.0000'),
('1326','31','7.0000'),
('1332','31','7.0000'),
('1338','31','7.0000'),
('1344','31','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1350','31','7.0000'),
('1356','31','7.0000'),
('1362','31','7.0000'),
('1368','31','7.0000'),
('1374','31','7.0000'),
('1380','31','7.0000'),
('1386','31','7.0000'),
('1392','31','7.0000'),
('1398','31','7.0000'),
('1404','31','7.0000'),
('1410','31','7.0000'),
('1416','31','7.0000'),
('1422','31','7.0000'),
('1428','31','7.0000'),
('1434','31','7.0000'),
('1440','31','7.0000'),
('1446','31','7.0000'),
('1452','31','7.0000'),
('1458','31','7.0000'),
('1464','31','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1470','31','7.0000'),
('1476','31','7.0000'),
('1482','31','7.0000'),
('1488','31','7.0000'),
('1494','31','7.0000'),
('1500','31','7.0000'),
('1506','31','7.0000'),
('1512','31','7.0000'),
('1518','31','7.0000'),
('1524','31','7.0000'),
('1530','31','7.0000'),
('1536','31','7.0000'),
('1542','31','7.0000'),
('1548','31','7.0000'),
('1554','31','7.0000'),
('1560','31','7.0000'),
('1566','31','7.0000'),
('1572','31','7.0000'),
('1578','31','7.0000'),
('1584','31','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1590','31','7.0000'),
('1596','31','7.0000'),
('1602','31','7.0000'),
('1608','31','7.0000'),
('1614','31','7.0000'),
('1620','31','7.0000'),
('1626','31','7.0000'),
('1632','31','7.0000'),
('1638','31','7.0000'),
('1644','31','7.0000'),
('1650','31','7.0000'),
('1656','31','7.0000'),
('1662','31','7.0000'),
('1668','31','7.0000'),
('1674','31','7.0000'),
('1680','31','7.0000'),
('1686','31','7.0000'),
('1692','31','7.0000'),
('1698','31','7.0000'),
('1704','31','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1710','31','7.0000'),
('1716','31','7.0000'),
('1722','31','7.0000'),
('1728','31','7.0000'),
('6','32','7.0000'),
('12','32','7.0000'),
('18','32','7.0000'),
('24','32','7.0000'),
('30','32','7.0000'),
('36','32','7.0000'),
('42','32','7.0000'),
('48','32','7.0000'),
('54','32','7.0000'),
('60','32','7.0000'),
('66','32','7.0000'),
('72','32','7.0000'),
('78','32','7.0000'),
('84','32','7.0000'),
('90','32','7.0000'),
('96','32','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('102','32','7.0000'),
('108','32','7.0000'),
('114','32','7.0000'),
('120','32','7.0000'),
('126','32','7.0000'),
('132','32','7.0000'),
('138','32','7.0000'),
('144','32','7.0000'),
('150','32','7.0000'),
('156','32','7.0000'),
('162','32','7.0000'),
('168','32','7.0000'),
('174','32','7.0000'),
('180','32','7.0000'),
('186','32','7.0000'),
('192','32','7.0000'),
('198','32','7.0000'),
('204','32','7.0000'),
('210','32','7.0000'),
('216','32','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('222','32','7.0000'),
('228','32','7.0000'),
('234','32','7.0000'),
('240','32','7.0000'),
('246','32','7.0000'),
('252','32','7.0000'),
('258','32','7.0000'),
('264','32','7.0000'),
('270','32','7.0000'),
('276','32','7.0000'),
('282','32','7.0000'),
('288','32','7.0000'),
('294','32','7.0000'),
('300','32','7.0000'),
('306','32','7.0000'),
('312','32','7.0000'),
('318','32','7.0000'),
('324','32','7.0000'),
('330','32','7.0000'),
('336','32','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('342','32','7.0000'),
('348','32','7.0000'),
('354','32','7.0000'),
('360','32','7.0000'),
('366','32','7.0000'),
('372','32','7.0000'),
('378','32','7.0000'),
('384','32','7.0000'),
('390','32','7.0000'),
('396','32','7.0000'),
('402','32','7.0000'),
('408','32','7.0000'),
('414','32','7.0000'),
('420','32','7.0000'),
('426','32','7.0000'),
('432','32','7.0000'),
('438','32','7.0000'),
('444','32','7.0000'),
('450','32','7.0000'),
('456','32','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('462','32','7.0000'),
('468','32','7.0000'),
('474','32','7.0000'),
('480','32','7.0000'),
('486','32','7.0000'),
('492','32','7.0000'),
('498','32','7.0000'),
('504','32','7.0000'),
('510','32','7.0000'),
('516','32','7.0000'),
('522','32','7.0000'),
('528','32','7.0000'),
('534','32','7.0000'),
('540','32','7.0000'),
('546','32','7.0000'),
('552','32','7.0000'),
('558','32','7.0000'),
('564','32','7.0000'),
('570','32','7.0000'),
('576','32','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('582','32','7.0000'),
('588','32','7.0000'),
('594','32','7.0000'),
('600','32','7.0000'),
('606','32','7.0000'),
('612','32','7.0000'),
('618','32','7.0000'),
('624','32','7.0000'),
('630','32','7.0000'),
('636','32','7.0000'),
('642','32','7.0000'),
('648','32','7.0000'),
('654','32','7.0000'),
('660','32','7.0000'),
('666','32','7.0000'),
('672','32','7.0000'),
('678','32','7.0000'),
('684','32','7.0000'),
('690','32','7.0000'),
('696','32','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('702','32','7.0000'),
('708','32','7.0000'),
('714','32','7.0000'),
('720','32','7.0000'),
('726','32','7.0000'),
('732','32','7.0000'),
('738','32','7.0000'),
('744','32','7.0000'),
('750','32','7.0000'),
('756','32','7.0000'),
('762','32','7.0000'),
('768','32','7.0000'),
('774','32','7.0000'),
('780','32','7.0000'),
('786','32','7.0000'),
('792','32','7.0000'),
('798','32','7.0000'),
('804','32','7.0000'),
('810','32','7.0000'),
('816','32','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('822','32','7.0000'),
('828','32','7.0000'),
('834','32','7.0000'),
('840','32','7.0000'),
('846','32','7.0000'),
('852','32','7.0000'),
('858','32','7.0000'),
('864','32','7.0000'),
('870','32','7.0000'),
('876','32','7.0000'),
('882','32','7.0000'),
('888','32','7.0000'),
('894','32','7.0000'),
('900','32','7.0000'),
('906','32','7.0000'),
('912','32','7.0000'),
('918','32','7.0000'),
('924','32','7.0000'),
('930','32','7.0000'),
('936','32','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('942','32','7.0000'),
('948','32','7.0000'),
('954','32','7.0000'),
('960','32','7.0000'),
('966','32','7.0000'),
('972','32','7.0000'),
('978','32','7.0000'),
('984','32','7.0000'),
('990','32','7.0000'),
('996','32','7.0000'),
('1002','32','7.0000'),
('1008','32','7.0000'),
('1014','32','7.0000'),
('1020','32','7.0000'),
('1026','32','7.0000'),
('1032','32','7.0000'),
('1038','32','7.0000'),
('1044','32','7.0000'),
('1050','32','7.0000'),
('1056','32','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1062','32','7.0000'),
('1068','32','7.0000'),
('1074','32','7.0000'),
('1080','32','7.0000'),
('1086','32','7.0000'),
('1092','32','7.0000'),
('1098','32','7.0000'),
('1104','32','7.0000'),
('1110','32','7.0000'),
('1116','32','7.0000'),
('1122','32','7.0000'),
('1128','32','7.0000'),
('1134','32','7.0000'),
('1140','32','7.0000'),
('1146','32','7.0000'),
('1152','32','7.0000'),
('1158','32','7.0000'),
('1164','32','7.0000'),
('1170','32','7.0000'),
('1176','32','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1182','32','7.0000'),
('1188','32','7.0000'),
('1194','32','7.0000'),
('1200','32','7.0000'),
('1206','32','7.0000'),
('1212','32','7.0000'),
('1218','32','7.0000'),
('1224','32','7.0000'),
('1230','32','7.0000'),
('1236','32','7.0000'),
('1242','32','7.0000'),
('1248','32','7.0000'),
('1254','32','7.0000'),
('1260','32','7.0000'),
('1266','32','7.0000'),
('1272','32','7.0000'),
('1278','32','7.0000'),
('1284','32','7.0000'),
('1290','32','7.0000'),
('1296','32','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1302','32','7.0000'),
('1308','32','7.0000'),
('1314','32','7.0000'),
('1320','32','7.0000'),
('1326','32','7.0000'),
('1332','32','7.0000'),
('1338','32','7.0000'),
('1344','32','7.0000'),
('1350','32','7.0000'),
('1356','32','7.0000'),
('1362','32','7.0000'),
('1368','32','7.0000'),
('1374','32','7.0000'),
('1380','32','7.0000'),
('1386','32','7.0000'),
('1392','32','7.0000'),
('1398','32','7.0000'),
('1404','32','7.0000'),
('1410','32','7.0000'),
('1416','32','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1422','32','7.0000'),
('1428','32','7.0000'),
('1434','32','7.0000'),
('1440','32','7.0000'),
('1446','32','7.0000'),
('1452','32','7.0000'),
('1458','32','7.0000'),
('1464','32','7.0000'),
('1470','32','7.0000'),
('1476','32','7.0000'),
('1482','32','7.0000'),
('1488','32','7.0000'),
('1494','32','7.0000'),
('1500','32','7.0000'),
('1506','32','7.0000'),
('1512','32','7.0000'),
('1518','32','7.0000'),
('1524','32','7.0000'),
('1530','32','7.0000'),
('1536','32','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1542','32','7.0000'),
('1548','32','7.0000'),
('1554','32','7.0000'),
('1560','32','7.0000'),
('1566','32','7.0000'),
('1572','32','7.0000'),
('1578','32','7.0000'),
('1584','32','7.0000'),
('1590','32','7.0000'),
('1596','32','7.0000'),
('1602','32','7.0000'),
('1608','32','7.0000'),
('1614','32','7.0000'),
('1620','32','7.0000'),
('1626','32','7.0000'),
('1632','32','7.0000'),
('1638','32','7.0000'),
('1644','32','7.0000'),
('1650','32','7.0000'),
('1656','32','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1662','32','7.0000'),
('1668','32','7.0000'),
('1674','32','7.0000'),
('1680','32','7.0000'),
('1686','32','7.0000'),
('1692','32','7.0000'),
('1698','32','7.0000'),
('1704','32','7.0000'),
('1710','32','7.0000'),
('1716','32','7.0000'),
('1722','32','7.0000'),
('1728','32','7.0000'),
('6','33','7.0000'),
('12','33','7.0000'),
('18','33','7.0000'),
('24','33','7.0000'),
('30','33','7.0000'),
('36','33','7.0000'),
('42','33','7.0000'),
('48','33','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('54','33','7.0000'),
('60','33','7.0000'),
('66','33','7.0000'),
('72','33','7.0000'),
('78','33','7.0000'),
('84','33','7.0000'),
('90','33','7.0000'),
('96','33','7.0000'),
('102','33','7.0000'),
('108','33','7.0000'),
('114','33','7.0000'),
('120','33','7.0000'),
('126','33','7.0000'),
('132','33','7.0000'),
('138','33','7.0000'),
('144','33','7.0000'),
('150','33','7.0000'),
('156','33','7.0000'),
('162','33','7.0000'),
('168','33','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('174','33','7.0000'),
('180','33','7.0000'),
('186','33','7.0000'),
('192','33','7.0000'),
('198','33','7.0000'),
('204','33','7.0000'),
('210','33','7.0000'),
('216','33','7.0000'),
('222','33','7.0000'),
('228','33','7.0000'),
('234','33','7.0000'),
('240','33','7.0000'),
('246','33','7.0000'),
('252','33','7.0000'),
('258','33','7.0000'),
('264','33','7.0000'),
('270','33','7.0000'),
('276','33','7.0000'),
('282','33','7.0000'),
('288','33','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('294','33','7.0000'),
('300','33','7.0000'),
('306','33','7.0000'),
('312','33','7.0000'),
('318','33','7.0000'),
('324','33','7.0000'),
('330','33','7.0000'),
('336','33','7.0000'),
('342','33','7.0000'),
('348','33','7.0000'),
('354','33','7.0000'),
('360','33','7.0000'),
('366','33','7.0000'),
('372','33','7.0000'),
('378','33','7.0000'),
('384','33','7.0000'),
('390','33','7.0000'),
('396','33','7.0000'),
('402','33','7.0000'),
('408','33','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('414','33','7.0000'),
('420','33','7.0000'),
('426','33','7.0000'),
('432','33','7.0000'),
('438','33','7.0000'),
('444','33','7.0000'),
('450','33','7.0000'),
('456','33','7.0000'),
('462','33','7.0000'),
('468','33','7.0000'),
('474','33','7.0000'),
('480','33','7.0000'),
('486','33','7.0000'),
('492','33','7.0000'),
('498','33','7.0000'),
('504','33','7.0000'),
('510','33','7.0000'),
('516','33','7.0000'),
('522','33','7.0000'),
('528','33','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('534','33','7.0000'),
('540','33','7.0000'),
('546','33','7.0000'),
('552','33','7.0000'),
('558','33','7.0000'),
('564','33','7.0000'),
('570','33','7.0000'),
('576','33','7.0000'),
('582','33','7.0000'),
('588','33','7.0000'),
('594','33','7.0000'),
('600','33','7.0000'),
('606','33','7.0000'),
('612','33','7.0000'),
('618','33','7.0000'),
('624','33','7.0000'),
('630','33','7.0000'),
('636','33','7.0000'),
('642','33','7.0000'),
('648','33','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('654','33','7.0000'),
('660','33','7.0000'),
('666','33','7.0000'),
('672','33','7.0000'),
('678','33','7.0000'),
('684','33','7.0000'),
('690','33','7.0000'),
('696','33','7.0000'),
('702','33','7.0000'),
('708','33','7.0000'),
('714','33','7.0000'),
('720','33','7.0000'),
('726','33','7.0000'),
('732','33','7.0000'),
('738','33','7.0000'),
('744','33','7.0000'),
('750','33','7.0000'),
('756','33','7.0000'),
('762','33','7.0000'),
('768','33','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('774','33','7.0000'),
('780','33','7.0000'),
('786','33','7.0000'),
('792','33','7.0000'),
('798','33','7.0000'),
('804','33','7.0000'),
('810','33','7.0000'),
('816','33','7.0000'),
('822','33','7.0000'),
('828','33','7.0000'),
('834','33','7.0000'),
('840','33','7.0000'),
('846','33','7.0000'),
('852','33','7.0000'),
('858','33','7.0000'),
('864','33','7.0000'),
('870','33','7.0000'),
('876','33','7.0000'),
('882','33','7.0000'),
('888','33','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('894','33','7.0000'),
('900','33','7.0000'),
('906','33','7.0000'),
('912','33','7.0000'),
('918','33','7.0000'),
('924','33','7.0000'),
('930','33','7.0000'),
('936','33','7.0000'),
('942','33','7.0000'),
('948','33','7.0000'),
('954','33','7.0000'),
('960','33','7.0000'),
('966','33','7.0000'),
('972','33','7.0000'),
('978','33','7.0000'),
('984','33','7.0000'),
('990','33','7.0000'),
('996','33','7.0000'),
('1002','33','7.0000'),
('1008','33','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1014','33','7.0000'),
('1020','33','7.0000'),
('1026','33','7.0000'),
('1032','33','7.0000'),
('1038','33','7.0000'),
('1044','33','7.0000'),
('1050','33','7.0000'),
('1056','33','7.0000'),
('1062','33','7.0000'),
('1068','33','7.0000'),
('1074','33','7.0000'),
('1080','33','7.0000'),
('1086','33','7.0000'),
('1092','33','7.0000'),
('1098','33','7.0000'),
('1104','33','7.0000'),
('1110','33','7.0000'),
('1116','33','7.0000'),
('1122','33','7.0000'),
('1128','33','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1134','33','7.0000'),
('1140','33','7.0000'),
('1146','33','7.0000'),
('1152','33','7.0000'),
('1158','33','7.0000'),
('1164','33','7.0000'),
('1170','33','7.0000'),
('1176','33','7.0000'),
('1182','33','7.0000'),
('1188','33','7.0000'),
('1194','33','7.0000'),
('1200','33','7.0000'),
('1206','33','7.0000'),
('1212','33','7.0000'),
('1218','33','7.0000'),
('1224','33','7.0000'),
('1230','33','7.0000'),
('1236','33','7.0000'),
('1242','33','7.0000'),
('1248','33','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1254','33','7.0000'),
('1260','33','7.0000'),
('1266','33','7.0000'),
('1272','33','7.0000'),
('1278','33','7.0000'),
('1284','33','7.0000'),
('1290','33','7.0000'),
('1296','33','7.0000'),
('1302','33','7.0000'),
('1308','33','7.0000'),
('1314','33','7.0000'),
('1320','33','7.0000'),
('1326','33','7.0000'),
('1332','33','7.0000'),
('1338','33','7.0000'),
('1344','33','7.0000'),
('1350','33','7.0000'),
('1356','33','7.0000'),
('1362','33','7.0000'),
('1368','33','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1374','33','7.0000'),
('1380','33','7.0000'),
('1386','33','7.0000'),
('1392','33','7.0000'),
('1398','33','7.0000'),
('1404','33','7.0000'),
('1410','33','7.0000'),
('1416','33','7.0000'),
('1422','33','7.0000'),
('1428','33','7.0000'),
('1434','33','7.0000'),
('1440','33','7.0000'),
('1446','33','7.0000'),
('1452','33','7.0000'),
('1458','33','7.0000'),
('1464','33','7.0000'),
('1470','33','7.0000'),
('1476','33','7.0000'),
('1482','33','7.0000'),
('1488','33','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1494','33','7.0000'),
('1500','33','7.0000'),
('1506','33','7.0000'),
('1512','33','7.0000'),
('1518','33','7.0000'),
('1524','33','7.0000'),
('1530','33','7.0000'),
('1536','33','7.0000'),
('1542','33','7.0000'),
('1548','33','7.0000'),
('1554','33','7.0000'),
('1560','33','7.0000'),
('1566','33','7.0000'),
('1572','33','7.0000'),
('1578','33','7.0000'),
('1584','33','7.0000'),
('1590','33','7.0000'),
('1596','33','7.0000'),
('1602','33','7.0000'),
('1608','33','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1614','33','7.0000'),
('1620','33','7.0000'),
('1626','33','7.0000'),
('1632','33','7.0000'),
('1638','33','7.0000'),
('1644','33','7.0000'),
('1650','33','7.0000'),
('1656','33','7.0000'),
('1662','33','7.0000'),
('1668','33','7.0000'),
('1674','33','7.0000'),
('1680','33','7.0000'),
('1686','33','7.0000'),
('1692','33','7.0000'),
('1698','33','7.0000'),
('1704','33','7.0000'),
('1710','33','7.0000'),
('1716','33','7.0000'),
('1722','33','7.0000'),
('1728','33','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('6','34','7.0000'),
('12','34','7.0000'),
('18','34','7.0000'),
('24','34','7.0000'),
('30','34','7.0000'),
('36','34','7.0000'),
('42','34','7.0000'),
('48','34','7.0000'),
('54','34','7.0000'),
('60','34','7.0000'),
('66','34','7.0000'),
('72','34','7.0000'),
('78','34','7.0000'),
('84','34','7.0000'),
('90','34','7.0000'),
('96','34','7.0000'),
('102','34','7.0000'),
('108','34','7.0000'),
('114','34','7.0000'),
('120','34','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('126','34','7.0000'),
('132','34','7.0000'),
('138','34','7.0000'),
('144','34','7.0000'),
('150','34','7.0000'),
('156','34','7.0000'),
('162','34','7.0000'),
('168','34','7.0000'),
('174','34','7.0000'),
('180','34','7.0000'),
('186','34','7.0000'),
('192','34','7.0000'),
('198','34','7.0000'),
('204','34','7.0000'),
('210','34','7.0000'),
('216','34','7.0000'),
('222','34','7.0000'),
('228','34','7.0000'),
('234','34','7.0000'),
('240','34','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('246','34','7.0000'),
('252','34','7.0000'),
('258','34','7.0000'),
('264','34','7.0000'),
('270','34','7.0000'),
('276','34','7.0000'),
('282','34','7.0000'),
('288','34','7.0000'),
('294','34','7.0000'),
('300','34','7.0000'),
('306','34','7.0000'),
('312','34','7.0000'),
('318','34','7.0000'),
('324','34','7.0000'),
('330','34','7.0000'),
('336','34','7.0000'),
('342','34','7.0000'),
('348','34','7.0000'),
('354','34','7.0000'),
('360','34','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('366','34','7.0000'),
('372','34','7.0000'),
('378','34','7.0000'),
('384','34','7.0000'),
('390','34','7.0000'),
('396','34','7.0000'),
('402','34','7.0000'),
('408','34','7.0000'),
('414','34','7.0000'),
('420','34','7.0000'),
('426','34','7.0000'),
('432','34','7.0000'),
('438','34','7.0000'),
('444','34','7.0000'),
('450','34','7.0000'),
('456','34','7.0000'),
('462','34','7.0000'),
('468','34','7.0000'),
('474','34','7.0000'),
('480','34','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('486','34','7.0000'),
('492','34','7.0000'),
('498','34','7.0000'),
('504','34','7.0000'),
('510','34','7.0000'),
('516','34','7.0000'),
('522','34','7.0000'),
('528','34','7.0000'),
('534','34','7.0000'),
('540','34','7.0000'),
('546','34','7.0000'),
('552','34','7.0000'),
('558','34','7.0000'),
('564','34','7.0000'),
('570','34','7.0000'),
('576','34','7.0000'),
('582','34','7.0000'),
('588','34','7.0000'),
('594','34','7.0000'),
('600','34','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('606','34','7.0000'),
('612','34','7.0000'),
('618','34','7.0000'),
('624','34','7.0000'),
('630','34','7.0000'),
('636','34','7.0000'),
('642','34','7.0000'),
('648','34','7.0000'),
('654','34','7.0000'),
('660','34','7.0000'),
('666','34','7.0000'),
('672','34','7.0000'),
('678','34','7.0000'),
('684','34','7.0000'),
('690','34','7.0000'),
('696','34','7.0000'),
('702','34','7.0000'),
('708','34','7.0000'),
('714','34','7.0000'),
('720','34','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('726','34','7.0000'),
('732','34','7.0000'),
('738','34','7.0000'),
('744','34','7.0000'),
('750','34','7.0000'),
('756','34','7.0000'),
('762','34','7.0000'),
('768','34','7.0000'),
('774','34','7.0000'),
('780','34','7.0000'),
('786','34','7.0000'),
('792','34','7.0000'),
('798','34','7.0000'),
('804','34','7.0000'),
('810','34','7.0000'),
('816','34','7.0000'),
('822','34','7.0000'),
('828','34','7.0000'),
('834','34','7.0000'),
('840','34','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('846','34','7.0000'),
('852','34','7.0000'),
('858','34','7.0000'),
('864','34','7.0000'),
('870','34','7.0000'),
('876','34','7.0000'),
('882','34','7.0000'),
('888','34','7.0000'),
('894','34','7.0000'),
('900','34','7.0000'),
('906','34','7.0000'),
('912','34','7.0000'),
('918','34','7.0000'),
('924','34','7.0000'),
('930','34','7.0000'),
('936','34','7.0000'),
('942','34','7.0000'),
('948','34','7.0000'),
('954','34','7.0000'),
('960','34','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('966','34','7.0000'),
('972','34','7.0000'),
('978','34','7.0000'),
('984','34','7.0000'),
('990','34','7.0000'),
('996','34','7.0000'),
('1002','34','7.0000'),
('1008','34','7.0000'),
('1014','34','7.0000'),
('1020','34','7.0000'),
('1026','34','7.0000'),
('1032','34','7.0000'),
('1038','34','7.0000'),
('1044','34','7.0000'),
('1050','34','7.0000'),
('1056','34','7.0000'),
('1062','34','7.0000'),
('1068','34','7.0000'),
('1074','34','7.0000'),
('1080','34','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1086','34','7.0000'),
('1092','34','7.0000'),
('1098','34','7.0000'),
('1104','34','7.0000'),
('1110','34','7.0000'),
('1116','34','7.0000'),
('1122','34','7.0000'),
('1128','34','7.0000'),
('1134','34','7.0000'),
('1140','34','7.0000'),
('1146','34','7.0000'),
('1152','34','7.0000'),
('1158','34','7.0000'),
('1164','34','7.0000'),
('1170','34','7.0000'),
('1176','34','7.0000'),
('1182','34','7.0000'),
('1188','34','7.0000'),
('1194','34','7.0000'),
('1200','34','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1206','34','7.0000'),
('1212','34','7.0000'),
('1218','34','7.0000'),
('1224','34','7.0000'),
('1230','34','7.0000'),
('1236','34','7.0000'),
('1242','34','7.0000'),
('1248','34','7.0000'),
('1254','34','7.0000'),
('1260','34','7.0000'),
('1266','34','7.0000'),
('1272','34','7.0000'),
('1278','34','7.0000'),
('1284','34','7.0000'),
('1290','34','7.0000'),
('1296','34','7.0000'),
('1302','34','7.0000'),
('1308','34','7.0000'),
('1314','34','7.0000'),
('1320','34','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1326','34','7.0000'),
('1332','34','7.0000'),
('1338','34','7.0000'),
('1344','34','7.0000'),
('1350','34','7.0000'),
('1356','34','7.0000'),
('1362','34','7.0000'),
('1368','34','7.0000'),
('1374','34','7.0000'),
('1380','34','7.0000'),
('1386','34','7.0000'),
('1392','34','7.0000'),
('1398','34','7.0000'),
('1404','34','7.0000'),
('1410','34','7.0000'),
('1416','34','7.0000'),
('1422','34','7.0000'),
('1428','34','7.0000'),
('1434','34','7.0000'),
('1440','34','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1446','34','7.0000'),
('1452','34','7.0000'),
('1458','34','7.0000'),
('1464','34','7.0000'),
('1470','34','7.0000'),
('1476','34','7.0000'),
('1482','34','7.0000'),
('1488','34','7.0000'),
('1494','34','7.0000'),
('1500','34','7.0000'),
('1506','34','7.0000'),
('1512','34','7.0000'),
('1518','34','7.0000'),
('1524','34','7.0000'),
('1530','34','7.0000'),
('1536','34','7.0000'),
('1542','34','7.0000'),
('1548','34','7.0000'),
('1554','34','7.0000'),
('1560','34','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1566','34','7.0000'),
('1572','34','7.0000'),
('1578','34','7.0000'),
('1584','34','7.0000'),
('1590','34','7.0000'),
('1596','34','7.0000'),
('1602','34','7.0000'),
('1608','34','7.0000'),
('1614','34','7.0000'),
('1620','34','7.0000'),
('1626','34','7.0000'),
('1632','34','7.0000'),
('1638','34','7.0000'),
('1644','34','7.0000'),
('1650','34','7.0000'),
('1656','34','7.0000'),
('1662','34','7.0000'),
('1668','34','7.0000'),
('1674','34','7.0000'),
('1680','34','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1686','34','7.0000'),
('1692','34','7.0000'),
('1698','34','7.0000'),
('1704','34','7.0000'),
('1710','34','7.0000'),
('1716','34','7.0000'),
('1722','34','7.0000'),
('1728','34','7.0000'),
('6','35','7.0000'),
('12','35','7.0000'),
('18','35','7.0000'),
('24','35','7.0000'),
('30','35','7.0000'),
('36','35','7.0000'),
('42','35','7.0000'),
('48','35','7.0000'),
('54','35','7.0000'),
('60','35','7.0000'),
('66','35','7.0000'),
('72','35','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('78','35','7.0000'),
('84','35','7.0000'),
('90','35','7.0000'),
('96','35','7.0000'),
('102','35','7.0000'),
('108','35','7.0000'),
('114','35','7.0000'),
('120','35','7.0000'),
('126','35','7.0000'),
('132','35','7.0000'),
('138','35','7.0000'),
('144','35','7.0000'),
('150','35','7.0000'),
('156','35','7.0000'),
('162','35','7.0000'),
('168','35','7.0000'),
('174','35','7.0000'),
('180','35','7.0000'),
('186','35','7.0000'),
('192','35','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('198','35','7.0000'),
('204','35','7.0000'),
('210','35','7.0000'),
('216','35','7.0000'),
('222','35','7.0000'),
('228','35','7.0000'),
('234','35','7.0000'),
('240','35','7.0000'),
('246','35','7.0000'),
('252','35','7.0000'),
('258','35','7.0000'),
('264','35','7.0000'),
('270','35','7.0000'),
('276','35','7.0000'),
('282','35','7.0000'),
('288','35','7.0000'),
('294','35','7.0000'),
('300','35','7.0000'),
('306','35','7.0000'),
('312','35','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('318','35','7.0000'),
('324','35','7.0000'),
('330','35','7.0000'),
('336','35','7.0000'),
('342','35','7.0000'),
('348','35','7.0000'),
('354','35','7.0000'),
('360','35','7.0000'),
('366','35','7.0000'),
('372','35','7.0000'),
('378','35','7.0000'),
('384','35','7.0000'),
('390','35','7.0000'),
('396','35','7.0000'),
('402','35','7.0000'),
('408','35','7.0000'),
('414','35','7.0000'),
('420','35','7.0000'),
('426','35','7.0000'),
('432','35','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('438','35','7.0000'),
('444','35','7.0000'),
('450','35','7.0000'),
('456','35','7.0000'),
('462','35','7.0000'),
('468','35','7.0000'),
('474','35','7.0000'),
('480','35','7.0000'),
('486','35','7.0000'),
('492','35','7.0000'),
('498','35','7.0000'),
('504','35','7.0000'),
('510','35','7.0000'),
('516','35','7.0000'),
('522','35','7.0000'),
('528','35','7.0000'),
('534','35','7.0000'),
('540','35','7.0000'),
('546','35','7.0000'),
('552','35','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('558','35','7.0000'),
('564','35','7.0000'),
('570','35','7.0000'),
('576','35','7.0000'),
('582','35','7.0000'),
('588','35','7.0000'),
('594','35','7.0000'),
('600','35','7.0000'),
('606','35','7.0000'),
('612','35','7.0000'),
('618','35','7.0000'),
('624','35','7.0000'),
('630','35','7.0000'),
('636','35','7.0000'),
('642','35','7.0000'),
('648','35','7.0000'),
('654','35','7.0000'),
('660','35','7.0000'),
('666','35','7.0000'),
('672','35','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('678','35','7.0000'),
('684','35','7.0000'),
('690','35','7.0000'),
('696','35','7.0000'),
('702','35','7.0000'),
('708','35','7.0000'),
('714','35','7.0000'),
('720','35','7.0000'),
('726','35','7.0000'),
('732','35','7.0000'),
('738','35','7.0000'),
('744','35','7.0000'),
('750','35','7.0000'),
('756','35','7.0000'),
('762','35','7.0000'),
('768','35','7.0000'),
('774','35','7.0000'),
('780','35','7.0000'),
('786','35','7.0000'),
('792','35','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('798','35','7.0000'),
('804','35','7.0000'),
('810','35','7.0000'),
('816','35','7.0000'),
('822','35','7.0000'),
('828','35','7.0000'),
('834','35','7.0000'),
('840','35','7.0000'),
('846','35','7.0000'),
('852','35','7.0000'),
('858','35','7.0000'),
('864','35','7.0000'),
('870','35','7.0000'),
('876','35','7.0000'),
('882','35','7.0000'),
('888','35','7.0000'),
('894','35','7.0000'),
('900','35','7.0000'),
('906','35','7.0000'),
('912','35','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('918','35','7.0000'),
('924','35','7.0000'),
('930','35','7.0000'),
('936','35','7.0000'),
('942','35','7.0000'),
('948','35','7.0000'),
('954','35','7.0000'),
('960','35','7.0000'),
('966','35','7.0000'),
('972','35','7.0000'),
('978','35','7.0000'),
('984','35','7.0000'),
('990','35','7.0000'),
('996','35','7.0000'),
('1002','35','7.0000'),
('1008','35','7.0000'),
('1014','35','7.0000'),
('1020','35','7.0000'),
('1026','35','7.0000'),
('1032','35','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1038','35','7.0000'),
('1044','35','7.0000'),
('1050','35','7.0000'),
('1056','35','7.0000'),
('1062','35','7.0000'),
('1068','35','7.0000'),
('1074','35','7.0000'),
('1080','35','7.0000'),
('1086','35','7.0000'),
('1092','35','7.0000'),
('1098','35','7.0000'),
('1104','35','7.0000'),
('1110','35','7.0000'),
('1116','35','7.0000'),
('1122','35','7.0000'),
('1128','35','7.0000'),
('1134','35','7.0000'),
('1140','35','7.0000'),
('1146','35','7.0000'),
('1152','35','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1158','35','7.0000'),
('1164','35','7.0000'),
('1170','35','7.0000'),
('1176','35','7.0000'),
('1182','35','7.0000'),
('1188','35','7.0000'),
('1194','35','7.0000'),
('1200','35','7.0000'),
('1206','35','7.0000'),
('1212','35','7.0000'),
('1218','35','7.0000'),
('1224','35','7.0000'),
('1230','35','7.0000'),
('1236','35','7.0000'),
('1242','35','7.0000'),
('1248','35','7.0000'),
('1254','35','7.0000'),
('1260','35','7.0000'),
('1266','35','7.0000'),
('1272','35','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1278','35','7.0000'),
('1284','35','7.0000'),
('1290','35','7.0000'),
('1296','35','7.0000'),
('1302','35','7.0000'),
('1308','35','7.0000'),
('1314','35','7.0000'),
('1320','35','7.0000'),
('1326','35','7.0000'),
('1332','35','7.0000'),
('1338','35','7.0000'),
('1344','35','7.0000'),
('1350','35','7.0000'),
('1356','35','7.0000'),
('1362','35','7.0000'),
('1368','35','7.0000'),
('1374','35','7.0000'),
('1380','35','7.0000'),
('1386','35','7.0000'),
('1392','35','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1398','35','7.0000'),
('1404','35','7.0000'),
('1410','35','7.0000'),
('1416','35','7.0000'),
('1422','35','7.0000'),
('1428','35','7.0000'),
('1434','35','7.0000'),
('1440','35','7.0000'),
('1446','35','7.0000'),
('1452','35','7.0000'),
('1458','35','7.0000'),
('1464','35','7.0000'),
('1470','35','7.0000'),
('1476','35','7.0000'),
('1482','35','7.0000'),
('1488','35','7.0000'),
('1494','35','7.0000'),
('1500','35','7.0000'),
('1506','35','7.0000'),
('1512','35','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1518','35','7.0000'),
('1524','35','7.0000'),
('1530','35','7.0000'),
('1536','35','7.0000'),
('1542','35','7.0000'),
('1548','35','7.0000'),
('1554','35','7.0000'),
('1560','35','7.0000'),
('1566','35','7.0000'),
('1572','35','7.0000'),
('1578','35','7.0000'),
('1584','35','7.0000'),
('1590','35','7.0000'),
('1596','35','7.0000'),
('1602','35','7.0000'),
('1608','35','7.0000'),
('1614','35','7.0000'),
('1620','35','7.0000'),
('1626','35','7.0000'),
('1632','35','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1638','35','7.0000'),
('1644','35','7.0000'),
('1650','35','7.0000'),
('1656','35','7.0000'),
('1662','35','7.0000'),
('1668','35','7.0000'),
('1674','35','7.0000'),
('1680','35','7.0000'),
('1686','35','7.0000'),
('1692','35','7.0000'),
('1698','35','7.0000'),
('1704','35','7.0000'),
('1710','35','7.0000'),
('1716','35','7.0000'),
('1722','35','7.0000'),
('1728','35','7.0000'),
('6','36','7.0000'),
('12','36','7.0000'),
('18','36','7.0000'),
('24','36','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('30','36','7.0000'),
('36','36','7.0000'),
('42','36','7.0000'),
('48','36','7.0000'),
('54','36','7.0000'),
('60','36','7.0000'),
('66','36','7.0000'),
('72','36','7.0000'),
('78','36','7.0000'),
('84','36','7.0000'),
('90','36','7.0000'),
('96','36','7.0000'),
('102','36','7.0000'),
('108','36','7.0000'),
('114','36','7.0000'),
('120','36','7.0000'),
('126','36','7.0000'),
('132','36','7.0000'),
('138','36','7.0000'),
('144','36','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('150','36','7.0000'),
('156','36','7.0000'),
('162','36','7.0000'),
('168','36','7.0000'),
('174','36','7.0000'),
('180','36','7.0000'),
('186','36','7.0000'),
('192','36','7.0000'),
('198','36','7.0000'),
('204','36','7.0000'),
('210','36','7.0000'),
('216','36','7.0000'),
('222','36','7.0000'),
('228','36','7.0000'),
('234','36','7.0000'),
('240','36','7.0000'),
('246','36','7.0000'),
('252','36','7.0000'),
('258','36','7.0000'),
('264','36','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('270','36','7.0000'),
('276','36','7.0000'),
('282','36','7.0000'),
('288','36','7.0000'),
('294','36','7.0000'),
('300','36','7.0000'),
('306','36','7.0000'),
('312','36','7.0000'),
('318','36','7.0000'),
('324','36','7.0000'),
('330','36','7.0000'),
('336','36','7.0000'),
('342','36','7.0000'),
('348','36','7.0000'),
('354','36','7.0000'),
('360','36','7.0000'),
('366','36','7.0000'),
('372','36','7.0000'),
('378','36','7.0000'),
('384','36','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('390','36','7.0000'),
('396','36','7.0000'),
('402','36','7.0000'),
('408','36','7.0000'),
('414','36','7.0000'),
('420','36','7.0000'),
('426','36','7.0000'),
('432','36','7.0000'),
('438','36','7.0000'),
('444','36','7.0000'),
('450','36','7.0000'),
('456','36','7.0000'),
('462','36','7.0000'),
('468','36','7.0000'),
('474','36','7.0000'),
('480','36','7.0000'),
('486','36','7.0000'),
('492','36','7.0000'),
('498','36','7.0000'),
('504','36','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('510','36','7.0000'),
('516','36','7.0000'),
('522','36','7.0000'),
('528','36','7.0000'),
('534','36','7.0000'),
('540','36','7.0000'),
('546','36','7.0000'),
('552','36','7.0000'),
('558','36','7.0000'),
('564','36','7.0000'),
('570','36','7.0000'),
('576','36','7.0000'),
('582','36','7.0000'),
('588','36','7.0000'),
('594','36','7.0000'),
('600','36','7.0000'),
('606','36','7.0000'),
('612','36','7.0000'),
('618','36','7.0000'),
('624','36','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('630','36','7.0000'),
('636','36','7.0000'),
('642','36','7.0000'),
('648','36','7.0000'),
('654','36','7.0000'),
('660','36','7.0000'),
('666','36','7.0000'),
('672','36','7.0000'),
('678','36','7.0000'),
('684','36','7.0000'),
('690','36','7.0000'),
('696','36','7.0000'),
('702','36','7.0000'),
('708','36','7.0000'),
('714','36','7.0000'),
('720','36','7.0000'),
('726','36','7.0000'),
('732','36','7.0000'),
('738','36','7.0000'),
('744','36','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('750','36','7.0000'),
('756','36','7.0000'),
('762','36','7.0000'),
('768','36','7.0000'),
('774','36','7.0000'),
('780','36','7.0000'),
('786','36','7.0000'),
('792','36','7.0000'),
('798','36','7.0000'),
('804','36','7.0000'),
('810','36','7.0000'),
('816','36','7.0000'),
('822','36','7.0000'),
('828','36','7.0000'),
('834','36','7.0000'),
('840','36','7.0000'),
('846','36','7.0000'),
('852','36','7.0000'),
('858','36','7.0000'),
('864','36','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('870','36','7.0000'),
('876','36','7.0000'),
('882','36','7.0000'),
('888','36','7.0000'),
('894','36','7.0000'),
('900','36','7.0000'),
('906','36','7.0000'),
('912','36','7.0000'),
('918','36','7.0000'),
('924','36','7.0000'),
('930','36','7.0000'),
('936','36','7.0000'),
('942','36','7.0000'),
('948','36','7.0000'),
('954','36','7.0000'),
('960','36','7.0000'),
('966','36','7.0000'),
('972','36','7.0000'),
('978','36','7.0000'),
('984','36','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('990','36','7.0000'),
('996','36','7.0000'),
('1002','36','7.0000'),
('1008','36','7.0000'),
('1014','36','7.0000'),
('1020','36','7.0000'),
('1026','36','7.0000'),
('1032','36','7.0000'),
('1038','36','7.0000'),
('1044','36','7.0000'),
('1050','36','7.0000'),
('1056','36','7.0000'),
('1062','36','7.0000'),
('1068','36','7.0000'),
('1074','36','7.0000'),
('1080','36','7.0000'),
('1086','36','7.0000'),
('1092','36','7.0000'),
('1098','36','7.0000'),
('1104','36','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1110','36','7.0000'),
('1116','36','7.0000'),
('1122','36','7.0000'),
('1128','36','7.0000'),
('1134','36','7.0000'),
('1140','36','7.0000'),
('1146','36','7.0000'),
('1152','36','7.0000'),
('1158','36','7.0000'),
('1164','36','7.0000'),
('1170','36','7.0000'),
('1176','36','7.0000'),
('1182','36','7.0000'),
('1188','36','7.0000'),
('1194','36','7.0000'),
('1200','36','7.0000'),
('1206','36','7.0000'),
('1212','36','7.0000'),
('1218','36','7.0000'),
('1224','36','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1230','36','7.0000'),
('1236','36','7.0000'),
('1242','36','7.0000'),
('1248','36','7.0000'),
('1254','36','7.0000'),
('1260','36','7.0000'),
('1266','36','7.0000'),
('1272','36','7.0000'),
('1278','36','7.0000'),
('1284','36','7.0000'),
('1290','36','7.0000'),
('1296','36','7.0000'),
('1302','36','7.0000'),
('1308','36','7.0000'),
('1314','36','7.0000'),
('1320','36','7.0000'),
('1326','36','7.0000'),
('1332','36','7.0000'),
('1338','36','7.0000'),
('1344','36','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1350','36','7.0000'),
('1356','36','7.0000'),
('1362','36','7.0000'),
('1368','36','7.0000'),
('1374','36','7.0000'),
('1380','36','7.0000'),
('1386','36','7.0000'),
('1392','36','7.0000'),
('1398','36','7.0000'),
('1404','36','7.0000'),
('1410','36','7.0000'),
('1416','36','7.0000'),
('1422','36','7.0000'),
('1428','36','7.0000'),
('1434','36','7.0000'),
('1440','36','7.0000'),
('1446','36','7.0000'),
('1452','36','7.0000'),
('1458','36','7.0000'),
('1464','36','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1470','36','7.0000'),
('1476','36','7.0000'),
('1482','36','7.0000'),
('1488','36','7.0000'),
('1494','36','7.0000'),
('1500','36','7.0000'),
('1506','36','7.0000'),
('1512','36','7.0000'),
('1518','36','7.0000'),
('1524','36','7.0000'),
('1530','36','7.0000'),
('1536','36','7.0000'),
('1542','36','7.0000'),
('1548','36','7.0000'),
('1554','36','7.0000'),
('1560','36','7.0000'),
('1566','36','7.0000'),
('1572','36','7.0000'),
('1578','36','7.0000'),
('1584','36','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1590','36','7.0000'),
('1596','36','7.0000'),
('1602','36','7.0000'),
('1608','36','7.0000'),
('1614','36','7.0000'),
('1620','36','7.0000'),
('1626','36','7.0000'),
('1632','36','7.0000'),
('1638','36','7.0000'),
('1644','36','7.0000'),
('1650','36','7.0000'),
('1656','36','7.0000'),
('1662','36','7.0000'),
('1668','36','7.0000'),
('1674','36','7.0000'),
('1680','36','7.0000'),
('1686','36','7.0000'),
('1692','36','7.0000'),
('1698','36','7.0000'),
('1704','36','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1710','36','7.0000'),
('1716','36','7.0000'),
('1722','36','7.0000'),
('1728','36','7.0000'),
('6','37','7.0000'),
('12','37','7.0000'),
('18','37','7.0000'),
('24','37','7.0000'),
('30','37','7.0000'),
('36','37','7.0000'),
('42','37','7.0000'),
('48','37','7.0000'),
('54','37','7.0000'),
('60','37','7.0000'),
('66','37','7.0000'),
('72','37','7.0000'),
('78','37','7.0000'),
('84','37','7.0000'),
('90','37','7.0000'),
('96','37','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('102','37','7.0000'),
('108','37','7.0000'),
('114','37','7.0000'),
('120','37','7.0000'),
('126','37','7.0000'),
('132','37','7.0000'),
('138','37','7.0000'),
('144','37','7.0000'),
('150','37','7.0000'),
('156','37','7.0000'),
('162','37','7.0000'),
('168','37','7.0000'),
('174','37','7.0000'),
('180','37','7.0000'),
('186','37','7.0000'),
('192','37','7.0000'),
('198','37','7.0000'),
('204','37','7.0000'),
('210','37','7.0000'),
('216','37','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('222','37','7.0000'),
('228','37','7.0000'),
('234','37','7.0000'),
('240','37','7.0000'),
('246','37','7.0000'),
('252','37','7.0000'),
('258','37','7.0000'),
('264','37','7.0000'),
('270','37','7.0000'),
('276','37','7.0000'),
('282','37','7.0000'),
('288','37','7.0000'),
('294','37','7.0000'),
('300','37','7.0000'),
('306','37','7.0000'),
('312','37','7.0000'),
('318','37','7.0000'),
('324','37','7.0000'),
('330','37','7.0000'),
('336','37','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('342','37','7.0000'),
('348','37','7.0000'),
('354','37','7.0000'),
('360','37','7.0000'),
('366','37','7.0000'),
('372','37','7.0000'),
('378','37','7.0000'),
('384','37','7.0000'),
('390','37','7.0000'),
('396','37','7.0000'),
('402','37','7.0000'),
('408','37','7.0000'),
('414','37','7.0000'),
('420','37','7.0000'),
('426','37','7.0000'),
('432','37','7.0000'),
('438','37','7.0000'),
('444','37','7.0000'),
('450','37','7.0000'),
('456','37','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('462','37','7.0000'),
('468','37','7.0000'),
('474','37','7.0000'),
('480','37','7.0000'),
('486','37','7.0000'),
('492','37','7.0000'),
('498','37','7.0000'),
('504','37','7.0000'),
('510','37','7.0000'),
('516','37','7.0000'),
('522','37','7.0000'),
('528','37','7.0000'),
('534','37','7.0000'),
('540','37','7.0000'),
('546','37','7.0000'),
('552','37','7.0000'),
('558','37','7.0000'),
('564','37','7.0000'),
('570','37','7.0000'),
('576','37','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('582','37','7.0000'),
('588','37','7.0000'),
('594','37','7.0000'),
('600','37','7.0000'),
('606','37','7.0000'),
('612','37','7.0000'),
('618','37','7.0000'),
('624','37','7.0000'),
('630','37','7.0000'),
('636','37','7.0000'),
('642','37','7.0000'),
('648','37','7.0000'),
('654','37','7.0000'),
('660','37','7.0000'),
('666','37','7.0000'),
('672','37','7.0000'),
('678','37','7.0000'),
('684','37','7.0000'),
('690','37','7.0000'),
('696','37','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('702','37','7.0000'),
('708','37','7.0000'),
('714','37','7.0000'),
('720','37','7.0000'),
('726','37','7.0000'),
('732','37','7.0000'),
('738','37','7.0000'),
('744','37','7.0000'),
('750','37','7.0000'),
('756','37','7.0000'),
('762','37','7.0000'),
('768','37','7.0000'),
('774','37','7.0000'),
('780','37','7.0000'),
('786','37','7.0000'),
('792','37','7.0000'),
('798','37','7.0000'),
('804','37','7.0000'),
('810','37','7.0000'),
('816','37','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('822','37','7.0000'),
('828','37','7.0000'),
('834','37','7.0000'),
('840','37','7.0000'),
('846','37','7.0000'),
('852','37','7.0000'),
('858','37','7.0000'),
('864','37','7.0000'),
('870','37','7.0000'),
('876','37','7.0000'),
('882','37','7.0000'),
('888','37','7.0000'),
('894','37','7.0000'),
('900','37','7.0000'),
('906','37','7.0000'),
('912','37','7.0000'),
('918','37','7.0000'),
('924','37','7.0000'),
('930','37','7.0000'),
('936','37','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('942','37','7.0000'),
('948','37','7.0000'),
('954','37','7.0000'),
('960','37','7.0000'),
('966','37','7.0000'),
('972','37','7.0000'),
('978','37','7.0000'),
('984','37','7.0000'),
('990','37','7.0000'),
('996','37','7.0000'),
('1002','37','7.0000'),
('1008','37','7.0000'),
('1014','37','7.0000'),
('1020','37','7.0000'),
('1026','37','7.0000'),
('1032','37','7.0000'),
('1038','37','7.0000'),
('1044','37','7.0000'),
('1050','37','7.0000'),
('1056','37','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1062','37','7.0000'),
('1068','37','7.0000'),
('1074','37','7.0000'),
('1080','37','7.0000'),
('1086','37','7.0000'),
('1092','37','7.0000'),
('1098','37','7.0000'),
('1104','37','7.0000'),
('1110','37','7.0000'),
('1116','37','7.0000'),
('1122','37','7.0000'),
('1128','37','7.0000'),
('1134','37','7.0000'),
('1140','37','7.0000'),
('1146','37','7.0000'),
('1152','37','7.0000'),
('1158','37','7.0000'),
('1164','37','7.0000'),
('1170','37','7.0000'),
('1176','37','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1182','37','7.0000'),
('1188','37','7.0000'),
('1194','37','7.0000'),
('1200','37','7.0000'),
('1206','37','7.0000'),
('1212','37','7.0000'),
('1218','37','7.0000'),
('1224','37','7.0000'),
('1230','37','7.0000'),
('1236','37','7.0000'),
('1242','37','7.0000'),
('1248','37','7.0000'),
('1254','37','7.0000'),
('1260','37','7.0000'),
('1266','37','7.0000'),
('1272','37','7.0000'),
('1278','37','7.0000'),
('1284','37','7.0000'),
('1290','37','7.0000'),
('1296','37','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1302','37','7.0000'),
('1308','37','7.0000'),
('1314','37','7.0000'),
('1320','37','7.0000'),
('1326','37','7.0000'),
('1332','37','7.0000'),
('1338','37','7.0000'),
('1344','37','7.0000'),
('1350','37','7.0000'),
('1356','37','7.0000'),
('1362','37','7.0000'),
('1368','37','7.0000'),
('1374','37','7.0000'),
('1380','37','7.0000'),
('1386','37','7.0000'),
('1392','37','7.0000'),
('1398','37','7.0000'),
('1404','37','7.0000'),
('1410','37','7.0000'),
('1416','37','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1422','37','7.0000'),
('1428','37','7.0000'),
('1434','37','7.0000'),
('1440','37','7.0000'),
('1446','37','7.0000'),
('1452','37','7.0000'),
('1458','37','7.0000'),
('1464','37','7.0000'),
('1470','37','7.0000'),
('1476','37','7.0000'),
('1482','37','7.0000'),
('1488','37','7.0000'),
('1494','37','7.0000'),
('1500','37','7.0000'),
('1506','37','7.0000'),
('1512','37','7.0000'),
('1518','37','7.0000'),
('1524','37','7.0000'),
('1530','37','7.0000'),
('1536','37','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1542','37','7.0000'),
('1548','37','7.0000'),
('1554','37','7.0000'),
('1560','37','7.0000'),
('1566','37','7.0000'),
('1572','37','7.0000'),
('1578','37','7.0000'),
('1584','37','7.0000'),
('1590','37','7.0000'),
('1596','37','7.0000'),
('1602','37','7.0000'),
('1608','37','7.0000'),
('1614','37','7.0000'),
('1620','37','7.0000'),
('1626','37','7.0000'),
('1632','37','7.0000'),
('1638','37','7.0000'),
('1644','37','7.0000'),
('1650','37','7.0000'),
('1656','37','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1662','37','7.0000'),
('1668','37','7.0000'),
('1674','37','7.0000'),
('1680','37','7.0000'),
('1686','37','7.0000'),
('1692','37','7.0000'),
('1698','37','7.0000'),
('1704','37','7.0000'),
('1710','37','7.0000'),
('1716','37','7.0000'),
('1722','37','7.0000'),
('1728','37','7.0000'),
('6','38','7.0000'),
('12','38','7.0000'),
('18','38','7.0000'),
('24','38','7.0000'),
('30','38','7.0000'),
('36','38','7.0000'),
('42','38','7.0000'),
('48','38','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('54','38','7.0000'),
('60','38','7.0000'),
('66','38','7.0000'),
('72','38','7.0000'),
('78','38','7.0000'),
('84','38','7.0000'),
('90','38','7.0000'),
('96','38','7.0000'),
('102','38','7.0000'),
('108','38','7.0000'),
('114','38','7.0000'),
('120','38','7.0000'),
('126','38','7.0000'),
('132','38','7.0000'),
('138','38','7.0000'),
('144','38','7.0000'),
('150','38','7.0000'),
('156','38','7.0000'),
('162','38','7.0000'),
('168','38','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('174','38','7.0000'),
('180','38','7.0000'),
('186','38','7.0000'),
('192','38','7.0000'),
('198','38','7.0000'),
('204','38','7.0000'),
('210','38','7.0000'),
('216','38','7.0000'),
('222','38','7.0000'),
('228','38','7.0000'),
('234','38','7.0000'),
('240','38','7.0000'),
('246','38','7.0000'),
('252','38','7.0000'),
('258','38','7.0000'),
('264','38','7.0000'),
('270','38','7.0000'),
('276','38','7.0000'),
('282','38','7.0000'),
('288','38','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('294','38','7.0000'),
('300','38','7.0000'),
('306','38','7.0000'),
('312','38','7.0000'),
('318','38','7.0000'),
('324','38','7.0000'),
('330','38','7.0000'),
('336','38','7.0000'),
('342','38','7.0000'),
('348','38','7.0000'),
('354','38','7.0000'),
('360','38','7.0000'),
('366','38','7.0000'),
('372','38','7.0000'),
('378','38','7.0000'),
('384','38','7.0000'),
('390','38','7.0000'),
('396','38','7.0000'),
('402','38','7.0000'),
('408','38','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('414','38','7.0000'),
('420','38','7.0000'),
('426','38','7.0000'),
('432','38','7.0000'),
('438','38','7.0000'),
('444','38','7.0000'),
('450','38','7.0000'),
('456','38','7.0000'),
('462','38','7.0000'),
('468','38','7.0000'),
('474','38','7.0000'),
('480','38','7.0000'),
('486','38','7.0000'),
('492','38','7.0000'),
('498','38','7.0000'),
('504','38','7.0000'),
('510','38','7.0000'),
('516','38','7.0000'),
('522','38','7.0000'),
('528','38','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('534','38','7.0000'),
('540','38','7.0000'),
('546','38','7.0000'),
('552','38','7.0000'),
('558','38','7.0000'),
('564','38','7.0000'),
('570','38','7.0000'),
('576','38','7.0000'),
('582','38','7.0000'),
('588','38','7.0000'),
('594','38','7.0000'),
('600','38','7.0000'),
('606','38','7.0000'),
('612','38','7.0000'),
('618','38','7.0000'),
('624','38','7.0000'),
('630','38','7.0000'),
('636','38','7.0000'),
('642','38','7.0000'),
('648','38','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('654','38','7.0000'),
('660','38','7.0000'),
('666','38','7.0000'),
('672','38','7.0000'),
('678','38','7.0000'),
('684','38','7.0000'),
('690','38','7.0000'),
('696','38','7.0000'),
('702','38','7.0000'),
('708','38','7.0000'),
('714','38','7.0000'),
('720','38','7.0000'),
('726','38','7.0000'),
('732','38','7.0000'),
('738','38','7.0000'),
('744','38','7.0000'),
('750','38','7.0000'),
('756','38','7.0000'),
('762','38','7.0000'),
('768','38','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('774','38','7.0000'),
('780','38','7.0000'),
('786','38','7.0000'),
('792','38','7.0000'),
('798','38','7.0000'),
('804','38','7.0000'),
('810','38','7.0000'),
('816','38','7.0000'),
('822','38','7.0000'),
('828','38','7.0000'),
('834','38','7.0000'),
('840','38','7.0000'),
('846','38','7.0000'),
('852','38','7.0000'),
('858','38','7.0000'),
('864','38','7.0000'),
('870','38','7.0000'),
('876','38','7.0000'),
('882','38','7.0000'),
('888','38','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('894','38','7.0000'),
('900','38','7.0000'),
('906','38','7.0000'),
('912','38','7.0000'),
('918','38','7.0000'),
('924','38','7.0000'),
('930','38','7.0000'),
('936','38','7.0000'),
('942','38','7.0000'),
('948','38','7.0000'),
('954','38','7.0000'),
('960','38','7.0000'),
('966','38','7.0000'),
('972','38','7.0000'),
('978','38','7.0000'),
('984','38','7.0000'),
('990','38','7.0000'),
('996','38','7.0000'),
('1002','38','7.0000'),
('1008','38','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1014','38','7.0000'),
('1020','38','7.0000'),
('1026','38','7.0000'),
('1032','38','7.0000'),
('1038','38','7.0000'),
('1044','38','7.0000'),
('1050','38','7.0000'),
('1056','38','7.0000'),
('1062','38','7.0000'),
('1068','38','7.0000'),
('1074','38','7.0000'),
('1080','38','7.0000'),
('1086','38','7.0000'),
('1092','38','7.0000'),
('1098','38','7.0000'),
('1104','38','7.0000'),
('1110','38','7.0000'),
('1116','38','7.0000'),
('1122','38','7.0000'),
('1128','38','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1134','38','7.0000'),
('1140','38','7.0000'),
('1146','38','7.0000'),
('1152','38','7.0000'),
('1158','38','7.0000'),
('1164','38','7.0000'),
('1170','38','7.0000'),
('1176','38','7.0000'),
('1182','38','7.0000'),
('1188','38','7.0000'),
('1194','38','7.0000'),
('1200','38','7.0000'),
('1206','38','7.0000'),
('1212','38','7.0000'),
('1218','38','7.0000'),
('1224','38','7.0000'),
('1230','38','7.0000'),
('1236','38','7.0000'),
('1242','38','7.0000'),
('1248','38','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1254','38','7.0000'),
('1260','38','7.0000'),
('1266','38','7.0000'),
('1272','38','7.0000'),
('1278','38','7.0000'),
('1284','38','7.0000'),
('1290','38','7.0000'),
('1296','38','7.0000'),
('1302','38','7.0000'),
('1308','38','7.0000'),
('1314','38','7.0000'),
('1320','38','7.0000'),
('1326','38','7.0000'),
('1332','38','7.0000'),
('1338','38','7.0000'),
('1344','38','7.0000'),
('1350','38','7.0000'),
('1356','38','7.0000'),
('1362','38','7.0000'),
('1368','38','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1374','38','7.0000'),
('1380','38','7.0000'),
('1386','38','7.0000'),
('1392','38','7.0000'),
('1398','38','7.0000'),
('1404','38','7.0000'),
('1410','38','7.0000'),
('1416','38','7.0000'),
('1422','38','7.0000'),
('1428','38','7.0000'),
('1434','38','7.0000'),
('1440','38','7.0000'),
('1446','38','7.0000'),
('1452','38','7.0000'),
('1458','38','7.0000'),
('1464','38','7.0000'),
('1470','38','7.0000'),
('1476','38','7.0000'),
('1482','38','7.0000'),
('1488','38','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1494','38','7.0000'),
('1500','38','7.0000'),
('1506','38','7.0000'),
('1512','38','7.0000'),
('1518','38','7.0000'),
('1524','38','7.0000'),
('1530','38','7.0000'),
('1536','38','7.0000'),
('1542','38','7.0000'),
('1548','38','7.0000'),
('1554','38','7.0000'),
('1560','38','7.0000'),
('1566','38','7.0000'),
('1572','38','7.0000'),
('1578','38','7.0000'),
('1584','38','7.0000'),
('1590','38','7.0000'),
('1596','38','7.0000'),
('1602','38','7.0000'),
('1608','38','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1614','38','7.0000'),
('1620','38','7.0000'),
('1626','38','7.0000'),
('1632','38','7.0000'),
('1638','38','7.0000'),
('1644','38','7.0000'),
('1650','38','7.0000'),
('1656','38','7.0000'),
('1662','38','7.0000'),
('1668','38','7.0000'),
('1674','38','7.0000'),
('1680','38','7.0000'),
('1686','38','7.0000'),
('1692','38','7.0000'),
('1698','38','7.0000'),
('1704','38','7.0000'),
('1710','38','7.0000'),
('1716','38','7.0000'),
('1722','38','7.0000'),
('1728','38','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('6','39','7.0000'),
('12','39','7.0000'),
('18','39','7.0000'),
('24','39','7.0000'),
('30','39','7.0000'),
('36','39','7.0000'),
('42','39','7.0000'),
('48','39','7.0000'),
('54','39','7.0000'),
('60','39','7.0000'),
('66','39','7.0000'),
('72','39','7.0000'),
('78','39','7.0000'),
('84','39','7.0000'),
('90','39','7.0000'),
('96','39','7.0000'),
('102','39','7.0000'),
('108','39','7.0000'),
('114','39','7.0000'),
('120','39','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('126','39','7.0000'),
('132','39','7.0000'),
('138','39','7.0000'),
('144','39','7.0000'),
('150','39','7.0000'),
('156','39','7.0000'),
('162','39','7.0000'),
('168','39','7.0000'),
('174','39','7.0000'),
('180','39','7.0000'),
('186','39','7.0000'),
('192','39','7.0000'),
('198','39','7.0000'),
('204','39','7.0000'),
('210','39','7.0000'),
('216','39','7.0000'),
('222','39','7.0000'),
('228','39','7.0000'),
('234','39','7.0000'),
('240','39','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('246','39','7.0000'),
('252','39','7.0000'),
('258','39','7.0000'),
('264','39','7.0000'),
('270','39','7.0000'),
('276','39','7.0000'),
('282','39','7.0000'),
('288','39','7.0000'),
('294','39','7.0000'),
('300','39','7.0000'),
('306','39','7.0000'),
('312','39','7.0000'),
('318','39','7.0000'),
('324','39','7.0000'),
('330','39','7.0000'),
('336','39','7.0000'),
('342','39','7.0000'),
('348','39','7.0000'),
('354','39','7.0000'),
('360','39','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('366','39','7.0000'),
('372','39','7.0000'),
('378','39','7.0000'),
('384','39','7.0000'),
('390','39','7.0000'),
('396','39','7.0000'),
('402','39','7.0000'),
('408','39','7.0000'),
('414','39','7.0000'),
('420','39','7.0000'),
('426','39','7.0000'),
('432','39','7.0000'),
('438','39','7.0000'),
('444','39','7.0000'),
('450','39','7.0000'),
('456','39','7.0000'),
('462','39','7.0000'),
('468','39','7.0000'),
('474','39','7.0000'),
('480','39','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('486','39','7.0000'),
('492','39','7.0000'),
('498','39','7.0000'),
('504','39','7.0000'),
('510','39','7.0000'),
('516','39','7.0000'),
('522','39','7.0000'),
('528','39','7.0000'),
('534','39','7.0000'),
('540','39','7.0000'),
('546','39','7.0000'),
('552','39','7.0000'),
('558','39','7.0000'),
('564','39','7.0000'),
('570','39','7.0000'),
('576','39','7.0000'),
('582','39','7.0000'),
('588','39','7.0000'),
('594','39','7.0000'),
('600','39','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('606','39','7.0000'),
('612','39','7.0000'),
('618','39','7.0000'),
('624','39','7.0000'),
('630','39','7.0000'),
('636','39','7.0000'),
('642','39','7.0000'),
('648','39','7.0000'),
('654','39','7.0000'),
('660','39','7.0000'),
('666','39','7.0000'),
('672','39','7.0000'),
('678','39','7.0000'),
('684','39','7.0000'),
('690','39','7.0000'),
('696','39','7.0000'),
('702','39','7.0000'),
('708','39','7.0000'),
('714','39','7.0000'),
('720','39','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('726','39','7.0000'),
('732','39','7.0000'),
('738','39','7.0000'),
('744','39','7.0000'),
('750','39','7.0000'),
('756','39','7.0000'),
('762','39','7.0000'),
('768','39','7.0000'),
('774','39','7.0000'),
('780','39','7.0000'),
('786','39','7.0000'),
('792','39','7.0000'),
('798','39','7.0000'),
('804','39','7.0000'),
('810','39','7.0000'),
('816','39','7.0000'),
('822','39','7.0000'),
('828','39','7.0000'),
('834','39','7.0000'),
('840','39','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('846','39','7.0000'),
('852','39','7.0000'),
('858','39','7.0000'),
('864','39','7.0000'),
('870','39','7.0000'),
('876','39','7.0000'),
('882','39','7.0000'),
('888','39','7.0000'),
('894','39','7.0000'),
('900','39','7.0000'),
('906','39','7.0000'),
('912','39','7.0000'),
('918','39','7.0000'),
('924','39','7.0000'),
('930','39','7.0000'),
('936','39','7.0000'),
('942','39','7.0000'),
('948','39','7.0000'),
('954','39','7.0000'),
('960','39','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('966','39','7.0000'),
('972','39','7.0000'),
('978','39','7.0000'),
('984','39','7.0000'),
('990','39','7.0000'),
('996','39','7.0000'),
('1002','39','7.0000'),
('1008','39','7.0000'),
('1014','39','7.0000'),
('1020','39','7.0000'),
('1026','39','7.0000'),
('1032','39','7.0000'),
('1038','39','7.0000'),
('1044','39','7.0000'),
('1050','39','7.0000'),
('1056','39','7.0000'),
('1062','39','7.0000'),
('1068','39','7.0000'),
('1074','39','7.0000'),
('1080','39','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1086','39','7.0000'),
('1092','39','7.0000'),
('1098','39','7.0000'),
('1104','39','7.0000'),
('1110','39','7.0000'),
('1116','39','7.0000'),
('1122','39','7.0000'),
('1128','39','7.0000'),
('1134','39','7.0000'),
('1140','39','7.0000'),
('1146','39','7.0000'),
('1152','39','7.0000'),
('1158','39','7.0000'),
('1164','39','7.0000'),
('1170','39','7.0000'),
('1176','39','7.0000'),
('1182','39','7.0000'),
('1188','39','7.0000'),
('1194','39','7.0000'),
('1200','39','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1206','39','7.0000'),
('1212','39','7.0000'),
('1218','39','7.0000'),
('1224','39','7.0000'),
('1230','39','7.0000'),
('1236','39','7.0000'),
('1242','39','7.0000'),
('1248','39','7.0000'),
('1254','39','7.0000'),
('1260','39','7.0000'),
('1266','39','7.0000'),
('1272','39','7.0000'),
('1278','39','7.0000'),
('1284','39','7.0000'),
('1290','39','7.0000'),
('1296','39','7.0000'),
('1302','39','7.0000'),
('1308','39','7.0000'),
('1314','39','7.0000'),
('1320','39','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1326','39','7.0000'),
('1332','39','7.0000'),
('1338','39','7.0000'),
('1344','39','7.0000'),
('1350','39','7.0000'),
('1356','39','7.0000'),
('1362','39','7.0000'),
('1368','39','7.0000'),
('1374','39','7.0000'),
('1380','39','7.0000'),
('1386','39','7.0000'),
('1392','39','7.0000'),
('1398','39','7.0000'),
('1404','39','7.0000'),
('1410','39','7.0000'),
('1416','39','7.0000'),
('1422','39','7.0000'),
('1428','39','7.0000'),
('1434','39','7.0000'),
('1440','39','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1446','39','7.0000'),
('1452','39','7.0000'),
('1458','39','7.0000'),
('1464','39','7.0000'),
('1470','39','7.0000'),
('1476','39','7.0000'),
('1482','39','7.0000'),
('1488','39','7.0000'),
('1494','39','7.0000'),
('1500','39','7.0000'),
('1506','39','7.0000'),
('1512','39','7.0000'),
('1518','39','7.0000'),
('1524','39','7.0000'),
('1530','39','7.0000'),
('1536','39','7.0000'),
('1542','39','7.0000'),
('1548','39','7.0000'),
('1554','39','7.0000'),
('1560','39','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1566','39','7.0000'),
('1572','39','7.0000'),
('1578','39','7.0000'),
('1584','39','7.0000'),
('1590','39','7.0000'),
('1596','39','7.0000'),
('1602','39','7.0000'),
('1608','39','7.0000'),
('1614','39','7.0000'),
('1620','39','7.0000'),
('1626','39','7.0000'),
('1632','39','7.0000'),
('1638','39','7.0000'),
('1644','39','7.0000'),
('1650','39','7.0000'),
('1656','39','7.0000'),
('1662','39','7.0000'),
('1668','39','7.0000'),
('1674','39','7.0000'),
('1680','39','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1686','39','7.0000'),
('1692','39','7.0000'),
('1698','39','7.0000'),
('1704','39','7.0000'),
('1710','39','7.0000'),
('1716','39','7.0000'),
('1722','39','7.0000'),
('1728','39','7.0000'),
('6','40','7.0000'),
('12','40','7.0000'),
('18','40','7.0000'),
('24','40','7.0000'),
('30','40','7.0000'),
('36','40','7.0000'),
('42','40','7.0000'),
('48','40','7.0000'),
('54','40','7.0000'),
('60','40','7.0000'),
('66','40','7.0000'),
('72','40','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('78','40','7.0000'),
('84','40','7.0000'),
('90','40','7.0000'),
('96','40','7.0000'),
('102','40','7.0000'),
('108','40','7.0000'),
('114','40','7.0000'),
('120','40','7.0000'),
('126','40','7.0000'),
('132','40','7.0000'),
('138','40','7.0000'),
('144','40','7.0000'),
('150','40','7.0000'),
('156','40','7.0000'),
('162','40','7.0000'),
('168','40','7.0000'),
('174','40','7.0000'),
('180','40','7.0000'),
('186','40','7.0000'),
('192','40','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('198','40','7.0000'),
('204','40','7.0000'),
('210','40','7.0000'),
('216','40','7.0000'),
('222','40','7.0000'),
('228','40','7.0000'),
('234','40','7.0000'),
('240','40','7.0000'),
('246','40','7.0000'),
('252','40','7.0000'),
('258','40','7.0000'),
('264','40','7.0000'),
('270','40','7.0000'),
('276','40','7.0000'),
('282','40','7.0000'),
('288','40','7.0000'),
('294','40','7.0000'),
('300','40','7.0000'),
('306','40','7.0000'),
('312','40','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('318','40','7.0000'),
('324','40','7.0000'),
('330','40','7.0000'),
('336','40','7.0000'),
('342','40','7.0000'),
('348','40','7.0000'),
('354','40','7.0000'),
('360','40','7.0000'),
('366','40','7.0000'),
('372','40','7.0000'),
('378','40','7.0000'),
('384','40','7.0000'),
('390','40','7.0000'),
('396','40','7.0000'),
('402','40','7.0000'),
('408','40','7.0000'),
('414','40','7.0000'),
('420','40','7.0000'),
('426','40','7.0000'),
('432','40','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('438','40','7.0000'),
('444','40','7.0000'),
('450','40','7.0000'),
('456','40','7.0000'),
('462','40','7.0000'),
('468','40','7.0000'),
('474','40','7.0000'),
('480','40','7.0000'),
('486','40','7.0000'),
('492','40','7.0000'),
('498','40','7.0000'),
('504','40','7.0000'),
('510','40','7.0000'),
('516','40','7.0000'),
('522','40','7.0000'),
('528','40','7.0000'),
('534','40','7.0000'),
('540','40','7.0000'),
('546','40','7.0000'),
('552','40','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('558','40','7.0000'),
('564','40','7.0000'),
('570','40','7.0000'),
('576','40','7.0000'),
('582','40','7.0000'),
('588','40','7.0000'),
('594','40','7.0000'),
('600','40','7.0000'),
('606','40','7.0000'),
('612','40','7.0000'),
('618','40','7.0000'),
('624','40','7.0000'),
('630','40','7.0000'),
('636','40','7.0000'),
('642','40','7.0000'),
('648','40','7.0000'),
('654','40','7.0000'),
('660','40','7.0000'),
('666','40','7.0000'),
('672','40','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('678','40','7.0000'),
('684','40','7.0000'),
('690','40','7.0000'),
('696','40','7.0000'),
('702','40','7.0000'),
('708','40','7.0000'),
('714','40','7.0000'),
('720','40','7.0000'),
('726','40','7.0000'),
('732','40','7.0000'),
('738','40','7.0000'),
('744','40','7.0000'),
('750','40','7.0000'),
('756','40','7.0000'),
('762','40','7.0000'),
('768','40','7.0000'),
('774','40','7.0000'),
('780','40','7.0000'),
('786','40','7.0000'),
('792','40','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('798','40','7.0000'),
('804','40','7.0000'),
('810','40','7.0000'),
('816','40','7.0000'),
('822','40','7.0000'),
('828','40','7.0000'),
('834','40','7.0000'),
('840','40','7.0000'),
('846','40','7.0000'),
('852','40','7.0000'),
('858','40','7.0000'),
('864','40','7.0000'),
('870','40','7.0000'),
('876','40','7.0000'),
('882','40','7.0000'),
('888','40','7.0000'),
('894','40','7.0000'),
('900','40','7.0000'),
('906','40','7.0000'),
('912','40','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('918','40','7.0000'),
('924','40','7.0000'),
('930','40','7.0000'),
('936','40','7.0000'),
('942','40','7.0000'),
('948','40','7.0000'),
('954','40','7.0000'),
('960','40','7.0000'),
('966','40','7.0000'),
('972','40','7.0000'),
('978','40','7.0000'),
('984','40','7.0000'),
('990','40','7.0000'),
('996','40','7.0000'),
('1002','40','7.0000'),
('1008','40','7.0000'),
('1014','40','7.0000'),
('1020','40','7.0000'),
('1026','40','7.0000'),
('1032','40','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1038','40','7.0000'),
('1044','40','7.0000'),
('1050','40','7.0000'),
('1056','40','7.0000'),
('1062','40','7.0000'),
('1068','40','7.0000'),
('1074','40','7.0000'),
('1080','40','7.0000'),
('1086','40','7.0000'),
('1092','40','7.0000'),
('1098','40','7.0000'),
('1104','40','7.0000'),
('1110','40','7.0000'),
('1116','40','7.0000'),
('1122','40','7.0000'),
('1128','40','7.0000'),
('1134','40','7.0000'),
('1140','40','7.0000'),
('1146','40','7.0000'),
('1152','40','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1158','40','7.0000'),
('1164','40','7.0000'),
('1170','40','7.0000'),
('1176','40','7.0000'),
('1182','40','7.0000'),
('1188','40','7.0000'),
('1194','40','7.0000'),
('1200','40','7.0000'),
('1206','40','7.0000'),
('1212','40','7.0000'),
('1218','40','7.0000'),
('1224','40','7.0000'),
('1230','40','7.0000'),
('1236','40','7.0000'),
('1242','40','7.0000'),
('1248','40','7.0000'),
('1254','40','7.0000'),
('1260','40','7.0000'),
('1266','40','7.0000'),
('1272','40','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1278','40','7.0000'),
('1284','40','7.0000'),
('1290','40','7.0000'),
('1296','40','7.0000'),
('1302','40','7.0000'),
('1308','40','7.0000'),
('1314','40','7.0000'),
('1320','40','7.0000'),
('1326','40','7.0000'),
('1332','40','7.0000'),
('1338','40','7.0000'),
('1344','40','7.0000'),
('1350','40','7.0000'),
('1356','40','7.0000'),
('1362','40','7.0000'),
('1368','40','7.0000'),
('1374','40','7.0000'),
('1380','40','7.0000'),
('1386','40','7.0000'),
('1392','40','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1398','40','7.0000'),
('1404','40','7.0000'),
('1410','40','7.0000'),
('1416','40','7.0000'),
('1422','40','7.0000'),
('1428','40','7.0000'),
('1434','40','7.0000'),
('1440','40','7.0000'),
('1446','40','7.0000'),
('1452','40','7.0000'),
('1458','40','7.0000'),
('1464','40','7.0000'),
('1470','40','7.0000'),
('1476','40','7.0000'),
('1482','40','7.0000'),
('1488','40','7.0000'),
('1494','40','7.0000'),
('1500','40','7.0000'),
('1506','40','7.0000'),
('1512','40','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1518','40','7.0000'),
('1524','40','7.0000'),
('1530','40','7.0000'),
('1536','40','7.0000'),
('1542','40','7.0000'),
('1548','40','7.0000'),
('1554','40','7.0000'),
('1560','40','7.0000'),
('1566','40','7.0000'),
('1572','40','7.0000'),
('1578','40','7.0000'),
('1584','40','7.0000'),
('1590','40','7.0000'),
('1596','40','7.0000'),
('1602','40','7.0000'),
('1608','40','7.0000'),
('1614','40','7.0000'),
('1620','40','7.0000'),
('1626','40','7.0000'),
('1632','40','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1638','40','7.0000'),
('1644','40','7.0000'),
('1650','40','7.0000'),
('1656','40','7.0000'),
('1662','40','7.0000'),
('1668','40','7.0000'),
('1674','40','7.0000'),
('1680','40','7.0000'),
('1686','40','7.0000'),
('1692','40','7.0000'),
('1698','40','7.0000'),
('1704','40','7.0000'),
('1710','40','7.0000'),
('1716','40','7.0000'),
('1722','40','7.0000'),
('1728','40','7.0000'),
('6','41','7.0000'),
('12','41','7.0000'),
('18','41','7.0000'),
('24','41','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('30','41','7.0000'),
('36','41','7.0000'),
('42','41','7.0000'),
('48','41','7.0000'),
('54','41','7.0000'),
('60','41','7.0000'),
('66','41','7.0000'),
('72','41','7.0000'),
('78','41','7.0000'),
('84','41','7.0000'),
('90','41','7.0000'),
('96','41','7.0000'),
('102','41','7.0000'),
('108','41','7.0000'),
('114','41','7.0000'),
('120','41','7.0000'),
('126','41','7.0000'),
('132','41','7.0000'),
('138','41','7.0000'),
('144','41','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('150','41','7.0000'),
('156','41','7.0000'),
('162','41','7.0000'),
('168','41','7.0000'),
('174','41','7.0000'),
('180','41','7.0000'),
('186','41','7.0000'),
('192','41','7.0000'),
('198','41','7.0000'),
('204','41','7.0000'),
('210','41','7.0000'),
('216','41','7.0000'),
('222','41','7.0000'),
('228','41','7.0000'),
('234','41','7.0000'),
('240','41','7.0000'),
('246','41','7.0000'),
('252','41','7.0000'),
('258','41','7.0000'),
('264','41','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('270','41','7.0000'),
('276','41','7.0000'),
('282','41','7.0000'),
('288','41','7.0000'),
('294','41','7.0000'),
('300','41','7.0000'),
('306','41','7.0000'),
('312','41','7.0000'),
('318','41','7.0000'),
('324','41','7.0000'),
('330','41','7.0000'),
('336','41','7.0000'),
('342','41','7.0000'),
('348','41','7.0000'),
('354','41','7.0000'),
('360','41','7.0000'),
('366','41','7.0000'),
('372','41','7.0000'),
('378','41','7.0000'),
('384','41','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('390','41','7.0000'),
('396','41','7.0000'),
('402','41','7.0000'),
('408','41','7.0000'),
('414','41','7.0000'),
('420','41','7.0000'),
('426','41','7.0000'),
('432','41','7.0000'),
('438','41','7.0000'),
('444','41','7.0000'),
('450','41','7.0000'),
('456','41','7.0000'),
('462','41','7.0000'),
('468','41','7.0000'),
('474','41','7.0000'),
('480','41','7.0000'),
('486','41','7.0000'),
('492','41','7.0000'),
('498','41','7.0000'),
('504','41','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('510','41','7.0000'),
('516','41','7.0000'),
('522','41','7.0000'),
('528','41','7.0000'),
('534','41','7.0000'),
('540','41','7.0000'),
('546','41','7.0000'),
('552','41','7.0000'),
('558','41','7.0000'),
('564','41','7.0000'),
('570','41','7.0000'),
('576','41','7.0000'),
('582','41','7.0000'),
('588','41','7.0000'),
('594','41','7.0000'),
('600','41','7.0000'),
('606','41','7.0000'),
('612','41','7.0000'),
('618','41','7.0000'),
('624','41','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('630','41','7.0000'),
('636','41','7.0000'),
('642','41','7.0000'),
('648','41','7.0000'),
('654','41','7.0000'),
('660','41','7.0000'),
('666','41','7.0000'),
('672','41','7.0000'),
('678','41','7.0000'),
('684','41','7.0000'),
('690','41','7.0000'),
('696','41','7.0000'),
('702','41','7.0000'),
('708','41','7.0000'),
('714','41','7.0000'),
('720','41','7.0000'),
('726','41','7.0000'),
('732','41','7.0000'),
('738','41','7.0000'),
('744','41','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('750','41','7.0000'),
('756','41','7.0000'),
('762','41','7.0000'),
('768','41','7.0000'),
('774','41','7.0000'),
('780','41','7.0000'),
('786','41','7.0000'),
('792','41','7.0000'),
('798','41','7.0000'),
('804','41','7.0000'),
('810','41','7.0000'),
('816','41','7.0000'),
('822','41','7.0000'),
('828','41','7.0000'),
('834','41','7.0000'),
('840','41','7.0000'),
('846','41','7.0000'),
('852','41','7.0000'),
('858','41','7.0000'),
('864','41','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('870','41','7.0000'),
('876','41','7.0000'),
('882','41','7.0000'),
('888','41','7.0000'),
('894','41','7.0000'),
('900','41','7.0000'),
('906','41','7.0000'),
('912','41','7.0000'),
('918','41','7.0000'),
('924','41','7.0000'),
('930','41','7.0000'),
('936','41','7.0000'),
('942','41','7.0000'),
('948','41','7.0000'),
('954','41','7.0000'),
('960','41','7.0000'),
('966','41','7.0000'),
('972','41','7.0000'),
('978','41','7.0000'),
('984','41','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('990','41','7.0000'),
('996','41','7.0000'),
('1002','41','7.0000'),
('1008','41','7.0000'),
('1014','41','7.0000'),
('1020','41','7.0000'),
('1026','41','7.0000'),
('1032','41','7.0000'),
('1038','41','7.0000'),
('1044','41','7.0000'),
('1050','41','7.0000'),
('1056','41','7.0000'),
('1062','41','7.0000'),
('1068','41','7.0000'),
('1074','41','7.0000'),
('1080','41','7.0000'),
('1086','41','7.0000'),
('1092','41','7.0000'),
('1098','41','7.0000'),
('1104','41','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1110','41','7.0000'),
('1116','41','7.0000'),
('1122','41','7.0000'),
('1128','41','7.0000'),
('1134','41','7.0000'),
('1140','41','7.0000'),
('1146','41','7.0000'),
('1152','41','7.0000'),
('1158','41','7.0000'),
('1164','41','7.0000'),
('1170','41','7.0000'),
('1176','41','7.0000'),
('1182','41','7.0000'),
('1188','41','7.0000'),
('1194','41','7.0000'),
('1200','41','7.0000'),
('1206','41','7.0000'),
('1212','41','7.0000'),
('1218','41','7.0000'),
('1224','41','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1230','41','7.0000'),
('1236','41','7.0000'),
('1242','41','7.0000'),
('1248','41','7.0000'),
('1254','41','7.0000'),
('1260','41','7.0000'),
('1266','41','7.0000'),
('1272','41','7.0000'),
('1278','41','7.0000'),
('1284','41','7.0000'),
('1290','41','7.0000'),
('1296','41','7.0000'),
('1302','41','7.0000'),
('1308','41','7.0000'),
('1314','41','7.0000'),
('1320','41','7.0000'),
('1326','41','7.0000'),
('1332','41','7.0000'),
('1338','41','7.0000'),
('1344','41','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1350','41','7.0000'),
('1356','41','7.0000'),
('1362','41','7.0000'),
('1368','41','7.0000'),
('1374','41','7.0000'),
('1380','41','7.0000'),
('1386','41','7.0000'),
('1392','41','7.0000'),
('1398','41','7.0000'),
('1404','41','7.0000'),
('1410','41','7.0000'),
('1416','41','7.0000'),
('1422','41','7.0000'),
('1428','41','7.0000'),
('1434','41','7.0000'),
('1440','41','7.0000'),
('1446','41','7.0000'),
('1452','41','7.0000'),
('1458','41','7.0000'),
('1464','41','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1470','41','7.0000'),
('1476','41','7.0000'),
('1482','41','7.0000'),
('1488','41','7.0000'),
('1494','41','7.0000'),
('1500','41','7.0000'),
('1506','41','7.0000'),
('1512','41','7.0000'),
('1518','41','7.0000'),
('1524','41','7.0000'),
('1530','41','7.0000'),
('1536','41','7.0000'),
('1542','41','7.0000'),
('1548','41','7.0000'),
('1554','41','7.0000'),
('1560','41','7.0000'),
('1566','41','7.0000'),
('1572','41','7.0000'),
('1578','41','7.0000'),
('1584','41','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1590','41','7.0000'),
('1596','41','7.0000'),
('1602','41','7.0000'),
('1608','41','7.0000'),
('1614','41','7.0000'),
('1620','41','7.0000'),
('1626','41','7.0000'),
('1632','41','7.0000'),
('1638','41','7.0000'),
('1644','41','7.0000'),
('1650','41','7.0000'),
('1656','41','7.0000'),
('1662','41','7.0000'),
('1668','41','7.0000'),
('1674','41','7.0000'),
('1680','41','7.0000'),
('1686','41','7.0000'),
('1692','41','7.0000'),
('1698','41','7.0000'),
('1704','41','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1710','41','7.0000'),
('1716','41','7.0000'),
('1722','41','7.0000'),
('1728','41','7.0000'),
('6','42','7.0000'),
('12','42','7.0000'),
('18','42','7.0000'),
('24','42','7.0000'),
('30','42','7.0000'),
('36','42','7.0000'),
('42','42','7.0000'),
('48','42','7.0000'),
('54','42','7.0000'),
('60','42','7.0000'),
('66','42','7.0000'),
('72','42','7.0000'),
('78','42','7.0000'),
('84','42','7.0000'),
('90','42','7.0000'),
('96','42','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('102','42','7.0000'),
('108','42','7.0000'),
('114','42','7.0000'),
('120','42','7.0000'),
('126','42','7.0000'),
('132','42','7.0000'),
('138','42','7.0000'),
('144','42','7.0000'),
('150','42','7.0000'),
('156','42','7.0000'),
('162','42','7.0000'),
('168','42','7.0000'),
('174','42','7.0000'),
('180','42','7.0000'),
('186','42','7.0000'),
('192','42','7.0000'),
('198','42','7.0000'),
('204','42','7.0000'),
('210','42','7.0000'),
('216','42','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('222','42','7.0000'),
('228','42','7.0000'),
('234','42','7.0000'),
('240','42','7.0000'),
('246','42','7.0000'),
('252','42','7.0000'),
('258','42','7.0000'),
('264','42','7.0000'),
('270','42','7.0000'),
('276','42','7.0000'),
('282','42','7.0000'),
('288','42','7.0000'),
('294','42','7.0000'),
('300','42','7.0000'),
('306','42','7.0000'),
('312','42','7.0000'),
('318','42','7.0000'),
('324','42','7.0000'),
('330','42','7.0000'),
('336','42','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('342','42','7.0000'),
('348','42','7.0000'),
('354','42','7.0000'),
('360','42','7.0000'),
('366','42','7.0000'),
('372','42','7.0000'),
('378','42','7.0000'),
('384','42','7.0000'),
('390','42','7.0000'),
('396','42','7.0000'),
('402','42','7.0000'),
('408','42','7.0000'),
('414','42','7.0000'),
('420','42','7.0000'),
('426','42','7.0000'),
('432','42','7.0000'),
('438','42','7.0000'),
('444','42','7.0000'),
('450','42','7.0000'),
('456','42','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('462','42','7.0000'),
('468','42','7.0000'),
('474','42','7.0000'),
('480','42','7.0000'),
('486','42','7.0000'),
('492','42','7.0000'),
('498','42','7.0000'),
('504','42','7.0000'),
('510','42','7.0000'),
('516','42','7.0000'),
('522','42','7.0000'),
('528','42','7.0000'),
('534','42','7.0000'),
('540','42','7.0000'),
('546','42','7.0000'),
('552','42','7.0000'),
('558','42','7.0000'),
('564','42','7.0000'),
('570','42','7.0000'),
('576','42','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('582','42','7.0000'),
('588','42','7.0000'),
('594','42','7.0000'),
('600','42','7.0000'),
('606','42','7.0000'),
('612','42','7.0000'),
('618','42','7.0000'),
('624','42','7.0000'),
('630','42','7.0000'),
('636','42','7.0000'),
('642','42','7.0000'),
('648','42','7.0000'),
('654','42','7.0000'),
('660','42','7.0000'),
('666','42','7.0000'),
('672','42','7.0000'),
('678','42','7.0000'),
('684','42','7.0000'),
('690','42','7.0000'),
('696','42','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('702','42','7.0000'),
('708','42','7.0000'),
('714','42','7.0000'),
('720','42','7.0000'),
('726','42','7.0000'),
('732','42','7.0000'),
('738','42','7.0000'),
('744','42','7.0000'),
('750','42','7.0000'),
('756','42','7.0000'),
('762','42','7.0000'),
('768','42','7.0000'),
('774','42','7.0000'),
('780','42','7.0000'),
('786','42','7.0000'),
('792','42','7.0000'),
('798','42','7.0000'),
('804','42','7.0000'),
('810','42','7.0000'),
('816','42','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('822','42','7.0000'),
('828','42','7.0000'),
('834','42','7.0000'),
('840','42','7.0000'),
('846','42','7.0000'),
('852','42','7.0000'),
('858','42','7.0000'),
('864','42','7.0000'),
('870','42','7.0000'),
('876','42','7.0000'),
('882','42','7.0000'),
('888','42','7.0000'),
('894','42','7.0000'),
('900','42','7.0000'),
('906','42','7.0000'),
('912','42','7.0000'),
('918','42','7.0000'),
('924','42','7.0000'),
('930','42','7.0000'),
('936','42','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('942','42','7.0000'),
('948','42','7.0000'),
('954','42','7.0000'),
('960','42','7.0000'),
('966','42','7.0000'),
('972','42','7.0000'),
('978','42','7.0000'),
('984','42','7.0000'),
('990','42','7.0000'),
('996','42','7.0000'),
('1002','42','7.0000'),
('1008','42','7.0000'),
('1014','42','7.0000'),
('1020','42','7.0000'),
('1026','42','7.0000'),
('1032','42','7.0000'),
('1038','42','7.0000'),
('1044','42','7.0000'),
('1050','42','7.0000'),
('1056','42','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1062','42','7.0000'),
('1068','42','7.0000'),
('1074','42','7.0000'),
('1080','42','7.0000'),
('1086','42','7.0000'),
('1092','42','7.0000'),
('1098','42','7.0000'),
('1104','42','7.0000'),
('1110','42','7.0000'),
('1116','42','7.0000'),
('1122','42','7.0000'),
('1128','42','7.0000'),
('1134','42','7.0000'),
('1140','42','7.0000'),
('1146','42','7.0000'),
('1152','42','7.0000'),
('1158','42','7.0000'),
('1164','42','7.0000'),
('1170','42','7.0000'),
('1176','42','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1182','42','7.0000'),
('1188','42','7.0000'),
('1194','42','7.0000'),
('1200','42','7.0000'),
('1206','42','7.0000'),
('1212','42','7.0000'),
('1218','42','7.0000'),
('1224','42','7.0000'),
('1230','42','7.0000'),
('1236','42','7.0000'),
('1242','42','7.0000'),
('1248','42','7.0000'),
('1254','42','7.0000'),
('1260','42','7.0000'),
('1266','42','7.0000'),
('1272','42','7.0000'),
('1278','42','7.0000'),
('1284','42','7.0000'),
('1290','42','7.0000'),
('1296','42','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1302','42','7.0000'),
('1308','42','7.0000'),
('1314','42','7.0000'),
('1320','42','7.0000'),
('1326','42','7.0000'),
('1332','42','7.0000'),
('1338','42','7.0000'),
('1344','42','7.0000'),
('1350','42','7.0000'),
('1356','42','7.0000'),
('1362','42','7.0000'),
('1368','42','7.0000'),
('1374','42','7.0000'),
('1380','42','7.0000'),
('1386','42','7.0000'),
('1392','42','7.0000'),
('1398','42','7.0000'),
('1404','42','7.0000'),
('1410','42','7.0000'),
('1416','42','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1422','42','7.0000'),
('1428','42','7.0000'),
('1434','42','7.0000'),
('1440','42','7.0000'),
('1446','42','7.0000'),
('1452','42','7.0000'),
('1458','42','7.0000'),
('1464','42','7.0000'),
('1470','42','7.0000'),
('1476','42','7.0000'),
('1482','42','7.0000'),
('1488','42','7.0000'),
('1494','42','7.0000'),
('1500','42','7.0000'),
('1506','42','7.0000'),
('1512','42','7.0000'),
('1518','42','7.0000'),
('1524','42','7.0000'),
('1530','42','7.0000'),
('1536','42','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1542','42','7.0000'),
('1548','42','7.0000'),
('1554','42','7.0000'),
('1560','42','7.0000'),
('1566','42','7.0000'),
('1572','42','7.0000'),
('1578','42','7.0000'),
('1584','42','7.0000'),
('1590','42','7.0000'),
('1596','42','7.0000'),
('1602','42','7.0000'),
('1608','42','7.0000'),
('1614','42','7.0000'),
('1620','42','7.0000'),
('1626','42','7.0000'),
('1632','42','7.0000'),
('1638','42','7.0000'),
('1644','42','7.0000'),
('1650','42','7.0000'),
('1656','42','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1662','42','7.0000'),
('1668','42','7.0000'),
('1674','42','7.0000'),
('1680','42','7.0000'),
('1686','42','7.0000'),
('1692','42','7.0000'),
('1698','42','7.0000'),
('1704','42','7.0000'),
('1710','42','7.0000'),
('1716','42','7.0000'),
('1722','42','7.0000'),
('1728','42','7.0000'),
('6','43','7.0000'),
('12','43','7.0000'),
('18','43','7.0000'),
('24','43','7.0000'),
('30','43','7.0000'),
('36','43','7.0000'),
('42','43','7.0000'),
('48','43','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('54','43','7.0000'),
('60','43','7.0000'),
('66','43','7.0000'),
('72','43','7.0000'),
('78','43','7.0000'),
('84','43','7.0000'),
('90','43','7.0000'),
('96','43','7.0000'),
('102','43','7.0000'),
('108','43','7.0000'),
('114','43','7.0000'),
('120','43','7.0000'),
('126','43','7.0000'),
('132','43','7.0000'),
('138','43','7.0000'),
('144','43','7.0000'),
('150','43','7.0000'),
('156','43','7.0000'),
('162','43','7.0000'),
('168','43','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('174','43','7.0000'),
('180','43','7.0000'),
('186','43','7.0000'),
('192','43','7.0000'),
('198','43','7.0000'),
('204','43','7.0000'),
('210','43','7.0000'),
('216','43','7.0000'),
('222','43','7.0000'),
('228','43','7.0000'),
('234','43','7.0000'),
('240','43','7.0000'),
('246','43','7.0000'),
('252','43','7.0000'),
('258','43','7.0000'),
('264','43','7.0000'),
('270','43','7.0000'),
('276','43','7.0000'),
('282','43','7.0000'),
('288','43','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('294','43','7.0000'),
('300','43','7.0000'),
('306','43','7.0000'),
('312','43','7.0000'),
('318','43','7.0000'),
('324','43','7.0000'),
('330','43','7.0000'),
('336','43','7.0000'),
('342','43','7.0000'),
('348','43','7.0000'),
('354','43','7.0000'),
('360','43','7.0000'),
('366','43','7.0000'),
('372','43','7.0000'),
('378','43','7.0000'),
('384','43','7.0000'),
('390','43','7.0000'),
('396','43','7.0000'),
('402','43','7.0000'),
('408','43','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('414','43','7.0000'),
('420','43','7.0000'),
('426','43','7.0000'),
('432','43','7.0000'),
('438','43','7.0000'),
('444','43','7.0000'),
('450','43','7.0000'),
('456','43','7.0000'),
('462','43','7.0000'),
('468','43','7.0000'),
('474','43','7.0000'),
('480','43','7.0000'),
('486','43','7.0000'),
('492','43','7.0000'),
('498','43','7.0000'),
('504','43','7.0000'),
('510','43','7.0000'),
('516','43','7.0000'),
('522','43','7.0000'),
('528','43','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('534','43','7.0000'),
('540','43','7.0000'),
('546','43','7.0000'),
('552','43','7.0000'),
('558','43','7.0000'),
('564','43','7.0000'),
('570','43','7.0000'),
('576','43','7.0000'),
('582','43','7.0000'),
('588','43','7.0000'),
('594','43','7.0000'),
('600','43','7.0000'),
('606','43','7.0000'),
('612','43','7.0000'),
('618','43','7.0000'),
('624','43','7.0000'),
('630','43','7.0000'),
('636','43','7.0000'),
('642','43','7.0000'),
('648','43','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('654','43','7.0000'),
('660','43','7.0000'),
('666','43','7.0000'),
('672','43','7.0000'),
('678','43','7.0000'),
('684','43','7.0000'),
('690','43','7.0000'),
('696','43','7.0000'),
('702','43','7.0000'),
('708','43','7.0000'),
('714','43','7.0000'),
('720','43','7.0000'),
('726','43','7.0000'),
('732','43','7.0000'),
('738','43','7.0000'),
('744','43','7.0000'),
('750','43','7.0000'),
('756','43','7.0000'),
('762','43','7.0000'),
('768','43','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('774','43','7.0000'),
('780','43','7.0000'),
('786','43','7.0000'),
('792','43','7.0000'),
('798','43','7.0000'),
('804','43','7.0000'),
('810','43','7.0000'),
('816','43','7.0000'),
('822','43','7.0000'),
('828','43','7.0000'),
('834','43','7.0000'),
('840','43','7.0000'),
('846','43','7.0000'),
('852','43','7.0000'),
('858','43','7.0000'),
('864','43','7.0000'),
('870','43','7.0000'),
('876','43','7.0000'),
('882','43','7.0000'),
('888','43','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('894','43','7.0000'),
('900','43','7.0000'),
('906','43','7.0000'),
('912','43','7.0000'),
('918','43','7.0000'),
('924','43','7.0000'),
('930','43','7.0000'),
('936','43','7.0000'),
('942','43','7.0000'),
('948','43','7.0000'),
('954','43','7.0000'),
('960','43','7.0000'),
('966','43','7.0000'),
('972','43','7.0000'),
('978','43','7.0000'),
('984','43','7.0000'),
('990','43','7.0000'),
('996','43','7.0000'),
('1002','43','7.0000'),
('1008','43','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1014','43','7.0000'),
('1020','43','7.0000'),
('1026','43','7.0000'),
('1032','43','7.0000'),
('1038','43','7.0000'),
('1044','43','7.0000'),
('1050','43','7.0000'),
('1056','43','7.0000'),
('1062','43','7.0000'),
('1068','43','7.0000'),
('1074','43','7.0000'),
('1080','43','7.0000'),
('1086','43','7.0000'),
('1092','43','7.0000'),
('1098','43','7.0000'),
('1104','43','7.0000'),
('1110','43','7.0000'),
('1116','43','7.0000'),
('1122','43','7.0000'),
('1128','43','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1134','43','7.0000'),
('1140','43','7.0000'),
('1146','43','7.0000'),
('1152','43','7.0000'),
('1158','43','7.0000'),
('1164','43','7.0000'),
('1170','43','7.0000'),
('1176','43','7.0000'),
('1182','43','7.0000'),
('1188','43','7.0000'),
('1194','43','7.0000'),
('1200','43','7.0000'),
('1206','43','7.0000'),
('1212','43','7.0000'),
('1218','43','7.0000'),
('1224','43','7.0000'),
('1230','43','7.0000'),
('1236','43','7.0000'),
('1242','43','7.0000'),
('1248','43','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1254','43','7.0000'),
('1260','43','7.0000'),
('1266','43','7.0000'),
('1272','43','7.0000'),
('1278','43','7.0000'),
('1284','43','7.0000'),
('1290','43','7.0000'),
('1296','43','7.0000'),
('1302','43','7.0000'),
('1308','43','7.0000'),
('1314','43','7.0000'),
('1320','43','7.0000'),
('1326','43','7.0000'),
('1332','43','7.0000'),
('1338','43','7.0000'),
('1344','43','7.0000'),
('1350','43','7.0000'),
('1356','43','7.0000'),
('1362','43','7.0000'),
('1368','43','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1374','43','7.0000'),
('1380','43','7.0000'),
('1386','43','7.0000'),
('1392','43','7.0000'),
('1398','43','7.0000'),
('1404','43','7.0000'),
('1410','43','7.0000'),
('1416','43','7.0000'),
('1422','43','7.0000'),
('1428','43','7.0000'),
('1434','43','7.0000'),
('1440','43','7.0000'),
('1446','43','7.0000'),
('1452','43','7.0000'),
('1458','43','7.0000'),
('1464','43','7.0000'),
('1470','43','7.0000'),
('1476','43','7.0000'),
('1482','43','7.0000'),
('1488','43','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1494','43','7.0000'),
('1500','43','7.0000'),
('1506','43','7.0000'),
('1512','43','7.0000'),
('1518','43','7.0000'),
('1524','43','7.0000'),
('1530','43','7.0000'),
('1536','43','7.0000'),
('1542','43','7.0000'),
('1548','43','7.0000'),
('1554','43','7.0000'),
('1560','43','7.0000'),
('1566','43','7.0000'),
('1572','43','7.0000'),
('1578','43','7.0000'),
('1584','43','7.0000'),
('1590','43','7.0000'),
('1596','43','7.0000'),
('1602','43','7.0000'),
('1608','43','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1614','43','7.0000'),
('1620','43','7.0000'),
('1626','43','7.0000'),
('1632','43','7.0000'),
('1638','43','7.0000'),
('1644','43','7.0000'),
('1650','43','7.0000'),
('1656','43','7.0000'),
('1662','43','7.0000'),
('1668','43','7.0000'),
('1674','43','7.0000'),
('1680','43','7.0000'),
('1686','43','7.0000'),
('1692','43','7.0000'),
('1698','43','7.0000'),
('1704','43','7.0000'),
('1710','43','7.0000'),
('1716','43','7.0000'),
('1722','43','7.0000'),
('1728','43','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('6','44','7.0000'),
('12','44','7.0000'),
('18','44','7.0000'),
('24','44','7.0000'),
('30','44','7.0000'),
('36','44','7.0000'),
('42','44','7.0000'),
('48','44','7.0000'),
('54','44','7.0000'),
('60','44','7.0000'),
('66','44','7.0000'),
('72','44','7.0000'),
('78','44','7.0000'),
('84','44','7.0000'),
('90','44','7.0000'),
('96','44','7.0000'),
('102','44','7.0000'),
('108','44','7.0000'),
('114','44','7.0000'),
('120','44','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('126','44','7.0000'),
('132','44','7.0000'),
('138','44','7.0000'),
('144','44','7.0000'),
('150','44','7.0000'),
('156','44','7.0000'),
('162','44','7.0000'),
('168','44','7.0000'),
('174','44','7.0000'),
('180','44','7.0000'),
('186','44','7.0000'),
('192','44','7.0000'),
('198','44','7.0000'),
('204','44','7.0000'),
('210','44','7.0000'),
('216','44','7.0000'),
('222','44','7.0000'),
('228','44','7.0000'),
('234','44','7.0000'),
('240','44','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('246','44','7.0000'),
('252','44','7.0000'),
('258','44','7.0000'),
('264','44','7.0000'),
('270','44','7.0000'),
('276','44','7.0000'),
('282','44','7.0000'),
('288','44','7.0000'),
('294','44','7.0000'),
('300','44','7.0000'),
('306','44','7.0000'),
('312','44','7.0000'),
('318','44','7.0000'),
('324','44','7.0000'),
('330','44','7.0000'),
('336','44','7.0000'),
('342','44','7.0000'),
('348','44','7.0000'),
('354','44','7.0000'),
('360','44','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('366','44','7.0000'),
('372','44','7.0000'),
('378','44','7.0000'),
('384','44','7.0000'),
('390','44','7.0000'),
('396','44','7.0000'),
('402','44','7.0000'),
('408','44','7.0000'),
('414','44','7.0000'),
('420','44','7.0000'),
('426','44','7.0000'),
('432','44','7.0000'),
('438','44','7.0000'),
('444','44','7.0000'),
('450','44','7.0000'),
('456','44','7.0000'),
('462','44','7.0000'),
('468','44','7.0000'),
('474','44','7.0000'),
('480','44','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('486','44','7.0000'),
('492','44','7.0000'),
('498','44','7.0000'),
('504','44','7.0000'),
('510','44','7.0000'),
('516','44','7.0000'),
('522','44','7.0000'),
('528','44','7.0000'),
('534','44','7.0000'),
('540','44','7.0000'),
('546','44','7.0000'),
('552','44','7.0000'),
('558','44','7.0000'),
('564','44','7.0000'),
('570','44','7.0000'),
('576','44','7.0000'),
('582','44','7.0000'),
('588','44','7.0000'),
('594','44','7.0000'),
('600','44','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('606','44','7.0000'),
('612','44','7.0000'),
('618','44','7.0000'),
('624','44','7.0000'),
('630','44','7.0000'),
('636','44','7.0000'),
('642','44','7.0000'),
('648','44','7.0000'),
('654','44','7.0000'),
('660','44','7.0000'),
('666','44','7.0000'),
('672','44','7.0000'),
('678','44','7.0000'),
('684','44','7.0000'),
('690','44','7.0000'),
('696','44','7.0000'),
('702','44','7.0000'),
('708','44','7.0000'),
('714','44','7.0000'),
('720','44','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('726','44','7.0000'),
('732','44','7.0000'),
('738','44','7.0000'),
('744','44','7.0000'),
('750','44','7.0000'),
('756','44','7.0000'),
('762','44','7.0000'),
('768','44','7.0000'),
('774','44','7.0000'),
('780','44','7.0000'),
('786','44','7.0000'),
('792','44','7.0000'),
('798','44','7.0000'),
('804','44','7.0000'),
('810','44','7.0000'),
('816','44','7.0000'),
('822','44','7.0000'),
('828','44','7.0000'),
('834','44','7.0000'),
('840','44','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('846','44','7.0000'),
('852','44','7.0000'),
('858','44','7.0000'),
('864','44','7.0000'),
('870','44','7.0000'),
('876','44','7.0000'),
('882','44','7.0000'),
('888','44','7.0000'),
('894','44','7.0000'),
('900','44','7.0000'),
('906','44','7.0000'),
('912','44','7.0000'),
('918','44','7.0000'),
('924','44','7.0000'),
('930','44','7.0000'),
('936','44','7.0000'),
('942','44','7.0000'),
('948','44','7.0000'),
('954','44','7.0000'),
('960','44','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('966','44','7.0000'),
('972','44','7.0000'),
('978','44','7.0000'),
('984','44','7.0000'),
('990','44','7.0000'),
('996','44','7.0000'),
('1002','44','7.0000'),
('1008','44','7.0000'),
('1014','44','7.0000'),
('1020','44','7.0000'),
('1026','44','7.0000'),
('1032','44','7.0000'),
('1038','44','7.0000'),
('1044','44','7.0000'),
('1050','44','7.0000'),
('1056','44','7.0000'),
('1062','44','7.0000'),
('1068','44','7.0000'),
('1074','44','7.0000'),
('1080','44','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1086','44','7.0000'),
('1092','44','7.0000'),
('1098','44','7.0000'),
('1104','44','7.0000'),
('1110','44','7.0000'),
('1116','44','7.0000'),
('1122','44','7.0000'),
('1128','44','7.0000'),
('1134','44','7.0000'),
('1140','44','7.0000'),
('1146','44','7.0000'),
('1152','44','7.0000'),
('1158','44','7.0000'),
('1164','44','7.0000'),
('1170','44','7.0000'),
('1176','44','7.0000'),
('1182','44','7.0000'),
('1188','44','7.0000'),
('1194','44','7.0000'),
('1200','44','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1206','44','7.0000'),
('1212','44','7.0000'),
('1218','44','7.0000'),
('1224','44','7.0000'),
('1230','44','7.0000'),
('1236','44','7.0000'),
('1242','44','7.0000'),
('1248','44','7.0000'),
('1254','44','7.0000'),
('1260','44','7.0000'),
('1266','44','7.0000'),
('1272','44','7.0000'),
('1278','44','7.0000'),
('1284','44','7.0000'),
('1290','44','7.0000'),
('1296','44','7.0000'),
('1302','44','7.0000'),
('1308','44','7.0000'),
('1314','44','7.0000'),
('1320','44','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1326','44','7.0000'),
('1332','44','7.0000'),
('1338','44','7.0000'),
('1344','44','7.0000'),
('1350','44','7.0000'),
('1356','44','7.0000'),
('1362','44','7.0000'),
('1368','44','7.0000'),
('1374','44','7.0000'),
('1380','44','7.0000'),
('1386','44','7.0000'),
('1392','44','7.0000'),
('1398','44','7.0000'),
('1404','44','7.0000'),
('1410','44','7.0000'),
('1416','44','7.0000'),
('1422','44','7.0000'),
('1428','44','7.0000'),
('1434','44','7.0000'),
('1440','44','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1446','44','7.0000'),
('1452','44','7.0000'),
('1458','44','7.0000'),
('1464','44','7.0000'),
('1470','44','7.0000'),
('1476','44','7.0000'),
('1482','44','7.0000'),
('1488','44','7.0000'),
('1494','44','7.0000'),
('1500','44','7.0000'),
('1506','44','7.0000'),
('1512','44','7.0000'),
('1518','44','7.0000'),
('1524','44','7.0000'),
('1530','44','7.0000'),
('1536','44','7.0000'),
('1542','44','7.0000'),
('1548','44','7.0000'),
('1554','44','7.0000'),
('1560','44','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1566','44','7.0000'),
('1572','44','7.0000'),
('1578','44','7.0000'),
('1584','44','7.0000'),
('1590','44','7.0000'),
('1596','44','7.0000'),
('1602','44','7.0000'),
('1608','44','7.0000'),
('1614','44','7.0000'),
('1620','44','7.0000'),
('1626','44','7.0000'),
('1632','44','7.0000'),
('1638','44','7.0000'),
('1644','44','7.0000'),
('1650','44','7.0000'),
('1656','44','7.0000'),
('1662','44','7.0000'),
('1668','44','7.0000'),
('1674','44','7.0000'),
('1680','44','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1686','44','7.0000'),
('1692','44','7.0000'),
('1698','44','7.0000'),
('1704','44','7.0000'),
('1710','44','7.0000'),
('1716','44','7.0000'),
('1722','44','7.0000'),
('1728','44','7.0000'),
('6','45','7.0000'),
('12','45','7.0000'),
('18','45','7.0000'),
('24','45','7.0000'),
('30','45','7.0000'),
('36','45','7.0000'),
('42','45','7.0000'),
('48','45','7.0000'),
('54','45','7.0000'),
('60','45','7.0000'),
('66','45','7.0000'),
('72','45','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('78','45','7.0000'),
('84','45','7.0000'),
('90','45','7.0000'),
('96','45','7.0000'),
('102','45','7.0000'),
('108','45','7.0000'),
('114','45','7.0000'),
('120','45','7.0000'),
('126','45','7.0000'),
('132','45','7.0000'),
('138','45','7.0000'),
('144','45','7.0000'),
('150','45','7.0000'),
('156','45','7.0000'),
('162','45','7.0000'),
('168','45','7.0000'),
('174','45','7.0000'),
('180','45','7.0000'),
('186','45','7.0000'),
('192','45','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('198','45','7.0000'),
('204','45','7.0000'),
('210','45','7.0000'),
('216','45','7.0000'),
('222','45','7.0000'),
('228','45','7.0000'),
('234','45','7.0000'),
('240','45','7.0000'),
('246','45','7.0000'),
('252','45','7.0000'),
('258','45','7.0000'),
('264','45','7.0000'),
('270','45','7.0000'),
('276','45','7.0000'),
('282','45','7.0000'),
('288','45','7.0000'),
('294','45','7.0000'),
('300','45','7.0000'),
('306','45','7.0000'),
('312','45','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('318','45','7.0000'),
('324','45','7.0000'),
('330','45','7.0000'),
('336','45','7.0000'),
('342','45','7.0000'),
('348','45','7.0000'),
('354','45','7.0000'),
('360','45','7.0000'),
('366','45','7.0000'),
('372','45','7.0000'),
('378','45','7.0000'),
('384','45','7.0000'),
('390','45','7.0000'),
('396','45','7.0000'),
('402','45','7.0000'),
('408','45','7.0000'),
('414','45','7.0000'),
('420','45','7.0000'),
('426','45','7.0000'),
('432','45','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('438','45','7.0000'),
('444','45','7.0000'),
('450','45','7.0000'),
('456','45','7.0000'),
('462','45','7.0000'),
('468','45','7.0000'),
('474','45','7.0000'),
('480','45','7.0000'),
('486','45','7.0000'),
('492','45','7.0000'),
('498','45','7.0000'),
('504','45','7.0000'),
('510','45','7.0000'),
('516','45','7.0000'),
('522','45','7.0000'),
('528','45','7.0000'),
('534','45','7.0000'),
('540','45','7.0000'),
('546','45','7.0000'),
('552','45','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('558','45','7.0000'),
('564','45','7.0000'),
('570','45','7.0000'),
('576','45','7.0000'),
('582','45','7.0000'),
('588','45','7.0000'),
('594','45','7.0000'),
('600','45','7.0000'),
('606','45','7.0000'),
('612','45','7.0000'),
('618','45','7.0000'),
('624','45','7.0000'),
('630','45','7.0000'),
('636','45','7.0000'),
('642','45','7.0000'),
('648','45','7.0000'),
('654','45','7.0000'),
('660','45','7.0000'),
('666','45','7.0000'),
('672','45','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('678','45','7.0000'),
('684','45','7.0000'),
('690','45','7.0000'),
('696','45','7.0000'),
('702','45','7.0000'),
('708','45','7.0000'),
('714','45','7.0000'),
('720','45','7.0000'),
('726','45','7.0000'),
('732','45','7.0000'),
('738','45','7.0000'),
('744','45','7.0000'),
('750','45','7.0000'),
('756','45','7.0000'),
('762','45','7.0000'),
('768','45','7.0000'),
('774','45','7.0000'),
('780','45','7.0000'),
('786','45','7.0000'),
('792','45','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('798','45','7.0000'),
('804','45','7.0000'),
('810','45','7.0000'),
('816','45','7.0000'),
('822','45','7.0000'),
('828','45','7.0000'),
('834','45','7.0000'),
('840','45','7.0000'),
('846','45','7.0000'),
('852','45','7.0000'),
('858','45','7.0000'),
('864','45','7.0000'),
('870','45','7.0000'),
('876','45','7.0000'),
('882','45','7.0000'),
('888','45','7.0000'),
('894','45','7.0000'),
('900','45','7.0000'),
('906','45','7.0000'),
('912','45','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('918','45','7.0000'),
('924','45','7.0000'),
('930','45','7.0000'),
('936','45','7.0000'),
('942','45','7.0000'),
('948','45','7.0000'),
('954','45','7.0000'),
('960','45','7.0000'),
('966','45','7.0000'),
('972','45','7.0000'),
('978','45','7.0000'),
('984','45','7.0000'),
('990','45','7.0000'),
('996','45','7.0000'),
('1002','45','7.0000'),
('1008','45','7.0000'),
('1014','45','7.0000'),
('1020','45','7.0000'),
('1026','45','7.0000'),
('1032','45','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1038','45','7.0000'),
('1044','45','7.0000'),
('1050','45','7.0000'),
('1056','45','7.0000'),
('1062','45','7.0000'),
('1068','45','7.0000'),
('1074','45','7.0000'),
('1080','45','7.0000'),
('1086','45','7.0000'),
('1092','45','7.0000'),
('1098','45','7.0000'),
('1104','45','7.0000'),
('1110','45','7.0000'),
('1116','45','7.0000'),
('1122','45','7.0000'),
('1128','45','7.0000'),
('1134','45','7.0000'),
('1140','45','7.0000'),
('1146','45','7.0000'),
('1152','45','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1158','45','7.0000'),
('1164','45','7.0000'),
('1170','45','7.0000'),
('1176','45','7.0000'),
('1182','45','7.0000'),
('1188','45','7.0000'),
('1194','45','7.0000'),
('1200','45','7.0000'),
('1206','45','7.0000'),
('1212','45','7.0000'),
('1218','45','7.0000'),
('1224','45','7.0000'),
('1230','45','7.0000'),
('1236','45','7.0000'),
('1242','45','7.0000'),
('1248','45','7.0000'),
('1254','45','7.0000'),
('1260','45','7.0000'),
('1266','45','7.0000'),
('1272','45','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1278','45','7.0000'),
('1284','45','7.0000'),
('1290','45','7.0000'),
('1296','45','7.0000'),
('1302','45','7.0000'),
('1308','45','7.0000'),
('1314','45','7.0000'),
('1320','45','7.0000'),
('1326','45','7.0000'),
('1332','45','7.0000'),
('1338','45','7.0000'),
('1344','45','7.0000'),
('1350','45','7.0000'),
('1356','45','7.0000'),
('1362','45','7.0000'),
('1368','45','7.0000'),
('1374','45','7.0000'),
('1380','45','7.0000'),
('1386','45','7.0000'),
('1392','45','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1398','45','7.0000'),
('1404','45','7.0000'),
('1410','45','7.0000'),
('1416','45','7.0000'),
('1422','45','7.0000'),
('1428','45','7.0000'),
('1434','45','7.0000'),
('1440','45','7.0000'),
('1446','45','7.0000'),
('1452','45','7.0000'),
('1458','45','7.0000'),
('1464','45','7.0000'),
('1470','45','7.0000'),
('1476','45','7.0000'),
('1482','45','7.0000'),
('1488','45','7.0000'),
('1494','45','7.0000'),
('1500','45','7.0000'),
('1506','45','7.0000'),
('1512','45','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1518','45','7.0000'),
('1524','45','7.0000'),
('1530','45','7.0000'),
('1536','45','7.0000'),
('1542','45','7.0000'),
('1548','45','7.0000'),
('1554','45','7.0000'),
('1560','45','7.0000'),
('1566','45','7.0000'),
('1572','45','7.0000'),
('1578','45','7.0000'),
('1584','45','7.0000'),
('1590','45','7.0000'),
('1596','45','7.0000'),
('1602','45','7.0000'),
('1608','45','7.0000'),
('1614','45','7.0000'),
('1620','45','7.0000'),
('1626','45','7.0000'),
('1632','45','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1638','45','7.0000'),
('1644','45','7.0000'),
('1650','45','7.0000'),
('1656','45','7.0000'),
('1662','45','7.0000'),
('1668','45','7.0000'),
('1674','45','7.0000'),
('1680','45','7.0000'),
('1686','45','7.0000'),
('1692','45','7.0000'),
('1698','45','7.0000'),
('1704','45','7.0000'),
('1710','45','7.0000'),
('1716','45','7.0000'),
('1722','45','7.0000'),
('1728','45','7.0000'),
('6','46','7.0000'),
('12','46','7.0000'),
('18','46','7.0000'),
('24','46','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('30','46','7.0000'),
('36','46','7.0000'),
('42','46','7.0000'),
('48','46','7.0000'),
('54','46','7.0000'),
('60','46','7.0000'),
('66','46','7.0000'),
('72','46','7.0000'),
('78','46','7.0000'),
('84','46','7.0000'),
('90','46','7.0000'),
('96','46','7.0000'),
('102','46','7.0000'),
('108','46','7.0000'),
('114','46','7.0000'),
('120','46','7.0000'),
('126','46','7.0000'),
('132','46','7.0000'),
('138','46','7.0000'),
('144','46','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('150','46','7.0000'),
('156','46','7.0000'),
('162','46','7.0000'),
('168','46','7.0000'),
('174','46','7.0000'),
('180','46','7.0000'),
('186','46','7.0000'),
('192','46','7.0000'),
('198','46','7.0000'),
('204','46','7.0000'),
('210','46','7.0000'),
('216','46','7.0000'),
('222','46','7.0000'),
('228','46','7.0000'),
('234','46','7.0000'),
('240','46','7.0000'),
('246','46','7.0000'),
('252','46','7.0000'),
('258','46','7.0000'),
('264','46','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('270','46','7.0000'),
('276','46','7.0000'),
('282','46','7.0000'),
('288','46','7.0000'),
('294','46','7.0000'),
('300','46','7.0000'),
('306','46','7.0000'),
('312','46','7.0000'),
('318','46','7.0000'),
('324','46','7.0000'),
('330','46','7.0000'),
('336','46','7.0000'),
('342','46','7.0000'),
('348','46','7.0000'),
('354','46','7.0000'),
('360','46','7.0000'),
('366','46','7.0000'),
('372','46','7.0000'),
('378','46','7.0000'),
('384','46','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('390','46','7.0000'),
('396','46','7.0000'),
('402','46','7.0000'),
('408','46','7.0000'),
('414','46','7.0000'),
('420','46','7.0000'),
('426','46','7.0000'),
('432','46','7.0000'),
('438','46','7.0000'),
('444','46','7.0000'),
('450','46','7.0000'),
('456','46','7.0000'),
('462','46','7.0000'),
('468','46','7.0000'),
('474','46','7.0000'),
('480','46','7.0000'),
('486','46','7.0000'),
('492','46','7.0000'),
('498','46','7.0000'),
('504','46','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('510','46','7.0000'),
('516','46','7.0000'),
('522','46','7.0000'),
('528','46','7.0000'),
('534','46','7.0000'),
('540','46','7.0000'),
('546','46','7.0000'),
('552','46','7.0000'),
('558','46','7.0000'),
('564','46','7.0000'),
('570','46','7.0000'),
('576','46','7.0000'),
('582','46','7.0000'),
('588','46','7.0000'),
('594','46','7.0000'),
('600','46','7.0000'),
('606','46','7.0000'),
('612','46','7.0000'),
('618','46','7.0000'),
('624','46','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('630','46','7.0000'),
('636','46','7.0000'),
('642','46','7.0000'),
('648','46','7.0000'),
('654','46','7.0000'),
('660','46','7.0000'),
('666','46','7.0000'),
('672','46','7.0000'),
('678','46','7.0000'),
('684','46','7.0000'),
('690','46','7.0000'),
('696','46','7.0000'),
('702','46','7.0000'),
('708','46','7.0000'),
('714','46','7.0000'),
('720','46','7.0000'),
('726','46','7.0000'),
('732','46','7.0000'),
('738','46','7.0000'),
('744','46','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('750','46','7.0000'),
('756','46','7.0000'),
('762','46','7.0000'),
('768','46','7.0000'),
('774','46','7.0000'),
('780','46','7.0000'),
('786','46','7.0000'),
('792','46','7.0000'),
('798','46','7.0000'),
('804','46','7.0000'),
('810','46','7.0000'),
('816','46','7.0000'),
('822','46','7.0000'),
('828','46','7.0000'),
('834','46','7.0000'),
('840','46','7.0000'),
('846','46','7.0000'),
('852','46','7.0000'),
('858','46','7.0000'),
('864','46','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('870','46','7.0000'),
('876','46','7.0000'),
('882','46','7.0000'),
('888','46','7.0000'),
('894','46','7.0000'),
('900','46','7.0000'),
('906','46','7.0000'),
('912','46','7.0000'),
('918','46','7.0000'),
('924','46','7.0000'),
('930','46','7.0000'),
('936','46','7.0000'),
('942','46','7.0000'),
('948','46','7.0000'),
('954','46','7.0000'),
('960','46','7.0000'),
('966','46','7.0000'),
('972','46','7.0000'),
('978','46','7.0000'),
('984','46','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('990','46','7.0000'),
('996','46','7.0000'),
('1002','46','7.0000'),
('1008','46','7.0000'),
('1014','46','7.0000'),
('1020','46','7.0000'),
('1026','46','7.0000'),
('1032','46','7.0000'),
('1038','46','7.0000'),
('1044','46','7.0000'),
('1050','46','7.0000'),
('1056','46','7.0000'),
('1062','46','7.0000'),
('1068','46','7.0000'),
('1074','46','7.0000'),
('1080','46','7.0000'),
('1086','46','7.0000'),
('1092','46','7.0000'),
('1098','46','7.0000'),
('1104','46','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1110','46','7.0000'),
('1116','46','7.0000'),
('1122','46','7.0000'),
('1128','46','7.0000'),
('1134','46','7.0000'),
('1140','46','7.0000'),
('1146','46','7.0000'),
('1152','46','7.0000'),
('1158','46','7.0000'),
('1164','46','7.0000'),
('1170','46','7.0000'),
('1176','46','7.0000'),
('1182','46','7.0000'),
('1188','46','7.0000'),
('1194','46','7.0000'),
('1200','46','7.0000'),
('1206','46','7.0000'),
('1212','46','7.0000'),
('1218','46','7.0000'),
('1224','46','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1230','46','7.0000'),
('1236','46','7.0000'),
('1242','46','7.0000'),
('1248','46','7.0000'),
('1254','46','7.0000'),
('1260','46','7.0000'),
('1266','46','7.0000'),
('1272','46','7.0000'),
('1278','46','7.0000'),
('1284','46','7.0000'),
('1290','46','7.0000'),
('1296','46','7.0000'),
('1302','46','7.0000'),
('1308','46','7.0000'),
('1314','46','7.0000'),
('1320','46','7.0000'),
('1326','46','7.0000'),
('1332','46','7.0000'),
('1338','46','7.0000'),
('1344','46','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1350','46','7.0000'),
('1356','46','7.0000'),
('1362','46','7.0000'),
('1368','46','7.0000'),
('1374','46','7.0000'),
('1380','46','7.0000'),
('1386','46','7.0000'),
('1392','46','7.0000'),
('1398','46','7.0000'),
('1404','46','7.0000'),
('1410','46','7.0000'),
('1416','46','7.0000'),
('1422','46','7.0000'),
('1428','46','7.0000'),
('1434','46','7.0000'),
('1440','46','7.0000'),
('1446','46','7.0000'),
('1452','46','7.0000'),
('1458','46','7.0000'),
('1464','46','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1470','46','7.0000'),
('1476','46','7.0000'),
('1482','46','7.0000'),
('1488','46','7.0000'),
('1494','46','7.0000'),
('1500','46','7.0000'),
('1506','46','7.0000'),
('1512','46','7.0000'),
('1518','46','7.0000'),
('1524','46','7.0000'),
('1530','46','7.0000'),
('1536','46','7.0000'),
('1542','46','7.0000'),
('1548','46','7.0000'),
('1554','46','7.0000'),
('1560','46','7.0000'),
('1566','46','7.0000'),
('1572','46','7.0000'),
('1578','46','7.0000'),
('1584','46','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1590','46','7.0000'),
('1596','46','7.0000'),
('1602','46','7.0000'),
('1608','46','7.0000'),
('1614','46','7.0000'),
('1620','46','7.0000'),
('1626','46','7.0000'),
('1632','46','7.0000'),
('1638','46','7.0000'),
('1644','46','7.0000'),
('1650','46','7.0000'),
('1656','46','7.0000'),
('1662','46','7.0000'),
('1668','46','7.0000'),
('1674','46','7.0000'),
('1680','46','7.0000'),
('1686','46','7.0000'),
('1692','46','7.0000'),
('1698','46','7.0000'),
('1704','46','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1710','46','7.0000'),
('1716','46','7.0000'),
('1722','46','7.0000'),
('1728','46','7.0000'),
('6','47','7.0000'),
('12','47','7.0000'),
('18','47','7.0000'),
('24','47','7.0000'),
('30','47','7.0000'),
('36','47','7.0000'),
('42','47','7.0000'),
('48','47','7.0000'),
('54','47','7.0000'),
('60','47','7.0000'),
('66','47','7.0000'),
('72','47','7.0000'),
('78','47','7.0000'),
('84','47','7.0000'),
('90','47','7.0000'),
('96','47','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('102','47','7.0000'),
('108','47','7.0000'),
('114','47','7.0000'),
('120','47','7.0000'),
('126','47','7.0000'),
('132','47','7.0000'),
('138','47','7.0000'),
('144','47','7.0000'),
('150','47','7.0000'),
('156','47','7.0000'),
('162','47','7.0000'),
('168','47','7.0000'),
('174','47','7.0000'),
('180','47','7.0000'),
('186','47','7.0000'),
('192','47','7.0000'),
('198','47','7.0000'),
('204','47','7.0000'),
('210','47','7.0000'),
('216','47','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('222','47','7.0000'),
('228','47','7.0000'),
('234','47','7.0000'),
('240','47','7.0000'),
('246','47','7.0000'),
('252','47','7.0000'),
('258','47','7.0000'),
('264','47','7.0000'),
('270','47','7.0000'),
('276','47','7.0000'),
('282','47','7.0000'),
('288','47','7.0000'),
('294','47','7.0000'),
('300','47','7.0000'),
('306','47','7.0000'),
('312','47','7.0000'),
('318','47','7.0000'),
('324','47','7.0000'),
('330','47','7.0000'),
('336','47','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('342','47','7.0000'),
('348','47','7.0000'),
('354','47','7.0000'),
('360','47','7.0000'),
('366','47','7.0000'),
('372','47','7.0000'),
('378','47','7.0000'),
('384','47','7.0000'),
('390','47','7.0000'),
('396','47','7.0000'),
('402','47','7.0000'),
('408','47','7.0000'),
('414','47','7.0000'),
('420','47','7.0000'),
('426','47','7.0000'),
('432','47','7.0000'),
('438','47','7.0000'),
('444','47','7.0000'),
('450','47','7.0000'),
('456','47','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('462','47','7.0000'),
('468','47','7.0000'),
('474','47','7.0000'),
('480','47','7.0000'),
('486','47','7.0000'),
('492','47','7.0000'),
('498','47','7.0000'),
('504','47','7.0000'),
('510','47','7.0000'),
('516','47','7.0000'),
('522','47','7.0000'),
('528','47','7.0000'),
('534','47','7.0000'),
('540','47','7.0000'),
('546','47','7.0000'),
('552','47','7.0000'),
('558','47','7.0000'),
('564','47','7.0000'),
('570','47','7.0000'),
('576','47','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('582','47','7.0000'),
('588','47','7.0000'),
('594','47','7.0000'),
('600','47','7.0000'),
('606','47','7.0000'),
('612','47','7.0000'),
('618','47','7.0000'),
('624','47','7.0000'),
('630','47','7.0000'),
('636','47','7.0000'),
('642','47','7.0000'),
('648','47','7.0000'),
('654','47','7.0000'),
('660','47','7.0000'),
('666','47','7.0000'),
('672','47','7.0000'),
('678','47','7.0000'),
('684','47','7.0000'),
('690','47','7.0000'),
('696','47','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('702','47','7.0000'),
('708','47','7.0000'),
('714','47','7.0000'),
('720','47','7.0000'),
('726','47','7.0000'),
('732','47','7.0000'),
('738','47','7.0000'),
('744','47','7.0000'),
('750','47','7.0000'),
('756','47','7.0000'),
('762','47','7.0000'),
('768','47','7.0000'),
('774','47','7.0000'),
('780','47','7.0000'),
('786','47','7.0000'),
('792','47','7.0000'),
('798','47','7.0000'),
('804','47','7.0000'),
('810','47','7.0000'),
('816','47','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('822','47','7.0000'),
('828','47','7.0000'),
('834','47','7.0000'),
('840','47','7.0000'),
('846','47','7.0000'),
('852','47','7.0000'),
('858','47','7.0000'),
('864','47','7.0000'),
('870','47','7.0000'),
('876','47','7.0000'),
('882','47','7.0000'),
('888','47','7.0000'),
('894','47','7.0000'),
('900','47','7.0000'),
('906','47','7.0000'),
('912','47','7.0000'),
('918','47','7.0000'),
('924','47','7.0000'),
('930','47','7.0000'),
('936','47','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('942','47','7.0000'),
('948','47','7.0000'),
('954','47','7.0000'),
('960','47','7.0000'),
('966','47','7.0000'),
('972','47','7.0000'),
('978','47','7.0000'),
('984','47','7.0000'),
('990','47','7.0000'),
('996','47','7.0000'),
('1002','47','7.0000'),
('1008','47','7.0000'),
('1014','47','7.0000'),
('1020','47','7.0000'),
('1026','47','7.0000'),
('1032','47','7.0000'),
('1038','47','7.0000'),
('1044','47','7.0000'),
('1050','47','7.0000'),
('1056','47','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1062','47','7.0000'),
('1068','47','7.0000'),
('1074','47','7.0000'),
('1080','47','7.0000'),
('1086','47','7.0000'),
('1092','47','7.0000'),
('1098','47','7.0000'),
('1104','47','7.0000'),
('1110','47','7.0000'),
('1116','47','7.0000'),
('1122','47','7.0000'),
('1128','47','7.0000'),
('1134','47','7.0000'),
('1140','47','7.0000'),
('1146','47','7.0000'),
('1152','47','7.0000'),
('1158','47','7.0000'),
('1164','47','7.0000'),
('1170','47','7.0000'),
('1176','47','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1182','47','7.0000'),
('1188','47','7.0000'),
('1194','47','7.0000'),
('1200','47','7.0000'),
('1206','47','7.0000'),
('1212','47','7.0000'),
('1218','47','7.0000'),
('1224','47','7.0000'),
('1230','47','7.0000'),
('1236','47','7.0000'),
('1242','47','7.0000'),
('1248','47','7.0000'),
('1254','47','7.0000'),
('1260','47','7.0000'),
('1266','47','7.0000'),
('1272','47','7.0000'),
('1278','47','7.0000'),
('1284','47','7.0000'),
('1290','47','7.0000'),
('1296','47','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1302','47','7.0000'),
('1308','47','7.0000'),
('1314','47','7.0000'),
('1320','47','7.0000'),
('1326','47','7.0000'),
('1332','47','7.0000'),
('1338','47','7.0000'),
('1344','47','7.0000'),
('1350','47','7.0000'),
('1356','47','7.0000'),
('1362','47','7.0000'),
('1368','47','7.0000'),
('1374','47','7.0000'),
('1380','47','7.0000'),
('1386','47','7.0000'),
('1392','47','7.0000'),
('1398','47','7.0000'),
('1404','47','7.0000'),
('1410','47','7.0000'),
('1416','47','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1422','47','7.0000'),
('1428','47','7.0000'),
('1434','47','7.0000'),
('1440','47','7.0000'),
('1446','47','7.0000'),
('1452','47','7.0000'),
('1458','47','7.0000'),
('1464','47','7.0000'),
('1470','47','7.0000'),
('1476','47','7.0000'),
('1482','47','7.0000'),
('1488','47','7.0000'),
('1494','47','7.0000'),
('1500','47','7.0000'),
('1506','47','7.0000'),
('1512','47','7.0000'),
('1518','47','7.0000'),
('1524','47','7.0000'),
('1530','47','7.0000'),
('1536','47','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1542','47','7.0000'),
('1548','47','7.0000'),
('1554','47','7.0000'),
('1560','47','7.0000'),
('1566','47','7.0000'),
('1572','47','7.0000'),
('1578','47','7.0000'),
('1584','47','7.0000'),
('1590','47','7.0000'),
('1596','47','7.0000'),
('1602','47','7.0000'),
('1608','47','7.0000'),
('1614','47','7.0000'),
('1620','47','7.0000'),
('1626','47','7.0000'),
('1632','47','7.0000'),
('1638','47','7.0000'),
('1644','47','7.0000'),
('1650','47','7.0000'),
('1656','47','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1662','47','7.0000'),
('1668','47','7.0000'),
('1674','47','7.0000'),
('1680','47','7.0000'),
('1686','47','7.0000'),
('1692','47','7.0000'),
('1698','47','7.0000'),
('1704','47','7.0000'),
('1710','47','7.0000'),
('1716','47','7.0000'),
('1722','47','7.0000'),
('1728','47','7.0000'),
('6','48','7.0000'),
('12','48','7.0000'),
('18','48','7.0000'),
('24','48','7.0000'),
('30','48','7.0000'),
('36','48','7.0000'),
('42','48','7.0000'),
('48','48','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('54','48','7.0000'),
('60','48','7.0000'),
('66','48','7.0000'),
('72','48','7.0000'),
('78','48','7.0000'),
('84','48','7.0000'),
('90','48','7.0000'),
('96','48','7.0000'),
('102','48','7.0000'),
('108','48','7.0000'),
('114','48','7.0000'),
('120','48','7.0000'),
('126','48','7.0000'),
('132','48','7.0000'),
('138','48','7.0000'),
('144','48','7.0000'),
('150','48','7.0000'),
('156','48','7.0000'),
('162','48','7.0000'),
('168','48','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('174','48','7.0000'),
('180','48','7.0000'),
('186','48','7.0000'),
('192','48','7.0000'),
('198','48','7.0000'),
('204','48','7.0000'),
('210','48','7.0000'),
('216','48','7.0000'),
('222','48','7.0000'),
('228','48','7.0000'),
('234','48','7.0000'),
('240','48','7.0000'),
('246','48','7.0000'),
('252','48','7.0000'),
('258','48','7.0000'),
('264','48','7.0000'),
('270','48','7.0000'),
('276','48','7.0000'),
('282','48','7.0000'),
('288','48','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('294','48','7.0000'),
('300','48','7.0000'),
('306','48','7.0000'),
('312','48','7.0000'),
('318','48','7.0000'),
('324','48','7.0000'),
('330','48','7.0000'),
('336','48','7.0000'),
('342','48','7.0000'),
('348','48','7.0000'),
('354','48','7.0000'),
('360','48','7.0000'),
('366','48','7.0000'),
('372','48','7.0000'),
('378','48','7.0000'),
('384','48','7.0000'),
('390','48','7.0000'),
('396','48','7.0000'),
('402','48','7.0000'),
('408','48','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('414','48','7.0000'),
('420','48','7.0000'),
('426','48','7.0000'),
('432','48','7.0000'),
('438','48','7.0000'),
('444','48','7.0000'),
('450','48','7.0000'),
('456','48','7.0000'),
('462','48','7.0000'),
('468','48','7.0000'),
('474','48','7.0000'),
('480','48','7.0000'),
('486','48','7.0000'),
('492','48','7.0000'),
('498','48','7.0000'),
('504','48','7.0000'),
('510','48','7.0000'),
('516','48','7.0000'),
('522','48','7.0000'),
('528','48','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('534','48','7.0000'),
('540','48','7.0000'),
('546','48','7.0000'),
('552','48','7.0000'),
('558','48','7.0000'),
('564','48','7.0000'),
('570','48','7.0000'),
('576','48','7.0000'),
('582','48','7.0000'),
('588','48','7.0000'),
('594','48','7.0000'),
('600','48','7.0000'),
('606','48','7.0000'),
('612','48','7.0000'),
('618','48','7.0000'),
('624','48','7.0000'),
('630','48','7.0000'),
('636','48','7.0000'),
('642','48','7.0000'),
('648','48','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('654','48','7.0000'),
('660','48','7.0000'),
('666','48','7.0000'),
('672','48','7.0000'),
('678','48','7.0000'),
('684','48','7.0000'),
('690','48','7.0000'),
('696','48','7.0000'),
('702','48','7.0000'),
('708','48','7.0000'),
('714','48','7.0000'),
('720','48','7.0000'),
('726','48','7.0000'),
('732','48','7.0000'),
('738','48','7.0000'),
('744','48','7.0000'),
('750','48','7.0000'),
('756','48','7.0000'),
('762','48','7.0000'),
('768','48','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('774','48','7.0000'),
('780','48','7.0000'),
('786','48','7.0000'),
('792','48','7.0000'),
('798','48','7.0000'),
('804','48','7.0000'),
('810','48','7.0000'),
('816','48','7.0000'),
('822','48','7.0000'),
('828','48','7.0000'),
('834','48','7.0000'),
('840','48','7.0000'),
('846','48','7.0000'),
('852','48','7.0000'),
('858','48','7.0000'),
('864','48','7.0000'),
('870','48','7.0000'),
('876','48','7.0000'),
('882','48','7.0000'),
('888','48','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('894','48','7.0000'),
('900','48','7.0000'),
('906','48','7.0000'),
('912','48','7.0000'),
('918','48','7.0000'),
('924','48','7.0000'),
('930','48','7.0000'),
('936','48','7.0000'),
('942','48','7.0000'),
('948','48','7.0000'),
('954','48','7.0000'),
('960','48','7.0000'),
('966','48','7.0000'),
('972','48','7.0000'),
('978','48','7.0000'),
('984','48','7.0000'),
('990','48','7.0000'),
('996','48','7.0000'),
('1002','48','7.0000'),
('1008','48','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1014','48','7.0000'),
('1020','48','7.0000'),
('1026','48','7.0000'),
('1032','48','7.0000'),
('1038','48','7.0000'),
('1044','48','7.0000'),
('1050','48','7.0000'),
('1056','48','7.0000'),
('1062','48','7.0000'),
('1068','48','7.0000'),
('1074','48','7.0000'),
('1080','48','7.0000'),
('1086','48','7.0000'),
('1092','48','7.0000'),
('1098','48','7.0000'),
('1104','48','7.0000'),
('1110','48','7.0000'),
('1116','48','7.0000'),
('1122','48','7.0000'),
('1128','48','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1134','48','7.0000'),
('1140','48','7.0000'),
('1146','48','7.0000'),
('1152','48','7.0000'),
('1158','48','7.0000'),
('1164','48','7.0000'),
('1170','48','7.0000'),
('1176','48','7.0000'),
('1182','48','7.0000'),
('1188','48','7.0000'),
('1194','48','7.0000'),
('1200','48','7.0000'),
('1206','48','7.0000'),
('1212','48','7.0000'),
('1218','48','7.0000'),
('1224','48','7.0000'),
('1230','48','7.0000'),
('1236','48','7.0000'),
('1242','48','7.0000'),
('1248','48','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1254','48','7.0000'),
('1260','48','7.0000'),
('1266','48','7.0000'),
('1272','48','7.0000'),
('1278','48','7.0000'),
('1284','48','7.0000'),
('1290','48','7.0000'),
('1296','48','7.0000'),
('1302','48','7.0000'),
('1308','48','7.0000'),
('1314','48','7.0000'),
('1320','48','7.0000'),
('1326','48','7.0000'),
('1332','48','7.0000'),
('1338','48','7.0000'),
('1344','48','7.0000'),
('1350','48','7.0000'),
('1356','48','7.0000'),
('1362','48','7.0000'),
('1368','48','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1374','48','7.0000'),
('1380','48','7.0000'),
('1386','48','7.0000'),
('1392','48','7.0000'),
('1398','48','7.0000'),
('1404','48','7.0000'),
('1410','48','7.0000'),
('1416','48','7.0000'),
('1422','48','7.0000'),
('1428','48','7.0000'),
('1434','48','7.0000'),
('1440','48','7.0000'),
('1446','48','7.0000'),
('1452','48','7.0000'),
('1458','48','7.0000'),
('1464','48','7.0000'),
('1470','48','7.0000'),
('1476','48','7.0000'),
('1482','48','7.0000'),
('1488','48','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1494','48','7.0000'),
('1500','48','7.0000'),
('1506','48','7.0000'),
('1512','48','7.0000'),
('1518','48','7.0000'),
('1524','48','7.0000'),
('1530','48','7.0000'),
('1536','48','7.0000'),
('1542','48','7.0000'),
('1548','48','7.0000'),
('1554','48','7.0000'),
('1560','48','7.0000'),
('1566','48','7.0000'),
('1572','48','7.0000'),
('1578','48','7.0000'),
('1584','48','7.0000'),
('1590','48','7.0000'),
('1596','48','7.0000'),
('1602','48','7.0000'),
('1608','48','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1614','48','7.0000'),
('1620','48','7.0000'),
('1626','48','7.0000'),
('1632','48','7.0000'),
('1638','48','7.0000'),
('1644','48','7.0000'),
('1650','48','7.0000'),
('1656','48','7.0000'),
('1662','48','7.0000'),
('1668','48','7.0000'),
('1674','48','7.0000'),
('1680','48','7.0000'),
('1686','48','7.0000'),
('1692','48','7.0000'),
('1698','48','7.0000'),
('1704','48','7.0000'),
('1710','48','7.0000'),
('1716','48','7.0000'),
('1722','48','7.0000'),
('1728','48','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('6','49','7.0000'),
('12','49','7.0000'),
('18','49','7.0000'),
('24','49','7.0000'),
('30','49','7.0000'),
('36','49','7.0000'),
('42','49','7.0000'),
('48','49','7.0000'),
('54','49','7.0000'),
('60','49','7.0000'),
('66','49','7.0000'),
('72','49','7.0000'),
('78','49','7.0000'),
('84','49','7.0000'),
('90','49','7.0000'),
('96','49','7.0000'),
('102','49','7.0000'),
('108','49','7.0000'),
('114','49','7.0000'),
('120','49','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('126','49','7.0000'),
('132','49','7.0000'),
('138','49','7.0000'),
('144','49','7.0000'),
('150','49','7.0000'),
('156','49','7.0000'),
('162','49','7.0000'),
('168','49','7.0000'),
('174','49','7.0000'),
('180','49','7.0000'),
('186','49','7.0000'),
('192','49','7.0000'),
('198','49','7.0000'),
('204','49','7.0000'),
('210','49','7.0000'),
('216','49','7.0000'),
('222','49','7.0000'),
('228','49','7.0000'),
('234','49','7.0000'),
('240','49','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('246','49','7.0000'),
('252','49','7.0000'),
('258','49','7.0000'),
('264','49','7.0000'),
('270','49','7.0000'),
('276','49','7.0000'),
('282','49','7.0000'),
('288','49','7.0000'),
('294','49','7.0000'),
('300','49','7.0000'),
('306','49','7.0000'),
('312','49','7.0000'),
('318','49','7.0000'),
('324','49','7.0000'),
('330','49','7.0000'),
('336','49','7.0000'),
('342','49','7.0000'),
('348','49','7.0000'),
('354','49','7.0000'),
('360','49','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('366','49','7.0000'),
('372','49','7.0000'),
('378','49','7.0000'),
('384','49','7.0000'),
('390','49','7.0000'),
('396','49','7.0000'),
('402','49','7.0000'),
('408','49','7.0000'),
('414','49','7.0000'),
('420','49','7.0000'),
('426','49','7.0000'),
('432','49','7.0000'),
('438','49','7.0000'),
('444','49','7.0000'),
('450','49','7.0000'),
('456','49','7.0000'),
('462','49','7.0000'),
('468','49','7.0000'),
('474','49','7.0000'),
('480','49','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('486','49','7.0000'),
('492','49','7.0000'),
('498','49','7.0000'),
('504','49','7.0000'),
('510','49','7.0000'),
('516','49','7.0000'),
('522','49','7.0000'),
('528','49','7.0000'),
('534','49','7.0000'),
('540','49','7.0000'),
('546','49','7.0000'),
('552','49','7.0000'),
('558','49','7.0000'),
('564','49','7.0000'),
('570','49','7.0000'),
('576','49','7.0000'),
('582','49','7.0000'),
('588','49','7.0000'),
('594','49','7.0000'),
('600','49','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('606','49','7.0000'),
('612','49','7.0000'),
('618','49','7.0000'),
('624','49','7.0000'),
('630','49','7.0000'),
('636','49','7.0000'),
('642','49','7.0000'),
('648','49','7.0000'),
('654','49','7.0000'),
('660','49','7.0000'),
('666','49','7.0000'),
('672','49','7.0000'),
('678','49','7.0000'),
('684','49','7.0000'),
('690','49','7.0000'),
('696','49','7.0000'),
('702','49','7.0000'),
('708','49','7.0000'),
('714','49','7.0000'),
('720','49','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('726','49','7.0000'),
('732','49','7.0000'),
('738','49','7.0000'),
('744','49','7.0000'),
('750','49','7.0000'),
('756','49','7.0000'),
('762','49','7.0000'),
('768','49','7.0000'),
('774','49','7.0000'),
('780','49','7.0000'),
('786','49','7.0000'),
('792','49','7.0000'),
('798','49','7.0000'),
('804','49','7.0000'),
('810','49','7.0000'),
('816','49','7.0000'),
('822','49','7.0000'),
('828','49','7.0000'),
('834','49','7.0000'),
('840','49','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('846','49','7.0000'),
('852','49','7.0000'),
('858','49','7.0000'),
('864','49','7.0000'),
('870','49','7.0000'),
('876','49','7.0000'),
('882','49','7.0000'),
('888','49','7.0000'),
('894','49','7.0000'),
('900','49','7.0000'),
('906','49','7.0000'),
('912','49','7.0000'),
('918','49','7.0000'),
('924','49','7.0000'),
('930','49','7.0000'),
('936','49','7.0000'),
('942','49','7.0000'),
('948','49','7.0000'),
('954','49','7.0000'),
('960','49','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('966','49','7.0000'),
('972','49','7.0000'),
('978','49','7.0000'),
('984','49','7.0000'),
('990','49','7.0000'),
('996','49','7.0000'),
('1002','49','7.0000'),
('1008','49','7.0000'),
('1014','49','7.0000'),
('1020','49','7.0000'),
('1026','49','7.0000'),
('1032','49','7.0000'),
('1038','49','7.0000'),
('1044','49','7.0000'),
('1050','49','7.0000'),
('1056','49','7.0000'),
('1062','49','7.0000'),
('1068','49','7.0000'),
('1074','49','7.0000'),
('1080','49','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1086','49','7.0000'),
('1092','49','7.0000'),
('1098','49','7.0000'),
('1104','49','7.0000'),
('1110','49','7.0000'),
('1116','49','7.0000'),
('1122','49','7.0000'),
('1128','49','7.0000'),
('1134','49','7.0000'),
('1140','49','7.0000'),
('1146','49','7.0000'),
('1152','49','7.0000'),
('1158','49','7.0000'),
('1164','49','7.0000'),
('1170','49','7.0000'),
('1176','49','7.0000'),
('1182','49','7.0000'),
('1188','49','7.0000'),
('1194','49','7.0000'),
('1200','49','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1206','49','7.0000'),
('1212','49','7.0000'),
('1218','49','7.0000'),
('1224','49','7.0000'),
('1230','49','7.0000'),
('1236','49','7.0000'),
('1242','49','7.0000'),
('1248','49','7.0000'),
('1254','49','7.0000'),
('1260','49','7.0000'),
('1266','49','7.0000'),
('1272','49','7.0000'),
('1278','49','7.0000'),
('1284','49','7.0000'),
('1290','49','7.0000'),
('1296','49','7.0000'),
('1302','49','7.0000'),
('1308','49','7.0000'),
('1314','49','7.0000'),
('1320','49','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1326','49','7.0000'),
('1332','49','7.0000'),
('1338','49','7.0000'),
('1344','49','7.0000'),
('1350','49','7.0000'),
('1356','49','7.0000'),
('1362','49','7.0000'),
('1368','49','7.0000'),
('1374','49','7.0000'),
('1380','49','7.0000'),
('1386','49','7.0000'),
('1392','49','7.0000'),
('1398','49','7.0000'),
('1404','49','7.0000'),
('1410','49','7.0000'),
('1416','49','7.0000'),
('1422','49','7.0000'),
('1428','49','7.0000'),
('1434','49','7.0000'),
('1440','49','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1446','49','7.0000'),
('1452','49','7.0000'),
('1458','49','7.0000'),
('1464','49','7.0000'),
('1470','49','7.0000'),
('1476','49','7.0000'),
('1482','49','7.0000'),
('1488','49','7.0000'),
('1494','49','7.0000'),
('1500','49','7.0000'),
('1506','49','7.0000'),
('1512','49','7.0000'),
('1518','49','7.0000'),
('1524','49','7.0000'),
('1530','49','7.0000'),
('1536','49','7.0000'),
('1542','49','7.0000'),
('1548','49','7.0000'),
('1554','49','7.0000'),
('1560','49','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1566','49','7.0000'),
('1572','49','7.0000'),
('1578','49','7.0000'),
('1584','49','7.0000'),
('1590','49','7.0000'),
('1596','49','7.0000'),
('1602','49','7.0000'),
('1608','49','7.0000'),
('1614','49','7.0000'),
('1620','49','7.0000'),
('1626','49','7.0000'),
('1632','49','7.0000'),
('1638','49','7.0000'),
('1644','49','7.0000'),
('1650','49','7.0000'),
('1656','49','7.0000'),
('1662','49','7.0000'),
('1668','49','7.0000'),
('1674','49','7.0000'),
('1680','49','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1686','49','7.0000'),
('1692','49','7.0000'),
('1698','49','7.0000'),
('1704','49','7.0000'),
('1710','49','7.0000'),
('1716','49','7.0000'),
('1722','49','7.0000'),
('1728','49','7.0000'),
('6','50','7.0000'),
('12','50','7.0000'),
('18','50','7.0000'),
('24','50','7.0000'),
('30','50','7.0000'),
('36','50','7.0000'),
('42','50','7.0000'),
('48','50','7.0000'),
('54','50','7.0000'),
('60','50','7.0000'),
('66','50','7.0000'),
('72','50','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('78','50','7.0000'),
('84','50','7.0000'),
('90','50','7.0000'),
('96','50','7.0000'),
('102','50','7.0000'),
('108','50','7.0000'),
('114','50','7.0000'),
('120','50','7.0000'),
('126','50','7.0000'),
('132','50','7.0000'),
('138','50','7.0000'),
('144','50','7.0000'),
('150','50','7.0000'),
('156','50','7.0000'),
('162','50','7.0000'),
('168','50','7.0000'),
('174','50','7.0000'),
('180','50','7.0000'),
('186','50','7.0000'),
('192','50','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('198','50','7.0000'),
('204','50','7.0000'),
('210','50','7.0000'),
('216','50','7.0000'),
('222','50','7.0000'),
('228','50','7.0000'),
('234','50','7.0000'),
('240','50','7.0000'),
('246','50','7.0000'),
('252','50','7.0000'),
('258','50','7.0000'),
('264','50','7.0000'),
('270','50','7.0000'),
('276','50','7.0000'),
('282','50','7.0000'),
('288','50','7.0000'),
('294','50','7.0000'),
('300','50','7.0000'),
('306','50','7.0000'),
('312','50','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('318','50','7.0000'),
('324','50','7.0000'),
('330','50','7.0000'),
('336','50','7.0000'),
('342','50','7.0000'),
('348','50','7.0000'),
('354','50','7.0000'),
('360','50','7.0000'),
('366','50','7.0000'),
('372','50','7.0000'),
('378','50','7.0000'),
('384','50','7.0000'),
('390','50','7.0000'),
('396','50','7.0000'),
('402','50','7.0000'),
('408','50','7.0000'),
('414','50','7.0000'),
('420','50','7.0000'),
('426','50','7.0000'),
('432','50','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('438','50','7.0000'),
('444','50','7.0000'),
('450','50','7.0000'),
('456','50','7.0000'),
('462','50','7.0000'),
('468','50','7.0000'),
('474','50','7.0000'),
('480','50','7.0000'),
('486','50','7.0000'),
('492','50','7.0000'),
('498','50','7.0000'),
('504','50','7.0000'),
('510','50','7.0000'),
('516','50','7.0000'),
('522','50','7.0000'),
('528','50','7.0000'),
('534','50','7.0000'),
('540','50','7.0000'),
('546','50','7.0000'),
('552','50','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('558','50','7.0000'),
('564','50','7.0000'),
('570','50','7.0000'),
('576','50','7.0000'),
('582','50','7.0000'),
('588','50','7.0000'),
('594','50','7.0000'),
('600','50','7.0000'),
('606','50','7.0000'),
('612','50','7.0000'),
('618','50','7.0000'),
('624','50','7.0000'),
('630','50','7.0000'),
('636','50','7.0000'),
('642','50','7.0000'),
('648','50','7.0000'),
('654','50','7.0000'),
('660','50','7.0000'),
('666','50','7.0000'),
('672','50','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('678','50','7.0000'),
('684','50','7.0000'),
('690','50','7.0000'),
('696','50','7.0000'),
('702','50','7.0000'),
('708','50','7.0000'),
('714','50','7.0000'),
('720','50','7.0000'),
('726','50','7.0000'),
('732','50','7.0000'),
('738','50','7.0000'),
('744','50','7.0000'),
('750','50','7.0000'),
('756','50','7.0000'),
('762','50','7.0000'),
('768','50','7.0000'),
('774','50','7.0000'),
('780','50','7.0000'),
('786','50','7.0000'),
('792','50','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('798','50','7.0000'),
('804','50','7.0000'),
('810','50','7.0000'),
('816','50','7.0000'),
('822','50','7.0000'),
('828','50','7.0000'),
('834','50','7.0000'),
('840','50','7.0000'),
('846','50','7.0000'),
('852','50','7.0000'),
('858','50','7.0000'),
('864','50','7.0000'),
('870','50','7.0000'),
('876','50','7.0000'),
('882','50','7.0000'),
('888','50','7.0000'),
('894','50','7.0000'),
('900','50','7.0000'),
('906','50','7.0000'),
('912','50','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('918','50','7.0000'),
('924','50','7.0000'),
('930','50','7.0000'),
('936','50','7.0000'),
('942','50','7.0000'),
('948','50','7.0000'),
('954','50','7.0000'),
('960','50','7.0000'),
('966','50','7.0000'),
('972','50','7.0000'),
('978','50','7.0000'),
('984','50','7.0000'),
('990','50','7.0000'),
('996','50','7.0000'),
('1002','50','7.0000'),
('1008','50','7.0000'),
('1014','50','7.0000'),
('1020','50','7.0000'),
('1026','50','7.0000'),
('1032','50','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1038','50','7.0000'),
('1044','50','7.0000'),
('1050','50','7.0000'),
('1056','50','7.0000'),
('1062','50','7.0000'),
('1068','50','7.0000'),
('1074','50','7.0000'),
('1080','50','7.0000'),
('1086','50','7.0000'),
('1092','50','7.0000'),
('1098','50','7.0000'),
('1104','50','7.0000'),
('1110','50','7.0000'),
('1116','50','7.0000'),
('1122','50','7.0000'),
('1128','50','7.0000'),
('1134','50','7.0000'),
('1140','50','7.0000'),
('1146','50','7.0000'),
('1152','50','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1158','50','7.0000'),
('1164','50','7.0000'),
('1170','50','7.0000'),
('1176','50','7.0000'),
('1182','50','7.0000'),
('1188','50','7.0000'),
('1194','50','7.0000'),
('1200','50','7.0000'),
('1206','50','7.0000'),
('1212','50','7.0000'),
('1218','50','7.0000'),
('1224','50','7.0000'),
('1230','50','7.0000'),
('1236','50','7.0000'),
('1242','50','7.0000'),
('1248','50','7.0000'),
('1254','50','7.0000'),
('1260','50','7.0000'),
('1266','50','7.0000'),
('1272','50','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1278','50','7.0000'),
('1284','50','7.0000'),
('1290','50','7.0000'),
('1296','50','7.0000'),
('1302','50','7.0000'),
('1308','50','7.0000'),
('1314','50','7.0000'),
('1320','50','7.0000'),
('1326','50','7.0000'),
('1332','50','7.0000'),
('1338','50','7.0000'),
('1344','50','7.0000'),
('1350','50','7.0000'),
('1356','50','7.0000'),
('1362','50','7.0000'),
('1368','50','7.0000'),
('1374','50','7.0000'),
('1380','50','7.0000'),
('1386','50','7.0000'),
('1392','50','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1398','50','7.0000'),
('1404','50','7.0000'),
('1410','50','7.0000'),
('1416','50','7.0000'),
('1422','50','7.0000'),
('1428','50','7.0000'),
('1434','50','7.0000'),
('1440','50','7.0000'),
('1446','50','7.0000'),
('1452','50','7.0000'),
('1458','50','7.0000'),
('1464','50','7.0000'),
('1470','50','7.0000'),
('1476','50','7.0000'),
('1482','50','7.0000'),
('1488','50','7.0000'),
('1494','50','7.0000'),
('1500','50','7.0000'),
('1506','50','7.0000'),
('1512','50','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1518','50','7.0000'),
('1524','50','7.0000'),
('1530','50','7.0000'),
('1536','50','7.0000'),
('1542','50','7.0000'),
('1548','50','7.0000'),
('1554','50','7.0000'),
('1560','50','7.0000'),
('1566','50','7.0000'),
('1572','50','7.0000'),
('1578','50','7.0000'),
('1584','50','7.0000'),
('1590','50','7.0000'),
('1596','50','7.0000'),
('1602','50','7.0000'),
('1608','50','7.0000'),
('1614','50','7.0000'),
('1620','50','7.0000'),
('1626','50','7.0000'),
('1632','50','7.0000');
insert into `products_price_break` (`products_id`, `quantity`, `discount_per_item`) values ('1638','50','7.0000'),
('1644','50','7.0000'),
('1650','50','7.0000'),
('1656','50','7.0000'),
('1662','50','7.0000'),
('1668','50','7.0000'),
('1674','50','7.0000'),
('1680','50','7.0000'),
('1686','50','7.0000'),
('1692','50','7.0000'),
('1698','50','7.0000'),
('1704','50','7.0000'),
('1710','50','7.0000'),
('1716','50','7.0000'),
('1722','50','7.0000'),
('1728','50','7.0000');

drop table if exists `products_to_categories`;
CREATE TABLE `products_to_categories` (
  `products_id` int(11) NOT NULL DEFAULT 0,
  `categories_id` int(11) NOT NULL DEFAULT 0,
  `section_id` int(11) NOT NULL,
  PRIMARY KEY (`products_id`,`categories_id`)
);

insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1','25','1'),
('2','25','1'),
('3','25','1'),
('4','25','1'),
('5','25','1'),
('6','25','1'),
('7','26','1'),
('8','26','1'),
('9','26','1'),
('10','26','1'),
('11','26','1'),
('12','26','1'),
('13','27','1'),
('14','27','1'),
('15','27','1'),
('16','27','1'),
('17','27','1'),
('18','27','1'),
('19','28','1'),
('20','28','1');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('21','28','1'),
('22','28','1'),
('23','28','1'),
('24','28','1'),
('25','29','1'),
('26','29','1'),
('27','29','1'),
('28','29','1'),
('29','29','1'),
('30','29','1'),
('31','30','1'),
('32','30','1'),
('33','30','1'),
('34','30','1'),
('35','30','1'),
('36','30','1'),
('37','31','1'),
('38','31','1'),
('39','31','1'),
('40','31','1');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('41','31','1'),
('42','31','1'),
('43','32','1'),
('44','32','1'),
('45','32','1'),
('46','32','1'),
('47','32','1'),
('48','32','1'),
('49','33','1'),
('50','33','1'),
('51','33','1'),
('52','33','1'),
('53','33','1'),
('54','33','1'),
('55','34','1'),
('56','34','1'),
('57','34','1'),
('58','34','1'),
('59','34','1'),
('60','34','1');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('61','35','1'),
('62','35','1'),
('63','35','1'),
('64','35','1'),
('65','35','1'),
('66','35','1'),
('67','36','1'),
('68','36','1'),
('69','36','1'),
('70','36','1'),
('71','36','1'),
('72','36','1'),
('73','37','2'),
('74','37','2'),
('75','37','2'),
('76','37','2'),
('77','37','2'),
('78','37','2'),
('79','38','2'),
('80','38','2');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('81','38','2'),
('82','38','2'),
('83','38','2'),
('84','38','2'),
('85','39','2'),
('86','39','2'),
('87','39','2'),
('88','39','2'),
('89','39','2'),
('90','39','2'),
('91','40','2'),
('92','40','2'),
('93','40','2'),
('94','40','2'),
('95','40','2'),
('96','40','2'),
('97','41','2'),
('98','41','2'),
('99','41','2'),
('100','41','2');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('101','41','2'),
('102','41','2'),
('103','42','2'),
('104','42','2'),
('105','42','2'),
('106','42','2'),
('107','42','2'),
('108','42','2'),
('109','43','2'),
('110','43','2'),
('111','43','2'),
('112','43','2'),
('113','43','2'),
('114','43','2'),
('115','44','2'),
('116','44','2'),
('117','44','2'),
('118','44','2'),
('119','44','2'),
('120','44','2');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('121','45','2'),
('122','45','2'),
('123','45','2'),
('124','45','2'),
('125','45','2'),
('126','45','2'),
('127','46','2'),
('128','46','2'),
('129','46','2'),
('130','46','2'),
('131','46','2'),
('132','46','2'),
('133','47','2'),
('134','47','2'),
('135','47','2'),
('136','47','2'),
('137','47','2'),
('138','47','2'),
('139','48','2'),
('140','48','2');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('141','48','2'),
('142','48','2'),
('143','48','2'),
('144','48','2'),
('145','49','3'),
('146','49','3'),
('147','49','3'),
('148','49','3'),
('149','49','3'),
('150','49','3'),
('151','50','3'),
('152','50','3'),
('153','50','3'),
('154','50','3'),
('155','50','3'),
('156','50','3'),
('157','51','3'),
('158','51','3'),
('159','51','3'),
('160','51','3');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('161','51','3'),
('162','51','3'),
('163','52','3'),
('164','52','3'),
('165','52','3'),
('166','52','3'),
('167','52','3'),
('168','52','3'),
('169','53','3'),
('170','53','3'),
('171','53','3'),
('172','53','3'),
('173','53','3'),
('174','53','3'),
('175','54','3'),
('176','54','3'),
('177','54','3'),
('178','54','3'),
('179','54','3'),
('180','54','3');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('181','55','3'),
('182','55','3'),
('183','55','3'),
('184','55','3'),
('185','55','3'),
('186','55','3'),
('187','56','3'),
('188','56','3'),
('189','56','3'),
('190','56','3'),
('191','56','3'),
('192','56','3'),
('193','57','3'),
('194','57','3'),
('195','57','3'),
('196','57','3'),
('197','57','3'),
('198','57','3'),
('199','58','3'),
('200','58','3');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('201','58','3'),
('202','58','3'),
('203','58','3'),
('204','58','3'),
('205','59','3'),
('206','59','3'),
('207','59','3'),
('208','59','3'),
('209','59','3'),
('210','59','3'),
('211','60','3'),
('212','60','3'),
('213','60','3'),
('214','60','3'),
('215','60','3'),
('216','60','3'),
('217','61','4'),
('218','61','4'),
('219','61','4'),
('220','61','4');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('221','61','4'),
('222','61','4'),
('223','62','4'),
('224','62','4'),
('225','62','4'),
('226','62','4'),
('227','62','4'),
('228','62','4'),
('229','63','4'),
('230','63','4'),
('231','63','4'),
('232','63','4'),
('233','63','4'),
('234','63','4'),
('235','64','4'),
('236','64','4'),
('237','64','4'),
('238','64','4'),
('239','64','4'),
('240','64','4');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('241','65','4'),
('242','65','4'),
('243','65','4'),
('244','65','4'),
('245','65','4'),
('246','65','4'),
('247','66','4'),
('248','66','4'),
('249','66','4'),
('250','66','4'),
('251','66','4'),
('252','66','4'),
('253','67','4'),
('254','67','4'),
('255','67','4'),
('256','67','4'),
('257','67','4'),
('258','67','4'),
('259','68','4'),
('260','68','4');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('261','68','4'),
('262','68','4'),
('263','68','4'),
('264','68','4'),
('265','69','4'),
('266','69','4'),
('267','69','4'),
('268','69','4'),
('269','69','4'),
('270','69','4'),
('271','70','4'),
('272','70','4'),
('273','70','4'),
('274','70','4'),
('275','70','4'),
('276','70','4'),
('277','71','4'),
('278','71','4'),
('279','71','4'),
('280','71','4');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('281','71','4'),
('282','71','4'),
('283','72','4'),
('284','72','4'),
('285','72','4'),
('286','72','4'),
('287','72','4'),
('288','72','4'),
('289','73','5'),
('290','73','5'),
('291','73','5'),
('292','73','5'),
('293','73','5'),
('294','73','5'),
('295','74','5'),
('296','74','5'),
('297','74','5'),
('298','74','5'),
('299','74','5'),
('300','74','5');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('301','75','5'),
('302','75','5'),
('303','75','5'),
('304','75','5'),
('305','75','5'),
('306','75','5'),
('307','76','5'),
('308','76','5'),
('309','76','5'),
('310','76','5'),
('311','76','5'),
('312','76','5'),
('313','77','5'),
('314','77','5'),
('315','77','5'),
('316','77','5'),
('317','77','5'),
('318','77','5'),
('319','78','5'),
('320','78','5');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('321','78','5'),
('322','78','5'),
('323','78','5'),
('324','78','5'),
('325','79','5'),
('326','79','5'),
('327','79','5'),
('328','79','5'),
('329','79','5'),
('330','79','5'),
('331','80','5'),
('332','80','5'),
('333','80','5'),
('334','80','5'),
('335','80','5'),
('336','80','5'),
('337','81','5'),
('338','81','5'),
('339','81','5'),
('340','81','5');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('341','81','5'),
('342','81','5'),
('343','82','5'),
('344','82','5'),
('345','82','5'),
('346','82','5'),
('347','82','5'),
('348','82','5'),
('349','83','5'),
('350','83','5'),
('351','83','5'),
('352','83','5'),
('353','83','5'),
('354','83','5'),
('355','84','5'),
('356','84','5'),
('357','84','5'),
('358','84','5'),
('359','84','5'),
('360','84','5');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('361','85','6'),
('362','85','6'),
('363','85','6'),
('364','85','6'),
('365','85','6'),
('366','85','6'),
('367','86','6'),
('368','86','6'),
('369','86','6'),
('370','86','6'),
('371','86','6'),
('372','86','6'),
('373','87','6'),
('374','87','6'),
('375','87','6'),
('376','87','6'),
('377','87','6'),
('378','87','6'),
('379','88','6'),
('380','88','6');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('381','88','6'),
('382','88','6'),
('383','88','6'),
('384','88','6'),
('385','89','6'),
('386','89','6'),
('387','89','6'),
('388','89','6'),
('389','89','6'),
('390','89','6'),
('391','90','6'),
('392','90','6'),
('393','90','6'),
('394','90','6'),
('395','90','6'),
('396','90','6'),
('397','91','6'),
('398','91','6'),
('399','91','6'),
('400','91','6');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('401','91','6'),
('402','91','6'),
('403','92','6'),
('404','92','6'),
('405','92','6'),
('406','92','6'),
('407','92','6'),
('408','92','6'),
('409','93','6'),
('410','93','6'),
('411','93','6'),
('412','93','6'),
('413','93','6'),
('414','93','6'),
('415','94','6'),
('416','94','6'),
('417','94','6'),
('418','94','6'),
('419','94','6'),
('420','94','6');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('421','95','6'),
('422','95','6'),
('423','95','6'),
('424','95','6'),
('425','95','6'),
('426','95','6'),
('427','96','6'),
('428','96','6'),
('429','96','6'),
('430','96','6'),
('431','96','6'),
('432','96','6'),
('433','97','7'),
('434','97','7'),
('435','97','7'),
('436','97','7'),
('437','97','7'),
('438','97','7'),
('439','98','7'),
('440','98','7');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('441','98','7'),
('442','98','7'),
('443','98','7'),
('444','98','7'),
('445','99','7'),
('446','99','7'),
('447','99','7'),
('448','99','7'),
('449','99','7'),
('450','99','7'),
('451','100','7'),
('452','100','7'),
('453','100','7'),
('454','100','7'),
('455','100','7'),
('456','100','7'),
('457','101','7'),
('458','101','7'),
('459','101','7'),
('460','101','7');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('461','101','7'),
('462','101','7'),
('463','102','7'),
('464','102','7'),
('465','102','7'),
('466','102','7'),
('467','102','7'),
('468','102','7'),
('469','103','7'),
('470','103','7'),
('471','103','7'),
('472','103','7'),
('473','103','7'),
('474','103','7'),
('475','104','7'),
('476','104','7'),
('477','104','7'),
('478','104','7'),
('479','104','7'),
('480','104','7');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('481','105','7'),
('482','105','7'),
('483','105','7'),
('484','105','7'),
('485','105','7'),
('486','105','7'),
('487','106','7'),
('488','106','7'),
('489','106','7'),
('490','106','7'),
('491','106','7'),
('492','106','7'),
('493','107','7'),
('494','107','7'),
('495','107','7'),
('496','107','7'),
('497','107','7'),
('498','107','7'),
('499','108','7'),
('500','108','7');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('501','108','7'),
('502','108','7'),
('503','108','7'),
('504','108','7'),
('505','109','8'),
('506','109','8'),
('507','109','8'),
('508','109','8'),
('509','109','8'),
('510','109','8'),
('511','110','8'),
('512','110','8'),
('513','110','8'),
('514','110','8'),
('515','110','8'),
('516','110','8'),
('517','111','8'),
('518','111','8'),
('519','111','8'),
('520','111','8');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('521','111','8'),
('522','111','8'),
('523','112','8'),
('524','112','8'),
('525','112','8'),
('526','112','8'),
('527','112','8'),
('528','112','8'),
('529','113','8'),
('530','113','8'),
('531','113','8'),
('532','113','8'),
('533','113','8'),
('534','113','8'),
('535','114','8'),
('536','114','8'),
('537','114','8'),
('538','114','8'),
('539','114','8'),
('540','114','8');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('541','115','8'),
('542','115','8'),
('543','115','8'),
('544','115','8'),
('545','115','8'),
('546','115','8'),
('547','116','8'),
('548','116','8'),
('549','116','8'),
('550','116','8'),
('551','116','8'),
('552','116','8'),
('553','117','8'),
('554','117','8'),
('555','117','8'),
('556','117','8'),
('557','117','8'),
('558','117','8'),
('559','118','8'),
('560','118','8');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('561','118','8'),
('562','118','8'),
('563','118','8'),
('564','118','8'),
('565','119','8'),
('566','119','8'),
('567','119','8'),
('568','119','8'),
('569','119','8'),
('570','119','8'),
('571','120','8'),
('572','120','8'),
('573','120','8'),
('574','120','8'),
('575','120','8'),
('576','120','8'),
('577','121','9'),
('578','121','9'),
('579','121','9'),
('580','121','9');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('581','121','9'),
('582','121','9'),
('583','122','9'),
('584','122','9'),
('585','122','9'),
('586','122','9'),
('587','122','9'),
('588','122','9'),
('589','123','9'),
('590','123','9'),
('591','123','9'),
('592','123','9'),
('593','123','9'),
('594','123','9'),
('595','124','9'),
('596','124','9'),
('597','124','9'),
('598','124','9'),
('599','124','9'),
('600','124','9');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('601','125','9'),
('602','125','9'),
('603','125','9'),
('604','125','9'),
('605','125','9'),
('606','125','9'),
('607','126','9'),
('608','126','9'),
('609','126','9'),
('610','126','9'),
('611','126','9'),
('612','126','9'),
('613','127','9'),
('614','127','9'),
('615','127','9'),
('616','127','9'),
('617','127','9'),
('618','127','9'),
('619','128','9'),
('620','128','9');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('621','128','9'),
('622','128','9'),
('623','128','9'),
('624','128','9'),
('625','129','9'),
('626','129','9'),
('627','129','9'),
('628','129','9'),
('629','129','9'),
('630','129','9'),
('631','130','9'),
('632','130','9'),
('633','130','9'),
('634','130','9'),
('635','130','9'),
('636','130','9'),
('637','131','9'),
('638','131','9'),
('639','131','9'),
('640','131','9');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('641','131','9'),
('642','131','9'),
('643','132','9'),
('644','132','9'),
('645','132','9'),
('646','132','9'),
('647','132','9'),
('648','132','9'),
('649','133','10'),
('650','133','10'),
('651','133','10'),
('652','133','10'),
('653','133','10'),
('654','133','10'),
('655','134','10'),
('656','134','10'),
('657','134','10'),
('658','134','10'),
('659','134','10'),
('660','134','10');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('661','135','10'),
('662','135','10'),
('663','135','10'),
('664','135','10'),
('665','135','10'),
('666','135','10'),
('667','136','10'),
('668','136','10'),
('669','136','10'),
('670','136','10'),
('671','136','10'),
('672','136','10'),
('673','137','10'),
('674','137','10'),
('675','137','10'),
('676','137','10'),
('677','137','10'),
('678','137','10'),
('679','138','10'),
('680','138','10');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('681','138','10'),
('682','138','10'),
('683','138','10'),
('684','138','10'),
('685','139','10'),
('686','139','10'),
('687','139','10'),
('688','139','10'),
('689','139','10'),
('690','139','10'),
('691','140','10'),
('692','140','10'),
('693','140','10'),
('694','140','10'),
('695','140','10'),
('696','140','10'),
('697','141','10'),
('698','141','10'),
('699','141','10'),
('700','141','10');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('701','141','10'),
('702','141','10'),
('703','142','10'),
('704','142','10'),
('705','142','10'),
('706','142','10'),
('707','142','10'),
('708','142','10'),
('709','143','10'),
('710','143','10'),
('711','143','10'),
('712','143','10'),
('713','143','10'),
('714','143','10'),
('715','144','10'),
('716','144','10'),
('717','144','10'),
('718','144','10'),
('719','144','10'),
('720','144','10');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('721','145','11'),
('722','145','11'),
('723','145','11'),
('724','145','11'),
('725','145','11'),
('726','145','11'),
('727','146','11'),
('728','146','11'),
('729','146','11'),
('730','146','11'),
('731','146','11'),
('732','146','11'),
('733','147','11'),
('734','147','11'),
('735','147','11'),
('736','147','11'),
('737','147','11'),
('738','147','11'),
('739','148','11'),
('740','148','11');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('741','148','11'),
('742','148','11'),
('743','148','11'),
('744','148','11'),
('745','149','11'),
('746','149','11'),
('747','149','11'),
('748','149','11'),
('749','149','11'),
('750','149','11'),
('751','150','11'),
('752','150','11'),
('753','150','11'),
('754','150','11'),
('755','150','11'),
('756','150','11'),
('757','151','11'),
('758','151','11'),
('759','151','11'),
('760','151','11');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('761','151','11'),
('762','151','11'),
('763','152','11'),
('764','152','11'),
('765','152','11'),
('766','152','11'),
('767','152','11'),
('768','152','11'),
('769','153','11'),
('770','153','11'),
('771','153','11'),
('772','153','11'),
('773','153','11'),
('774','153','11'),
('775','154','11'),
('776','154','11'),
('777','154','11'),
('778','154','11'),
('779','154','11'),
('780','154','11');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('781','155','11'),
('782','155','11'),
('783','155','11'),
('784','155','11'),
('785','155','11'),
('786','155','11'),
('787','156','11'),
('788','156','11'),
('789','156','11'),
('790','156','11'),
('791','156','11'),
('792','156','11'),
('793','157','12'),
('794','157','12'),
('795','157','12'),
('796','157','12'),
('797','157','12'),
('798','157','12'),
('799','158','12'),
('800','158','12');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('801','158','12'),
('802','158','12'),
('803','158','12'),
('804','158','12'),
('805','159','12'),
('806','159','12'),
('807','159','12'),
('808','159','12'),
('809','159','12'),
('810','159','12'),
('811','160','12'),
('812','160','12'),
('813','160','12'),
('814','160','12'),
('815','160','12'),
('816','160','12'),
('817','161','12'),
('818','161','12'),
('819','161','12'),
('820','161','12');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('821','161','12'),
('822','161','12'),
('823','162','12'),
('824','162','12'),
('825','162','12'),
('826','162','12'),
('827','162','12'),
('828','162','12'),
('829','163','12'),
('830','163','12'),
('831','163','12'),
('832','163','12'),
('833','163','12'),
('834','163','12'),
('835','164','12'),
('836','164','12'),
('837','164','12'),
('838','164','12'),
('839','164','12'),
('840','164','12');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('841','165','12'),
('842','165','12'),
('843','165','12'),
('844','165','12'),
('845','165','12'),
('846','165','12'),
('847','166','12'),
('848','166','12'),
('849','166','12'),
('850','166','12'),
('851','166','12'),
('852','166','12'),
('853','167','12'),
('854','167','12'),
('855','167','12'),
('856','167','12'),
('857','167','12'),
('858','167','12'),
('859','168','12'),
('860','168','12');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('861','168','12'),
('862','168','12'),
('863','168','12'),
('864','168','12'),
('865','169','13'),
('866','169','13'),
('867','169','13'),
('868','169','13'),
('869','169','13'),
('870','169','13'),
('871','170','13'),
('872','170','13'),
('873','170','13'),
('874','170','13'),
('875','170','13'),
('876','170','13'),
('877','171','13'),
('878','171','13'),
('879','171','13'),
('880','171','13');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('881','171','13'),
('882','171','13'),
('883','172','13'),
('884','172','13'),
('885','172','13'),
('886','172','13'),
('887','172','13'),
('888','172','13'),
('889','173','13'),
('890','173','13'),
('891','173','13'),
('892','173','13'),
('893','173','13'),
('894','173','13'),
('895','174','13'),
('896','174','13'),
('897','174','13'),
('898','174','13'),
('899','174','13'),
('900','174','13');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('901','175','13'),
('902','175','13'),
('903','175','13'),
('904','175','13'),
('905','175','13'),
('906','175','13'),
('907','176','13'),
('908','176','13'),
('909','176','13'),
('910','176','13'),
('911','176','13'),
('912','176','13'),
('913','177','13'),
('914','177','13'),
('915','177','13'),
('916','177','13'),
('917','177','13'),
('918','177','13'),
('919','178','13'),
('920','178','13');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('921','178','13'),
('922','178','13'),
('923','178','13'),
('924','178','13'),
('925','179','13'),
('926','179','13'),
('927','179','13'),
('928','179','13'),
('929','179','13'),
('930','179','13'),
('931','180','13'),
('932','180','13'),
('933','180','13'),
('934','180','13'),
('935','180','13'),
('936','180','13'),
('937','181','14'),
('938','181','14'),
('939','181','14'),
('940','181','14');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('941','181','14'),
('942','181','14'),
('943','182','14'),
('944','182','14'),
('945','182','14'),
('946','182','14'),
('947','182','14'),
('948','182','14'),
('949','183','14'),
('950','183','14'),
('951','183','14'),
('952','183','14'),
('953','183','14'),
('954','183','14'),
('955','184','14'),
('956','184','14'),
('957','184','14'),
('958','184','14'),
('959','184','14'),
('960','184','14');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('961','185','14'),
('962','185','14'),
('963','185','14'),
('964','185','14'),
('965','185','14'),
('966','185','14'),
('967','186','14'),
('968','186','14'),
('969','186','14'),
('970','186','14'),
('971','186','14'),
('972','186','14'),
('973','187','14'),
('974','187','14'),
('975','187','14'),
('976','187','14'),
('977','187','14'),
('978','187','14'),
('979','188','14'),
('980','188','14');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('981','188','14'),
('982','188','14'),
('983','188','14'),
('984','188','14'),
('985','189','14'),
('986','189','14'),
('987','189','14'),
('988','189','14'),
('989','189','14'),
('990','189','14'),
('991','190','14'),
('992','190','14'),
('993','190','14'),
('994','190','14'),
('995','190','14'),
('996','190','14'),
('997','191','14'),
('998','191','14'),
('999','191','14'),
('1000','191','14');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1001','191','14'),
('1002','191','14'),
('1003','192','14'),
('1004','192','14'),
('1005','192','14'),
('1006','192','14'),
('1007','192','14'),
('1008','192','14'),
('1009','193','15'),
('1010','193','15'),
('1011','193','15'),
('1012','193','15'),
('1013','193','15'),
('1014','193','15'),
('1015','194','15'),
('1016','194','15'),
('1017','194','15'),
('1018','194','15'),
('1019','194','15'),
('1020','194','15');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1021','195','15'),
('1022','195','15'),
('1023','195','15'),
('1024','195','15'),
('1025','195','15'),
('1026','195','15'),
('1027','196','15'),
('1028','196','15'),
('1029','196','15'),
('1030','196','15'),
('1031','196','15'),
('1032','196','15'),
('1033','197','15'),
('1034','197','15'),
('1035','197','15'),
('1036','197','15'),
('1037','197','15'),
('1038','197','15'),
('1039','198','15'),
('1040','198','15');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1041','198','15'),
('1042','198','15'),
('1043','198','15'),
('1044','198','15'),
('1045','199','15'),
('1046','199','15'),
('1047','199','15'),
('1048','199','15'),
('1049','199','15'),
('1050','199','15'),
('1051','200','15'),
('1052','200','15'),
('1053','200','15'),
('1054','200','15'),
('1055','200','15'),
('1056','200','15'),
('1057','201','15'),
('1058','201','15'),
('1059','201','15'),
('1060','201','15');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1061','201','15'),
('1062','201','15'),
('1063','202','15'),
('1064','202','15'),
('1065','202','15'),
('1066','202','15'),
('1067','202','15'),
('1068','202','15'),
('1069','203','15'),
('1070','203','15'),
('1071','203','15'),
('1072','203','15'),
('1073','203','15'),
('1074','203','15'),
('1075','204','15'),
('1076','204','15'),
('1077','204','15'),
('1078','204','15'),
('1079','204','15'),
('1080','204','15');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1081','205','16'),
('1082','205','16'),
('1083','205','16'),
('1084','205','16'),
('1085','205','16'),
('1086','205','16'),
('1087','206','16'),
('1088','206','16'),
('1089','206','16'),
('1090','206','16'),
('1091','206','16'),
('1092','206','16'),
('1093','207','16'),
('1094','207','16'),
('1095','207','16'),
('1096','207','16'),
('1097','207','16'),
('1098','207','16'),
('1099','208','16'),
('1100','208','16');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1101','208','16'),
('1102','208','16'),
('1103','208','16'),
('1104','208','16'),
('1105','209','16'),
('1106','209','16'),
('1107','209','16'),
('1108','209','16'),
('1109','209','16'),
('1110','209','16'),
('1111','210','16'),
('1112','210','16'),
('1113','210','16'),
('1114','210','16'),
('1115','210','16'),
('1116','210','16'),
('1117','211','16'),
('1118','211','16'),
('1119','211','16'),
('1120','211','16');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1121','211','16'),
('1122','211','16'),
('1123','212','16'),
('1124','212','16'),
('1125','212','16'),
('1126','212','16'),
('1127','212','16'),
('1128','212','16'),
('1129','213','16'),
('1130','213','16'),
('1131','213','16'),
('1132','213','16'),
('1133','213','16'),
('1134','213','16'),
('1135','214','16'),
('1136','214','16'),
('1137','214','16'),
('1138','214','16'),
('1139','214','16'),
('1140','214','16');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1141','215','16'),
('1142','215','16'),
('1143','215','16'),
('1144','215','16'),
('1145','215','16'),
('1146','215','16'),
('1147','216','16'),
('1148','216','16'),
('1149','216','16'),
('1150','216','16'),
('1151','216','16'),
('1152','216','16'),
('1153','217','17'),
('1154','217','17'),
('1155','217','17'),
('1156','217','17'),
('1157','217','17'),
('1158','217','17'),
('1159','218','17'),
('1160','218','17');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1161','218','17'),
('1162','218','17'),
('1163','218','17'),
('1164','218','17'),
('1165','219','17'),
('1166','219','17'),
('1167','219','17'),
('1168','219','17'),
('1169','219','17'),
('1170','219','17'),
('1171','220','17'),
('1172','220','17'),
('1173','220','17'),
('1174','220','17'),
('1175','220','17'),
('1176','220','17'),
('1177','221','17'),
('1178','221','17'),
('1179','221','17'),
('1180','221','17');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1181','221','17'),
('1182','221','17'),
('1183','222','17'),
('1184','222','17'),
('1185','222','17'),
('1186','222','17'),
('1187','222','17'),
('1188','222','17'),
('1189','223','17'),
('1190','223','17'),
('1191','223','17'),
('1192','223','17'),
('1193','223','17'),
('1194','223','17'),
('1195','224','17'),
('1196','224','17'),
('1197','224','17'),
('1198','224','17'),
('1199','224','17'),
('1200','224','17');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1201','225','17'),
('1202','225','17'),
('1203','225','17'),
('1204','225','17'),
('1205','225','17'),
('1206','225','17'),
('1207','226','17'),
('1208','226','17'),
('1209','226','17'),
('1210','226','17'),
('1211','226','17'),
('1212','226','17'),
('1213','227','17'),
('1214','227','17'),
('1215','227','17'),
('1216','227','17'),
('1217','227','17'),
('1218','227','17'),
('1219','228','17'),
('1220','228','17');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1221','228','17'),
('1222','228','17'),
('1223','228','17'),
('1224','228','17'),
('1225','229','18'),
('1226','229','18'),
('1227','229','18'),
('1228','229','18'),
('1229','229','18'),
('1230','229','18'),
('1231','230','18'),
('1232','230','18'),
('1233','230','18'),
('1234','230','18'),
('1235','230','18'),
('1236','230','18'),
('1237','231','18'),
('1238','231','18'),
('1239','231','18'),
('1240','231','18');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1241','231','18'),
('1242','231','18'),
('1243','232','18'),
('1244','232','18'),
('1245','232','18'),
('1246','232','18'),
('1247','232','18'),
('1248','232','18'),
('1249','233','18'),
('1250','233','18'),
('1251','233','18'),
('1252','233','18'),
('1253','233','18'),
('1254','233','18'),
('1255','234','18'),
('1256','234','18'),
('1257','234','18'),
('1258','234','18'),
('1259','234','18'),
('1260','234','18');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1261','235','18'),
('1262','235','18'),
('1263','235','18'),
('1264','235','18'),
('1265','235','18'),
('1266','235','18'),
('1267','236','18'),
('1268','236','18'),
('1269','236','18'),
('1270','236','18'),
('1271','236','18'),
('1272','236','18'),
('1273','237','18'),
('1274','237','18'),
('1275','237','18'),
('1276','237','18'),
('1277','237','18'),
('1278','237','18'),
('1279','238','18'),
('1280','238','18');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1281','238','18'),
('1282','238','18'),
('1283','238','18'),
('1284','238','18'),
('1285','239','18'),
('1286','239','18'),
('1287','239','18'),
('1288','239','18'),
('1289','239','18'),
('1290','239','18'),
('1291','240','18'),
('1292','240','18'),
('1293','240','18'),
('1294','240','18'),
('1295','240','18'),
('1296','240','18'),
('1297','241','19'),
('1298','241','19'),
('1299','241','19'),
('1300','241','19');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1301','241','19'),
('1302','241','19'),
('1303','242','19'),
('1304','242','19'),
('1305','242','19'),
('1306','242','19'),
('1307','242','19'),
('1308','242','19'),
('1309','243','19'),
('1310','243','19'),
('1311','243','19'),
('1312','243','19'),
('1313','243','19'),
('1314','243','19'),
('1315','244','19'),
('1316','244','19'),
('1317','244','19'),
('1318','244','19'),
('1319','244','19'),
('1320','244','19');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1321','245','19'),
('1322','245','19'),
('1323','245','19'),
('1324','245','19'),
('1325','245','19'),
('1326','245','19'),
('1327','246','19'),
('1328','246','19'),
('1329','246','19'),
('1330','246','19'),
('1331','246','19'),
('1332','246','19'),
('1333','247','19'),
('1334','247','19'),
('1335','247','19'),
('1336','247','19'),
('1337','247','19'),
('1338','247','19'),
('1339','248','19'),
('1340','248','19');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1341','248','19'),
('1342','248','19'),
('1343','248','19'),
('1344','248','19'),
('1345','249','19'),
('1346','249','19'),
('1347','249','19'),
('1348','249','19'),
('1349','249','19'),
('1350','249','19'),
('1351','250','19'),
('1352','250','19'),
('1353','250','19'),
('1354','250','19'),
('1355','250','19'),
('1356','250','19'),
('1357','251','19'),
('1358','251','19'),
('1359','251','19'),
('1360','251','19');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1361','251','19'),
('1362','251','19'),
('1363','252','19'),
('1364','252','19'),
('1365','252','19'),
('1366','252','19'),
('1367','252','19'),
('1368','252','19'),
('1369','253','20'),
('1370','253','20'),
('1371','253','20'),
('1372','253','20'),
('1373','253','20'),
('1374','253','20'),
('1375','254','20'),
('1376','254','20'),
('1377','254','20'),
('1378','254','20'),
('1379','254','20'),
('1380','254','20');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1381','255','20'),
('1382','255','20'),
('1383','255','20'),
('1384','255','20'),
('1385','255','20'),
('1386','255','20'),
('1387','256','20'),
('1388','256','20'),
('1389','256','20'),
('1390','256','20'),
('1391','256','20'),
('1392','256','20'),
('1393','257','20'),
('1394','257','20'),
('1395','257','20'),
('1396','257','20'),
('1397','257','20'),
('1398','257','20'),
('1399','258','20'),
('1400','258','20');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1401','258','20'),
('1402','258','20'),
('1403','258','20'),
('1404','258','20'),
('1405','259','20'),
('1406','259','20'),
('1407','259','20'),
('1408','259','20'),
('1409','259','20'),
('1410','259','20'),
('1411','260','20'),
('1412','260','20'),
('1413','260','20'),
('1414','260','20'),
('1415','260','20'),
('1416','260','20'),
('1417','261','20'),
('1418','261','20'),
('1419','261','20'),
('1420','261','20');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1421','261','20'),
('1422','261','20'),
('1423','262','20'),
('1424','262','20'),
('1425','262','20'),
('1426','262','20'),
('1427','262','20'),
('1428','262','20'),
('1429','263','20'),
('1430','263','20'),
('1431','263','20'),
('1432','263','20'),
('1433','263','20'),
('1434','263','20'),
('1435','264','20'),
('1436','264','20'),
('1437','264','20'),
('1438','264','20'),
('1439','264','20'),
('1440','264','20');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1441','265','21'),
('1442','265','21'),
('1443','265','21'),
('1444','265','21'),
('1445','265','21'),
('1446','265','21'),
('1447','266','21'),
('1448','266','21'),
('1449','266','21'),
('1450','266','21'),
('1451','266','21'),
('1452','266','21'),
('1453','267','21'),
('1454','267','21'),
('1455','267','21'),
('1456','267','21'),
('1457','267','21'),
('1458','267','21'),
('1459','268','21'),
('1460','268','21');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1461','268','21'),
('1462','268','21'),
('1463','268','21'),
('1464','268','21'),
('1465','269','21'),
('1466','269','21'),
('1467','269','21'),
('1468','269','21'),
('1469','269','21'),
('1470','269','21'),
('1471','270','21'),
('1472','270','21'),
('1473','270','21'),
('1474','270','21'),
('1475','270','21'),
('1476','270','21'),
('1477','271','21'),
('1478','271','21'),
('1479','271','21'),
('1480','271','21');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1481','271','21'),
('1482','271','21'),
('1483','272','21'),
('1484','272','21'),
('1485','272','21'),
('1486','272','21'),
('1487','272','21'),
('1488','272','21'),
('1489','273','21'),
('1490','273','21'),
('1491','273','21'),
('1492','273','21'),
('1493','273','21'),
('1494','273','21'),
('1495','274','21'),
('1496','274','21'),
('1497','274','21'),
('1498','274','21'),
('1499','274','21'),
('1500','274','21');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1501','275','21'),
('1502','275','21'),
('1503','275','21'),
('1504','275','21'),
('1505','275','21'),
('1506','275','21'),
('1507','276','21'),
('1508','276','21'),
('1509','276','21'),
('1510','276','21'),
('1511','276','21'),
('1512','276','21'),
('1513','277','22'),
('1514','277','22'),
('1515','277','22'),
('1516','277','22'),
('1517','277','22'),
('1518','277','22'),
('1519','278','22'),
('1520','278','22');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1521','278','22'),
('1522','278','22'),
('1523','278','22'),
('1524','278','22'),
('1525','279','22'),
('1526','279','22'),
('1527','279','22'),
('1528','279','22'),
('1529','279','22'),
('1530','279','22'),
('1531','280','22'),
('1532','280','22'),
('1533','280','22'),
('1534','280','22'),
('1535','280','22'),
('1536','280','22'),
('1537','281','22'),
('1538','281','22'),
('1539','281','22'),
('1540','281','22');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1541','281','22'),
('1542','281','22'),
('1543','282','22'),
('1544','282','22'),
('1545','282','22'),
('1546','282','22'),
('1547','282','22'),
('1548','282','22'),
('1549','283','22'),
('1550','283','22'),
('1551','283','22'),
('1552','283','22'),
('1553','283','22'),
('1554','283','22'),
('1555','284','22'),
('1556','284','22'),
('1557','284','22'),
('1558','284','22'),
('1559','284','22'),
('1560','284','22');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1561','285','22'),
('1562','285','22'),
('1563','285','22'),
('1564','285','22'),
('1565','285','22'),
('1566','285','22'),
('1567','286','22'),
('1568','286','22'),
('1569','286','22'),
('1570','286','22'),
('1571','286','22'),
('1572','286','22'),
('1573','287','22'),
('1574','287','22'),
('1575','287','22'),
('1576','287','22'),
('1577','287','22'),
('1578','287','22'),
('1579','288','22'),
('1580','288','22');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1581','288','22'),
('1582','288','22'),
('1583','288','22'),
('1584','288','22'),
('1585','289','23'),
('1586','289','23'),
('1587','289','23'),
('1588','289','23'),
('1589','289','23'),
('1590','289','23'),
('1591','290','23'),
('1592','290','23'),
('1593','290','23'),
('1594','290','23'),
('1595','290','23'),
('1596','290','23'),
('1597','291','23'),
('1598','291','23'),
('1599','291','23'),
('1600','291','23');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1601','291','23'),
('1602','291','23'),
('1603','292','23'),
('1604','292','23'),
('1605','292','23'),
('1606','292','23'),
('1607','292','23'),
('1608','292','23'),
('1609','293','23'),
('1610','293','23'),
('1611','293','23'),
('1612','293','23'),
('1613','293','23'),
('1614','293','23'),
('1615','294','23'),
('1616','294','23'),
('1617','294','23'),
('1618','294','23'),
('1619','294','23'),
('1620','294','23');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1621','295','23'),
('1622','295','23'),
('1623','295','23'),
('1624','295','23'),
('1625','295','23'),
('1626','295','23'),
('1627','296','23'),
('1628','296','23'),
('1629','296','23'),
('1630','296','23'),
('1631','296','23'),
('1632','296','23'),
('1633','297','23'),
('1634','297','23'),
('1635','297','23'),
('1636','297','23'),
('1637','297','23'),
('1638','297','23'),
('1639','298','23'),
('1640','298','23');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1641','298','23'),
('1642','298','23'),
('1643','298','23'),
('1644','298','23'),
('1645','299','23'),
('1646','299','23'),
('1647','299','23'),
('1648','299','23'),
('1649','299','23'),
('1650','299','23'),
('1651','300','23'),
('1652','300','23'),
('1653','300','23'),
('1654','300','23'),
('1655','300','23'),
('1656','300','23'),
('1657','301','24'),
('1658','301','24'),
('1659','301','24'),
('1660','301','24');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1661','301','24'),
('1662','301','24'),
('1663','302','24'),
('1664','302','24'),
('1665','302','24'),
('1666','302','24'),
('1667','302','24'),
('1668','302','24'),
('1669','303','24'),
('1670','303','24'),
('1671','303','24'),
('1672','303','24'),
('1673','303','24'),
('1674','303','24'),
('1675','304','24'),
('1676','304','24'),
('1677','304','24'),
('1678','304','24'),
('1679','304','24'),
('1680','304','24');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1681','305','24'),
('1682','305','24'),
('1683','305','24'),
('1684','305','24'),
('1685','305','24'),
('1686','305','24'),
('1687','306','24'),
('1688','306','24'),
('1689','306','24'),
('1690','306','24'),
('1691','306','24'),
('1692','306','24'),
('1693','307','24'),
('1694','307','24'),
('1695','307','24'),
('1696','307','24'),
('1697','307','24'),
('1698','307','24'),
('1699','308','24'),
('1700','308','24');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1701','308','24'),
('1702','308','24'),
('1703','308','24'),
('1704','308','24'),
('1705','309','24'),
('1706','309','24'),
('1707','309','24'),
('1708','309','24'),
('1709','309','24'),
('1710','309','24'),
('1711','310','24'),
('1712','310','24'),
('1713','310','24'),
('1714','310','24'),
('1715','310','24'),
('1716','310','24'),
('1717','311','24'),
('1718','311','24'),
('1719','311','24'),
('1720','311','24');
insert into `products_to_categories` (`products_id`, `categories_id`, `section_id`) values ('1721','311','24'),
('1722','311','24'),
('1723','312','24'),
('1724','312','24'),
('1725','312','24'),
('1726','312','24'),
('1727','312','24'),
('1728','312','24');

DROP VIEW IF EXISTS `carts_united`;
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `carts_united` AS select `cb`.`customers_basket_id` AS `customers_basket_id`,`cb`.`products_id` AS `products_id`,`cb`.`customers_id` AS `customers_id`,`cb`.`customers_basket_date_added` AS `customers_basket_date_added`,`cb`.`customers_basket_quantity` AS `customers_basket_quantity`,`cb`.`discount_id` AS `discount_id` from `customers_basket` `cb` union select `tb`.`customers_basket_id` AS `customers_basket_id`,`tb`.`products_id` AS `products_id`,`tb`.`customers_id` AS `customers_id`,`tb`.`customers_basket_date_added` AS `customers_basket_date_added`,`tb`.`customers_basket_quantity` AS `customers_basket_quantity`,`tb`.`discount_id` AS `discount_id` from `customers_temp_basket` `tb`;